/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM CallEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "CallEvent.h"
#include "CallEventBinding.h"
#include "EventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/CallEvent.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/TelephonyCall.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(CallEvent)

NS_IMPL_ADDREF_INHERITED(CallEvent, Event)
NS_IMPL_RELEASE_INHERITED(CallEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(CallEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mCall)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(CallEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(CallEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mCall)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(CallEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

CallEvent::CallEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

CallEvent::~CallEvent()
{
}

CallEvent*
CallEvent::AsCallEvent()
{
  return this;
}

JSObject*
CallEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return CallEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<CallEvent>
CallEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const CallEventInit& aEventInitDict)
{
  RefPtr<CallEvent> e = new CallEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mCall = aEventInitDict.mCall;
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<CallEvent>
CallEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const CallEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

TelephonyCall*
CallEvent::GetCall() const
{
  return mCall;
}


} // namespace dom
} // namespace mozilla
