/* THIS FILE IS AUTOGENERATED FROM CameraUtil.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "CameraUtilBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/ScriptSettings.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {


CameraGetPromiseData::CameraGetPromiseData()
  : mConfiguration(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
CameraGetPromiseData::InitIds(JSContext* cx, CameraGetPromiseDataAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->configuration_id.init(cx, "configuration") ||
      !atomsCache->camera_id.init(cx, "camera")) {
    return false;
  }
  return true;
}

bool
CameraGetPromiseData::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  CameraGetPromiseDataAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<CameraGetPromiseDataAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  { // scope for isConvertible
    bool isConvertible;
    if (!IsConvertibleToDictionary(cx, val, &isConvertible)) {
      return false;
    }
    if (!isConvertible) {
      return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
    }
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->camera_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<mozilla::nsDOMCameraControl>::value, "We can only store refcounted classes.");{
        nsresult rv = UnwrapObject<prototypes::id::CameraControl, mozilla::nsDOMCameraControl>(&temp.ref().toObject(), mCamera);
        if (NS_FAILED(rv)) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'camera' member of CameraGetPromiseData", "CameraControl");
          return false;
        }
      }
    } else if (temp.ref().isNullOrUndefined()) {
      mCamera = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'camera' member of CameraGetPromiseData");
      return false;
    }
  } else {
    mCamera = nullptr;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->configuration_id, temp.ptr())) {
    return false;
  }
  if (!mConfiguration.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue,  "'configuration' member of CameraGetPromiseData", passedToJSImpl)) {
    return false;
  }
  return true;
}

bool
CameraGetPromiseData::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
CameraGetPromiseData::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  CameraGetPromiseDataAtoms* atomsCache = GetAtomCache<CameraGetPromiseDataAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    RefPtr<mozilla::nsDOMCameraControl> const & currentValue = mCamera;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->camera_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!GetOrCreateDOMReflector(cx, currentValue, &temp)) {
      MOZ_ASSERT(true || JS_IsExceptionPending(cx));
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->camera_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    CameraConfiguration const & currentValue = mConfiguration;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->configuration_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
CameraGetPromiseData::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
CameraGetPromiseData::TraceDictionary(JSTracer* trc)
{
}

void
CameraGetPromiseData::operator=(const CameraGetPromiseData& aOther)
{
  mCamera = aOther.mCamera;
  mConfiguration = aOther.mConfiguration;
}

namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
