/* THIS FILE IS AUTOGENERATED FROM DOMTransaction.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "DOMTransactionBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"

namespace mozilla {
namespace dom {

void
DOMTransactionCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



bool
DOMTransaction::InitIds(JSContext* cx, DOMTransactionAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->redo_id.init(cx, "redo") ||
      !atomsCache->undo_id.init(cx, "undo") ||
      !atomsCache->execute_id.init(cx, "execute") ||
      !atomsCache->executeAutomatic_id.init(cx, "executeAutomatic") ||
      !atomsCache->label_id.init(cx, "label")) {
    return false;
  }
  return true;
}


void
DOMTransaction::GetLabel(nsString& aRetVal, ErrorResult& aRv, const char* aExecutionReason, ExceptionHandling aExceptionHandling, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "DOMTransaction.label", aExceptionHandling, aCompartment);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  DOMTransactionAtoms* atomsCache = GetAtomCache<DOMTransactionAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->label_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  binding_detail::FakeString rvalDecl;
  if (!ConvertJSValueToString(cx, rval, eNull, eNull, rvalDecl)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  aRetVal = rvalDecl;
}

already_AddRefed<DOMTransactionCallback>
DOMTransaction::GetExecuteAutomatic(ErrorResult& aRv, const char* aExecutionReason, ExceptionHandling aExceptionHandling, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "DOMTransaction.executeAutomatic", aExceptionHandling, aCompartment);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  DOMTransactionAtoms* atomsCache = GetAtomCache<DOMTransactionAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->executeAutomatic_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<DOMTransactionCallback> rvalDecl;
  if (rval.isObject()) {
    if (JS::IsCallable(&rval.toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new DOMTransactionCallback(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Return value of DOMTransaction.executeAutomatic");
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
  } else if (rval.isNullOrUndefined()) {
    rvalDecl = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Return value of DOMTransaction.executeAutomatic");
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  return rvalDecl.forget();
}

already_AddRefed<DOMTransactionCallback>
DOMTransaction::GetExecute(ErrorResult& aRv, const char* aExecutionReason, ExceptionHandling aExceptionHandling, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "DOMTransaction.execute", aExceptionHandling, aCompartment);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  DOMTransactionAtoms* atomsCache = GetAtomCache<DOMTransactionAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->execute_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<DOMTransactionCallback> rvalDecl;
  if (rval.isObject()) {
    if (JS::IsCallable(&rval.toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new DOMTransactionCallback(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Return value of DOMTransaction.execute");
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
  } else if (rval.isNullOrUndefined()) {
    rvalDecl = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Return value of DOMTransaction.execute");
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  return rvalDecl.forget();
}

already_AddRefed<DOMTransactionCallback>
DOMTransaction::GetUndo(ErrorResult& aRv, const char* aExecutionReason, ExceptionHandling aExceptionHandling, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "DOMTransaction.undo", aExceptionHandling, aCompartment);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  DOMTransactionAtoms* atomsCache = GetAtomCache<DOMTransactionAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->undo_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<DOMTransactionCallback> rvalDecl;
  if (rval.isObject()) {
    if (JS::IsCallable(&rval.toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new DOMTransactionCallback(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Return value of DOMTransaction.undo");
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
  } else if (rval.isNullOrUndefined()) {
    rvalDecl = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Return value of DOMTransaction.undo");
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  return rvalDecl.forget();
}

already_AddRefed<DOMTransactionCallback>
DOMTransaction::GetRedo(ErrorResult& aRv, const char* aExecutionReason, ExceptionHandling aExceptionHandling, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "DOMTransaction.redo", aExceptionHandling, aCompartment);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  DOMTransactionAtoms* atomsCache = GetAtomCache<DOMTransactionAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->redo_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<DOMTransactionCallback> rvalDecl;
  if (rval.isObject()) {
    if (JS::IsCallable(&rval.toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new DOMTransactionCallback(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Return value of DOMTransaction.redo");
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
  } else if (rval.isNullOrUndefined()) {
    rvalDecl = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Return value of DOMTransaction.redo");
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  return rvalDecl.forget();
}


} // namespace dom
} // namespace mozilla
