/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM MozSettingsEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "EventBinding.h"
#include "MozSettingsEvent.h"
#include "MozSettingsEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/MozSettingsEvent.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(MozSettingsEvent)

NS_IMPL_ADDREF_INHERITED(MozSettingsEvent, Event)
NS_IMPL_RELEASE_INHERITED(MozSettingsEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(MozSettingsEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(MozSettingsEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRACE_JSVAL_MEMBER_CALLBACK(mSettingValue)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(MozSettingsEvent, Event)
  tmp->mSettingValue.setUndefined();
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(MozSettingsEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

MozSettingsEvent::MozSettingsEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

MozSettingsEvent::~MozSettingsEvent()
{
  mSettingValue = JS::UndefinedValue();
  mozilla::DropJSObjects(this);
}

MozSettingsEvent*
MozSettingsEvent::AsMozSettingsEvent()
{
  return this;
}

JSObject*
MozSettingsEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return MozSettingsEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<MozSettingsEvent>
MozSettingsEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const MozSettingsEventInit& aEventInitDict)
{
  RefPtr<MozSettingsEvent> e = new MozSettingsEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mSettingName = aEventInitDict.mSettingName;
  e->mSettingValue = aEventInitDict.mSettingValue;
  e->SetTrusted(trusted);
  mozilla::HoldJSObjects(e.get());
  return e.forget();
}

already_AddRefed<MozSettingsEvent>
MozSettingsEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const MozSettingsEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
MozSettingsEvent::GetSettingName(nsString& aRetVal) const
{
  aRetVal = mSettingName;
}

void
MozSettingsEvent::GetSettingValue(JSContext* cx, JS::MutableHandle<JS::Value> aRetVal) const
{
  JS::ExposeValueToActiveJS(mSettingValue);
  aRetVal.set(mSettingValue);
  return;
}


} // namespace dom
} // namespace mozilla
