#include "AVInputPortBinding.h"
#include "AbortablePromiseBinding.h"
#include "ActivityRequestHandlerBinding.h"
#include "AlarmsManagerBinding.h"
#include "AnalyserNodeBinding.h"
#include "AnimationBinding.h"
#include "AnimationEffectReadOnlyBinding.h"
#include "AnimationEventBinding.h"
#include "AnimationPlaybackEventBinding.h"
#include "AnimationTimelineBinding.h"
#include "AnonymousContentBinding.h"
#include "AppsBinding.h"
#include "ArchiveReaderBinding.h"
#include "ArchiveRequestBinding.h"
#include "AttrBinding.h"
#include "AudioBufferBinding.h"
#include "AudioBufferSourceNodeBinding.h"
#include "AudioContextBinding.h"
#include "AudioDestinationNodeBinding.h"
#include "AudioListenerBinding.h"
#include "AudioNodeBinding.h"
#include "AudioParamBinding.h"
#include "AudioProcessingEventBinding.h"
#include "AudioStreamTrackBinding.h"
#include "AudioTrackBinding.h"
#include "AudioTrackListBinding.h"
#include "AutocompleteErrorEventBinding.h"
#include "BarPropBinding.h"
#include "BatteryManagerBinding.h"
#include "BeforeAfterKeyboardEventBinding.h"
#include "BeforeUnloadEventBinding.h"
#include "BiquadFilterNodeBinding.h"
#include "BlobBinding.h"
#include "BlobEventBinding.h"
#include "BoxObjectBinding.h"
#include "BroadcastChannelBinding.h"
#include "BrowserElementAudioChannelBinding.h"
#include "BrowserElementProxyBinding.h"
#include "CDATASectionBinding.h"
#include "CFStateChangeEventBinding.h"
#include "CSS2PropertiesBinding.h"
#include "CSSAnimationBinding.h"
#include "CSSBinding.h"
#include "CSSLexerBinding.h"
#include "CSSPrimitiveValueBinding.h"
#include "CSSRuleListBinding.h"
#include "CSSStyleDeclarationBinding.h"
#include "CSSStyleSheetBinding.h"
#include "CSSTransitionBinding.h"
#include "CSSValueBinding.h"
#include "CSSValueListBinding.h"
#include "CacheBinding.h"
#include "CacheStorageBinding.h"
#include "CallEventBinding.h"
#include "CallGroupErrorEventBinding.h"
#include "CameraCapabilitiesBinding.h"
#include "CameraClosedEventBinding.h"
#include "CameraConfigurationEventBinding.h"
#include "CameraControlBinding.h"
#include "CameraFacesDetectedEventBinding.h"
#include "CameraManagerBinding.h"
#include "CameraStateChangeEventBinding.h"
#include "CanvasCaptureMediaStreamBinding.h"
#include "CanvasRenderingContext2DBinding.h"
#include "CaretPositionBinding.h"
#include "CaretStateChangedEventBinding.h"
#include "ChannelMergerNodeBinding.h"
#include "ChannelSplitterNodeBinding.h"
#include "CharacterDataBinding.h"
#include "ChromeNodeListBinding.h"
#include "ChromeNotificationsBinding.h"
#include "ChromeUtilsBinding.h"
#include "ClipboardEventBinding.h"
#include "CloseEventBinding.h"
#include "CommandEventBinding.h"
#include "CommentBinding.h"
#include "CompositionEventBinding.h"
#include "ConsoleBinding.h"
#include "ContactsBinding.h"
#include "ConvolverNodeBinding.h"
#include "CreateOfferRequestBinding.h"
#include "CryptoBinding.h"
#include "CustomEventBinding.h"
#include "DOMCursorBinding.h"
#include "DOMErrorBinding.h"
#include "DOMExceptionBinding.h"
#include "DOMImplementationBinding.h"
#include "DOMMatrixBinding.h"
#include "DOMMobileMessageErrorBinding.h"
#include "DOMParserBinding.h"
#include "DOMPointBinding.h"
#include "DOMQuadBinding.h"
#include "DOMRectBinding.h"
#include "DOMRectListBinding.h"
#include "DOMRequestBinding.h"
#include "DOMSettableTokenListBinding.h"
#include "DOMStringListBinding.h"
#include "DOMStringMapBinding.h"
#include "DOMTokenListBinding.h"
#include "DOMTransactionEventBinding.h"
#include "DataChannelBinding.h"
#include "DataContainerEventBinding.h"
#include "DataErrorEventBinding.h"
#include "DataStoreBinding.h"
#include "DataStoreChangeEventBinding.h"
#include "DataStoreImplBinding.h"
#include "DataTransferBinding.h"
#include "DelayNodeBinding.h"
#include "DesktopNotificationBinding.h"
#include "DeviceLightEventBinding.h"
#include "DeviceMotionEventBinding.h"
#include "DeviceOrientationEventBinding.h"
#include "DeviceProximityEventBinding.h"
#include "DeviceStorageAreaChangedEventBinding.h"
#include "DeviceStorageAreaListenerBinding.h"
#include "DeviceStorageBinding.h"
#include "DeviceStorageChangeEventBinding.h"
#include "DirectoryBinding.h"
#include "DisplayPortInputPortBinding.h"
#include "DocumentBinding.h"
#include "DocumentFragmentBinding.h"
#include "DocumentTimelineBinding.h"
#include "DocumentTypeBinding.h"
#include "DominatorTreeBinding.h"
#include "DownloadEventBinding.h"
#include "DownloadsBinding.h"
#include "DragEventBinding.h"
#include "DynamicsCompressorNodeBinding.h"
#include "ElementBinding.h"
#include "EngineeringModeBinding.h"
#include "ErrorEventBinding.h"
#include "EventBinding.h"
#include "EventSourceBinding.h"
#include "EventTargetBinding.h"
#include "ExternalAppEventBinding.h"
#include "FileBinding.h"
#include "FileListBinding.h"
#include "FileReaderBinding.h"
#include "FocusEventBinding.h"
#include "FontFaceBinding.h"
#include "FontFaceSetBinding.h"
#include "FontFaceSetLoadEventBinding.h"
#include "FormDataBinding.h"
#include "GainNodeBinding.h"
#include "GamepadAxisMoveEventBinding.h"
#include "GamepadBinding.h"
#include "GamepadButtonEventBinding.h"
#include "GamepadEventBinding.h"
#include "HDMIInputPortBinding.h"
#include "HTMLAllCollectionBinding.h"
#include "HTMLAnchorElementBinding.h"
#include "HTMLAppletElementBinding.h"
#include "HTMLAreaElementBinding.h"
#include "HTMLAudioElementBinding.h"
#include "HTMLBRElementBinding.h"
#include "HTMLBaseElementBinding.h"
#include "HTMLBodyElementBinding.h"
#include "HTMLButtonElementBinding.h"
#include "HTMLCanvasElementBinding.h"
#include "HTMLCollectionBinding.h"
#include "HTMLContentElementBinding.h"
#include "HTMLDListElementBinding.h"
#include "HTMLDataElementBinding.h"
#include "HTMLDataListElementBinding.h"
#include "HTMLDirectoryElementBinding.h"
#include "HTMLDivElementBinding.h"
#include "HTMLDocumentBinding.h"
#include "HTMLElementBinding.h"
#include "HTMLEmbedElementBinding.h"
#include "HTMLExtAppElementBinding.h"
#include "HTMLFieldSetElementBinding.h"
#include "HTMLFontElementBinding.h"
#include "HTMLFormControlsCollectionBinding.h"
#include "HTMLFormElementBinding.h"
#include "HTMLFrameElementBinding.h"
#include "HTMLFrameSetElementBinding.h"
#include "HTMLHRElementBinding.h"
#include "HTMLHeadElementBinding.h"
#include "HTMLHeadingElementBinding.h"
#include "HTMLHtmlElementBinding.h"
#include "HTMLIFrameElementBinding.h"
#include "HTMLImageElementBinding.h"
#include "HTMLInputElementBinding.h"
#include "HTMLLIElementBinding.h"
#include "HTMLLabelElementBinding.h"
#include "HTMLLegendElementBinding.h"
#include "HTMLLinkElementBinding.h"
#include "HTMLMapElementBinding.h"
#include "HTMLMediaElementBinding.h"
#include "HTMLMenuElementBinding.h"
#include "HTMLMenuItemElementBinding.h"
#include "HTMLMetaElementBinding.h"
#include "HTMLMeterElementBinding.h"
#include "HTMLModElementBinding.h"
#include "HTMLOListElementBinding.h"
#include "HTMLObjectElementBinding.h"
#include "HTMLOptGroupElementBinding.h"
#include "HTMLOptionElementBinding.h"
#include "HTMLOptionsCollectionBinding.h"
#include "HTMLOutputElementBinding.h"
#include "HTMLParagraphElementBinding.h"
#include "HTMLParamElementBinding.h"
#include "HTMLPictureElementBinding.h"
#include "HTMLPreElementBinding.h"
#include "HTMLProgressElementBinding.h"
#include "HTMLPropertiesCollectionBinding.h"
#include "HTMLQuoteElementBinding.h"
#include "HTMLScriptElementBinding.h"
#include "HTMLSelectElementBinding.h"
#include "HTMLShadowElementBinding.h"
#include "HTMLSourceElementBinding.h"
#include "HTMLSpanElementBinding.h"
#include "HTMLStyleElementBinding.h"
#include "HTMLTableCaptionElementBinding.h"
#include "HTMLTableCellElementBinding.h"
#include "HTMLTableColElementBinding.h"
#include "HTMLTableElementBinding.h"
#include "HTMLTableRowElementBinding.h"
#include "HTMLTableSectionElementBinding.h"
#include "HTMLTemplateElementBinding.h"
#include "HTMLTextAreaElementBinding.h"
#include "HTMLTimeElementBinding.h"
#include "HTMLTitleElementBinding.h"
#include "HTMLTrackElementBinding.h"
#include "HTMLUListElementBinding.h"
#include "HTMLVideoElementBinding.h"
#include "HashChangeEventBinding.h"
#include "HeadersBinding.h"
#include "HeapSnapshotBinding.h"
#include "HistoryBinding.h"
#include "IDBCursorBinding.h"
#include "IDBDatabaseBinding.h"
#include "IDBFactoryBinding.h"
#include "IDBFileHandleBinding.h"
#include "IDBFileRequestBinding.h"
#include "IDBIndexBinding.h"
#include "IDBKeyRangeBinding.h"
#include "IDBMutableFileBinding.h"
#include "IDBObjectStoreBinding.h"
#include "IDBOpenDBRequestBinding.h"
#include "IDBRequestBinding.h"
#include "IDBTransactionBinding.h"
#include "IDBVersionChangeEventBinding.h"
#include "IccCardLockErrorBinding.h"
#include "IccChangeEventBinding.h"
#include "ImageBitmapBinding.h"
#include "ImageCaptureBinding.h"
#include "ImageCaptureErrorEventBinding.h"
#include "ImageDataBinding.h"
#include "ImageDocumentBinding.h"
#include "InputEventBinding.h"
#include "InputMethodBinding.h"
#include "InputPortBinding.h"
#include "InputPortManagerBinding.h"
#include "InstallTriggerBinding.h"
#include "InterAppConnectionBinding.h"
#include "InterAppConnectionRequestBinding.h"
#include "InterAppMessagePortBinding.h"
#include "KeyEventBinding.h"
#include "KeyboardEventBinding.h"
#include "KeyframeEffectBinding.h"
#include "KillSwitchBinding.h"
#include "LocalMediaStreamBinding.h"
#include "LocationBinding.h"
#include "MMICallBinding.h"
#include "MediaDeviceInfoBinding.h"
#include "MediaDevicesBinding.h"
#include "MediaElementAudioSourceNodeBinding.h"
#include "MediaEncryptedEventBinding.h"
#include "MediaErrorBinding.h"
#include "MediaKeyErrorBinding.h"
#include "MediaKeyMessageEventBinding.h"
#include "MediaKeySessionBinding.h"
#include "MediaKeyStatusMapBinding.h"
#include "MediaKeySystemAccessBinding.h"
#include "MediaKeysBinding.h"
#include "MediaListBinding.h"
#include "MediaQueryListBinding.h"
#include "MediaRecorderBinding.h"
#include "MediaSourceBinding.h"
#include "MediaStreamAudioDestinationNodeBinding.h"
#include "MediaStreamAudioSourceNodeBinding.h"
#include "MediaStreamBinding.h"
#include "MediaStreamEventBinding.h"
#include "MediaStreamListBinding.h"
#include "MediaStreamTrackBinding.h"
#include "MediaStreamTrackEventBinding.h"
#include "MenuBoxObjectBinding.h"
#include "MessageChannelBinding.h"
#include "MessageEventBinding.h"
#include "MessagePortBinding.h"
#include "MimeTypeArrayBinding.h"
#include "MimeTypeBinding.h"
#include "MmsMessageBinding.h"
#include "MobileMessageThreadBinding.h"
#include "MouseEventBinding.h"
#include "MouseScrollEventBinding.h"
#include "MozActivityBinding.h"
#include "MozApplicationEventBinding.h"
#include "MozCellBroadcastBinding.h"
#include "MozCellBroadcastEventBinding.h"
#include "MozCellBroadcastMessageBinding.h"
#include "MozClirModeEventBinding.h"
#include "MozContactChangeEventBinding.h"
#include "MozEmergencyCbModeEventBinding.h"
#include "MozIccBinding.h"
#include "MozIccInfoBinding.h"
#include "MozIccManagerBinding.h"
#include "MozInterAppMessageEventBinding.h"
#include "MozMessageDeletedEventBinding.h"
#include "MozMmsEventBinding.h"
#include "MozMobileCellInfoBinding.h"
#include "MozMobileConnectionArrayBinding.h"
#include "MozMobileConnectionBinding.h"
#include "MozMobileConnectionInfoBinding.h"
#include "MozMobileMessageManagerBinding.h"
#include "MozMobileNetworkInfoBinding.h"
#include "MozOtaStatusEventBinding.h"
#include "MozPowerManagerBinding.h"
#include "MozSelfSupportBinding.h"
#include "MozSettingsEventBinding.h"
#include "MozSettingsTransactionEventBinding.h"
#include "MozSmsEventBinding.h"
#include "MozStkCommandEventBinding.h"
#include "MozTetheringManagerBinding.h"
#include "MozTimeManagerBinding.h"
#include "MozVoicemailBinding.h"
#include "MozVoicemailEventBinding.h"
#include "MozVoicemailStatusBinding.h"
#include "MozWakeLockBinding.h"
#include "MutationEventBinding.h"
#include "MutationObserverBinding.h"
#include "NamedNodeMapBinding.h"
#include "NavigatorBinding.h"
#include "NetworkInformationBinding.h"
#include "NodeBinding.h"
#include "NodeFilterBinding.h"
#include "NodeIteratorBinding.h"
#include "NodeListBinding.h"
#include "NotificationBinding.h"
#include "NotifyPaintEventBinding.h"
#include "OfflineAudioCompletionEventBinding.h"
#include "OfflineAudioContextBinding.h"
#include "OfflineResourceListBinding.h"
#include "OffscreenCanvasBinding.h"
#include "OscillatorNodeBinding.h"
#include "PageTransitionEventBinding.h"
#include "PaintRequestBinding.h"
#include "PaintRequestListBinding.h"
#include "PannerNodeBinding.h"
#include "PeerConnectionImplBinding.h"
#include "PeerConnectionObserverBinding.h"
#include "PerformanceBinding.h"
#include "PerformanceCompositeTimingBinding.h"
#include "PerformanceEntryBinding.h"
#include "PerformanceEntryEventBinding.h"
#include "PerformanceMarkBinding.h"
#include "PerformanceMeasureBinding.h"
#include "PerformanceNavigationBinding.h"
#include "PerformanceObserverBinding.h"
#include "PerformanceObserverEntryListBinding.h"
#include "PerformanceRenderTimingBinding.h"
#include "PerformanceResourceTimingBinding.h"
#include "PerformanceTimingBinding.h"
#include "PeriodicWaveBinding.h"
#include "PermissionSettingsBinding.h"
#include "PermissionStatusBinding.h"
#include "PermissionsBinding.h"
#include "PhoneNumberServiceBinding.h"
#include "PluginArrayBinding.h"
#include "PluginBinding.h"
#include "PluginCrashedEventBinding.h"
#include "PointerEventBinding.h"
#include "PopStateEventBinding.h"
#include "PopupBlockedEventBinding.h"
#include "PopupBoxObjectBinding.h"
#include "PresentationAvailabilityBinding.h"
#include "PresentationBinding.h"
#include "PresentationConnectionAvailableEventBinding.h"
#include "PresentationConnectionBinding.h"
#include "PresentationDeviceInfoManagerBinding.h"
#include "PresentationReceiverBinding.h"
#include "PresentationRequestBinding.h"
#include "ProcessingInstructionBinding.h"
#include "ProgressEventBinding.h"
#include "PromiseBinding.h"
#include "PromiseDebuggingBinding.h"
#include "PushManagerBinding.h"
#include "PushSubscriptionBinding.h"
#include "RGBColorBinding.h"
#include "RTCCertificateBinding.h"
#include "RTCDataChannelEventBinding.h"
#include "RTCIceCandidateBinding.h"
#include "RTCPeerConnectionBinding.h"
#include "RTCPeerConnectionIceEventBinding.h"
#include "RTCPeerConnectionStaticBinding.h"
#include "RTCRtpReceiverBinding.h"
#include "RTCRtpSenderBinding.h"
#include "RTCSessionDescriptionBinding.h"
#include "RTCStatsReportBinding.h"
#include "RadioNodeListBinding.h"
#include "RangeBinding.h"
#include "RecordErrorEventBinding.h"
#include "RectBinding.h"
#include "RequestBinding.h"
#include "RequestSyncManagerBinding.h"
#include "RequestSyncSchedulerBinding.h"
#include "ResourceStatsBinding.h"
#include "ResourceStatsManagerBinding.h"
#include "ResponseBinding.h"
#include "SVGAElementBinding.h"
#include "SVGAltGlyphElementBinding.h"
#include "SVGAngleBinding.h"
#include "SVGAnimateElementBinding.h"
#include "SVGAnimateMotionElementBinding.h"
#include "SVGAnimateTransformElementBinding.h"
#include "SVGAnimatedAngleBinding.h"
#include "SVGAnimatedBooleanBinding.h"
#include "SVGAnimatedEnumerationBinding.h"
#include "SVGAnimatedIntegerBinding.h"
#include "SVGAnimatedLengthBinding.h"
#include "SVGAnimatedLengthListBinding.h"
#include "SVGAnimatedNumberBinding.h"
#include "SVGAnimatedNumberListBinding.h"
#include "SVGAnimatedPreserveAspectRatioBinding.h"
#include "SVGAnimatedRectBinding.h"
#include "SVGAnimatedStringBinding.h"
#include "SVGAnimatedTransformListBinding.h"
#include "SVGAnimationElementBinding.h"
#include "SVGCircleElementBinding.h"
#include "SVGClipPathElementBinding.h"
#include "SVGComponentTransferFunctionElementBinding.h"
#include "SVGDefsElementBinding.h"
#include "SVGDescElementBinding.h"
#include "SVGDocumentBinding.h"
#include "SVGElementBinding.h"
#include "SVGEllipseElementBinding.h"
#include "SVGFEBlendElementBinding.h"
#include "SVGFEColorMatrixElementBinding.h"
#include "SVGFEComponentTransferElementBinding.h"
#include "SVGFECompositeElementBinding.h"
#include "SVGFEConvolveMatrixElementBinding.h"
#include "SVGFEDiffuseLightingElementBinding.h"
#include "SVGFEDisplacementMapElementBinding.h"
#include "SVGFEDistantLightElementBinding.h"
#include "SVGFEDropShadowElementBinding.h"
#include "SVGFEFloodElementBinding.h"
#include "SVGFEFuncAElementBinding.h"
#include "SVGFEFuncBElementBinding.h"
#include "SVGFEFuncGElementBinding.h"
#include "SVGFEFuncRElementBinding.h"
#include "SVGFEGaussianBlurElementBinding.h"
#include "SVGFEImageElementBinding.h"
#include "SVGFEMergeElementBinding.h"
#include "SVGFEMergeNodeElementBinding.h"
#include "SVGFEMorphologyElementBinding.h"
#include "SVGFEOffsetElementBinding.h"
#include "SVGFEPointLightElementBinding.h"
#include "SVGFESpecularLightingElementBinding.h"
#include "SVGFESpotLightElementBinding.h"
#include "SVGFETileElementBinding.h"
#include "SVGFETurbulenceElementBinding.h"
#include "SVGFilterElementBinding.h"
#include "SVGForeignObjectElementBinding.h"
#include "SVGGElementBinding.h"
#include "SVGGradientElementBinding.h"
#include "SVGGraphicsElementBinding.h"
#include "SVGImageElementBinding.h"
#include "SVGLengthBinding.h"
#include "SVGLengthListBinding.h"
#include "SVGLineElementBinding.h"
#include "SVGLinearGradientElementBinding.h"
#include "SVGMPathElementBinding.h"
#include "SVGMarkerElementBinding.h"
#include "SVGMaskElementBinding.h"
#include "SVGMatrixBinding.h"
#include "SVGMetadataElementBinding.h"
#include "SVGNumberBinding.h"
#include "SVGNumberListBinding.h"
#include "SVGPathElementBinding.h"
#include "SVGPathSegBinding.h"
#include "SVGPathSegListBinding.h"
#include "SVGPatternElementBinding.h"
#include "SVGPointBinding.h"
#include "SVGPointListBinding.h"
#include "SVGPolygonElementBinding.h"
#include "SVGPolylineElementBinding.h"
#include "SVGPreserveAspectRatioBinding.h"
#include "SVGRadialGradientElementBinding.h"
#include "SVGRectBinding.h"
#include "SVGRectElementBinding.h"
#include "SVGSVGElementBinding.h"
#include "SVGScriptElementBinding.h"
#include "SVGSetElementBinding.h"
#include "SVGStopElementBinding.h"
#include "SVGStringListBinding.h"
#include "SVGStyleElementBinding.h"
#include "SVGSwitchElementBinding.h"
#include "SVGSymbolElementBinding.h"
#include "SVGTSpanElementBinding.h"
#include "SVGTextContentElementBinding.h"
#include "SVGTextElementBinding.h"
#include "SVGTextPathElementBinding.h"
#include "SVGTextPositioningElementBinding.h"
#include "SVGTitleElementBinding.h"
#include "SVGTransformBinding.h"
#include "SVGTransformListBinding.h"
#include "SVGUnitTypesBinding.h"
#include "SVGUseElementBinding.h"
#include "SVGViewElementBinding.h"
#include "SVGZoomAndPanBinding.h"
#include "SVGZoomEventBinding.h"
#include "ScreenBinding.h"
#include "ScreenOrientationBinding.h"
#include "ScriptProcessorNodeBinding.h"
#include "ScrollAreaEventBinding.h"
#include "ScrollViewChangeEventBinding.h"
#include "SecureElementBinding.h"
#include "SecureElementManagerBinding.h"
#include "SelectionBinding.h"
#include "SelectionStateChangedEventBinding.h"
#include "ServiceWorkerBinding.h"
#include "ServiceWorkerContainerBinding.h"
#include "ServiceWorkerMessageEventBinding.h"
#include "ServiceWorkerRegistrationBinding.h"
#include "SettingsManagerBinding.h"
#include "ShadowRootBinding.h"
#include "SharedWorkerBinding.h"
#include "SimpleGestureEventBinding.h"
#include "SmsMessageBinding.h"
#include "SourceBufferBinding.h"
#include "SourceBufferListBinding.h"
#include "SpeechGrammarBinding.h"
#include "SpeechGrammarListBinding.h"
#include "SpeechRecognitionAlternativeBinding.h"
#include "SpeechRecognitionBinding.h"
#include "SpeechRecognitionErrorBinding.h"
#include "SpeechRecognitionEventBinding.h"
#include "SpeechRecognitionResultBinding.h"
#include "SpeechRecognitionResultListBinding.h"
#include "SpeechSynthesisBinding.h"
#include "SpeechSynthesisErrorEventBinding.h"
#include "SpeechSynthesisEventBinding.h"
#include "SpeechSynthesisUtteranceBinding.h"
#include "SpeechSynthesisVoiceBinding.h"
#include "StereoPannerNodeBinding.h"
#include "StorageBinding.h"
#include "StorageEventBinding.h"
#include "StyleRuleChangeEventBinding.h"
#include "StyleSheetApplicableStateChangeEventBinding.h"
#include "StyleSheetBinding.h"
#include "StyleSheetChangeEventBinding.h"
#include "StyleSheetListBinding.h"
#include "SubtleCryptoBinding.h"
#include "SystemUpdateBinding.h"
#include "TCPServerSocketBinding.h"
#include "TCPServerSocketEventBinding.h"
#include "TCPSocketBinding.h"
#include "TCPSocketErrorEventBinding.h"
#include "TCPSocketEventBinding.h"
#include "TVChannelBinding.h"
#include "TVCurrentChannelChangedEventBinding.h"
#include "TVCurrentSourceChangedEventBinding.h"
#include "TVEITBroadcastedEventBinding.h"
#include "TVManagerBinding.h"
#include "TVProgramBinding.h"
#include "TVScanningStateChangedEventBinding.h"
#include "TVSourceBinding.h"
#include "TVTunerBinding.h"
#include "TelephonyBinding.h"
#include "TelephonyCallBinding.h"
#include "TelephonyCallGroupBinding.h"
#include "TelephonyCallIdBinding.h"
#include "TextBinding.h"
#include "TextDecoderBinding.h"
#include "TextEncoderBinding.h"
#include "TextTrackBinding.h"
#include "TextTrackCueBinding.h"
#include "TextTrackCueListBinding.h"
#include "TextTrackListBinding.h"
#include "ThreadSafeChromeUtilsBinding.h"
#include "TimeEventBinding.h"
#include "TimeRangesBinding.h"
#include "TouchBinding.h"
#include "TouchEventBinding.h"
#include "TouchListBinding.h"
#include "TrackEventBinding.h"
#include "TransitionEventBinding.h"
#include "TreeColumnBinding.h"
#include "TreeColumnsBinding.h"
#include "TreeWalkerBinding.h"
#include "UDPMessageEventBinding.h"
#include "UDPSocketBinding.h"
#include "UIEventBinding.h"
#include "URLBinding.h"
#include "URLSearchParamsBinding.h"
#include "USSDReceivedEventBinding.h"
#include "USSDSessionBinding.h"
#include "UndoManagerBinding.h"
#include "UserProximityEventBinding.h"
#include "VRDeviceBinding.h"
#include "VTTCueBinding.h"
#include "VTTRegionBinding.h"
#include "ValidityStateBinding.h"
#include "VideoPlaybackQualityBinding.h"
#include "VideoStreamTrackBinding.h"
#include "VideoTrackBinding.h"
#include "VideoTrackListBinding.h"
#include "WaveShaperNodeBinding.h"
#include "WebGL2RenderingContextBinding.h"
#include "WebGLRenderingContextBinding.h"
#include "WebSocketBinding.h"
#include "WebrtcDeprecatedBinding.h"
#include "WebrtcGlobalInformationBinding.h"
#include "WheelEventBinding.h"
#include "WindowBinding.h"
#include "WindowRootBinding.h"
#include "WorkerBinding.h"
#include "XMLDocumentBinding.h"
#include "XMLHttpRequestBinding.h"
#include "XMLHttpRequestEventTargetBinding.h"
#include "XMLHttpRequestUploadBinding.h"
#include "XMLSerializerBinding.h"
#include "XMLStylesheetProcessingInstructionBinding.h"
#include "XPathEvaluatorBinding.h"
#include "XPathExpressionBinding.h"
#include "XPathResultBinding.h"
#include "XSLTProcessorBinding.h"
#include "XULCommandEventBinding.h"
#include "XULDocumentBinding.h"
#include "XULElementBinding.h"
#include "nsScriptNameSpaceManager.h"

namespace mozilla {
namespace dom {
void
Register(nsScriptNameSpaceManager* aNameSpaceManager)
{

#define REGISTER_PROTO(_dom_class, _ctor_check) \
  aNameSpaceManager->RegisterDefineDOMInterface(MOZ_UTF16(#_dom_class), _dom_class##Binding::DefineDOMInterface, _ctor_check);
#define REGISTER_CONSTRUCTOR(_dom_constructor, _dom_class, _ctor_check) \
  aNameSpaceManager->RegisterDefineDOMInterface(MOZ_UTF16(#_dom_constructor), _dom_class##Binding::DefineDOMInterface, _ctor_check);
#define REGISTER_NAVIGATOR_CONSTRUCTOR(_prop, _dom_class, _ctor_check) \
  aNameSpaceManager->RegisterNavigatorDOMConstructor(MOZ_UTF16(_prop), _dom_class##Binding::ConstructNavigatorObject, _ctor_check);

REGISTER_PROTO(AVInputPort, AVInputPortBinding::ConstructorEnabled);
REGISTER_PROTO(ActivityRequestHandler, ActivityRequestHandlerBinding::ConstructorEnabled);
REGISTER_PROTO(AlarmsManager, AlarmsManagerBinding::ConstructorEnabled);
REGISTER_PROTO(AnalyserNode, nullptr);
REGISTER_PROTO(Animation, AnimationBinding::ConstructorEnabled);
REGISTER_PROTO(AnimationEffectReadOnly, AnimationEffectReadOnlyBinding::ConstructorEnabled);
REGISTER_PROTO(AnimationEvent, nullptr);
REGISTER_PROTO(AnimationPlaybackEvent, AnimationPlaybackEventBinding::ConstructorEnabled);
REGISTER_PROTO(AnimationTimeline, AnimationTimelineBinding::ConstructorEnabled);
REGISTER_PROTO(AnonymousContent, AnonymousContentBinding::ConstructorEnabled);
REGISTER_PROTO(ArchiveReader, ArchiveReaderBinding::ConstructorEnabled);
REGISTER_PROTO(ArchiveRequest, ArchiveRequestBinding::ConstructorEnabled);
REGISTER_PROTO(Attr, nullptr);
REGISTER_PROTO(AudioBuffer, nullptr);
REGISTER_PROTO(AudioBufferSourceNode, nullptr);
REGISTER_PROTO(AudioContext, nullptr);
REGISTER_PROTO(AudioDestinationNode, nullptr);
REGISTER_PROTO(AudioListener, nullptr);
REGISTER_PROTO(AudioNode, nullptr);
REGISTER_PROTO(AudioParam, nullptr);
REGISTER_PROTO(AudioProcessingEvent, nullptr);
REGISTER_PROTO(AudioStreamTrack, nullptr);
REGISTER_PROTO(AudioTrack, AudioTrackBinding::ConstructorEnabled);
REGISTER_PROTO(AudioTrackList, AudioTrackListBinding::ConstructorEnabled);
REGISTER_PROTO(AutocompleteErrorEvent, AutocompleteErrorEventBinding::ConstructorEnabled);
REGISTER_PROTO(BarProp, nullptr);
REGISTER_PROTO(BatteryManager, nullptr);
REGISTER_PROTO(BeforeAfterKeyboardEvent, BeforeAfterKeyboardEventBinding::ConstructorEnabled);
REGISTER_PROTO(BeforeUnloadEvent, nullptr);
REGISTER_PROTO(BiquadFilterNode, nullptr);
REGISTER_PROTO(Blob, nullptr);
REGISTER_PROTO(BlobEvent, nullptr);
REGISTER_PROTO(BoxObject, BoxObjectBinding::ConstructorEnabled);
REGISTER_PROTO(BroadcastChannel, nullptr);
REGISTER_PROTO(BrowserElementAudioChannel, BrowserElementAudioChannelBinding::ConstructorEnabled);
REGISTER_PROTO(BrowserElementProxy, BrowserElementProxyBinding::ConstructorEnabled);
REGISTER_PROTO(CDATASection, nullptr);
REGISTER_PROTO(CFStateChangeEvent, CFStateChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(CSS, nullptr);
REGISTER_PROTO(CSS2Properties, nullptr);
REGISTER_PROTO(CSSAnimation, CSSAnimationBinding::ConstructorEnabled);
REGISTER_PROTO(CSSLexer, CSSLexerBinding::ConstructorEnabled);
REGISTER_PROTO(CSSPrimitiveValue, nullptr);
REGISTER_PROTO(CSSRuleList, nullptr);
REGISTER_PROTO(CSSStyleDeclaration, nullptr);
REGISTER_PROTO(CSSStyleSheet, nullptr);
REGISTER_PROTO(CSSTransition, CSSTransitionBinding::ConstructorEnabled);
REGISTER_PROTO(CSSValue, nullptr);
REGISTER_PROTO(CSSValueList, nullptr);
REGISTER_PROTO(Cache, CacheBinding::ConstructorEnabled);
REGISTER_PROTO(CacheStorage, CacheStorageBinding::ConstructorEnabled);
REGISTER_PROTO(CallEvent, CallEventBinding::ConstructorEnabled);
REGISTER_PROTO(CallGroupErrorEvent, CallGroupErrorEventBinding::ConstructorEnabled);
REGISTER_PROTO(CameraCapabilities, CameraCapabilitiesBinding::ConstructorEnabled);
REGISTER_PROTO(CameraClosedEvent, CameraClosedEventBinding::ConstructorEnabled);
REGISTER_PROTO(CameraConfigurationEvent, CameraConfigurationEventBinding::ConstructorEnabled);
REGISTER_PROTO(CameraControl, CameraControlBinding::ConstructorEnabled);
REGISTER_PROTO(CameraDetectedFace, CameraDetectedFaceBinding::ConstructorEnabled);
REGISTER_PROTO(CameraFacesDetectedEvent, CameraFacesDetectedEventBinding::ConstructorEnabled);
REGISTER_PROTO(CameraManager, CameraManagerBinding::ConstructorEnabled);
REGISTER_PROTO(CameraRecorderAudioProfile, CameraRecorderAudioProfileBinding::ConstructorEnabled);
REGISTER_PROTO(CameraRecorderProfile, CameraRecorderProfileBinding::ConstructorEnabled);
REGISTER_PROTO(CameraRecorderProfiles, CameraRecorderProfilesBinding::ConstructorEnabled);
REGISTER_PROTO(CameraRecorderVideoProfile, CameraRecorderVideoProfileBinding::ConstructorEnabled);
REGISTER_PROTO(CameraStateChangeEvent, CameraStateChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(CanvasCaptureMediaStream, CanvasCaptureMediaStreamBinding::ConstructorEnabled);
REGISTER_PROTO(CanvasGradient, nullptr);
REGISTER_PROTO(CanvasPattern, nullptr);
REGISTER_PROTO(CanvasRenderingContext2D, nullptr);
REGISTER_PROTO(CaretPosition, nullptr);
REGISTER_PROTO(CaretStateChangedEvent, CaretStateChangedEventBinding::ConstructorEnabled);
REGISTER_PROTO(ChannelMergerNode, nullptr);
REGISTER_PROTO(ChannelSplitterNode, nullptr);
REGISTER_PROTO(CharacterData, nullptr);
REGISTER_PROTO(ChromeNodeList, ChromeNodeListBinding::ConstructorEnabled);
REGISTER_PROTO(ChromeNotifications, ChromeNotificationsBinding::ConstructorEnabled);
REGISTER_PROTO(ChromeUtils, ChromeUtilsBinding::ConstructorEnabled);
REGISTER_PROTO(ChromeWindow, ChromeWindowBinding::ConstructorEnabled);
REGISTER_PROTO(ChromeWorker, ChromeWorkerBinding::ConstructorEnabled);
REGISTER_PROTO(ClipboardEvent, nullptr);
REGISTER_PROTO(CloseEvent, nullptr);
REGISTER_PROTO(CommandEvent, nullptr);
REGISTER_PROTO(Comment, nullptr);
REGISTER_PROTO(CompositionEvent, nullptr);
REGISTER_PROTO(Console, ConsoleBinding::ConstructorEnabled);
REGISTER_PROTO(ConvolverNode, nullptr);
REGISTER_PROTO(CreateOfferRequest, CreateOfferRequestBinding::ConstructorEnabled);
REGISTER_PROTO(Crypto, nullptr);
REGISTER_PROTO(CryptoKey, nullptr);
REGISTER_PROTO(CustomEvent, nullptr);
REGISTER_PROTO(DOMApplication, DOMApplicationBinding::ConstructorEnabled);
REGISTER_PROTO(DOMApplicationsManager, DOMApplicationsManagerBinding::ConstructorEnabled);
REGISTER_PROTO(DOMCursor, nullptr);
REGISTER_PROTO(DOMDownload, DOMDownloadBinding::ConstructorEnabled);
REGISTER_PROTO(DOMError, nullptr);
REGISTER_PROTO(DOMException, nullptr);
REGISTER_PROTO(DOMImplementation, nullptr);
REGISTER_PROTO(DOMMatrix, DOMMatrixBinding::ConstructorEnabled);
REGISTER_PROTO(DOMMatrixReadOnly, DOMMatrixReadOnlyBinding::ConstructorEnabled);
REGISTER_PROTO(DOMMobileMessageError, DOMMobileMessageErrorBinding::ConstructorEnabled);
REGISTER_PROTO(DOMParser, nullptr);
REGISTER_PROTO(DOMPoint, DOMPointBinding::ConstructorEnabled);
REGISTER_PROTO(DOMPointReadOnly, DOMPointReadOnlyBinding::ConstructorEnabled);
REGISTER_PROTO(DOMQuad, DOMQuadBinding::ConstructorEnabled);
REGISTER_PROTO(DOMRect, nullptr);
REGISTER_PROTO(DOMRectList, nullptr);
REGISTER_PROTO(DOMRectReadOnly, nullptr);
REGISTER_PROTO(DOMRequest, nullptr);
REGISTER_PROTO(DOMSettableTokenList, nullptr);
REGISTER_PROTO(DOMStringList, nullptr);
REGISTER_PROTO(DOMStringMap, nullptr);
REGISTER_PROTO(DOMTokenList, nullptr);
REGISTER_PROTO(DOMTransactionEvent, nullptr);
REGISTER_PROTO(DataChannel, nullptr);
REGISTER_PROTO(DataContainerEvent, DataContainerEventBinding::ConstructorEnabled);
REGISTER_PROTO(DataErrorEvent, DataErrorEventBinding::ConstructorEnabled);
REGISTER_PROTO(DataStore, DataStoreBinding::ConstructorEnabled);
REGISTER_PROTO(DataStoreChangeEvent, DataStoreChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(DataStoreCursor, DataStoreCursorBinding::ConstructorEnabled);
REGISTER_PROTO(DataStoreCursorImpl, DataStoreCursorImplBinding::ConstructorEnabled);
REGISTER_PROTO(DataStoreImpl, DataStoreImplBinding::ConstructorEnabled);
REGISTER_PROTO(DataTransfer, nullptr);
REGISTER_PROTO(DelayNode, nullptr);
REGISTER_PROTO(DesktopNotification, nullptr);
REGISTER_PROTO(DesktopNotificationCenter, nullptr);
REGISTER_PROTO(DeviceLightEvent, nullptr);
REGISTER_PROTO(DeviceMotionEvent, nullptr);
REGISTER_PROTO(DeviceOrientationEvent, nullptr);
REGISTER_PROTO(DeviceProximityEvent, nullptr);
REGISTER_PROTO(DeviceStorage, DeviceStorageBinding::ConstructorEnabled);
REGISTER_PROTO(DeviceStorageAreaChangedEvent, DeviceStorageAreaChangedEventBinding::ConstructorEnabled);
REGISTER_PROTO(DeviceStorageAreaListener, DeviceStorageAreaListenerBinding::ConstructorEnabled);
REGISTER_PROTO(DeviceStorageChangeEvent, DeviceStorageChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(Directory, nullptr);
REGISTER_PROTO(DisplayPortInputPort, DisplayPortInputPortBinding::ConstructorEnabled);
REGISTER_PROTO(Document, nullptr);
REGISTER_PROTO(DocumentFragment, nullptr);
REGISTER_PROTO(DocumentTimeline, DocumentTimelineBinding::ConstructorEnabled);
REGISTER_PROTO(DocumentType, nullptr);
REGISTER_PROTO(DominatorTree, DominatorTreeBinding::ConstructorEnabled);
REGISTER_PROTO(DownloadEvent, DownloadEventBinding::ConstructorEnabled);
REGISTER_PROTO(DragEvent, nullptr);
REGISTER_PROTO(DynamicsCompressorNode, nullptr);
REGISTER_PROTO(Element, nullptr);
REGISTER_PROTO(EngineeringMode, EngineeringModeBinding::ConstructorEnabled);
REGISTER_PROTO(ErrorEvent, nullptr);
REGISTER_PROTO(Event, nullptr);
REGISTER_PROTO(EventSource, EventSourceBinding::ConstructorEnabled);
REGISTER_PROTO(EventTarget, nullptr);
REGISTER_PROTO(ExternalAppEvent, ExternalAppEventBinding::ConstructorEnabled);
REGISTER_PROTO(File, nullptr);
REGISTER_PROTO(FileList, nullptr);
REGISTER_PROTO(FileReader, nullptr);
REGISTER_PROTO(FocusEvent, nullptr);
REGISTER_PROTO(FontFace, FontFaceBinding::ConstructorEnabled);
REGISTER_PROTO(FontFaceSet, FontFaceSetBinding::ConstructorEnabled);
REGISTER_PROTO(FontFaceSetLoadEvent, FontFaceSetLoadEventBinding::ConstructorEnabled);
REGISTER_PROTO(FormData, nullptr);
REGISTER_PROTO(GainNode, nullptr);
REGISTER_PROTO(Gamepad, GamepadBinding::ConstructorEnabled);
REGISTER_PROTO(GamepadAxisMoveEvent, GamepadAxisMoveEventBinding::ConstructorEnabled);
REGISTER_PROTO(GamepadButton, GamepadButtonBinding::ConstructorEnabled);
REGISTER_PROTO(GamepadButtonEvent, GamepadButtonEventBinding::ConstructorEnabled);
REGISTER_PROTO(GamepadEvent, GamepadEventBinding::ConstructorEnabled);
REGISTER_PROTO(HDMIInputPort, HDMIInputPortBinding::ConstructorEnabled);
REGISTER_PROTO(HMDVRDevice, HMDVRDeviceBinding::ConstructorEnabled);
REGISTER_PROTO(HTMLAllCollection, nullptr);
REGISTER_PROTO(HTMLAnchorElement, nullptr);
REGISTER_PROTO(HTMLAppletElement, nullptr);
REGISTER_PROTO(HTMLAreaElement, nullptr);
REGISTER_PROTO(HTMLAudioElement, nullptr);
REGISTER_CONSTRUCTOR(Audio, HTMLAudioElement, nullptr);
REGISTER_PROTO(HTMLBRElement, nullptr);
REGISTER_PROTO(HTMLBaseElement, nullptr);
REGISTER_PROTO(HTMLBodyElement, nullptr);
REGISTER_PROTO(HTMLButtonElement, nullptr);
REGISTER_PROTO(HTMLCanvasElement, nullptr);
REGISTER_PROTO(HTMLCollection, nullptr);
REGISTER_PROTO(HTMLContentElement, nullptr);
REGISTER_PROTO(HTMLDListElement, nullptr);
REGISTER_PROTO(HTMLDataElement, nullptr);
REGISTER_PROTO(HTMLDataListElement, nullptr);
REGISTER_PROTO(HTMLDirectoryElement, nullptr);
REGISTER_PROTO(HTMLDivElement, nullptr);
REGISTER_PROTO(HTMLDocument, nullptr);
REGISTER_PROTO(HTMLElement, nullptr);
REGISTER_PROTO(HTMLEmbedElement, nullptr);
REGISTER_PROTO(HTMLExtAppElement, HTMLExtAppElementBinding::ConstructorEnabled);
REGISTER_PROTO(HTMLFieldSetElement, nullptr);
REGISTER_PROTO(HTMLFontElement, nullptr);
REGISTER_PROTO(HTMLFormControlsCollection, nullptr);
REGISTER_PROTO(HTMLFormElement, nullptr);
REGISTER_PROTO(HTMLFrameElement, nullptr);
REGISTER_PROTO(HTMLFrameSetElement, nullptr);
REGISTER_PROTO(HTMLHRElement, nullptr);
REGISTER_PROTO(HTMLHeadElement, nullptr);
REGISTER_PROTO(HTMLHeadingElement, nullptr);
REGISTER_PROTO(HTMLHtmlElement, nullptr);
REGISTER_PROTO(HTMLIFrameElement, nullptr);
REGISTER_PROTO(HTMLImageElement, nullptr);
REGISTER_CONSTRUCTOR(Image, HTMLImageElement, nullptr);
REGISTER_PROTO(HTMLInputElement, nullptr);
REGISTER_PROTO(HTMLLIElement, nullptr);
REGISTER_PROTO(HTMLLabelElement, nullptr);
REGISTER_PROTO(HTMLLegendElement, nullptr);
REGISTER_PROTO(HTMLLinkElement, nullptr);
REGISTER_PROTO(HTMLMapElement, nullptr);
REGISTER_PROTO(HTMLMediaElement, nullptr);
REGISTER_PROTO(HTMLMenuElement, nullptr);
REGISTER_PROTO(HTMLMenuItemElement, nullptr);
REGISTER_PROTO(HTMLMetaElement, nullptr);
REGISTER_PROTO(HTMLMeterElement, nullptr);
REGISTER_PROTO(HTMLModElement, nullptr);
REGISTER_PROTO(HTMLOListElement, nullptr);
REGISTER_PROTO(HTMLObjectElement, nullptr);
REGISTER_PROTO(HTMLOptGroupElement, nullptr);
REGISTER_PROTO(HTMLOptionElement, nullptr);
REGISTER_CONSTRUCTOR(Option, HTMLOptionElement, nullptr);
REGISTER_PROTO(HTMLOptionsCollection, nullptr);
REGISTER_PROTO(HTMLOutputElement, nullptr);
REGISTER_PROTO(HTMLParagraphElement, nullptr);
REGISTER_PROTO(HTMLParamElement, nullptr);
REGISTER_PROTO(HTMLPictureElement, HTMLPictureElementBinding::ConstructorEnabled);
REGISTER_PROTO(HTMLPreElement, nullptr);
REGISTER_PROTO(HTMLProgressElement, nullptr);
REGISTER_PROTO(HTMLPropertiesCollection, nullptr);
REGISTER_PROTO(HTMLQuoteElement, nullptr);
REGISTER_PROTO(HTMLScriptElement, nullptr);
REGISTER_PROTO(HTMLSelectElement, nullptr);
REGISTER_PROTO(HTMLShadowElement, nullptr);
REGISTER_PROTO(HTMLSourceElement, nullptr);
REGISTER_PROTO(HTMLSpanElement, nullptr);
REGISTER_PROTO(HTMLStyleElement, nullptr);
REGISTER_PROTO(HTMLTableCaptionElement, nullptr);
REGISTER_PROTO(HTMLTableCellElement, nullptr);
REGISTER_PROTO(HTMLTableColElement, nullptr);
REGISTER_PROTO(HTMLTableElement, nullptr);
REGISTER_PROTO(HTMLTableRowElement, nullptr);
REGISTER_PROTO(HTMLTableSectionElement, nullptr);
REGISTER_PROTO(HTMLTemplateElement, nullptr);
REGISTER_PROTO(HTMLTextAreaElement, nullptr);
REGISTER_PROTO(HTMLTimeElement, nullptr);
REGISTER_PROTO(HTMLTitleElement, nullptr);
REGISTER_PROTO(HTMLTrackElement, HTMLTrackElementBinding::ConstructorEnabled);
REGISTER_PROTO(HTMLUListElement, nullptr);
REGISTER_PROTO(HTMLUnknownElement, nullptr);
REGISTER_PROTO(HTMLVideoElement, nullptr);
REGISTER_PROTO(HashChangeEvent, nullptr);
REGISTER_PROTO(Headers, nullptr);
REGISTER_PROTO(HeapSnapshot, HeapSnapshotBinding::ConstructorEnabled);
REGISTER_PROTO(History, nullptr);
REGISTER_PROTO(IDBCursor, nullptr);
REGISTER_PROTO(IDBCursorWithValue, nullptr);
REGISTER_PROTO(IDBDatabase, nullptr);
REGISTER_PROTO(IDBFactory, nullptr);
REGISTER_PROTO(IDBFileHandle, nullptr);
REGISTER_PROTO(IDBFileRequest, nullptr);
REGISTER_PROTO(IDBIndex, nullptr);
REGISTER_PROTO(IDBKeyRange, nullptr);
REGISTER_PROTO(IDBLocaleAwareKeyRange, IDBLocaleAwareKeyRangeBinding::ConstructorEnabled);
REGISTER_PROTO(IDBMutableFile, nullptr);
REGISTER_PROTO(IDBObjectStore, nullptr);
REGISTER_PROTO(IDBOpenDBRequest, nullptr);
REGISTER_PROTO(IDBRequest, nullptr);
REGISTER_PROTO(IDBTransaction, nullptr);
REGISTER_PROTO(IDBVersionChangeEvent, nullptr);
REGISTER_PROTO(IccCardLockError, IccCardLockErrorBinding::ConstructorEnabled);
REGISTER_PROTO(IccChangeEvent, IccChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(ImageBitmap, nullptr);
REGISTER_PROTO(ImageCapture, ImageCaptureBinding::ConstructorEnabled);
REGISTER_PROTO(ImageCaptureErrorEvent, ImageCaptureErrorEventBinding::ConstructorEnabled);
REGISTER_PROTO(ImageData, nullptr);
REGISTER_PROTO(ImageDocument, ImageDocumentBinding::ConstructorEnabled);
REGISTER_PROTO(InputEvent, nullptr);
REGISTER_PROTO(InputPort, InputPortBinding::ConstructorEnabled);
REGISTER_PROTO(InputPortManager, InputPortManagerBinding::ConstructorEnabled);
REGISTER_PROTO(InstallTriggerImpl, InstallTriggerImplBinding::ConstructorEnabled);
REGISTER_PROTO(KeyEvent, nullptr);
REGISTER_PROTO(KeyboardEvent, nullptr);
REGISTER_PROTO(KeyframeEffectReadOnly, KeyframeEffectReadOnlyBinding::ConstructorEnabled);
REGISTER_PROTO(KillSwitch, KillSwitchBinding::ConstructorEnabled);
REGISTER_PROTO(LocalMediaStream, nullptr);
REGISTER_PROTO(Location, nullptr);
REGISTER_PROTO(MMICall, MMICallBinding::ConstructorEnabled);
REGISTER_PROTO(MediaDeviceInfo, MediaDeviceInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MediaDevices, MediaDevicesBinding::ConstructorEnabled);
REGISTER_PROTO(MediaElementAudioSourceNode, nullptr);
REGISTER_PROTO(MediaEncryptedEvent, MediaEncryptedEventBinding::ConstructorEnabled);
REGISTER_PROTO(MediaError, nullptr);
REGISTER_PROTO(MediaKeyError, MediaKeyErrorBinding::ConstructorEnabled);
REGISTER_PROTO(MediaKeyMessageEvent, MediaKeyMessageEventBinding::ConstructorEnabled);
REGISTER_PROTO(MediaKeySession, MediaKeySessionBinding::ConstructorEnabled);
REGISTER_PROTO(MediaKeyStatusMap, MediaKeyStatusMapBinding::ConstructorEnabled);
REGISTER_PROTO(MediaKeySystemAccess, MediaKeySystemAccessBinding::ConstructorEnabled);
REGISTER_PROTO(MediaKeys, MediaKeysBinding::ConstructorEnabled);
REGISTER_PROTO(MediaList, nullptr);
REGISTER_PROTO(MediaQueryList, nullptr);
REGISTER_PROTO(MediaRecorder, nullptr);
REGISTER_PROTO(MediaSource, MediaSourceBinding::ConstructorEnabled);
REGISTER_PROTO(MediaStream, nullptr);
REGISTER_PROTO(MediaStreamAudioDestinationNode, nullptr);
REGISTER_PROTO(MediaStreamAudioSourceNode, nullptr);
REGISTER_PROTO(MediaStreamEvent, MediaStreamEventBinding::ConstructorEnabled);
REGISTER_PROTO(MediaStreamList, MediaStreamListBinding::ConstructorEnabled);
REGISTER_PROTO(MediaStreamTrack, nullptr);
REGISTER_PROTO(MediaStreamTrackEvent, MediaStreamTrackEventBinding::ConstructorEnabled);
REGISTER_PROTO(MenuBoxObject, MenuBoxObjectBinding::ConstructorEnabled);
REGISTER_PROTO(MessageChannel, nullptr);
REGISTER_PROTO(MessageEvent, nullptr);
REGISTER_PROTO(MessagePort, nullptr);
REGISTER_PROTO(MimeType, nullptr);
REGISTER_PROTO(MimeTypeArray, nullptr);
REGISTER_PROTO(MmsMessage, MmsMessageBinding::ConstructorEnabled);
REGISTER_PROTO(MobileMessageThread, MobileMessageThreadBinding::ConstructorEnabled);
REGISTER_PROTO(MouseEvent, nullptr);
REGISTER_PROTO(MouseScrollEvent, nullptr);
REGISTER_PROTO(MozAbortablePromise, MozAbortablePromiseBinding::ConstructorEnabled);
REGISTER_PROTO(MozActivity, MozActivityBinding::ConstructorEnabled);
REGISTER_PROTO(MozApplicationEvent, MozApplicationEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozCanvasPrintState, MozCanvasPrintStateBinding::ConstructorEnabled);
REGISTER_PROTO(MozCdmaIccInfo, MozCdmaIccInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MozCellBroadcast, MozCellBroadcastBinding::ConstructorEnabled);
REGISTER_PROTO(MozCellBroadcastEtwsInfo, MozCellBroadcastEtwsInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MozCellBroadcastEvent, MozCellBroadcastEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozCellBroadcastMessage, MozCellBroadcastMessageBinding::ConstructorEnabled);
REGISTER_PROTO(MozClirModeEvent, MozClirModeEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozContactChangeEvent, nullptr);
REGISTER_PROTO(MozEmergencyCbModeEvent, MozEmergencyCbModeEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozGsmIccInfo, MozGsmIccInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MozIcc, MozIccBinding::ConstructorEnabled);
REGISTER_PROTO(MozIccInfo, MozIccInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MozIccManager, MozIccManagerBinding::ConstructorEnabled);
REGISTER_PROTO(MozInputContext, MozInputContextBinding::ConstructorEnabled);
REGISTER_PROTO(MozInputContextFocusEventDetail, MozInputContextFocusEventDetailBinding::ConstructorEnabled);
REGISTER_PROTO(MozInputMethod, MozInputMethodBinding::ConstructorEnabled);
REGISTER_PROTO(MozInputMethodManager, MozInputMethodManagerBinding::ConstructorEnabled);
REGISTER_PROTO(MozInputRegistryEventDetail, MozInputRegistryEventDetailBinding::ConstructorEnabled);
REGISTER_PROTO(MozInterAppConnection, MozInterAppConnectionBinding::ConstructorEnabled);
REGISTER_PROTO(MozInterAppConnectionRequest, MozInterAppConnectionRequestBinding::ConstructorEnabled);
REGISTER_PROTO(MozInterAppMessageEvent, MozInterAppMessageEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozInterAppMessagePort, MozInterAppMessagePortBinding::ConstructorEnabled);
REGISTER_PROTO(MozMessageDeletedEvent, MozMessageDeletedEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozMmsEvent, MozMmsEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozMobileCellInfo, MozMobileCellInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MozMobileConnection, MozMobileConnectionBinding::ConstructorEnabled);
REGISTER_PROTO(MozMobileConnectionArray, MozMobileConnectionArrayBinding::ConstructorEnabled);
REGISTER_PROTO(MozMobileConnectionInfo, MozMobileConnectionInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MozMobileMessageManager, MozMobileMessageManagerBinding::ConstructorEnabled);
REGISTER_PROTO(MozMobileNetworkInfo, MozMobileNetworkInfoBinding::ConstructorEnabled);
REGISTER_PROTO(MozOtaStatusEvent, MozOtaStatusEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozPowerManager, nullptr);
REGISTER_PROTO(MozSelfSupport, MozSelfSupportBinding::ConstructorEnabled);
REGISTER_PROTO(MozSettingsEvent, nullptr);
REGISTER_PROTO(MozSettingsTransactionEvent, MozSettingsTransactionEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozSmsEvent, MozSmsEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozStkCommandEvent, MozStkCommandEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozTetheringManager, MozTetheringManagerBinding::ConstructorEnabled);
REGISTER_PROTO(MozTimeManager, MozTimeManagerBinding::ConstructorEnabled);
REGISTER_PROTO(MozVoicemail, MozVoicemailBinding::ConstructorEnabled);
REGISTER_PROTO(MozVoicemailEvent, MozVoicemailEventBinding::ConstructorEnabled);
REGISTER_PROTO(MozVoicemailStatus, MozVoicemailStatusBinding::ConstructorEnabled);
REGISTER_PROTO(MozWakeLock, MozWakeLockBinding::ConstructorEnabled);
REGISTER_PROTO(MutationEvent, nullptr);
REGISTER_PROTO(MutationObserver, nullptr);
REGISTER_PROTO(MutationRecord, nullptr);
REGISTER_PROTO(NamedNodeMap, nullptr);
REGISTER_PROTO(Navigator, nullptr);
REGISTER_PROTO(NetworkInformation, NetworkInformationBinding::ConstructorEnabled);
REGISTER_PROTO(NetworkStatsData, NetworkStatsDataBinding::ConstructorEnabled);
REGISTER_PROTO(Node, nullptr);
REGISTER_PROTO(NodeFilter, nullptr);
REGISTER_PROTO(NodeIterator, nullptr);
REGISTER_PROTO(NodeList, nullptr);
REGISTER_PROTO(Notification, NotificationBinding::ConstructorEnabled);
REGISTER_PROTO(NotifyPaintEvent, nullptr);
REGISTER_PROTO(OfflineAudioCompletionEvent, nullptr);
REGISTER_PROTO(OfflineAudioContext, nullptr);
REGISTER_PROTO(OfflineResourceList, nullptr);
REGISTER_PROTO(OffscreenCanvas, OffscreenCanvasBinding::ConstructorEnabled);
REGISTER_PROTO(OscillatorNode, nullptr);
REGISTER_PROTO(PageTransitionEvent, nullptr);
REGISTER_PROTO(PaintRequest, nullptr);
REGISTER_PROTO(PaintRequestList, nullptr);
REGISTER_PROTO(PannerNode, nullptr);
REGISTER_PROTO(Path2D, Path2DBinding::ConstructorEnabled);
REGISTER_PROTO(PeerConnectionImpl, PeerConnectionImplBinding::ConstructorEnabled);
REGISTER_PROTO(PeerConnectionObserver, PeerConnectionObserverBinding::ConstructorEnabled);
REGISTER_PROTO(Performance, nullptr);
REGISTER_PROTO(PerformanceCompositeTiming, PerformanceCompositeTimingBinding::ConstructorEnabled);
REGISTER_PROTO(PerformanceEntry, nullptr);
REGISTER_PROTO(PerformanceEntryEvent, PerformanceEntryEventBinding::ConstructorEnabled);
REGISTER_PROTO(PerformanceMark, nullptr);
REGISTER_PROTO(PerformanceMeasure, nullptr);
REGISTER_PROTO(PerformanceNavigation, nullptr);
REGISTER_PROTO(PerformanceObserver, PerformanceObserverBinding::ConstructorEnabled);
REGISTER_PROTO(PerformanceObserverEntryList, PerformanceObserverEntryListBinding::ConstructorEnabled);
REGISTER_PROTO(PerformanceRenderTiming, PerformanceRenderTimingBinding::ConstructorEnabled);
REGISTER_PROTO(PerformanceResourceTiming, nullptr);
REGISTER_PROTO(PerformanceTiming, nullptr);
REGISTER_PROTO(PeriodicWave, nullptr);
REGISTER_PROTO(PermissionSettings, PermissionSettingsBinding::ConstructorEnabled);
REGISTER_PROTO(PermissionStatus, PermissionStatusBinding::ConstructorEnabled);
REGISTER_PROTO(Permissions, PermissionsBinding::ConstructorEnabled);
REGISTER_PROTO(PhoneNumberService, PhoneNumberServiceBinding::ConstructorEnabled);
REGISTER_PROTO(Plugin, nullptr);
REGISTER_PROTO(PluginArray, nullptr);
REGISTER_PROTO(PluginCrashedEvent, PluginCrashedEventBinding::ConstructorEnabled);
REGISTER_PROTO(PointerEvent, PointerEventBinding::ConstructorEnabled);
REGISTER_PROTO(PopStateEvent, nullptr);
REGISTER_PROTO(PopupBlockedEvent, nullptr);
REGISTER_PROTO(PopupBoxObject, PopupBoxObjectBinding::ConstructorEnabled);
REGISTER_PROTO(PositionSensorVRDevice, PositionSensorVRDeviceBinding::ConstructorEnabled);
REGISTER_PROTO(PowerStatsData, PowerStatsDataBinding::ConstructorEnabled);
REGISTER_PROTO(Presentation, PresentationBinding::ConstructorEnabled);
REGISTER_PROTO(PresentationAvailability, PresentationAvailabilityBinding::ConstructorEnabled);
REGISTER_PROTO(PresentationConnection, PresentationConnectionBinding::ConstructorEnabled);
REGISTER_PROTO(PresentationConnectionAvailableEvent, PresentationConnectionAvailableEventBinding::ConstructorEnabled);
REGISTER_PROTO(PresentationDeviceInfoManager, PresentationDeviceInfoManagerBinding::ConstructorEnabled);
REGISTER_PROTO(PresentationReceiver, PresentationReceiverBinding::ConstructorEnabled);
REGISTER_PROTO(PresentationRequest, PresentationRequestBinding::ConstructorEnabled);
REGISTER_PROTO(ProcessingInstruction, nullptr);
REGISTER_PROTO(ProgressEvent, nullptr);
REGISTER_PROTO(Promise, nullptr);
REGISTER_PROTO(PromiseDebugging, PromiseDebuggingBinding::ConstructorEnabled);
REGISTER_PROTO(PropertyNodeList, nullptr);
REGISTER_PROTO(PushManager, PushManagerBinding::ConstructorEnabled);
REGISTER_PROTO(PushSubscription, PushSubscriptionBinding::ConstructorEnabled);
REGISTER_PROTO(RGBColor, nullptr);
REGISTER_PROTO(RTCCertificate, RTCCertificateBinding::ConstructorEnabled);
REGISTER_PROTO(RTCDataChannelEvent, RTCDataChannelEventBinding::ConstructorEnabled);
REGISTER_PROTO(RTCIceCandidate, RTCIceCandidateBinding::ConstructorEnabled);
REGISTER_PROTO(RTCPeerConnection, RTCPeerConnectionBinding::ConstructorEnabled);
REGISTER_PROTO(RTCPeerConnectionIceEvent, RTCPeerConnectionIceEventBinding::ConstructorEnabled);
REGISTER_PROTO(RTCPeerConnectionStatic, RTCPeerConnectionStaticBinding::ConstructorEnabled);
REGISTER_PROTO(RTCRtpReceiver, RTCRtpReceiverBinding::ConstructorEnabled);
REGISTER_PROTO(RTCRtpSender, RTCRtpSenderBinding::ConstructorEnabled);
REGISTER_PROTO(RTCSessionDescription, RTCSessionDescriptionBinding::ConstructorEnabled);
REGISTER_PROTO(RTCStatsReport, RTCStatsReportBinding::ConstructorEnabled);
REGISTER_PROTO(RadioNodeList, nullptr);
REGISTER_PROTO(Range, nullptr);
REGISTER_PROTO(RecordErrorEvent, nullptr);
REGISTER_PROTO(Rect, nullptr);
REGISTER_PROTO(Request, nullptr);
REGISTER_PROTO(RequestSyncApp, RequestSyncAppBinding::ConstructorEnabled);
REGISTER_PROTO(RequestSyncManager, RequestSyncManagerBinding::ConstructorEnabled);
REGISTER_PROTO(RequestSyncScheduler, RequestSyncSchedulerBinding::ConstructorEnabled);
REGISTER_PROTO(RequestSyncTask, RequestSyncTaskBinding::ConstructorEnabled);
REGISTER_PROTO(ResourceStats, ResourceStatsBinding::ConstructorEnabled);
REGISTER_PROTO(ResourceStatsAlarm, ResourceStatsAlarmBinding::ConstructorEnabled);
REGISTER_PROTO(ResourceStatsManager, ResourceStatsManagerBinding::ConstructorEnabled);
REGISTER_PROTO(Response, nullptr);
REGISTER_PROTO(SEChannel, SEChannelBinding::ConstructorEnabled);
REGISTER_PROTO(SEReader, SEReaderBinding::ConstructorEnabled);
REGISTER_PROTO(SEResponse, SEResponseBinding::ConstructorEnabled);
REGISTER_PROTO(SESession, SESessionBinding::ConstructorEnabled);
REGISTER_PROTO(SVGAElement, nullptr);
REGISTER_PROTO(SVGAltGlyphElement, nullptr);
REGISTER_PROTO(SVGAngle, nullptr);
REGISTER_PROTO(SVGAnimateElement, nullptr);
REGISTER_PROTO(SVGAnimateMotionElement, nullptr);
REGISTER_PROTO(SVGAnimateTransformElement, nullptr);
REGISTER_PROTO(SVGAnimatedAngle, nullptr);
REGISTER_PROTO(SVGAnimatedBoolean, nullptr);
REGISTER_PROTO(SVGAnimatedEnumeration, nullptr);
REGISTER_PROTO(SVGAnimatedInteger, nullptr);
REGISTER_PROTO(SVGAnimatedLength, nullptr);
REGISTER_PROTO(SVGAnimatedLengthList, nullptr);
REGISTER_PROTO(SVGAnimatedNumber, nullptr);
REGISTER_PROTO(SVGAnimatedNumberList, nullptr);
REGISTER_PROTO(SVGAnimatedPreserveAspectRatio, nullptr);
REGISTER_PROTO(SVGAnimatedRect, nullptr);
REGISTER_PROTO(SVGAnimatedString, nullptr);
REGISTER_PROTO(SVGAnimatedTransformList, nullptr);
REGISTER_PROTO(SVGAnimationElement, nullptr);
REGISTER_PROTO(SVGCircleElement, nullptr);
REGISTER_PROTO(SVGClipPathElement, nullptr);
REGISTER_PROTO(SVGComponentTransferFunctionElement, nullptr);
REGISTER_PROTO(SVGDefsElement, nullptr);
REGISTER_PROTO(SVGDescElement, nullptr);
REGISTER_PROTO(SVGDocument, nullptr);
REGISTER_PROTO(SVGElement, nullptr);
REGISTER_PROTO(SVGEllipseElement, nullptr);
REGISTER_PROTO(SVGFEBlendElement, nullptr);
REGISTER_PROTO(SVGFEColorMatrixElement, nullptr);
REGISTER_PROTO(SVGFEComponentTransferElement, nullptr);
REGISTER_PROTO(SVGFECompositeElement, nullptr);
REGISTER_PROTO(SVGFEConvolveMatrixElement, nullptr);
REGISTER_PROTO(SVGFEDiffuseLightingElement, nullptr);
REGISTER_PROTO(SVGFEDisplacementMapElement, nullptr);
REGISTER_PROTO(SVGFEDistantLightElement, nullptr);
REGISTER_PROTO(SVGFEDropShadowElement, nullptr);
REGISTER_PROTO(SVGFEFloodElement, nullptr);
REGISTER_PROTO(SVGFEFuncAElement, nullptr);
REGISTER_PROTO(SVGFEFuncBElement, nullptr);
REGISTER_PROTO(SVGFEFuncGElement, nullptr);
REGISTER_PROTO(SVGFEFuncRElement, nullptr);
REGISTER_PROTO(SVGFEGaussianBlurElement, nullptr);
REGISTER_PROTO(SVGFEImageElement, nullptr);
REGISTER_PROTO(SVGFEMergeElement, nullptr);
REGISTER_PROTO(SVGFEMergeNodeElement, nullptr);
REGISTER_PROTO(SVGFEMorphologyElement, nullptr);
REGISTER_PROTO(SVGFEOffsetElement, nullptr);
REGISTER_PROTO(SVGFEPointLightElement, nullptr);
REGISTER_PROTO(SVGFESpecularLightingElement, nullptr);
REGISTER_PROTO(SVGFESpotLightElement, nullptr);
REGISTER_PROTO(SVGFETileElement, nullptr);
REGISTER_PROTO(SVGFETurbulenceElement, nullptr);
REGISTER_PROTO(SVGFilterElement, nullptr);
REGISTER_PROTO(SVGForeignObjectElement, nullptr);
REGISTER_PROTO(SVGGElement, nullptr);
REGISTER_PROTO(SVGGradientElement, nullptr);
REGISTER_PROTO(SVGGraphicsElement, nullptr);
REGISTER_PROTO(SVGImageElement, nullptr);
REGISTER_PROTO(SVGLength, nullptr);
REGISTER_PROTO(SVGLengthList, nullptr);
REGISTER_PROTO(SVGLineElement, nullptr);
REGISTER_PROTO(SVGLinearGradientElement, nullptr);
REGISTER_PROTO(SVGMPathElement, nullptr);
REGISTER_PROTO(SVGMarkerElement, nullptr);
REGISTER_PROTO(SVGMaskElement, nullptr);
REGISTER_PROTO(SVGMatrix, nullptr);
REGISTER_PROTO(SVGMetadataElement, nullptr);
REGISTER_PROTO(SVGNumber, nullptr);
REGISTER_PROTO(SVGNumberList, nullptr);
REGISTER_PROTO(SVGPathElement, nullptr);
REGISTER_PROTO(SVGPathSeg, nullptr);
REGISTER_PROTO(SVGPathSegArcAbs, nullptr);
REGISTER_PROTO(SVGPathSegArcRel, nullptr);
REGISTER_PROTO(SVGPathSegClosePath, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoCubicAbs, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoCubicRel, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoCubicSmoothAbs, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoCubicSmoothRel, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoQuadraticAbs, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoQuadraticRel, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoQuadraticSmoothAbs, nullptr);
REGISTER_PROTO(SVGPathSegCurvetoQuadraticSmoothRel, nullptr);
REGISTER_PROTO(SVGPathSegLinetoAbs, nullptr);
REGISTER_PROTO(SVGPathSegLinetoHorizontalAbs, nullptr);
REGISTER_PROTO(SVGPathSegLinetoHorizontalRel, nullptr);
REGISTER_PROTO(SVGPathSegLinetoRel, nullptr);
REGISTER_PROTO(SVGPathSegLinetoVerticalAbs, nullptr);
REGISTER_PROTO(SVGPathSegLinetoVerticalRel, nullptr);
REGISTER_PROTO(SVGPathSegList, nullptr);
REGISTER_PROTO(SVGPathSegMovetoAbs, nullptr);
REGISTER_PROTO(SVGPathSegMovetoRel, nullptr);
REGISTER_PROTO(SVGPatternElement, nullptr);
REGISTER_PROTO(SVGPoint, nullptr);
REGISTER_PROTO(SVGPointList, nullptr);
REGISTER_PROTO(SVGPolygonElement, nullptr);
REGISTER_PROTO(SVGPolylineElement, nullptr);
REGISTER_PROTO(SVGPreserveAspectRatio, nullptr);
REGISTER_PROTO(SVGRadialGradientElement, nullptr);
REGISTER_PROTO(SVGRect, nullptr);
REGISTER_PROTO(SVGRectElement, nullptr);
REGISTER_PROTO(SVGSVGElement, nullptr);
REGISTER_PROTO(SVGScriptElement, nullptr);
REGISTER_PROTO(SVGSetElement, nullptr);
REGISTER_PROTO(SVGStopElement, nullptr);
REGISTER_PROTO(SVGStringList, nullptr);
REGISTER_PROTO(SVGStyleElement, nullptr);
REGISTER_PROTO(SVGSwitchElement, nullptr);
REGISTER_PROTO(SVGSymbolElement, nullptr);
REGISTER_PROTO(SVGTSpanElement, nullptr);
REGISTER_PROTO(SVGTextContentElement, nullptr);
REGISTER_PROTO(SVGTextElement, nullptr);
REGISTER_PROTO(SVGTextPathElement, nullptr);
REGISTER_PROTO(SVGTextPositioningElement, nullptr);
REGISTER_PROTO(SVGTitleElement, nullptr);
REGISTER_PROTO(SVGTransform, nullptr);
REGISTER_PROTO(SVGTransformList, nullptr);
REGISTER_PROTO(SVGUnitTypes, nullptr);
REGISTER_PROTO(SVGUseElement, nullptr);
REGISTER_PROTO(SVGViewElement, nullptr);
REGISTER_PROTO(SVGZoomAndPan, nullptr);
REGISTER_PROTO(SVGZoomEvent, nullptr);
REGISTER_PROTO(Screen, nullptr);
REGISTER_PROTO(ScreenOrientation, nullptr);
REGISTER_PROTO(ScriptProcessorNode, nullptr);
REGISTER_PROTO(ScrollAreaEvent, nullptr);
REGISTER_PROTO(ScrollViewChangeEvent, ScrollViewChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(Selection, nullptr);
REGISTER_PROTO(SelectionStateChangedEvent, SelectionStateChangedEventBinding::ConstructorEnabled);
REGISTER_PROTO(ServiceWorker, ServiceWorkerBinding::ConstructorEnabled);
REGISTER_PROTO(ServiceWorkerContainer, ServiceWorkerContainerBinding::ConstructorEnabled);
REGISTER_PROTO(ServiceWorkerMessageEvent, ServiceWorkerMessageEventBinding::ConstructorEnabled);
REGISTER_PROTO(ServiceWorkerRegistration, ServiceWorkerRegistrationBinding::ConstructorEnabled);
REGISTER_PROTO(SettingsLock, SettingsLockBinding::ConstructorEnabled);
REGISTER_PROTO(SettingsManager, SettingsManagerBinding::ConstructorEnabled);
REGISTER_PROTO(ShadowRoot, ShadowRootBinding::ConstructorEnabled);
REGISTER_PROTO(SharedWorker, nullptr);
REGISTER_PROTO(SimpleGestureEvent, nullptr);
REGISTER_PROTO(SmsMessage, SmsMessageBinding::ConstructorEnabled);
REGISTER_PROTO(SourceBuffer, SourceBufferBinding::ConstructorEnabled);
REGISTER_PROTO(SourceBufferList, SourceBufferListBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechGrammar, SpeechGrammarBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechGrammarList, SpeechGrammarListBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechRecognition, SpeechRecognitionBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechRecognitionAlternative, SpeechRecognitionAlternativeBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechRecognitionError, SpeechRecognitionErrorBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechRecognitionEvent, SpeechRecognitionEventBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechRecognitionResult, SpeechRecognitionResultBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechRecognitionResultList, SpeechRecognitionResultListBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechSynthesis, SpeechSynthesisBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechSynthesisErrorEvent, SpeechSynthesisErrorEventBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechSynthesisEvent, SpeechSynthesisEventBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechSynthesisUtterance, SpeechSynthesisUtteranceBinding::ConstructorEnabled);
REGISTER_PROTO(SpeechSynthesisVoice, SpeechSynthesisVoiceBinding::ConstructorEnabled);
REGISTER_PROTO(StereoPannerNode, nullptr);
REGISTER_PROTO(Storage, nullptr);
REGISTER_PROTO(StorageEvent, nullptr);
REGISTER_PROTO(StyleRuleChangeEvent, StyleRuleChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(StyleSheet, nullptr);
REGISTER_PROTO(StyleSheetApplicableStateChangeEvent, StyleSheetApplicableStateChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(StyleSheetChangeEvent, StyleSheetChangeEventBinding::ConstructorEnabled);
REGISTER_PROTO(StyleSheetList, nullptr);
REGISTER_PROTO(SubtleCrypto, nullptr);
REGISTER_PROTO(SystemUpdateManager, SystemUpdateManagerBinding::ConstructorEnabled);
REGISTER_PROTO(SystemUpdateProvider, SystemUpdateProviderBinding::ConstructorEnabled);
REGISTER_PROTO(TCPServerSocket, TCPServerSocketBinding::ConstructorEnabled);
REGISTER_PROTO(TCPServerSocketEvent, TCPServerSocketEventBinding::ConstructorEnabled);
REGISTER_PROTO(TCPSocket, TCPSocketBinding::ConstructorEnabled);
REGISTER_PROTO(TCPSocketErrorEvent, TCPSocketErrorEventBinding::ConstructorEnabled);
REGISTER_PROTO(TCPSocketEvent, TCPSocketEventBinding::ConstructorEnabled);
REGISTER_PROTO(TVChannel, TVChannelBinding::ConstructorEnabled);
REGISTER_PROTO(TVCurrentChannelChangedEvent, TVCurrentChannelChangedEventBinding::ConstructorEnabled);
REGISTER_PROTO(TVCurrentSourceChangedEvent, TVCurrentSourceChangedEventBinding::ConstructorEnabled);
REGISTER_PROTO(TVEITBroadcastedEvent, TVEITBroadcastedEventBinding::ConstructorEnabled);
REGISTER_PROTO(TVManager, TVManagerBinding::ConstructorEnabled);
REGISTER_PROTO(TVProgram, TVProgramBinding::ConstructorEnabled);
REGISTER_PROTO(TVScanningStateChangedEvent, TVScanningStateChangedEventBinding::ConstructorEnabled);
REGISTER_PROTO(TVSource, TVSourceBinding::ConstructorEnabled);
REGISTER_PROTO(TVTuner, TVTunerBinding::ConstructorEnabled);
REGISTER_PROTO(Telephony, TelephonyBinding::ConstructorEnabled);
REGISTER_PROTO(TelephonyCall, TelephonyCallBinding::ConstructorEnabled);
REGISTER_PROTO(TelephonyCallGroup, TelephonyCallGroupBinding::ConstructorEnabled);
REGISTER_PROTO(TelephonyCallId, TelephonyCallIdBinding::ConstructorEnabled);
REGISTER_PROTO(Text, nullptr);
REGISTER_PROTO(TextDecoder, nullptr);
REGISTER_PROTO(TextEncoder, nullptr);
REGISTER_PROTO(TextMetrics, nullptr);
REGISTER_PROTO(TextTrack, TextTrackBinding::ConstructorEnabled);
REGISTER_PROTO(TextTrackCue, TextTrackCueBinding::ConstructorEnabled);
REGISTER_PROTO(TextTrackCueList, TextTrackCueListBinding::ConstructorEnabled);
REGISTER_PROTO(TextTrackList, TextTrackListBinding::ConstructorEnabled);
REGISTER_PROTO(ThreadSafeChromeUtils, ThreadSafeChromeUtilsBinding::ConstructorEnabled);
REGISTER_PROTO(TimeEvent, nullptr);
REGISTER_PROTO(TimeRanges, nullptr);
REGISTER_PROTO(Touch, TouchBinding::ConstructorEnabled);
REGISTER_PROTO(TouchEvent, TouchEventBinding::ConstructorEnabled);
REGISTER_PROTO(TouchList, TouchListBinding::ConstructorEnabled);
REGISTER_PROTO(TrackEvent, nullptr);
REGISTER_PROTO(TransitionEvent, nullptr);
REGISTER_PROTO(TreeColumn, TreeColumnBinding::ConstructorEnabled);
REGISTER_PROTO(TreeColumns, TreeColumnsBinding::ConstructorEnabled);
REGISTER_PROTO(TreeWalker, nullptr);
REGISTER_PROTO(UDPMessageEvent, UDPMessageEventBinding::ConstructorEnabled);
REGISTER_PROTO(UDPSocket, UDPSocketBinding::ConstructorEnabled);
REGISTER_PROTO(UIEvent, nullptr);
REGISTER_PROTO(URL, nullptr);
REGISTER_PROTO(URLSearchParams, nullptr);
REGISTER_PROTO(USSDReceivedEvent, USSDReceivedEventBinding::ConstructorEnabled);
REGISTER_PROTO(USSDSession, USSDSessionBinding::ConstructorEnabled);
REGISTER_PROTO(UndoManager, UndoManagerBinding::ConstructorEnabled);
REGISTER_PROTO(UserProximityEvent, nullptr);
REGISTER_PROTO(VRDevice, VRDeviceBinding::ConstructorEnabled);
REGISTER_PROTO(VREyeParameters, VREyeParametersBinding::ConstructorEnabled);
REGISTER_PROTO(VRFieldOfView, VRFieldOfViewBinding::ConstructorEnabled);
REGISTER_PROTO(VRFieldOfViewReadOnly, VRFieldOfViewReadOnlyBinding::ConstructorEnabled);
REGISTER_PROTO(VRPositionState, VRPositionStateBinding::ConstructorEnabled);
REGISTER_PROTO(VTTCue, VTTCueBinding::ConstructorEnabled);
REGISTER_PROTO(VTTRegion, VTTRegionBinding::ConstructorEnabled);
REGISTER_PROTO(ValidityState, nullptr);
REGISTER_PROTO(VideoPlaybackQuality, VideoPlaybackQualityBinding::ConstructorEnabled);
REGISTER_PROTO(VideoStreamTrack, nullptr);
REGISTER_PROTO(VideoTrack, VideoTrackBinding::ConstructorEnabled);
REGISTER_PROTO(VideoTrackList, VideoTrackListBinding::ConstructorEnabled);
REGISTER_PROTO(WaveShaperNode, nullptr);
REGISTER_PROTO(WebGL2RenderingContext, WebGL2RenderingContextBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLActiveInfo, WebGLActiveInfoBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLBuffer, WebGLBufferBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLFramebuffer, WebGLFramebufferBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLProgram, WebGLProgramBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLQuery, WebGLQueryBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLRenderbuffer, WebGLRenderbufferBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLRenderingContext, WebGLRenderingContextBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLSampler, WebGLSamplerBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLShader, WebGLShaderBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLShaderPrecisionFormat, WebGLShaderPrecisionFormatBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLSync, WebGLSyncBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLTexture, WebGLTextureBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLTransformFeedback, WebGLTransformFeedbackBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLUniformLocation, WebGLUniformLocationBinding::ConstructorEnabled);
REGISTER_PROTO(WebGLVertexArrayObject, WebGLVertexArrayObjectBinding::ConstructorEnabled);
REGISTER_PROTO(WebSocket, nullptr);
REGISTER_PROTO(WebrtcGlobalInformation, WebrtcGlobalInformationBinding::ConstructorEnabled);
REGISTER_PROTO(WheelEvent, nullptr);
REGISTER_PROTO(Window, nullptr);
REGISTER_PROTO(WindowRoot, WindowRootBinding::ConstructorEnabled);
REGISTER_PROTO(Worker, WorkerBinding::ConstructorEnabled);
REGISTER_PROTO(XMLDocument, nullptr);
REGISTER_PROTO(XMLHttpRequest, XMLHttpRequestBinding::ConstructorEnabled);
REGISTER_PROTO(XMLHttpRequestEventTarget, XMLHttpRequestEventTargetBinding::ConstructorEnabled);
REGISTER_PROTO(XMLHttpRequestUpload, XMLHttpRequestUploadBinding::ConstructorEnabled);
REGISTER_PROTO(XMLSerializer, nullptr);
REGISTER_PROTO(XMLStylesheetProcessingInstruction, nullptr);
REGISTER_PROTO(XPathEvaluator, nullptr);
REGISTER_PROTO(XPathExpression, nullptr);
REGISTER_PROTO(XPathResult, nullptr);
REGISTER_PROTO(XSLTProcessor, nullptr);
REGISTER_PROTO(XULCommandEvent, XULCommandEventBinding::ConstructorEnabled);
REGISTER_PROTO(XULDocument, XULDocumentBinding::ConstructorEnabled);
REGISTER_PROTO(XULElement, XULElementBinding::ConstructorEnabled);
REGISTER_PROTO(mozContact, nullptr);
REGISTER_PROTO(mozRTCIceCandidate, mozRTCIceCandidateBinding::ConstructorEnabled);
REGISTER_PROTO(mozRTCPeerConnection, mozRTCPeerConnectionBinding::ConstructorEnabled);
REGISTER_PROTO(mozRTCSessionDescription, mozRTCSessionDescriptionBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozAlarms", AlarmsManager, AlarmsManagerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozBrowserElementProxy", BrowserElementProxy, BrowserElementProxyBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozChromeNotifications", ChromeNotifications, ChromeNotificationsBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozContacts", ContactManager, nullptr);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozApps", DOMApplicationsRegistry, nullptr);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozDownloadManager", DOMDownloadManager, DOMDownloadManagerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("engineeringMode", EngineeringMode, EngineeringModeBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozKillSwitch", KillSwitch, KillSwitchBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozInputMethod", MozInputMethod, MozInputMethodBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozTetheringManager", MozTetheringManager, MozTetheringManagerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozPermissionSettings", PermissionSettings, PermissionSettingsBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozPhoneNumberService", PhoneNumberService, PhoneNumberServiceBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozPresentationDeviceInfo", PresentationDeviceInfoManager, PresentationDeviceInfoManagerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("syncManager", RequestSyncManager, RequestSyncManagerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("sync", RequestSyncScheduler, RequestSyncSchedulerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("seManager", SEManager, SEManagerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("mozSettings", SettingsManager, SettingsManagerBinding::ConstructorEnabled);
REGISTER_NAVIGATOR_CONSTRUCTOR("updateManager", SystemUpdateManager, SystemUpdateManagerBinding::ConstructorEnabled);

#undef REGISTER_CONSTRUCTOR
#undef REGISTER_PROTO
#undef REGISTER_NAVIGATOR_CONSTRUCTOR
}

} // namespace dom
} // namespace mozilla

