#include "BlobBinding.h"
#include "BroadcastChannelBinding.h"
#include "CacheBinding.h"
#include "CacheStorageBinding.h"
#include "ClientBinding.h"
#include "ClientsBinding.h"
#include "ConsoleBinding.h"
#include "DOMCursorBinding.h"
#include "DOMErrorBinding.h"
#include "DOMExceptionBinding.h"
#include "DOMRequestBinding.h"
#include "DOMStringListBinding.h"
#include "DataStoreBinding.h"
#include "DedicatedWorkerGlobalScopeBinding.h"
#include "DominatorTreeBinding.h"
#include "EventBinding.h"
#include "EventTargetBinding.h"
#include "ExtendableEventBinding.h"
#include "ExtendableMessageEventBinding.h"
#include "FetchEventBinding.h"
#include "FileBinding.h"
#include "FileReaderSyncBinding.h"
#include "FormDataBinding.h"
#include "HeadersBinding.h"
#include "HeapSnapshotBinding.h"
#include "IDBCursorBinding.h"
#include "IDBDatabaseBinding.h"
#include "IDBFactoryBinding.h"
#include "IDBIndexBinding.h"
#include "IDBKeyRangeBinding.h"
#include "IDBObjectStoreBinding.h"
#include "IDBOpenDBRequestBinding.h"
#include "IDBRequestBinding.h"
#include "IDBTransactionBinding.h"
#include "IDBVersionChangeEventBinding.h"
#include "ImageBitmapBinding.h"
#include "ImageDataBinding.h"
#include "MessageChannelBinding.h"
#include "MessageEventBinding.h"
#include "MessagePortBinding.h"
#include "NotificationBinding.h"
#include "NotificationEventBinding.h"
#include "OffscreenCanvasBinding.h"
#include "PerformanceBinding.h"
#include "PerformanceEntryBinding.h"
#include "PerformanceMarkBinding.h"
#include "PerformanceMeasureBinding.h"
#include "PerformanceObserverBinding.h"
#include "PerformanceObserverEntryListBinding.h"
#include "PromiseBinding.h"
#include "PushEventBinding.h"
#include "PushManagerBinding.h"
#include "PushMessageDataBinding.h"
#include "PushSubscriptionBinding.h"
#include "RequestBinding.h"
#include "ResponseBinding.h"
#include "ServiceWorkerBinding.h"
#include "ServiceWorkerGlobalScopeBinding.h"
#include "ServiceWorkerRegistrationBinding.h"
#include "SharedWorkerGlobalScopeBinding.h"
#include "TextDecoderBinding.h"
#include "TextEncoderBinding.h"
#include "ThreadSafeChromeUtilsBinding.h"
#include "URLBinding.h"
#include "URLSearchParamsBinding.h"
#include "WebGLRenderingContextBinding.h"
#include "WebSocketBinding.h"
#include "WorkerBinding.h"
#include "WorkerGlobalScopeBinding.h"
#include "WorkerLocationBinding.h"
#include "WorkerNavigatorBinding.h"
#include "XMLHttpRequestBinding.h"
#include "XMLHttpRequestEventTargetBinding.h"
#include "XMLHttpRequestUploadBinding.h"

namespace mozilla {
namespace dom {
bool
RegisterWorkerBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (DataStoreCursorBinding_workers::ConstructorEnabled(aCx, aObj) && !DataStoreCursorBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (DataStoreBinding_workers::ConstructorEnabled(aCx, aObj) && !DataStoreBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (DedicatedWorkerGlobalScopeBinding_workers::ConstructorEnabled(aCx, aObj) && !DedicatedWorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!FileReaderSyncBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PerformanceBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (PushEventBinding_workers::ConstructorEnabled(aCx, aObj) && !PushEventBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (PushManagerBinding_workers::ConstructorEnabled(aCx, aObj) && !PushManagerBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (PushMessageDataBinding_workers::ConstructorEnabled(aCx, aObj) && !PushMessageDataBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (PushSubscriptionBinding_workers::ConstructorEnabled(aCx, aObj) && !PushSubscriptionBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ServiceWorkerGlobalScopeBinding_workers::ConstructorEnabled(aCx, aObj) && !ServiceWorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ServiceWorkerRegistrationBinding_workers::ConstructorEnabled(aCx, aObj) && !ServiceWorkerRegistrationBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (SharedWorkerGlobalScopeBinding_workers::ConstructorEnabled(aCx, aObj) && !SharedWorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!URLBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WorkerLocationBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WorkerNavigatorBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (XMLHttpRequestUploadBinding_workers::ConstructorEnabled(aCx, aObj) && !XMLHttpRequestUploadBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (XMLHttpRequestBinding_workers::ConstructorEnabled(aCx, aObj) && !XMLHttpRequestBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!BlobBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!BroadcastChannelBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (CacheBinding::ConstructorEnabled(aCx, aObj) && !CacheBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (CacheStorageBinding::ConstructorEnabled(aCx, aObj) && !CacheStorageBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ChromeWorkerBinding::ConstructorEnabled(aCx, aObj) && !ChromeWorkerBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ClientBinding::ConstructorEnabled(aCx, aObj) && !ClientBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ClientsBinding::ConstructorEnabled(aCx, aObj) && !ClientsBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ConsoleBinding::ConstructorEnabled(aCx, aObj) && !ConsoleBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!DOMCursorBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!DOMErrorBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!DOMExceptionBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!DOMRequestBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!DOMStringListBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (DominatorTreeBinding::ConstructorEnabled(aCx, aObj) && !DominatorTreeBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!EventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!EventTargetBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ExtendableEventBinding::ConstructorEnabled(aCx, aObj) && !ExtendableEventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ExtendableMessageEventBinding::ConstructorEnabled(aCx, aObj) && !ExtendableMessageEventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (FetchEventBinding::ConstructorEnabled(aCx, aObj) && !FetchEventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!FileBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!FormDataBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!HeadersBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (HeapSnapshotBinding::ConstructorEnabled(aCx, aObj) && !HeapSnapshotBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBCursorBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBCursorWithValueBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBDatabaseBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBFactoryBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBIndexBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBKeyRangeBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (IDBLocaleAwareKeyRangeBinding::ConstructorEnabled(aCx, aObj) && !IDBLocaleAwareKeyRangeBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBObjectStoreBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBOpenDBRequestBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBRequestBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBTransactionBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!IDBVersionChangeEventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!ImageBitmapBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!ImageDataBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!MessageChannelBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!MessageEventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!MessagePortBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (NotificationBinding::ConstructorEnabled(aCx, aObj) && !NotificationBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (NotificationEventBinding::ConstructorEnabled(aCx, aObj) && !NotificationEventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (OffscreenCanvasBinding::ConstructorEnabled(aCx, aObj) && !OffscreenCanvasBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PerformanceEntryBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PerformanceMarkBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PerformanceMeasureBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (PerformanceObserverBinding::ConstructorEnabled(aCx, aObj) && !PerformanceObserverBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (PerformanceObserverEntryListBinding::ConstructorEnabled(aCx, aObj) && !PerformanceObserverEntryListBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PromiseBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!RequestBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!ResponseBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ServiceWorkerBinding::ConstructorEnabled(aCx, aObj) && !ServiceWorkerBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!TextDecoderBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!TextEncoderBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ThreadSafeChromeUtilsBinding::ConstructorEnabled(aCx, aObj) && !ThreadSafeChromeUtilsBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!URLSearchParamsBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLActiveInfoBinding::ConstructorEnabled(aCx, aObj) && !WebGLActiveInfoBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLBufferBinding::ConstructorEnabled(aCx, aObj) && !WebGLBufferBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLFramebufferBinding::ConstructorEnabled(aCx, aObj) && !WebGLFramebufferBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLProgramBinding::ConstructorEnabled(aCx, aObj) && !WebGLProgramBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLRenderbufferBinding::ConstructorEnabled(aCx, aObj) && !WebGLRenderbufferBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLRenderingContextBinding::ConstructorEnabled(aCx, aObj) && !WebGLRenderingContextBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLShaderBinding::ConstructorEnabled(aCx, aObj) && !WebGLShaderBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLShaderPrecisionFormatBinding::ConstructorEnabled(aCx, aObj) && !WebGLShaderPrecisionFormatBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLTextureBinding::ConstructorEnabled(aCx, aObj) && !WebGLTextureBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebGLUniformLocationBinding::ConstructorEnabled(aCx, aObj) && !WebGLUniformLocationBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WebSocketBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WindowClientBinding::ConstructorEnabled(aCx, aObj) && !WindowClientBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WorkerBinding::ConstructorEnabled(aCx, aObj) && !WorkerBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (XMLHttpRequestEventTargetBinding::ConstructorEnabled(aCx, aObj) && !XMLHttpRequestEventTargetBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  return true;
}

} // namespace dom
} // namespace mozilla

