/* THIS FILE IS AUTOGENERATED FROM SystemUpdate.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "EventHandlerBinding.h"
#include "EventTargetBinding.h"
#include "SystemUpdateBinding.h"
#include "WrapperFactory.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/Promise.h"
#include "mozilla/dom/ScriptSettings.h"
#include "nsContentUtils.h"
#include "nsIGlobalObject.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {


SystemUpdatePackageInfo::SystemUpdatePackageInfo()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
SystemUpdatePackageInfo::InitIds(JSContext* cx, SystemUpdatePackageInfoAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->version_id.init(cx, "version") ||
      !atomsCache->type_id.init(cx, "type") ||
      !atomsCache->size_id.init(cx, "size") ||
      !atomsCache->description_id.init(cx, "description") ||
      !atomsCache->buildDate_id.init(cx, "buildDate")) {
    return false;
  }
  return true;
}

bool
SystemUpdatePackageInfo::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  SystemUpdatePackageInfoAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<SystemUpdatePackageInfoAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  { // scope for isConvertible
    bool isConvertible;
    if (!IsConvertibleToDictionary(cx, val, &isConvertible)) {
      return false;
    }
    if (!isConvertible) {
      return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
    }
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->buildDate_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &mBuildDate)) {
      return false;
    }
  } else {
    mBuildDate = 0ULL;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->description_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mDescription)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mDescription.Rebind(data, ArrayLength(data) - 1);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->size_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &mSize)) {
      return false;
    }
  } else {
    mSize = 0ULL;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->type_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mType)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mType.Rebind(data, ArrayLength(data) - 1);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->version_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mVersion)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mVersion.Rebind(data, ArrayLength(data) - 1);
  }
  return true;
}

bool
SystemUpdatePackageInfo::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
SystemUpdatePackageInfo::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  SystemUpdatePackageInfoAtoms* atomsCache = GetAtomCache<SystemUpdatePackageInfoAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint64_t const & currentValue = mBuildDate;
    temp.set(JS_NumberValue(double(currentValue)));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->buildDate_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mDescription;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->description_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint64_t const & currentValue = mSize;
    temp.set(JS_NumberValue(double(currentValue)));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->size_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mType;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->type_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mVersion;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->version_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
SystemUpdatePackageInfo::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
SystemUpdatePackageInfo::TraceDictionary(JSTracer* trc)
{
}

void
SystemUpdatePackageInfo::operator=(const SystemUpdatePackageInfo& aOther)
{
  mBuildDate = aOther.mBuildDate;
  mDescription = aOther.mDescription;
  mSize = aOther.mSize;
  mType = aOther.mType;
  mVersion = aOther.mVersion;
}

namespace binding_detail {
} // namespace binding_detail



SystemUpdateProviderInfo::SystemUpdateProviderInfo()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
SystemUpdateProviderInfo::InitIds(JSContext* cx, SystemUpdateProviderInfoAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->uuid_id.init(cx, "uuid") ||
      !atomsCache->name_id.init(cx, "name")) {
    return false;
  }
  return true;
}

bool
SystemUpdateProviderInfo::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  SystemUpdateProviderInfoAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<SystemUpdateProviderInfoAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  { // scope for isConvertible
    bool isConvertible;
    if (!IsConvertibleToDictionary(cx, val, &isConvertible)) {
      return false;
    }
    if (!isConvertible) {
      return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
    }
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->name_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mName)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mName.Rebind(data, ArrayLength(data) - 1);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->uuid_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mUuid)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mUuid.Rebind(data, ArrayLength(data) - 1);
  }
  return true;
}

bool
SystemUpdateProviderInfo::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
SystemUpdateProviderInfo::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  SystemUpdateProviderInfoAtoms* atomsCache = GetAtomCache<SystemUpdateProviderInfoAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mName;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->name_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mUuid;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->uuid_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
SystemUpdateProviderInfo::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
SystemUpdateProviderInfo::TraceDictionary(JSTracer* trc)
{
}

void
SystemUpdateProviderInfo::operator=(const SystemUpdateProviderInfo& aOther)
{
  mName = aOther.mName;
  mUuid = aOther.mUuid;
}

namespace binding_detail {
} // namespace binding_detail


namespace SystemUpdateManagerBinding {

static bool
getProviders(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateManager* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->GetProviders(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj))));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
getProviders_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateManager* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = getProviders(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo getProviders_methodinfo = {
  { (JSJitGetterOp)getProviders_promiseWrapper },
  { prototypes::id::SystemUpdateManager },
  PrototypeTraits<prototypes::id::SystemUpdateManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
setActiveProvider(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateManager* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SystemUpdateManager.setActiveProvider");
  }
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->SetActiveProvider(NonNullHelper(Constify(arg0)), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj))));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
setActiveProvider_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateManager* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = setActiveProvider(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo setActiveProvider_methodinfo = {
  { (JSJitGetterOp)setActiveProvider_promiseWrapper },
  { prototypes::id::SystemUpdateManager },
  PrototypeTraits<prototypes::id::SystemUpdateManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getActiveProvider(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateManager* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->GetActiveProvider(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj))));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
getActiveProvider_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateManager* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = getActiveProvider(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo getActiveProvider_methodinfo = {
  { (JSJitGetterOp)getActiveProvider_promiseWrapper },
  { prototypes::id::SystemUpdateManager },
  PrototypeTraits<prototypes::id::SystemUpdateManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static already_AddRefed<SystemUpdateManager>
ConstructNavigatorObjectHelper(JSContext* cx, GlobalObject& global, ErrorResult& aRv)
{
  JS::Rooted<JSObject*> jsImplObj(cx);
  nsCOMPtr<nsIGlobalObject> globalHolder =
    ConstructJSImplementation(cx, "@mozilla.org/system-update-manager;1", global, &jsImplObj, aRv);
  if (aRv.Failed()) {
    return nullptr;
  }
  // Build the C++ implementation.
  RefPtr<SystemUpdateManager> impl = new SystemUpdateManager(jsImplObj, globalHolder);
  return impl.forget();
}

JSObject*
ConstructNavigatorObject(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  GlobalObject global(aCx, aObj);
  if (global.Failed()) {
    return nullptr;
  }
  ErrorResult rv;
  JS::Rooted<JS::Value> v(aCx);
  {  // Scope to make sure |result| goes out of scope while |v| is rooted
    RefPtr<mozilla::dom::SystemUpdateManager> result = ConstructNavigatorObjectHelper(aCx, global, rv);
    if (rv.MaybeSetPendingException(aCx)) {
      return nullptr;
    }
    if (!GetOrCreateDOMReflector(aCx, result, &v)) {
      //XXX Assertion disabled for now, see bug 991271.
      MOZ_ASSERT(true || JS_IsExceptionPending(aCx));
      return nullptr;
    }
  }
  return &v.toObject();
}

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::SystemUpdateManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SystemUpdateManager>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::SystemUpdateManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SystemUpdateManager>(obj);
  if (self) {
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::SystemUpdateManager>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::SystemUpdateManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SystemUpdateManager>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const char* const anypermissions_0[] = {
  "system-update",
  nullptr
};

static const JSFunctionSpec sChromeStaticMethods_specs[] = {
  JS_FNSPEC("_create", SystemUpdateManager::_Create, nullptr, 2, 0, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sChromeStaticMethods[] = {
  { true, 0, nullptr, nullptr, nullptr, nullptr, &sChromeStaticMethods_specs[0] },
  { false, 0, nullptr, nullptr, nullptr, nullptr, nullptr }
};

static jsid sChromeStaticMethods_ids[2];

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("getProviders", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&getProviders_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("setActiveProvider", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&setActiveProvider_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getActiveProvider", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&getActiveProvider_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, 0, nullptr, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, 0, nullptr, nullptr, nullptr, nullptr, nullptr }
};

static jsid sMethods_ids[4];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

static const NativeProperties sChromeOnlyNativeProperties = {
  sChromeStaticMethods, sChromeStaticMethods_ids, sChromeStaticMethods_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, &sChromeOnlyNativeProperties },
  prototypes::id::SystemUpdateManager,
  constructors::id::SystemUpdateManager,
  nullptr
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    {
      nullptr, /* lookupProperty */
      nullptr, /* defineProperty */
      nullptr, /* hasProperty */
      nullptr, /* getProperty */
      nullptr, /* setProperty */
      nullptr, /* getOwnPropertyDescriptor */
      nullptr, /* deleteProperty */
      nullptr, /* watch */
      nullptr, /* unwatch */
      nullptr, /* getElements */
      nullptr, /* enumerate */
      InterfaceObjectToString, /* funToString */
    }
  },
  eInterface,
  sNativePropertyHooks,
  "function SystemUpdateManager() {\n    [native code]\n}",
  prototypes::id::SystemUpdateManager,
  PrototypeTraits<prototypes::id::SystemUpdateManager>::Depth,
  JS_GetFunctionPrototype
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "SystemUpdateManagerPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object SystemUpdateManagerPrototype]",
  prototypes::id::SystemUpdateManager,
  PrototypeTraits<prototypes::id::SystemUpdateManager>::Depth,
  JS_GetObjectPrototype
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.system_update.enabled") &&
         CheckAnyPermissions(aCx, aObj, anypermissions_0);
}

static const DOMJSClass Class = {
  { "SystemUpdateManager",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::SystemUpdateManager, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::SystemUpdateManager >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::SystemUpdateManager>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::SystemUpdateManager>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::SystemUpdateManager* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::SystemUpdateManager*>(aObject) ==
             reinterpret_cast<mozilla::dom::SystemUpdateManager*>(aObject),
             "Multiple inheritance for mozilla::dom::SystemUpdateManager is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::SystemUpdateManager> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sChromeStaticMethods, sChromeStaticMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::SystemUpdateManager);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::SystemUpdateManager);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nsContentUtils::ThreadsafeIsCallerChrome() ? &sChromeOnlyNativeProperties : nullptr,
                              "SystemUpdateManager", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::SystemUpdateManager)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::SystemUpdateManager).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::SystemUpdateManager)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::SystemUpdateManager).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace SystemUpdateManagerBinding



namespace SystemUpdateProviderBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<EventTargetBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
get_name(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitGetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  DOMString result;
  self->GetName(result, rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo name_getterinfo = {
  { (JSJitGetterOp)get_name },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_uuid(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitGetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  DOMString result;
  self->GetUuid(result, rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo uuid_getterinfo = {
  { (JSJitGetterOp)get_uuid },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_onupdateavailable(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitGetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  RefPtr<EventHandlerNonNull> result(self->GetOnupdateavailable(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onupdateavailable(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitSetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->SetOnupdateavailable(Constify(arg0), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo onupdateavailable_getterinfo = {
  { (JSJitGetterOp)get_onupdateavailable },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo onupdateavailable_setterinfo = {
  { (JSJitGetterOp)set_onupdateavailable },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_onprogress(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitGetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  RefPtr<EventHandlerNonNull> result(self->GetOnprogress(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onprogress(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitSetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->SetOnprogress(Constify(arg0), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo onprogress_getterinfo = {
  { (JSJitGetterOp)get_onprogress },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo onprogress_setterinfo = {
  { (JSJitGetterOp)set_onprogress },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_onupdateready(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitGetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  RefPtr<EventHandlerNonNull> result(self->GetOnupdateready(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onupdateready(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitSetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->SetOnupdateready(Constify(arg0), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo onupdateready_getterinfo = {
  { (JSJitGetterOp)get_onupdateready },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo onupdateready_setterinfo = {
  { (JSJitGetterOp)set_onupdateready },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_onerror(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitGetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  RefPtr<EventHandlerNonNull> result(self->GetOnerror(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onerror(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, JSJitSetterCallArgs args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->SetOnerror(Constify(arg0), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo onerror_getterinfo = {
  { (JSJitGetterOp)get_onerror },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo onerror_setterinfo = {
  { (JSJitGetterOp)set_onerror },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
checkForUpdate(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->CheckForUpdate(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo checkForUpdate_methodinfo = {
  { (JSJitGetterOp)checkForUpdate },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
startDownload(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->StartDownload(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo startDownload_methodinfo = {
  { (JSJitGetterOp)startDownload },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
stopDownload(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->StopDownload(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo stopDownload_methodinfo = {
  { (JSJitGetterOp)stopDownload },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
applyUpdate(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, const JSJitMethodCallArgs& args)
{
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  self->ApplyUpdate(rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo applyUpdate_methodinfo = {
  { (JSJitGetterOp)applyUpdate },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
setParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SystemUpdateProvider.setParameter");
  }
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  binding_detail::FakeString arg1;
  if (!ConvertJSValueToString(cx, args[1], eStringify, eStringify, arg1)) {
    return false;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  bool result(self->SetParameter(NonNullHelper(Constify(arg0)), NonNullHelper(Constify(arg1)), rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo setParameter_methodinfo = {
  { (JSJitGetterOp)setParameter },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getParameter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SystemUpdateProvider* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SystemUpdateProvider.getParameter");
  }
  Maybe<JS::Rooted<JSObject*> > unwrappedObj;
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  if (objIsXray) {
    unwrappedObj.emplace(cx, obj);
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  if (objIsXray) {
    unwrappedObj.ref() = js::CheckedUnwrap(unwrappedObj.ref());
    if (!unwrappedObj.ref()) {
      return false;
    }
  }
  ErrorResult rv;
  DOMString result;
  self->GetParameter(NonNullHelper(Constify(arg0)), result, rv, js::GetObjectCompartment(unwrappedObj ? *unwrappedObj : obj));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo getParameter_methodinfo = {
  { (JSJitGetterOp)getParameter },
  { prototypes::id::SystemUpdateProvider },
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::SystemUpdateProvider* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SystemUpdateProvider>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::SystemUpdateProvider* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SystemUpdateProvider>(obj);
  if (self) {
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::SystemUpdateProvider>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::SystemUpdateProvider* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SystemUpdateProvider>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const char* const anypermissions_0[] = {
  "system-update",
  nullptr
};

static const JSFunctionSpec sChromeStaticMethods_specs[] = {
  JS_FNSPEC("_create", SystemUpdateProvider::_Create, nullptr, 2, 0, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sChromeStaticMethods[] = {
  { true, 0, nullptr, nullptr, nullptr, nullptr, &sChromeStaticMethods_specs[0] },
  { false, 0, nullptr, nullptr, nullptr, nullptr, nullptr }
};

static jsid sChromeStaticMethods_ids[2];

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("checkForUpdate", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&checkForUpdate_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("startDownload", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&startDownload_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("stopDownload", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&stopDownload_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("applyUpdate", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&applyUpdate_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("setParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&setParameter_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getParameter", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getParameter_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, 0, nullptr, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, 0, nullptr, nullptr, nullptr, nullptr, nullptr }
};

static jsid sMethods_ids[7];

static const JSPropertySpec sAttributes_specs[] = {
  { "name", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &name_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "uuid", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &uuid_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "onupdateavailable", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &onupdateavailable_getterinfo } }, { { GenericBindingSetter, &onupdateavailable_setterinfo } }},
  { "onprogress", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &onprogress_getterinfo } }, { { GenericBindingSetter, &onprogress_setterinfo } }},
  { "onupdateready", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &onupdateready_getterinfo } }, { { GenericBindingSetter, &onupdateready_setterinfo } }},
  { "onerror", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &onerror_getterinfo } }, { { GenericBindingSetter, &onerror_setterinfo } }},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, 0, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, 0, nullptr, nullptr, nullptr, nullptr, nullptr }
};

static jsid sAttributes_ids[7];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

static const NativeProperties sChromeOnlyNativeProperties = {
  sChromeStaticMethods, sChromeStaticMethods_ids, sChromeStaticMethods_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, &sChromeOnlyNativeProperties },
  prototypes::id::SystemUpdateProvider,
  constructors::id::SystemUpdateProvider,
  EventTargetBinding::sNativePropertyHooks
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    {
      nullptr, /* lookupProperty */
      nullptr, /* defineProperty */
      nullptr, /* hasProperty */
      nullptr, /* getProperty */
      nullptr, /* setProperty */
      nullptr, /* getOwnPropertyDescriptor */
      nullptr, /* deleteProperty */
      nullptr, /* watch */
      nullptr, /* unwatch */
      nullptr, /* getElements */
      nullptr, /* enumerate */
      InterfaceObjectToString, /* funToString */
    }
  },
  eInterface,
  sNativePropertyHooks,
  "function SystemUpdateProvider() {\n    [native code]\n}",
  prototypes::id::SystemUpdateProvider,
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  EventTargetBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "SystemUpdateProviderPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object SystemUpdateProviderPrototype]",
  prototypes::id::SystemUpdateProvider,
  PrototypeTraits<prototypes::id::SystemUpdateProvider>::Depth,
  EventTargetBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.system_update.enabled") &&
         CheckAnyPermissions(aCx, aObj, anypermissions_0);
}

static const DOMJSClass Class = {
  { "SystemUpdateProvider",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::EventTarget, prototypes::id::SystemUpdateProvider, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::SystemUpdateProvider >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::SystemUpdateProvider>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::SystemUpdateProvider>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::SystemUpdateProvider* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::SystemUpdateProvider*>(aObject) ==
             reinterpret_cast<mozilla::dom::SystemUpdateProvider*>(aObject),
             "Multiple inheritance for mozilla::dom::SystemUpdateProvider is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::EventTarget*>(aObject) ==
             reinterpret_cast<mozilla::dom::EventTarget*>(aObject),
             "Multiple inheritance for mozilla::dom::EventTarget is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::SystemUpdateProvider> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(EventTargetBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(EventTargetBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sChromeStaticMethods, sChromeStaticMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::SystemUpdateProvider);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::SystemUpdateProvider);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nsContentUtils::ThreadsafeIsCallerChrome() ? &sChromeOnlyNativeProperties : nullptr,
                              "SystemUpdateProvider", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::SystemUpdateProvider)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::SystemUpdateProvider).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::SystemUpdateProvider)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::SystemUpdateProvider).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace SystemUpdateProviderBinding



already_AddRefed<Promise>
SystemUpdateManagerJSImpl::GetProviders(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateManager.getProviders", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateManagerAtoms* atomsCache = GetAtomCache<SystemUpdateManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->getProviders_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<mozilla::dom::Promise> rvalDecl;
  { // Scope for our GlobalObject, ErrorResult, JSAutoCompartment,
    // etc.

    JS::Rooted<JSObject*> globalObj(cx, JS::CurrentGlobalOrNull(cx));
    if (!rval.isObject()) {
      aRv.ThrowTypeError<MSG_NOT_OBJECT>(NS_LITERAL_STRING("return value of SystemUpdateManager.getProviders"));
      return nullptr;
    }
    JSObject* unwrappedVal = js::CheckedUnwrap(&rval.toObject());
    if (!unwrappedVal) {
      // A slight lie, but not much of one, for a dead object wrapper.
      aRv.ThrowTypeError<MSG_NOT_OBJECT>(NS_LITERAL_STRING("return value of SystemUpdateManager.getProviders"));
      return nullptr;
    }
    globalObj = js::GetGlobalForObjectCrossCompartment(unwrappedVal);
    JSAutoCompartment ac(cx, globalObj);
    GlobalObject promiseGlobal(cx, globalObj);
    if (promiseGlobal.Failed()) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    ErrorResult promiseRv;
    JS::Handle<JSObject*> promiseCtor =
      PromiseBinding::GetConstructorObjectHandle(cx, globalObj);
    if (!promiseCtor) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    JS::Rooted<JS::Value> resolveThisv(cx, JS::ObjectValue(*promiseCtor));
    JS::Rooted<JS::Value> resolveResult(cx);
    JS::Rooted<JS::Value> valueToResolve(cx, rval);
    if (!JS_WrapValue(cx, &valueToResolve)) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    Promise::Resolve(promiseGlobal, resolveThisv, valueToResolve,
                     &resolveResult, promiseRv);
    if (promiseRv.MaybeSetPendingException(cx)) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    nsresult unwrapRv = UNWRAP_OBJECT(Promise, &resolveResult.toObject(), rvalDecl);
    if (NS_FAILED(unwrapRv)) { // Quite odd
      promiseRv.Throw(unwrapRv);
      promiseRv.MaybeSetPendingException(cx);
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
  }
  return rvalDecl.forget();
}

already_AddRefed<Promise>
SystemUpdateManagerJSImpl::SetActiveProvider(const nsAString& uuid, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateManager.setActiveProvider", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return nullptr;
  }
  unsigned argc = 1;

  do {
    nsString mutableStr(uuid);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateManagerAtoms* atomsCache = GetAtomCache<SystemUpdateManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->setActiveProvider_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<mozilla::dom::Promise> rvalDecl;
  { // Scope for our GlobalObject, ErrorResult, JSAutoCompartment,
    // etc.

    JS::Rooted<JSObject*> globalObj(cx, JS::CurrentGlobalOrNull(cx));
    if (!rval.isObject()) {
      aRv.ThrowTypeError<MSG_NOT_OBJECT>(NS_LITERAL_STRING("return value of SystemUpdateManager.setActiveProvider"));
      return nullptr;
    }
    JSObject* unwrappedVal = js::CheckedUnwrap(&rval.toObject());
    if (!unwrappedVal) {
      // A slight lie, but not much of one, for a dead object wrapper.
      aRv.ThrowTypeError<MSG_NOT_OBJECT>(NS_LITERAL_STRING("return value of SystemUpdateManager.setActiveProvider"));
      return nullptr;
    }
    globalObj = js::GetGlobalForObjectCrossCompartment(unwrappedVal);
    JSAutoCompartment ac(cx, globalObj);
    GlobalObject promiseGlobal(cx, globalObj);
    if (promiseGlobal.Failed()) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    ErrorResult promiseRv;
    JS::Handle<JSObject*> promiseCtor =
      PromiseBinding::GetConstructorObjectHandle(cx, globalObj);
    if (!promiseCtor) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    JS::Rooted<JS::Value> resolveThisv(cx, JS::ObjectValue(*promiseCtor));
    JS::Rooted<JS::Value> resolveResult(cx);
    JS::Rooted<JS::Value> valueToResolve(cx, rval);
    if (!JS_WrapValue(cx, &valueToResolve)) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    Promise::Resolve(promiseGlobal, resolveThisv, valueToResolve,
                     &resolveResult, promiseRv);
    if (promiseRv.MaybeSetPendingException(cx)) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    nsresult unwrapRv = UNWRAP_OBJECT(Promise, &resolveResult.toObject(), rvalDecl);
    if (NS_FAILED(unwrapRv)) { // Quite odd
      promiseRv.Throw(unwrapRv);
      promiseRv.MaybeSetPendingException(cx);
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
  }
  return rvalDecl.forget();
}

already_AddRefed<Promise>
SystemUpdateManagerJSImpl::GetActiveProvider(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateManager.getActiveProvider", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateManagerAtoms* atomsCache = GetAtomCache<SystemUpdateManagerAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->getActiveProvider_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<mozilla::dom::Promise> rvalDecl;
  { // Scope for our GlobalObject, ErrorResult, JSAutoCompartment,
    // etc.

    JS::Rooted<JSObject*> globalObj(cx, JS::CurrentGlobalOrNull(cx));
    if (!rval.isObject()) {
      aRv.ThrowTypeError<MSG_NOT_OBJECT>(NS_LITERAL_STRING("return value of SystemUpdateManager.getActiveProvider"));
      return nullptr;
    }
    JSObject* unwrappedVal = js::CheckedUnwrap(&rval.toObject());
    if (!unwrappedVal) {
      // A slight lie, but not much of one, for a dead object wrapper.
      aRv.ThrowTypeError<MSG_NOT_OBJECT>(NS_LITERAL_STRING("return value of SystemUpdateManager.getActiveProvider"));
      return nullptr;
    }
    globalObj = js::GetGlobalForObjectCrossCompartment(unwrappedVal);
    JSAutoCompartment ac(cx, globalObj);
    GlobalObject promiseGlobal(cx, globalObj);
    if (promiseGlobal.Failed()) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    ErrorResult promiseRv;
    JS::Handle<JSObject*> promiseCtor =
      PromiseBinding::GetConstructorObjectHandle(cx, globalObj);
    if (!promiseCtor) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    JS::Rooted<JS::Value> resolveThisv(cx, JS::ObjectValue(*promiseCtor));
    JS::Rooted<JS::Value> resolveResult(cx);
    JS::Rooted<JS::Value> valueToResolve(cx, rval);
    if (!JS_WrapValue(cx, &valueToResolve)) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    Promise::Resolve(promiseGlobal, resolveThisv, valueToResolve,
                     &resolveResult, promiseRv);
    if (promiseRv.MaybeSetPendingException(cx)) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
    nsresult unwrapRv = UNWRAP_OBJECT(Promise, &resolveResult.toObject(), rvalDecl);
    if (NS_FAILED(unwrapRv)) { // Quite odd
      promiseRv.Throw(unwrapRv);
      promiseRv.MaybeSetPendingException(cx);
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return nullptr;
    }
  }
  return rvalDecl.forget();
}

bool
SystemUpdateManagerJSImpl::InitIds(JSContext* cx, SystemUpdateManagerAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->getActiveProvider_id.init(cx, "getActiveProvider") ||
      !atomsCache->setActiveProvider_id.init(cx, "setActiveProvider") ||
      !atomsCache->getProviders_id.init(cx, "getProviders")) {
    return false;
  }
  return true;
}



NS_IMPL_CYCLE_COLLECTION_CLASS(SystemUpdateManager)
NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN(SystemUpdateManager)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mImpl)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mParent)
  NS_IMPL_CYCLE_COLLECTION_UNLINK_PRESERVED_WRAPPER
  tmp->ClearWeakReferences();
NS_IMPL_CYCLE_COLLECTION_UNLINK_END
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN(SystemUpdateManager)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mImpl)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mParent)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE_SCRIPT_OBJECTS
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END
NS_IMPL_CYCLE_COLLECTION_TRACE_WRAPPERCACHE(SystemUpdateManager)
NS_IMPL_CYCLE_COLLECTING_ADDREF(SystemUpdateManager)
NS_IMPL_CYCLE_COLLECTING_RELEASE(SystemUpdateManager)
NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION(SystemUpdateManager)
  NS_WRAPPERCACHE_INTERFACE_MAP_ENTRY
  NS_INTERFACE_MAP_ENTRY(nsISupports)
  NS_INTERFACE_MAP_ENTRY(nsISupportsWeakReference)
NS_INTERFACE_MAP_END

SystemUpdateManager::SystemUpdateManager(JS::Handle<JSObject*> aJSImplObject, nsIGlobalObject* aParent)
  : mImpl(new SystemUpdateManagerJSImpl(nullptr, aJSImplObject, /* aIncumbentGlobal = */ nullptr)),
    mParent(aParent)
{
}


SystemUpdateManager::~SystemUpdateManager()
{
}

nsISupports*
SystemUpdateManager::GetParentObject() const
{
  return mParent;
}

JSObject*
SystemUpdateManager::WrapObject(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  JS::Rooted<JSObject*> obj(aCx, SystemUpdateManagerBinding::Wrap(aCx, this, aGivenProto));
  if (!obj) {
    return nullptr;
  }

  // Now define it on our chrome object
  JSAutoCompartment ac(aCx, mImpl->Callback());
  if (!JS_WrapObject(aCx, &obj)) {
    return nullptr;
  }
  if (!JS_DefineProperty(aCx, mImpl->Callback(), "__DOM_IMPL__", obj, 0)) {
    return nullptr;
  }
  return obj;
}

// Return a raw pointer here to avoid refcounting, but make sure it's safe (the object should be kept alive by the callee).
already_AddRefed<Promise>
SystemUpdateManager::GetProviders(ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->GetProviders(aRv, aCompartment);
}

// Return a raw pointer here to avoid refcounting, but make sure it's safe (the object should be kept alive by the callee).
already_AddRefed<Promise>
SystemUpdateManager::SetActiveProvider(const nsAString& uuid, ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->SetActiveProvider(uuid, aRv, aCompartment);
}

// Return a raw pointer here to avoid refcounting, but make sure it's safe (the object should be kept alive by the callee).
already_AddRefed<Promise>
SystemUpdateManager::GetActiveProvider(ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->GetActiveProvider(aRv, aCompartment);
}

bool
SystemUpdateManager::_Create(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  if (args.length() < 2) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SystemUpdateManager._create");
  }
  if (!args[0].isObject()) {
    return ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of SystemUpdateManager._create");
  }
  if (!args[1].isObject()) {
    return ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 2 of SystemUpdateManager._create");
  }

  // GlobalObject will go through wrappers as needed for us, and
  // is simpler than the right UnwrapArg incantation.
  GlobalObject global(cx, &args[0].toObject());
  if (global.Failed()) {
    return false;
  }
  nsCOMPtr<nsIGlobalObject> globalHolder = do_QueryInterface(global.GetAsSupports());
  MOZ_ASSERT(globalHolder);
  JS::Rooted<JSObject*> arg(cx, &args[1].toObject());
  RefPtr<SystemUpdateManager> impl = new SystemUpdateManager(arg, globalHolder);
  MOZ_ASSERT(js::IsObjectInContextCompartment(arg, cx));
  return GetOrCreateDOMReflector(cx, impl, args.rval());
}


void
SystemUpdateProviderJSImpl::CheckForUpdate(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.checkForUpdate", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->checkForUpdate_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
SystemUpdateProviderJSImpl::StartDownload(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.startDownload", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->startDownload_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
SystemUpdateProviderJSImpl::StopDownload(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.stopDownload", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->stopDownload_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
SystemUpdateProviderJSImpl::ApplyUpdate(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.applyUpdate", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->applyUpdate_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

bool
SystemUpdateProviderJSImpl::SetParameter(const nsAString& name, const nsAString& value, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.setParameter", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return bool(0);
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(2)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return bool(0);
  }
  unsigned argc = 2;

  do {
    nsString mutableStr(value);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[1])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return bool(0);
    }
    break;
  } while (0);

  do {
    nsString mutableStr(name);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return bool(0);
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->setParameter_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return bool(0);
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return bool(0);
  }
  bool rvalDecl;
  if (!ValueToPrimitive<bool, eDefault>(cx, rval, &rvalDecl)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return bool(0);
  }
  return rvalDecl;
}

void
SystemUpdateProviderJSImpl::GetParameter(const nsAString& name, nsString& aRetVal, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.getParameter", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    nsString mutableStr(name);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !GetCallableProperty(cx, atomsCache->getParameter_id, &callable)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> thisValue(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, thisValue, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  binding_detail::FakeString rvalDecl;
  if (!ConvertJSValueToString(cx, rval, eStringify, eStringify, rvalDecl)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  aRetVal = rvalDecl;
}

bool
SystemUpdateProviderJSImpl::InitIds(JSContext* cx, SystemUpdateProviderAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->getParameter_id.init(cx, "getParameter") ||
      !atomsCache->setParameter_id.init(cx, "setParameter") ||
      !atomsCache->applyUpdate_id.init(cx, "applyUpdate") ||
      !atomsCache->stopDownload_id.init(cx, "stopDownload") ||
      !atomsCache->startDownload_id.init(cx, "startDownload") ||
      !atomsCache->checkForUpdate_id.init(cx, "checkForUpdate") ||
      !atomsCache->onerror_id.init(cx, "onerror") ||
      !atomsCache->onupdateready_id.init(cx, "onupdateready") ||
      !atomsCache->onprogress_id.init(cx, "onprogress") ||
      !atomsCache->onupdateavailable_id.init(cx, "onupdateavailable") ||
      !atomsCache->uuid_id.init(cx, "uuid") ||
      !atomsCache->name_id.init(cx, "name")) {
    return false;
  }
  return true;
}


void
SystemUpdateProviderJSImpl::GetName(nsString& aRetVal, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.name", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->name_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  binding_detail::FakeString rvalDecl;
  if (!ConvertJSValueToString(cx, rval, eStringify, eStringify, rvalDecl)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  aRetVal = rvalDecl;
}

void
SystemUpdateProviderJSImpl::GetUuid(nsString& aRetVal, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.uuid", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->uuid_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  binding_detail::FakeString rvalDecl;
  if (!ConvertJSValueToString(cx, rval, eStringify, eStringify, rvalDecl)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  aRetVal = rvalDecl;
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProviderJSImpl::GetOnupdateavailable(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onupdateavailable", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->onupdateavailable_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<EventHandlerNonNull> rvalDecl;
  if (rval.isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    rvalDecl = nullptr;
  }
  return rvalDecl.forget();
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProviderJSImpl::GetOnprogress(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onprogress", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->onprogress_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<EventHandlerNonNull> rvalDecl;
  if (rval.isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    rvalDecl = nullptr;
  }
  return rvalDecl.forget();
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProviderJSImpl::GetOnupdateready(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onupdateready", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->onupdateready_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<EventHandlerNonNull> rvalDecl;
  if (rval.isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    rvalDecl = nullptr;
  }
  return rvalDecl.forget();
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProviderJSImpl::GetOnerror(ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onerror", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JSObject *> callback(cx, mCallback);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_GetPropertyById(cx, callback, atomsCache->onerror_id, &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return nullptr;
  }
  RefPtr<EventHandlerNonNull> rvalDecl;
  if (rval.isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &rval.toObject());
        rvalDecl = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    rvalDecl = nullptr;
  }
  return rvalDecl.forget();
}

void
SystemUpdateProviderJSImpl::SetOnupdateavailable(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onupdateavailable", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  do {
    if (arg) {
      argv[0].setObject(*GetCallbackFromCallbackObject(arg));
      if (!MaybeWrapObjectOrNullValue(cx, argv[0])) {
        aRv.Throw(NS_ERROR_UNEXPECTED);
        return;
      }
      break;
    } else {
      argv[0].setNull();
      break;
    }
  } while (0);

  MOZ_ASSERT(argv.length() == 1);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_SetPropertyById(cx, CallbackPreserveColor(), atomsCache->onupdateavailable_id, argv[0])) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
SystemUpdateProviderJSImpl::SetOnprogress(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onprogress", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  do {
    if (arg) {
      argv[0].setObject(*GetCallbackFromCallbackObject(arg));
      if (!MaybeWrapObjectOrNullValue(cx, argv[0])) {
        aRv.Throw(NS_ERROR_UNEXPECTED);
        return;
      }
      break;
    } else {
      argv[0].setNull();
      break;
    }
  } while (0);

  MOZ_ASSERT(argv.length() == 1);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_SetPropertyById(cx, CallbackPreserveColor(), atomsCache->onprogress_id, argv[0])) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
SystemUpdateProviderJSImpl::SetOnupdateready(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onupdateready", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  do {
    if (arg) {
      argv[0].setObject(*GetCallbackFromCallbackObject(arg));
      if (!MaybeWrapObjectOrNullValue(cx, argv[0])) {
        aRv.Throw(NS_ERROR_UNEXPECTED);
        return;
      }
      break;
    } else {
      argv[0].setNull();
      break;
    }
  } while (0);

  MOZ_ASSERT(argv.length() == 1);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_SetPropertyById(cx, CallbackPreserveColor(), atomsCache->onupdateready_id, argv[0])) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}

void
SystemUpdateProviderJSImpl::SetOnerror(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  CallSetup s(this, aRv, "SystemUpdateProvider.onerror", eRethrowContentExceptions, aCompartment, /* aIsJSImplementedWebIDL = */ true);
  JSContext* cx = s.GetContext();
  if (!cx) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  do {
    if (arg) {
      argv[0].setObject(*GetCallbackFromCallbackObject(arg));
      if (!MaybeWrapObjectOrNullValue(cx, argv[0])) {
        aRv.Throw(NS_ERROR_UNEXPECTED);
        return;
      }
      break;
    } else {
      argv[0].setNull();
      break;
    }
  } while (0);

  MOZ_ASSERT(argv.length() == 1);
  SystemUpdateProviderAtoms* atomsCache = GetAtomCache<SystemUpdateProviderAtoms>(cx);
  if ((!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) ||
      !JS_SetPropertyById(cx, CallbackPreserveColor(), atomsCache->onerror_id, argv[0])) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}


NS_IMPL_CYCLE_COLLECTION_INHERITED(SystemUpdateProvider, mozilla::DOMEventTargetHelper, mImpl, mParent)
NS_IMPL_ADDREF_INHERITED(SystemUpdateProvider, mozilla::DOMEventTargetHelper)
NS_IMPL_RELEASE_INHERITED(SystemUpdateProvider, mozilla::DOMEventTargetHelper)
NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(SystemUpdateProvider)
NS_INTERFACE_MAP_END_INHERITING(mozilla::DOMEventTargetHelper)

SystemUpdateProvider::SystemUpdateProvider(JS::Handle<JSObject*> aJSImplObject, nsIGlobalObject* aParent)
  : mozilla::DOMEventTargetHelper(aParent),
    mImpl(new SystemUpdateProviderJSImpl(nullptr, aJSImplObject, /* aIncumbentGlobal = */ nullptr)),
    mParent(aParent)
{
}


SystemUpdateProvider::~SystemUpdateProvider()
{
}

nsISupports*
SystemUpdateProvider::GetParentObject() const
{
  return mParent;
}

JSObject*
SystemUpdateProvider::WrapObject(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  JS::Rooted<JSObject*> obj(aCx, SystemUpdateProviderBinding::Wrap(aCx, this, aGivenProto));
  if (!obj) {
    return nullptr;
  }

  // Now define it on our chrome object
  JSAutoCompartment ac(aCx, mImpl->Callback());
  if (!JS_WrapObject(aCx, &obj)) {
    return nullptr;
  }
  if (!JS_DefineProperty(aCx, mImpl->Callback(), "__DOM_IMPL__", obj, 0)) {
    return nullptr;
  }
  return obj;
}

void
SystemUpdateProvider::GetName(nsString& aRetVal, ErrorResult& aRv, JSCompartment* aCompartment) const
{
  return mImpl->GetName(aRetVal, aRv, aCompartment);
}

void
SystemUpdateProvider::GetUuid(nsString& aRetVal, ErrorResult& aRv, JSCompartment* aCompartment) const
{
  return mImpl->GetUuid(aRetVal, aRv, aCompartment);
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProvider::GetOnupdateavailable(ErrorResult& aRv, JSCompartment* aCompartment) const
{
  return mImpl->GetOnupdateavailable(aRv, aCompartment);
}

void
SystemUpdateProvider::SetOnupdateavailable(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  mImpl->SetOnupdateavailable(arg, aRv, aCompartment);
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProvider::GetOnprogress(ErrorResult& aRv, JSCompartment* aCompartment) const
{
  return mImpl->GetOnprogress(aRv, aCompartment);
}

void
SystemUpdateProvider::SetOnprogress(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  mImpl->SetOnprogress(arg, aRv, aCompartment);
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProvider::GetOnupdateready(ErrorResult& aRv, JSCompartment* aCompartment) const
{
  return mImpl->GetOnupdateready(aRv, aCompartment);
}

void
SystemUpdateProvider::SetOnupdateready(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  mImpl->SetOnupdateready(arg, aRv, aCompartment);
}

already_AddRefed<EventHandlerNonNull>
SystemUpdateProvider::GetOnerror(ErrorResult& aRv, JSCompartment* aCompartment) const
{
  return mImpl->GetOnerror(aRv, aCompartment);
}

void
SystemUpdateProvider::SetOnerror(EventHandlerNonNull* arg, ErrorResult& aRv, JSCompartment* aCompartment)
{
  mImpl->SetOnerror(arg, aRv, aCompartment);
}

void
SystemUpdateProvider::CheckForUpdate(ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->CheckForUpdate(aRv, aCompartment);
}

void
SystemUpdateProvider::StartDownload(ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->StartDownload(aRv, aCompartment);
}

void
SystemUpdateProvider::StopDownload(ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->StopDownload(aRv, aCompartment);
}

void
SystemUpdateProvider::ApplyUpdate(ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->ApplyUpdate(aRv, aCompartment);
}

bool
SystemUpdateProvider::SetParameter(const nsAString& name, const nsAString& value, ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->SetParameter(name, value, aRv, aCompartment);
}

void
SystemUpdateProvider::GetParameter(const nsAString& name, nsString& aRetVal, ErrorResult& aRv, JSCompartment* aCompartment)
{
  return mImpl->GetParameter(name, aRetVal, aRv, aCompartment);
}

bool
SystemUpdateProvider::_Create(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  if (args.length() < 2) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SystemUpdateProvider._create");
  }
  if (!args[0].isObject()) {
    return ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of SystemUpdateProvider._create");
  }
  if (!args[1].isObject()) {
    return ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 2 of SystemUpdateProvider._create");
  }

  // GlobalObject will go through wrappers as needed for us, and
  // is simpler than the right UnwrapArg incantation.
  GlobalObject global(cx, &args[0].toObject());
  if (global.Failed()) {
    return false;
  }
  nsCOMPtr<nsIGlobalObject> globalHolder = do_QueryInterface(global.GetAsSupports());
  MOZ_ASSERT(globalHolder);
  JS::Rooted<JSObject*> arg(cx, &args[1].toObject());
  RefPtr<SystemUpdateProvider> impl = new SystemUpdateProvider(arg, globalHolder);
  MOZ_ASSERT(js::IsObjectInContextCompartment(arg, cx));
  return GetOrCreateDOMReflector(cx, impl, args.rval());
}


} // namespace dom
} // namespace mozilla
