/* THIS FILE IS AUTOGENERATED FROM Telephony.webidl BY Codegen.py - DO NOT EDIT */

#include "EventHandlerBinding.h"
#include "EventTargetBinding.h"
#include "TelephonyBinding.h"
#include "WrapperFactory.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/CallsList.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/MMICall.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/Promise.h"
#include "mozilla/dom/Telephony.h"
#include "mozilla/dom/TelephonyCall.h"
#include "mozilla/dom/TelephonyCallGroup.h"
#include "mozilla/dom/UnionConversions.h"

namespace mozilla {
namespace dom {

void
ImplCycleCollectionTraverse(nsCycleCollectionTraversalCallback& aCallback, OwningTelephonyCallOrMMICall& aUnion, const char* aName, uint32_t aFlags)
{
  if (aUnion.IsTelephonyCall()) {
    ImplCycleCollectionTraverse(aCallback, aUnion.GetAsTelephonyCall(), "mTelephonyCall", aFlags);
  } else if (aUnion.IsMMICall()) {
    ImplCycleCollectionTraverse(aCallback, aUnion.GetAsMMICall(), "mMMICall", aFlags);
  }
}


void
ImplCycleCollectionTraverse(nsCycleCollectionTraversalCallback& aCallback, OwningTelephonyCallOrTelephonyCallGroup& aUnion, const char* aName, uint32_t aFlags)
{
  if (aUnion.IsTelephonyCall()) {
    ImplCycleCollectionTraverse(aCallback, aUnion.GetAsTelephonyCall(), "mTelephonyCall", aFlags);
  } else if (aUnion.IsTelephonyCallGroup()) {
    ImplCycleCollectionTraverse(aCallback, aUnion.GetAsTelephonyCallGroup(), "mTelephonyCallGroup", aFlags);
  }
}


void
ImplCycleCollectionUnlink(OwningTelephonyCallOrMMICall& aUnion)
{
  aUnion.Uninit();
}


void
ImplCycleCollectionUnlink(OwningTelephonyCallOrTelephonyCallGroup& aUnion)
{
  aUnion.Uninit();
}


bool
TelephonyCallOrMMICall::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eTelephonyCall: {
      if (!GetOrCreateDOMReflector(cx, mValue.mTelephonyCall.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    case eMMICall: {
      if (!GetOrCreateDOMReflector(cx, mValue.mMMICall.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}


OwningNonNull<mozilla::dom::TelephonyCall>&
OwningTelephonyCallOrMMICall::RawSetAsTelephonyCall()
{
  if (mType == eTelephonyCall) {
    return mValue.mTelephonyCall.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eTelephonyCall;
  return mValue.mTelephonyCall.SetValue();
}

OwningNonNull<mozilla::dom::TelephonyCall>&
OwningTelephonyCallOrMMICall::SetAsTelephonyCall()
{
  if (mType == eTelephonyCall) {
    return mValue.mTelephonyCall.Value();
  }
  Uninit();
  mType = eTelephonyCall;
  return mValue.mTelephonyCall.SetValue();
}

bool
OwningTelephonyCallOrMMICall::TrySetToTelephonyCall(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    OwningNonNull<mozilla::dom::TelephonyCall>& memberSlot = RawSetAsTelephonyCall();
    static_assert(IsRefcounted<mozilla::dom::TelephonyCall>::value, "We can only store refcounted classes.");{
      nsresult rv = UnwrapObject<prototypes::id::TelephonyCall, mozilla::dom::TelephonyCall>(&value.toObject(), memberSlot);
      if (NS_FAILED(rv)) {
        DestroyTelephonyCall();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

void
OwningTelephonyCallOrMMICall::DestroyTelephonyCall()
{
  MOZ_ASSERT(IsTelephonyCall(), "Wrong type!");
  mValue.mTelephonyCall.Destroy();
  mType = eUninitialized;
}




OwningNonNull<mozilla::dom::MMICall>&
OwningTelephonyCallOrMMICall::RawSetAsMMICall()
{
  if (mType == eMMICall) {
    return mValue.mMMICall.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eMMICall;
  return mValue.mMMICall.SetValue();
}

OwningNonNull<mozilla::dom::MMICall>&
OwningTelephonyCallOrMMICall::SetAsMMICall()
{
  if (mType == eMMICall) {
    return mValue.mMMICall.Value();
  }
  Uninit();
  mType = eMMICall;
  return mValue.mMMICall.SetValue();
}

bool
OwningTelephonyCallOrMMICall::TrySetToMMICall(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    OwningNonNull<mozilla::dom::MMICall>& memberSlot = RawSetAsMMICall();
    static_assert(IsRefcounted<mozilla::dom::MMICall>::value, "We can only store refcounted classes.");{
      nsresult rv = UnwrapObject<prototypes::id::MMICall, mozilla::dom::MMICall>(&value.toObject(), memberSlot);
      if (NS_FAILED(rv)) {
        DestroyMMICall();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

void
OwningTelephonyCallOrMMICall::DestroyMMICall()
{
  MOZ_ASSERT(IsMMICall(), "Wrong type!");
  mValue.mMMICall.Destroy();
  mType = eUninitialized;
}




void
OwningTelephonyCallOrMMICall::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eTelephonyCall: {
      DestroyTelephonyCall();
      break;
    }
    case eMMICall: {
      DestroyMMICall();
      break;
    }
  }
}

bool
OwningTelephonyCallOrMMICall::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eTelephonyCall: {
      if (!GetOrCreateDOMReflector(cx, mValue.mTelephonyCall.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    case eMMICall: {
      if (!GetOrCreateDOMReflector(cx, mValue.mMMICall.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}

void
OwningTelephonyCallOrMMICall::TraceUnion(JSTracer* trc)
{
}

void
OwningTelephonyCallOrMMICall::operator=(const OwningTelephonyCallOrMMICall& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eTelephonyCall: {
      SetAsTelephonyCall() = aOther.GetAsTelephonyCall();
      break;
    }
    case eMMICall: {
      SetAsMMICall() = aOther.GetAsMMICall();
      break;
    }
  }
}


bool
TelephonyCallOrTelephonyCallGroup::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eTelephonyCall: {
      if (!GetOrCreateDOMReflector(cx, mValue.mTelephonyCall.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    case eTelephonyCallGroup: {
      if (!GetOrCreateDOMReflector(cx, mValue.mTelephonyCallGroup.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}


OwningNonNull<mozilla::dom::TelephonyCall>&
OwningTelephonyCallOrTelephonyCallGroup::RawSetAsTelephonyCall()
{
  if (mType == eTelephonyCall) {
    return mValue.mTelephonyCall.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eTelephonyCall;
  return mValue.mTelephonyCall.SetValue();
}

OwningNonNull<mozilla::dom::TelephonyCall>&
OwningTelephonyCallOrTelephonyCallGroup::SetAsTelephonyCall()
{
  if (mType == eTelephonyCall) {
    return mValue.mTelephonyCall.Value();
  }
  Uninit();
  mType = eTelephonyCall;
  return mValue.mTelephonyCall.SetValue();
}

bool
OwningTelephonyCallOrTelephonyCallGroup::TrySetToTelephonyCall(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    OwningNonNull<mozilla::dom::TelephonyCall>& memberSlot = RawSetAsTelephonyCall();
    static_assert(IsRefcounted<mozilla::dom::TelephonyCall>::value, "We can only store refcounted classes.");{
      nsresult rv = UnwrapObject<prototypes::id::TelephonyCall, mozilla::dom::TelephonyCall>(&value.toObject(), memberSlot);
      if (NS_FAILED(rv)) {
        DestroyTelephonyCall();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

void
OwningTelephonyCallOrTelephonyCallGroup::DestroyTelephonyCall()
{
  MOZ_ASSERT(IsTelephonyCall(), "Wrong type!");
  mValue.mTelephonyCall.Destroy();
  mType = eUninitialized;
}




OwningNonNull<mozilla::dom::TelephonyCallGroup>&
OwningTelephonyCallOrTelephonyCallGroup::RawSetAsTelephonyCallGroup()
{
  if (mType == eTelephonyCallGroup) {
    return mValue.mTelephonyCallGroup.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eTelephonyCallGroup;
  return mValue.mTelephonyCallGroup.SetValue();
}

OwningNonNull<mozilla::dom::TelephonyCallGroup>&
OwningTelephonyCallOrTelephonyCallGroup::SetAsTelephonyCallGroup()
{
  if (mType == eTelephonyCallGroup) {
    return mValue.mTelephonyCallGroup.Value();
  }
  Uninit();
  mType = eTelephonyCallGroup;
  return mValue.mTelephonyCallGroup.SetValue();
}

bool
OwningTelephonyCallOrTelephonyCallGroup::TrySetToTelephonyCallGroup(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    OwningNonNull<mozilla::dom::TelephonyCallGroup>& memberSlot = RawSetAsTelephonyCallGroup();
    static_assert(IsRefcounted<mozilla::dom::TelephonyCallGroup>::value, "We can only store refcounted classes.");{
      nsresult rv = UnwrapObject<prototypes::id::TelephonyCallGroup, mozilla::dom::TelephonyCallGroup>(&value.toObject(), memberSlot);
      if (NS_FAILED(rv)) {
        DestroyTelephonyCallGroup();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

void
OwningTelephonyCallOrTelephonyCallGroup::DestroyTelephonyCallGroup()
{
  MOZ_ASSERT(IsTelephonyCallGroup(), "Wrong type!");
  mValue.mTelephonyCallGroup.Destroy();
  mType = eUninitialized;
}




void
OwningTelephonyCallOrTelephonyCallGroup::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eTelephonyCall: {
      DestroyTelephonyCall();
      break;
    }
    case eTelephonyCallGroup: {
      DestroyTelephonyCallGroup();
      break;
    }
  }
}

bool
OwningTelephonyCallOrTelephonyCallGroup::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eTelephonyCall: {
      if (!GetOrCreateDOMReflector(cx, mValue.mTelephonyCall.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    case eTelephonyCallGroup: {
      if (!GetOrCreateDOMReflector(cx, mValue.mTelephonyCallGroup.Value(), rval)) {
        MOZ_ASSERT(true || JS_IsExceptionPending(cx));
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}

void
OwningTelephonyCallOrTelephonyCallGroup::TraceUnion(JSTracer* trc)
{
}

void
OwningTelephonyCallOrTelephonyCallGroup::operator=(const OwningTelephonyCallOrTelephonyCallGroup& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eTelephonyCall: {
      SetAsTelephonyCall() = aOther.GetAsTelephonyCall();
      break;
    }
    case eTelephonyCallGroup: {
      SetAsTelephonyCallGroup() = aOther.GetAsTelephonyCallGroup();
      break;
    }
  }
}


namespace TelephonyBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<EventTargetBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
dial(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "Telephony.dial");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  Optional<uint32_t> arg1;
  if (args.hasDefined(1)) {
    arg1.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->Dial(NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
dial_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = dial(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo dial_methodinfo = {
  { (JSJitGetterOp)dial_promiseWrapper },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
dialEmergency(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "Telephony.dialEmergency");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  Optional<uint32_t> arg1;
  if (args.hasDefined(1)) {
    arg1.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->DialEmergency(NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
dialEmergency_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = dialEmergency(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo dialEmergency_methodinfo = {
  { (JSJitGetterOp)dialEmergency_promiseWrapper },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
sendTones(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "Telephony.sendTones");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  uint32_t arg1;
  if (args.hasDefined(1)) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1)) {
      return false;
    }
  } else {
    arg1 = 3000U;
  }
  uint32_t arg2;
  if (args.hasDefined(2)) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[2], &arg2)) {
      return false;
    }
  } else {
    arg2 = 70U;
  }
  Optional<uint32_t> arg3;
  if (args.hasDefined(3)) {
    arg3.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[3], &arg3.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->SendTones(NonNullHelper(Constify(arg0)), arg1, arg2, Constify(arg3), rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
sendTones_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = sendTones(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo sendTones_methodinfo = {
  { (JSJitGetterOp)sendTones_promiseWrapper },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
startTone(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "Telephony.startTone");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  Optional<uint32_t> arg1;
  if (args.hasDefined(1)) {
    arg1.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  self->StartTone(NonNullHelper(Constify(arg0)), Constify(arg1), rv);
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo startTone_methodinfo = {
  { (JSJitGetterOp)startTone },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
stopTone(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  Optional<uint32_t> arg0;
  if (args.hasDefined(0)) {
    arg0.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  self->StopTone(Constify(arg0), rv);
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo stopTone_methodinfo = {
  { (JSJitGetterOp)stopTone },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
ownAudioChannel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  ErrorResult rv;
  self->OwnAudioChannel(rv);
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo ownAudioChannel_methodinfo = {
  { (JSJitGetterOp)ownAudioChannel },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_muted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  ErrorResult rv;
  bool result(self->GetMuted(rv));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static bool
set_muted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  bool arg0;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  ErrorResult rv;
  self->SetMuted(arg0, rv);
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo muted_getterinfo = {
  { (JSJitGetterOp)get_muted },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo muted_setterinfo = {
  { (JSJitGetterOp)set_muted },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_speakerEnabled(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  ErrorResult rv;
  bool result(self->GetSpeakerEnabled(rv));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static bool
set_speakerEnabled(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  bool arg0;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  ErrorResult rv;
  self->SetSpeakerEnabled(arg0, rv);
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo speakerEnabled_getterinfo = {
  { (JSJitGetterOp)get_speakerEnabled },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo speakerEnabled_setterinfo = {
  { (JSJitGetterOp)set_speakerEnabled },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_active(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  Nullable<OwningTelephonyCallOrTelephonyCallGroup> result;
  self->GetActive(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result.IsNull()) {
    args.rval().setNull();
    return true;
  }
  if (!result.Value().ToJSVal(cx, obj, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo active_getterinfo = {
  { (JSJitGetterOp)get_active },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_calls(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::CallsList>(self->Calls()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo calls_getterinfo = {
  { (JSJitGetterOp)get_calls },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_conferenceGroup(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::TelephonyCallGroup>(self->ConferenceGroup()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo conferenceGroup_getterinfo = {
  { (JSJitGetterOp)get_conferenceGroup },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_ready(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->GetReady(rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo ready_getterinfo = {
  { (JSJitGetterOp)get_ready },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_onincoming(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> result(self->GetOnincoming());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onincoming(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnincoming(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo onincoming_getterinfo = {
  { (JSJitGetterOp)get_onincoming },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo onincoming_setterinfo = {
  { (JSJitGetterOp)set_onincoming },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_oncallschanged(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> result(self->GetOncallschanged());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_oncallschanged(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOncallschanged(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo oncallschanged_getterinfo = {
  { (JSJitGetterOp)get_oncallschanged },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo oncallschanged_setterinfo = {
  { (JSJitGetterOp)set_oncallschanged },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_onremoteheld(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> result(self->GetOnremoteheld());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onremoteheld(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnremoteheld(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo onremoteheld_getterinfo = {
  { (JSJitGetterOp)get_onremoteheld },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo onremoteheld_setterinfo = {
  { (JSJitGetterOp)set_onremoteheld },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_onremoteresumed(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> result(self->GetOnremoteresumed());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onremoteresumed(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  RefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnremoteresumed(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo onremoteresumed_getterinfo = {
  { (JSJitGetterOp)get_onremoteresumed },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo onremoteresumed_setterinfo = {
  { (JSJitGetterOp)set_onremoteresumed },
  { prototypes::id::Telephony },
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::Telephony* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::Telephony>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::Telephony* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::Telephony>(obj);
  if (self) {
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::Telephony>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::Telephony* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::Telephony>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const char* const allpermissions_0[] = {
  "audio-channel-telephony",
  nullptr
};

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("dial", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&dial_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("dialEmergency", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&dialEmergency_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("sendTones", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&sendTones_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("startTone", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&startTone_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("stopTone", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&stopTone_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FS_END,
  JS_FNSPEC("ownAudioChannel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&ownAudioChannel_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, 0, nullptr, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { true, 0, nullptr, nullptr, nullptr, allpermissions_0, &sMethods_specs[6] },
  { false, 0, nullptr, nullptr, nullptr, nullptr, nullptr }
};

static jsid sMethods_ids[8];

static const JSPropertySpec sAttributes_specs[] = {
  { "muted", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &muted_getterinfo } }, { { GenericBindingSetter, &muted_setterinfo } }},
  { "speakerEnabled", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &speakerEnabled_getterinfo } }, { { GenericBindingSetter, &speakerEnabled_setterinfo } }},
  { "active", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &active_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "calls", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &calls_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "conferenceGroup", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &conferenceGroup_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "ready", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &ready_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "onincoming", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &onincoming_getterinfo } }, { { GenericBindingSetter, &onincoming_setterinfo } }},
  { "oncallschanged", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &oncallschanged_getterinfo } }, { { GenericBindingSetter, &oncallschanged_setterinfo } }},
  { "onremoteheld", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &onremoteheld_getterinfo } }, { { GenericBindingSetter, &onremoteheld_setterinfo } }},
  { "onremoteresumed", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &onremoteresumed_getterinfo } }, { { GenericBindingSetter, &onremoteresumed_setterinfo } }},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, 0, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, 0, nullptr, nullptr, nullptr, nullptr, nullptr }
};

static jsid sAttributes_ids[11];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::Telephony,
  constructors::id::Telephony,
  EventTargetBinding::sNativePropertyHooks
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    {
      nullptr, /* lookupProperty */
      nullptr, /* defineProperty */
      nullptr, /* hasProperty */
      nullptr, /* getProperty */
      nullptr, /* setProperty */
      nullptr, /* getOwnPropertyDescriptor */
      nullptr, /* deleteProperty */
      nullptr, /* watch */
      nullptr, /* unwatch */
      nullptr, /* getElements */
      nullptr, /* enumerate */
      InterfaceObjectToString, /* funToString */
    }
  },
  eInterface,
  sNativePropertyHooks,
  "function Telephony() {\n    [native code]\n}",
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  EventTargetBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "TelephonyPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object TelephonyPrototype]",
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  EventTargetBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.telephony.enabled");
}

static const DOMJSClass Class = {
  { "Telephony",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::EventTarget, prototypes::id::Telephony, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::Telephony >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::Telephony>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::Telephony>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::Telephony* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::Telephony*>(aObject) ==
             reinterpret_cast<mozilla::dom::Telephony*>(aObject),
             "Multiple inheritance for mozilla::dom::Telephony is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::EventTarget*>(aObject) ==
             reinterpret_cast<mozilla::dom::EventTarget*>(aObject),
             "Multiple inheritance for mozilla::dom::EventTarget is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::Telephony> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(EventTargetBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(EventTargetBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::Telephony);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::Telephony);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nullptr,
                              "Telephony", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::Telephony)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::Telephony).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::Telephony)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::Telephony).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace TelephonyBinding



} // namespace dom
} // namespace mozilla
