//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/CacheTypes.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheQueryParams|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheQueryParams::CacheQueryParams() :
    ignoreSearch_(),
    ignoreMethod_(),
    ignoreVary_(),
    cacheNameSet_(),
    cacheName_()
{
    Init();
}

CacheQueryParams::~CacheQueryParams()
{
}

auto CacheQueryParams::operator==(const CacheQueryParams& _o) const -> bool
{
    if ((!((ignoreSearch()) == ((_o).ignoreSearch())))) {
        return false;
    }
    if ((!((ignoreMethod()) == ((_o).ignoreMethod())))) {
        return false;
    }
    if ((!((ignoreVary()) == ((_o).ignoreVary())))) {
        return false;
    }
    if ((!((cacheNameSet()) == ((_o).cacheNameSet())))) {
        return false;
    }
    if ((!((cacheName()) == ((_o).cacheName())))) {
        return false;
    }
    return true;
}

auto CacheQueryParams::Init() -> void
{
}

auto CacheQueryParams::Assign(
        const bool& _ignoreSearch,
        const bool& _ignoreMethod,
        const bool& _ignoreVary,
        const bool& _cacheNameSet,
        const nsString& _cacheName) -> void
{
    ignoreSearch_ = _ignoreSearch;
    ignoreMethod_ = _ignoreMethod;
    ignoreVary_ = _ignoreVary;
    cacheNameSet_ = _cacheNameSet;
    cacheName_ = _cacheName;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheReadStream|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheReadStream::CacheReadStream() :
    id_()
{
    Init();
}

CacheReadStream::~CacheReadStream()
{
}

auto CacheReadStream::operator==(const CacheReadStream& _o) const -> bool
{
    if ((!((id()) == ((_o).id())))) {
        return false;
    }
    if ((!((params()) == ((_o).params())))) {
        return false;
    }
    if ((!((fds()) == ((_o).fds())))) {
        return false;
    }
    if ((!((controlParent()) == ((_o).controlParent())))) {
        return false;
    }
    if ((!((controlChild()) == ((_o).controlChild())))) {
        return false;
    }
    if ((!((pushStreamParent()) == ((_o).pushStreamParent())))) {
        return false;
    }
    if ((!((pushStreamChild()) == ((_o).pushStreamChild())))) {
        return false;
    }
    return true;
}

auto CacheReadStream::Init() -> void
{
    controlParent_ = nullptr;
    controlChild_ = nullptr;
    pushStreamParent_ = nullptr;
    pushStreamChild_ = nullptr;
}

auto CacheReadStream::Assign(
        const nsID& _id,
        const OptionalInputStreamParams& _params,
        const OptionalFileDescriptorSet& _fds,
        PCacheStreamControlParent* _controlParent,
        PCacheStreamControlChild* _controlChild,
        PCachePushStreamParent* _pushStreamParent,
        PCachePushStreamChild* _pushStreamChild) -> void
{
    id_ = _id;
    params_ = _params;
    fds_ = _fds;
    controlParent_ = _controlParent;
    controlChild_ = _controlChild;
    pushStreamParent_ = _pushStreamParent;
    pushStreamChild_ = _pushStreamChild;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union CacheReadStreamOrVoid|
//
namespace mozilla {
namespace dom {
namespace cache {
auto CacheReadStreamOrVoid::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    case TCacheReadStream:
        {
            (ptr_CacheReadStream())->~CacheReadStream__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT CacheReadStreamOrVoid::CacheReadStreamOrVoid(const void_t& aOther)
{
    new (ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT CacheReadStreamOrVoid::CacheReadStreamOrVoid(const CacheReadStream& aOther)
{
    new (ptr_CacheReadStream()) CacheReadStream(aOther);
    mType = TCacheReadStream;
}

MOZ_IMPLICIT CacheReadStreamOrVoid::CacheReadStreamOrVoid(const CacheReadStreamOrVoid& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tvoid_t:
        {
            new (ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case TCacheReadStream:
        {
            new (ptr_CacheReadStream()) CacheReadStream((aOther).get_CacheReadStream());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

CacheReadStreamOrVoid::~CacheReadStreamOrVoid()
{
    MaybeDestroy(T__None);
}

auto CacheReadStreamOrVoid::operator=(const void_t& aRhs) -> CacheReadStreamOrVoid&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto CacheReadStreamOrVoid::operator=(const CacheReadStream& aRhs) -> CacheReadStreamOrVoid&
{
    if (MaybeDestroy(TCacheReadStream)) {
        new (ptr_CacheReadStream()) CacheReadStream;
    }
    (*(ptr_CacheReadStream())) = aRhs;
    mType = TCacheReadStream;
    return (*(this));
}

auto CacheReadStreamOrVoid::operator=(const CacheReadStreamOrVoid& aRhs) -> CacheReadStreamOrVoid&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case TCacheReadStream:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheReadStream()) CacheReadStream;
            }
            (*(ptr_CacheReadStream())) = (aRhs).get_CacheReadStream();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto CacheReadStreamOrVoid::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto CacheReadStreamOrVoid::operator==(const CacheReadStream& aRhs) const -> bool
{
    return (get_CacheReadStream()) == (aRhs);
}

auto CacheReadStreamOrVoid::operator==(const CacheReadStreamOrVoid& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    case TCacheReadStream:
        {
            return (get_CacheReadStream()) == ((aRhs).get_CacheReadStream());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct HeadersEntry|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT HeadersEntry::HeadersEntry() :
    name_(),
    value_()
{
    Init();
}

HeadersEntry::~HeadersEntry()
{
}

auto HeadersEntry::operator==(const HeadersEntry& _o) const -> bool
{
    if ((!((name()) == ((_o).name())))) {
        return false;
    }
    if ((!((value()) == ((_o).value())))) {
        return false;
    }
    return true;
}

auto HeadersEntry::Init() -> void
{
}

auto HeadersEntry::Assign(
        const nsCString& _name,
        const nsCString& _value) -> void
{
    name_ = _name;
    value_ = _value;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheRequest|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheRequest::CacheRequest() :
    method_(),
    urlWithoutQuery_(),
    urlQuery_(),
    headersGuard_(),
    referrer_(),
    mode_(),
    credentials_(),
    contentPolicyType_(),
    requestCache_(),
    requestRedirect_()
{
    Init();
}

CacheRequest::~CacheRequest()
{
}

auto CacheRequest::operator==(const CacheRequest& _o) const -> bool
{
    if ((!((method()) == ((_o).method())))) {
        return false;
    }
    if ((!((urlWithoutQuery()) == ((_o).urlWithoutQuery())))) {
        return false;
    }
    if ((!((urlQuery()) == ((_o).urlQuery())))) {
        return false;
    }
    if ((!((headers()) == ((_o).headers())))) {
        return false;
    }
    if ((!((headersGuard()) == ((_o).headersGuard())))) {
        return false;
    }
    if ((!((referrer()) == ((_o).referrer())))) {
        return false;
    }
    if ((!((mode()) == ((_o).mode())))) {
        return false;
    }
    if ((!((credentials()) == ((_o).credentials())))) {
        return false;
    }
    if ((!((body()) == ((_o).body())))) {
        return false;
    }
    if ((!((contentPolicyType()) == ((_o).contentPolicyType())))) {
        return false;
    }
    if ((!((requestCache()) == ((_o).requestCache())))) {
        return false;
    }
    if ((!((requestRedirect()) == ((_o).requestRedirect())))) {
        return false;
    }
    return true;
}

auto CacheRequest::Init() -> void
{
}

auto CacheRequest::Assign(
        const nsCString& _method,
        const nsCString& _urlWithoutQuery,
        const nsCString& _urlQuery,
        const nsTArray<HeadersEntry>& _headers,
        const HeadersGuardEnum& _headersGuard,
        const nsString& _referrer,
        const RequestMode& _mode,
        const RequestCredentials& _credentials,
        const CacheReadStreamOrVoid& _body,
        const uint32_t& _contentPolicyType,
        const RequestCache& _requestCache,
        const RequestRedirect& _requestRedirect) -> void
{
    method_ = _method;
    urlWithoutQuery_ = _urlWithoutQuery;
    urlQuery_ = _urlQuery;
    headers_ = _headers;
    headersGuard_ = _headersGuard;
    referrer_ = _referrer;
    mode_ = _mode;
    credentials_ = _credentials;
    body_ = _body;
    contentPolicyType_ = _contentPolicyType;
    requestCache_ = _requestCache;
    requestRedirect_ = _requestRedirect;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union CacheRequestOrVoid|
//
namespace mozilla {
namespace dom {
namespace cache {
auto CacheRequestOrVoid::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    case TCacheRequest:
        {
            (ptr_CacheRequest())->~CacheRequest__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT CacheRequestOrVoid::CacheRequestOrVoid(const void_t& aOther)
{
    new (ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT CacheRequestOrVoid::CacheRequestOrVoid(const CacheRequest& aOther)
{
    new (ptr_CacheRequest()) CacheRequest(aOther);
    mType = TCacheRequest;
}

MOZ_IMPLICIT CacheRequestOrVoid::CacheRequestOrVoid(const CacheRequestOrVoid& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tvoid_t:
        {
            new (ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case TCacheRequest:
        {
            new (ptr_CacheRequest()) CacheRequest((aOther).get_CacheRequest());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

CacheRequestOrVoid::~CacheRequestOrVoid()
{
    MaybeDestroy(T__None);
}

auto CacheRequestOrVoid::operator=(const void_t& aRhs) -> CacheRequestOrVoid&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto CacheRequestOrVoid::operator=(const CacheRequest& aRhs) -> CacheRequestOrVoid&
{
    if (MaybeDestroy(TCacheRequest)) {
        new (ptr_CacheRequest()) CacheRequest;
    }
    (*(ptr_CacheRequest())) = aRhs;
    mType = TCacheRequest;
    return (*(this));
}

auto CacheRequestOrVoid::operator=(const CacheRequestOrVoid& aRhs) -> CacheRequestOrVoid&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case TCacheRequest:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheRequest()) CacheRequest;
            }
            (*(ptr_CacheRequest())) = (aRhs).get_CacheRequest();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto CacheRequestOrVoid::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto CacheRequestOrVoid::operator==(const CacheRequest& aRhs) const -> bool
{
    return (get_CacheRequest()) == (aRhs);
}

auto CacheRequestOrVoid::operator==(const CacheRequestOrVoid& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    case TCacheRequest:
        {
            return (get_CacheRequest()) == ((aRhs).get_CacheRequest());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheResponse|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheResponse::CacheResponse() :
    type_(),
    url_(),
    status_(),
    statusText_(),
    headersGuard_()
{
    Init();
}

CacheResponse::~CacheResponse()
{
}

auto CacheResponse::operator==(const CacheResponse& _o) const -> bool
{
    if ((!((type()) == ((_o).type())))) {
        return false;
    }
    if ((!((url()) == ((_o).url())))) {
        return false;
    }
    if ((!((status()) == ((_o).status())))) {
        return false;
    }
    if ((!((statusText()) == ((_o).statusText())))) {
        return false;
    }
    if ((!((headers()) == ((_o).headers())))) {
        return false;
    }
    if ((!((headersGuard()) == ((_o).headersGuard())))) {
        return false;
    }
    if ((!((body()) == ((_o).body())))) {
        return false;
    }
    if ((!((channelInfo()) == ((_o).channelInfo())))) {
        return false;
    }
    if ((!((principalInfo()) == ((_o).principalInfo())))) {
        return false;
    }
    return true;
}

auto CacheResponse::Init() -> void
{
}

auto CacheResponse::Assign(
        const ResponseType& _type,
        const nsCString& _url,
        const uint32_t& _status,
        const nsCString& _statusText,
        const nsTArray<HeadersEntry>& _headers,
        const HeadersGuardEnum& _headersGuard,
        const CacheReadStreamOrVoid& _body,
        const IPCChannelInfo& _channelInfo,
        const OptionalPrincipalInfo& _principalInfo) -> void
{
    type_ = _type;
    url_ = _url;
    status_ = _status;
    statusText_ = _statusText;
    headers_ = _headers;
    headersGuard_ = _headersGuard;
    body_ = _body;
    channelInfo_ = _channelInfo;
    principalInfo_ = _principalInfo;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union CacheResponseOrVoid|
//
namespace mozilla {
namespace dom {
namespace cache {
auto CacheResponseOrVoid::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    case TCacheResponse:
        {
            (ptr_CacheResponse())->~CacheResponse__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT CacheResponseOrVoid::CacheResponseOrVoid(const void_t& aOther)
{
    new (ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT CacheResponseOrVoid::CacheResponseOrVoid(const CacheResponse& aOther)
{
    new (ptr_CacheResponse()) CacheResponse(aOther);
    mType = TCacheResponse;
}

MOZ_IMPLICIT CacheResponseOrVoid::CacheResponseOrVoid(const CacheResponseOrVoid& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tvoid_t:
        {
            new (ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case TCacheResponse:
        {
            new (ptr_CacheResponse()) CacheResponse((aOther).get_CacheResponse());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

CacheResponseOrVoid::~CacheResponseOrVoid()
{
    MaybeDestroy(T__None);
}

auto CacheResponseOrVoid::operator=(const void_t& aRhs) -> CacheResponseOrVoid&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto CacheResponseOrVoid::operator=(const CacheResponse& aRhs) -> CacheResponseOrVoid&
{
    if (MaybeDestroy(TCacheResponse)) {
        new (ptr_CacheResponse()) CacheResponse;
    }
    (*(ptr_CacheResponse())) = aRhs;
    mType = TCacheResponse;
    return (*(this));
}

auto CacheResponseOrVoid::operator=(const CacheResponseOrVoid& aRhs) -> CacheResponseOrVoid&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case TCacheResponse:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheResponse()) CacheResponse;
            }
            (*(ptr_CacheResponse())) = (aRhs).get_CacheResponse();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto CacheResponseOrVoid::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto CacheResponseOrVoid::operator==(const CacheResponse& aRhs) const -> bool
{
    return (get_CacheResponse()) == (aRhs);
}

auto CacheResponseOrVoid::operator==(const CacheResponseOrVoid& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    case TCacheResponse:
        {
            return (get_CacheResponse()) == ((aRhs).get_CacheResponse());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheRequestResponse|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheRequestResponse::CacheRequestResponse()
{
    Init();
}

CacheRequestResponse::~CacheRequestResponse()
{
}

auto CacheRequestResponse::operator==(const CacheRequestResponse& _o) const -> bool
{
    if ((!((request()) == ((_o).request())))) {
        return false;
    }
    if ((!((response()) == ((_o).response())))) {
        return false;
    }
    return true;
}

auto CacheRequestResponse::Init() -> void
{
}

auto CacheRequestResponse::Assign(
        const CacheRequest& _request,
        const CacheResponse& _response) -> void
{
    request_ = _request;
    response_ = _response;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheMatchArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheMatchArgs::CacheMatchArgs()
{
    Init();
}

CacheMatchArgs::~CacheMatchArgs()
{
}

auto CacheMatchArgs::operator==(const CacheMatchArgs& _o) const -> bool
{
    if ((!((request()) == ((_o).request())))) {
        return false;
    }
    if ((!((params()) == ((_o).params())))) {
        return false;
    }
    return true;
}

auto CacheMatchArgs::Init() -> void
{
}

auto CacheMatchArgs::Assign(
        const CacheRequest& _request,
        const CacheQueryParams& _params) -> void
{
    request_ = _request;
    params_ = _params;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheMatchAllArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheMatchAllArgs::CacheMatchAllArgs()
{
    Init();
}

CacheMatchAllArgs::~CacheMatchAllArgs()
{
}

auto CacheMatchAllArgs::operator==(const CacheMatchAllArgs& _o) const -> bool
{
    if ((!((requestOrVoid()) == ((_o).requestOrVoid())))) {
        return false;
    }
    if ((!((params()) == ((_o).params())))) {
        return false;
    }
    return true;
}

auto CacheMatchAllArgs::Init() -> void
{
}

auto CacheMatchAllArgs::Assign(
        const CacheRequestOrVoid& _requestOrVoid,
        const CacheQueryParams& _params) -> void
{
    requestOrVoid_ = _requestOrVoid;
    params_ = _params;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CachePutAllArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CachePutAllArgs::CachePutAllArgs()
{
    Init();
}

CachePutAllArgs::~CachePutAllArgs()
{
}

auto CachePutAllArgs::operator==(const CachePutAllArgs& _o) const -> bool
{
    if ((!((requestResponseList()) == ((_o).requestResponseList())))) {
        return false;
    }
    return true;
}

auto CachePutAllArgs::Init() -> void
{
}

auto CachePutAllArgs::Assign(const nsTArray<CacheRequestResponse>& _requestResponseList) -> void
{
    requestResponseList_ = _requestResponseList;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheDeleteArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheDeleteArgs::CacheDeleteArgs()
{
    Init();
}

CacheDeleteArgs::~CacheDeleteArgs()
{
}

auto CacheDeleteArgs::operator==(const CacheDeleteArgs& _o) const -> bool
{
    if ((!((request()) == ((_o).request())))) {
        return false;
    }
    if ((!((params()) == ((_o).params())))) {
        return false;
    }
    return true;
}

auto CacheDeleteArgs::Init() -> void
{
}

auto CacheDeleteArgs::Assign(
        const CacheRequest& _request,
        const CacheQueryParams& _params) -> void
{
    request_ = _request;
    params_ = _params;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheKeysArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheKeysArgs::CacheKeysArgs()
{
    Init();
}

CacheKeysArgs::~CacheKeysArgs()
{
}

auto CacheKeysArgs::operator==(const CacheKeysArgs& _o) const -> bool
{
    if ((!((requestOrVoid()) == ((_o).requestOrVoid())))) {
        return false;
    }
    if ((!((params()) == ((_o).params())))) {
        return false;
    }
    return true;
}

auto CacheKeysArgs::Init() -> void
{
}

auto CacheKeysArgs::Assign(
        const CacheRequestOrVoid& _requestOrVoid,
        const CacheQueryParams& _params) -> void
{
    requestOrVoid_ = _requestOrVoid;
    params_ = _params;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageMatchArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageMatchArgs::StorageMatchArgs()
{
    Init();
}

StorageMatchArgs::~StorageMatchArgs()
{
}

auto StorageMatchArgs::operator==(const StorageMatchArgs& _o) const -> bool
{
    if ((!((request()) == ((_o).request())))) {
        return false;
    }
    if ((!((params()) == ((_o).params())))) {
        return false;
    }
    return true;
}

auto StorageMatchArgs::Init() -> void
{
}

auto StorageMatchArgs::Assign(
        const CacheRequest& _request,
        const CacheQueryParams& _params) -> void
{
    request_ = _request;
    params_ = _params;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageHasArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageHasArgs::StorageHasArgs() :
    key_()
{
    Init();
}

StorageHasArgs::~StorageHasArgs()
{
}

auto StorageHasArgs::operator==(const StorageHasArgs& _o) const -> bool
{
    if ((!((key()) == ((_o).key())))) {
        return false;
    }
    return true;
}

auto StorageHasArgs::Init() -> void
{
}

auto StorageHasArgs::Assign(const nsString& _key) -> void
{
    key_ = _key;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageOpenArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageOpenArgs::StorageOpenArgs() :
    key_()
{
    Init();
}

StorageOpenArgs::~StorageOpenArgs()
{
}

auto StorageOpenArgs::operator==(const StorageOpenArgs& _o) const -> bool
{
    if ((!((key()) == ((_o).key())))) {
        return false;
    }
    return true;
}

auto StorageOpenArgs::Init() -> void
{
}

auto StorageOpenArgs::Assign(const nsString& _key) -> void
{
    key_ = _key;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageDeleteArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageDeleteArgs::StorageDeleteArgs() :
    key_()
{
    Init();
}

StorageDeleteArgs::~StorageDeleteArgs()
{
}

auto StorageDeleteArgs::operator==(const StorageDeleteArgs& _o) const -> bool
{
    if ((!((key()) == ((_o).key())))) {
        return false;
    }
    return true;
}

auto StorageDeleteArgs::Init() -> void
{
}

auto StorageDeleteArgs::Assign(const nsString& _key) -> void
{
    key_ = _key;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageKeysArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
StorageKeysArgs::~StorageKeysArgs()
{
}

auto StorageKeysArgs::operator==(const StorageKeysArgs& _o) const -> bool
{
    return true;
}

auto StorageKeysArgs::Init() -> void
{
}

auto StorageKeysArgs::Assign() -> void
{
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union CacheOpArgs|
//
namespace mozilla {
namespace dom {
namespace cache {
auto CacheOpArgs::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TCacheMatchArgs:
        {
            (ptr_CacheMatchArgs())->~CacheMatchArgs__tdef();
            break;
        }
    case TCacheMatchAllArgs:
        {
            (ptr_CacheMatchAllArgs())->~CacheMatchAllArgs__tdef();
            break;
        }
    case TCachePutAllArgs:
        {
            (ptr_CachePutAllArgs())->~CachePutAllArgs__tdef();
            break;
        }
    case TCacheDeleteArgs:
        {
            (ptr_CacheDeleteArgs())->~CacheDeleteArgs__tdef();
            break;
        }
    case TCacheKeysArgs:
        {
            (ptr_CacheKeysArgs())->~CacheKeysArgs__tdef();
            break;
        }
    case TStorageMatchArgs:
        {
            (ptr_StorageMatchArgs())->~StorageMatchArgs__tdef();
            break;
        }
    case TStorageHasArgs:
        {
            (ptr_StorageHasArgs())->~StorageHasArgs__tdef();
            break;
        }
    case TStorageOpenArgs:
        {
            (ptr_StorageOpenArgs())->~StorageOpenArgs__tdef();
            break;
        }
    case TStorageDeleteArgs:
        {
            (ptr_StorageDeleteArgs())->~StorageDeleteArgs__tdef();
            break;
        }
    case TStorageKeysArgs:
        {
            (ptr_StorageKeysArgs())->~StorageKeysArgs__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const CacheMatchArgs& aOther)
{
    new (ptr_CacheMatchArgs()) CacheMatchArgs(aOther);
    mType = TCacheMatchArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const CacheMatchAllArgs& aOther)
{
    new (ptr_CacheMatchAllArgs()) CacheMatchAllArgs(aOther);
    mType = TCacheMatchAllArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const CachePutAllArgs& aOther)
{
    new (ptr_CachePutAllArgs()) CachePutAllArgs(aOther);
    mType = TCachePutAllArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const CacheDeleteArgs& aOther)
{
    new (ptr_CacheDeleteArgs()) CacheDeleteArgs(aOther);
    mType = TCacheDeleteArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const CacheKeysArgs& aOther)
{
    new (ptr_CacheKeysArgs()) CacheKeysArgs(aOther);
    mType = TCacheKeysArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const StorageMatchArgs& aOther)
{
    new (ptr_StorageMatchArgs()) StorageMatchArgs(aOther);
    mType = TStorageMatchArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const StorageHasArgs& aOther)
{
    new (ptr_StorageHasArgs()) StorageHasArgs(aOther);
    mType = TStorageHasArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const StorageOpenArgs& aOther)
{
    new (ptr_StorageOpenArgs()) StorageOpenArgs(aOther);
    mType = TStorageOpenArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const StorageDeleteArgs& aOther)
{
    new (ptr_StorageDeleteArgs()) StorageDeleteArgs(aOther);
    mType = TStorageDeleteArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const StorageKeysArgs& aOther)
{
    new (ptr_StorageKeysArgs()) StorageKeysArgs(aOther);
    mType = TStorageKeysArgs;
}

MOZ_IMPLICIT CacheOpArgs::CacheOpArgs(const CacheOpArgs& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TCacheMatchArgs:
        {
            new (ptr_CacheMatchArgs()) CacheMatchArgs((aOther).get_CacheMatchArgs());
            break;
        }
    case TCacheMatchAllArgs:
        {
            new (ptr_CacheMatchAllArgs()) CacheMatchAllArgs((aOther).get_CacheMatchAllArgs());
            break;
        }
    case TCachePutAllArgs:
        {
            new (ptr_CachePutAllArgs()) CachePutAllArgs((aOther).get_CachePutAllArgs());
            break;
        }
    case TCacheDeleteArgs:
        {
            new (ptr_CacheDeleteArgs()) CacheDeleteArgs((aOther).get_CacheDeleteArgs());
            break;
        }
    case TCacheKeysArgs:
        {
            new (ptr_CacheKeysArgs()) CacheKeysArgs((aOther).get_CacheKeysArgs());
            break;
        }
    case TStorageMatchArgs:
        {
            new (ptr_StorageMatchArgs()) StorageMatchArgs((aOther).get_StorageMatchArgs());
            break;
        }
    case TStorageHasArgs:
        {
            new (ptr_StorageHasArgs()) StorageHasArgs((aOther).get_StorageHasArgs());
            break;
        }
    case TStorageOpenArgs:
        {
            new (ptr_StorageOpenArgs()) StorageOpenArgs((aOther).get_StorageOpenArgs());
            break;
        }
    case TStorageDeleteArgs:
        {
            new (ptr_StorageDeleteArgs()) StorageDeleteArgs((aOther).get_StorageDeleteArgs());
            break;
        }
    case TStorageKeysArgs:
        {
            new (ptr_StorageKeysArgs()) StorageKeysArgs((aOther).get_StorageKeysArgs());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

CacheOpArgs::~CacheOpArgs()
{
    MaybeDestroy(T__None);
}

auto CacheOpArgs::operator=(const CacheMatchArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TCacheMatchArgs)) {
        new (ptr_CacheMatchArgs()) CacheMatchArgs;
    }
    (*(ptr_CacheMatchArgs())) = aRhs;
    mType = TCacheMatchArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const CacheMatchAllArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TCacheMatchAllArgs)) {
        new (ptr_CacheMatchAllArgs()) CacheMatchAllArgs;
    }
    (*(ptr_CacheMatchAllArgs())) = aRhs;
    mType = TCacheMatchAllArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const CachePutAllArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TCachePutAllArgs)) {
        new (ptr_CachePutAllArgs()) CachePutAllArgs;
    }
    (*(ptr_CachePutAllArgs())) = aRhs;
    mType = TCachePutAllArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const CacheDeleteArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TCacheDeleteArgs)) {
        new (ptr_CacheDeleteArgs()) CacheDeleteArgs;
    }
    (*(ptr_CacheDeleteArgs())) = aRhs;
    mType = TCacheDeleteArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const CacheKeysArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TCacheKeysArgs)) {
        new (ptr_CacheKeysArgs()) CacheKeysArgs;
    }
    (*(ptr_CacheKeysArgs())) = aRhs;
    mType = TCacheKeysArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const StorageMatchArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TStorageMatchArgs)) {
        new (ptr_StorageMatchArgs()) StorageMatchArgs;
    }
    (*(ptr_StorageMatchArgs())) = aRhs;
    mType = TStorageMatchArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const StorageHasArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TStorageHasArgs)) {
        new (ptr_StorageHasArgs()) StorageHasArgs;
    }
    (*(ptr_StorageHasArgs())) = aRhs;
    mType = TStorageHasArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const StorageOpenArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TStorageOpenArgs)) {
        new (ptr_StorageOpenArgs()) StorageOpenArgs;
    }
    (*(ptr_StorageOpenArgs())) = aRhs;
    mType = TStorageOpenArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const StorageDeleteArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TStorageDeleteArgs)) {
        new (ptr_StorageDeleteArgs()) StorageDeleteArgs;
    }
    (*(ptr_StorageDeleteArgs())) = aRhs;
    mType = TStorageDeleteArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const StorageKeysArgs& aRhs) -> CacheOpArgs&
{
    if (MaybeDestroy(TStorageKeysArgs)) {
        new (ptr_StorageKeysArgs()) StorageKeysArgs;
    }
    (*(ptr_StorageKeysArgs())) = aRhs;
    mType = TStorageKeysArgs;
    return (*(this));
}

auto CacheOpArgs::operator=(const CacheOpArgs& aRhs) -> CacheOpArgs&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TCacheMatchArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheMatchArgs()) CacheMatchArgs;
            }
            (*(ptr_CacheMatchArgs())) = (aRhs).get_CacheMatchArgs();
            break;
        }
    case TCacheMatchAllArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheMatchAllArgs()) CacheMatchAllArgs;
            }
            (*(ptr_CacheMatchAllArgs())) = (aRhs).get_CacheMatchAllArgs();
            break;
        }
    case TCachePutAllArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CachePutAllArgs()) CachePutAllArgs;
            }
            (*(ptr_CachePutAllArgs())) = (aRhs).get_CachePutAllArgs();
            break;
        }
    case TCacheDeleteArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheDeleteArgs()) CacheDeleteArgs;
            }
            (*(ptr_CacheDeleteArgs())) = (aRhs).get_CacheDeleteArgs();
            break;
        }
    case TCacheKeysArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheKeysArgs()) CacheKeysArgs;
            }
            (*(ptr_CacheKeysArgs())) = (aRhs).get_CacheKeysArgs();
            break;
        }
    case TStorageMatchArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageMatchArgs()) StorageMatchArgs;
            }
            (*(ptr_StorageMatchArgs())) = (aRhs).get_StorageMatchArgs();
            break;
        }
    case TStorageHasArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageHasArgs()) StorageHasArgs;
            }
            (*(ptr_StorageHasArgs())) = (aRhs).get_StorageHasArgs();
            break;
        }
    case TStorageOpenArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageOpenArgs()) StorageOpenArgs;
            }
            (*(ptr_StorageOpenArgs())) = (aRhs).get_StorageOpenArgs();
            break;
        }
    case TStorageDeleteArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageDeleteArgs()) StorageDeleteArgs;
            }
            (*(ptr_StorageDeleteArgs())) = (aRhs).get_StorageDeleteArgs();
            break;
        }
    case TStorageKeysArgs:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageKeysArgs()) StorageKeysArgs;
            }
            (*(ptr_StorageKeysArgs())) = (aRhs).get_StorageKeysArgs();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto CacheOpArgs::operator==(const CacheMatchArgs& aRhs) const -> bool
{
    return (get_CacheMatchArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const CacheMatchAllArgs& aRhs) const -> bool
{
    return (get_CacheMatchAllArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const CachePutAllArgs& aRhs) const -> bool
{
    return (get_CachePutAllArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const CacheDeleteArgs& aRhs) const -> bool
{
    return (get_CacheDeleteArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const CacheKeysArgs& aRhs) const -> bool
{
    return (get_CacheKeysArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const StorageMatchArgs& aRhs) const -> bool
{
    return (get_StorageMatchArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const StorageHasArgs& aRhs) const -> bool
{
    return (get_StorageHasArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const StorageOpenArgs& aRhs) const -> bool
{
    return (get_StorageOpenArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const StorageDeleteArgs& aRhs) const -> bool
{
    return (get_StorageDeleteArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const StorageKeysArgs& aRhs) const -> bool
{
    return (get_StorageKeysArgs()) == (aRhs);
}

auto CacheOpArgs::operator==(const CacheOpArgs& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TCacheMatchArgs:
        {
            return (get_CacheMatchArgs()) == ((aRhs).get_CacheMatchArgs());
        }
    case TCacheMatchAllArgs:
        {
            return (get_CacheMatchAllArgs()) == ((aRhs).get_CacheMatchAllArgs());
        }
    case TCachePutAllArgs:
        {
            return (get_CachePutAllArgs()) == ((aRhs).get_CachePutAllArgs());
        }
    case TCacheDeleteArgs:
        {
            return (get_CacheDeleteArgs()) == ((aRhs).get_CacheDeleteArgs());
        }
    case TCacheKeysArgs:
        {
            return (get_CacheKeysArgs()) == ((aRhs).get_CacheKeysArgs());
        }
    case TStorageMatchArgs:
        {
            return (get_StorageMatchArgs()) == ((aRhs).get_StorageMatchArgs());
        }
    case TStorageHasArgs:
        {
            return (get_StorageHasArgs()) == ((aRhs).get_StorageHasArgs());
        }
    case TStorageOpenArgs:
        {
            return (get_StorageOpenArgs()) == ((aRhs).get_StorageOpenArgs());
        }
    case TStorageDeleteArgs:
        {
            return (get_StorageDeleteArgs()) == ((aRhs).get_StorageDeleteArgs());
        }
    case TStorageKeysArgs:
        {
            return (get_StorageKeysArgs()) == ((aRhs).get_StorageKeysArgs());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheMatchResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheMatchResult::CacheMatchResult()
{
    Init();
}

CacheMatchResult::~CacheMatchResult()
{
}

auto CacheMatchResult::operator==(const CacheMatchResult& _o) const -> bool
{
    if ((!((responseOrVoid()) == ((_o).responseOrVoid())))) {
        return false;
    }
    return true;
}

auto CacheMatchResult::Init() -> void
{
}

auto CacheMatchResult::Assign(const CacheResponseOrVoid& _responseOrVoid) -> void
{
    responseOrVoid_ = _responseOrVoid;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheMatchAllResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheMatchAllResult::CacheMatchAllResult()
{
    Init();
}

CacheMatchAllResult::~CacheMatchAllResult()
{
}

auto CacheMatchAllResult::operator==(const CacheMatchAllResult& _o) const -> bool
{
    if ((!((responseList()) == ((_o).responseList())))) {
        return false;
    }
    return true;
}

auto CacheMatchAllResult::Init() -> void
{
}

auto CacheMatchAllResult::Assign(const nsTArray<CacheResponse>& _responseList) -> void
{
    responseList_ = _responseList;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CachePutAllResult|
//
namespace mozilla {
namespace dom {
namespace cache {
CachePutAllResult::~CachePutAllResult()
{
}

auto CachePutAllResult::operator==(const CachePutAllResult& _o) const -> bool
{
    return true;
}

auto CachePutAllResult::Init() -> void
{
}

auto CachePutAllResult::Assign() -> void
{
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheDeleteResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheDeleteResult::CacheDeleteResult() :
    success_()
{
    Init();
}

CacheDeleteResult::~CacheDeleteResult()
{
}

auto CacheDeleteResult::operator==(const CacheDeleteResult& _o) const -> bool
{
    if ((!((success()) == ((_o).success())))) {
        return false;
    }
    return true;
}

auto CacheDeleteResult::Init() -> void
{
}

auto CacheDeleteResult::Assign(const bool& _success) -> void
{
    success_ = _success;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CacheKeysResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT CacheKeysResult::CacheKeysResult()
{
    Init();
}

CacheKeysResult::~CacheKeysResult()
{
}

auto CacheKeysResult::operator==(const CacheKeysResult& _o) const -> bool
{
    if ((!((requestList()) == ((_o).requestList())))) {
        return false;
    }
    return true;
}

auto CacheKeysResult::Init() -> void
{
}

auto CacheKeysResult::Assign(const nsTArray<CacheRequest>& _requestList) -> void
{
    requestList_ = _requestList;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageMatchResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageMatchResult::StorageMatchResult()
{
    Init();
}

StorageMatchResult::~StorageMatchResult()
{
}

auto StorageMatchResult::operator==(const StorageMatchResult& _o) const -> bool
{
    if ((!((responseOrVoid()) == ((_o).responseOrVoid())))) {
        return false;
    }
    return true;
}

auto StorageMatchResult::Init() -> void
{
}

auto StorageMatchResult::Assign(const CacheResponseOrVoid& _responseOrVoid) -> void
{
    responseOrVoid_ = _responseOrVoid;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageHasResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageHasResult::StorageHasResult() :
    success_()
{
    Init();
}

StorageHasResult::~StorageHasResult()
{
}

auto StorageHasResult::operator==(const StorageHasResult& _o) const -> bool
{
    if ((!((success()) == ((_o).success())))) {
        return false;
    }
    return true;
}

auto StorageHasResult::Init() -> void
{
}

auto StorageHasResult::Assign(const bool& _success) -> void
{
    success_ = _success;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageOpenResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageOpenResult::StorageOpenResult()
{
    Init();
}

StorageOpenResult::~StorageOpenResult()
{
}

auto StorageOpenResult::operator==(const StorageOpenResult& _o) const -> bool
{
    if ((!((actorParent()) == ((_o).actorParent())))) {
        return false;
    }
    if ((!((actorChild()) == ((_o).actorChild())))) {
        return false;
    }
    return true;
}

auto StorageOpenResult::Init() -> void
{
    actorParent_ = nullptr;
    actorChild_ = nullptr;
}

auto StorageOpenResult::Assign(
        PCacheParent* _actorParent,
        PCacheChild* _actorChild) -> void
{
    actorParent_ = _actorParent;
    actorChild_ = _actorChild;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageDeleteResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageDeleteResult::StorageDeleteResult() :
    success_()
{
    Init();
}

StorageDeleteResult::~StorageDeleteResult()
{
}

auto StorageDeleteResult::operator==(const StorageDeleteResult& _o) const -> bool
{
    if ((!((success()) == ((_o).success())))) {
        return false;
    }
    return true;
}

auto StorageDeleteResult::Init() -> void
{
}

auto StorageDeleteResult::Assign(const bool& _success) -> void
{
    success_ = _success;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct StorageKeysResult|
//
namespace mozilla {
namespace dom {
namespace cache {
MOZ_IMPLICIT StorageKeysResult::StorageKeysResult()
{
    Init();
}

StorageKeysResult::~StorageKeysResult()
{
}

auto StorageKeysResult::operator==(const StorageKeysResult& _o) const -> bool
{
    if ((!((keyList()) == ((_o).keyList())))) {
        return false;
    }
    return true;
}

auto StorageKeysResult::Init() -> void
{
}

auto StorageKeysResult::Assign(const nsTArray<nsString>& _keyList) -> void
{
    keyList_ = _keyList;
}

} // namespace cache
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union CacheOpResult|
//
namespace mozilla {
namespace dom {
namespace cache {
auto CacheOpResult::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    case TCacheMatchResult:
        {
            (ptr_CacheMatchResult())->~CacheMatchResult__tdef();
            break;
        }
    case TCacheMatchAllResult:
        {
            (ptr_CacheMatchAllResult())->~CacheMatchAllResult__tdef();
            break;
        }
    case TCachePutAllResult:
        {
            (ptr_CachePutAllResult())->~CachePutAllResult__tdef();
            break;
        }
    case TCacheDeleteResult:
        {
            (ptr_CacheDeleteResult())->~CacheDeleteResult__tdef();
            break;
        }
    case TCacheKeysResult:
        {
            (ptr_CacheKeysResult())->~CacheKeysResult__tdef();
            break;
        }
    case TStorageMatchResult:
        {
            (ptr_StorageMatchResult())->~StorageMatchResult__tdef();
            break;
        }
    case TStorageHasResult:
        {
            (ptr_StorageHasResult())->~StorageHasResult__tdef();
            break;
        }
    case TStorageOpenResult:
        {
            (ptr_StorageOpenResult())->~StorageOpenResult__tdef();
            break;
        }
    case TStorageDeleteResult:
        {
            (ptr_StorageDeleteResult())->~StorageDeleteResult__tdef();
            break;
        }
    case TStorageKeysResult:
        {
            (ptr_StorageKeysResult())->~StorageKeysResult__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const void_t& aOther)
{
    new (ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const CacheMatchResult& aOther)
{
    new (ptr_CacheMatchResult()) CacheMatchResult(aOther);
    mType = TCacheMatchResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const CacheMatchAllResult& aOther)
{
    new (ptr_CacheMatchAllResult()) CacheMatchAllResult(aOther);
    mType = TCacheMatchAllResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const CachePutAllResult& aOther)
{
    new (ptr_CachePutAllResult()) CachePutAllResult(aOther);
    mType = TCachePutAllResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const CacheDeleteResult& aOther)
{
    new (ptr_CacheDeleteResult()) CacheDeleteResult(aOther);
    mType = TCacheDeleteResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const CacheKeysResult& aOther)
{
    new (ptr_CacheKeysResult()) CacheKeysResult(aOther);
    mType = TCacheKeysResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const StorageMatchResult& aOther)
{
    new (ptr_StorageMatchResult()) StorageMatchResult(aOther);
    mType = TStorageMatchResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const StorageHasResult& aOther)
{
    new (ptr_StorageHasResult()) StorageHasResult(aOther);
    mType = TStorageHasResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const StorageOpenResult& aOther)
{
    new (ptr_StorageOpenResult()) StorageOpenResult(aOther);
    mType = TStorageOpenResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const StorageDeleteResult& aOther)
{
    new (ptr_StorageDeleteResult()) StorageDeleteResult(aOther);
    mType = TStorageDeleteResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const StorageKeysResult& aOther)
{
    new (ptr_StorageKeysResult()) StorageKeysResult(aOther);
    mType = TStorageKeysResult;
}

MOZ_IMPLICIT CacheOpResult::CacheOpResult(const CacheOpResult& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tvoid_t:
        {
            new (ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case TCacheMatchResult:
        {
            new (ptr_CacheMatchResult()) CacheMatchResult((aOther).get_CacheMatchResult());
            break;
        }
    case TCacheMatchAllResult:
        {
            new (ptr_CacheMatchAllResult()) CacheMatchAllResult((aOther).get_CacheMatchAllResult());
            break;
        }
    case TCachePutAllResult:
        {
            new (ptr_CachePutAllResult()) CachePutAllResult((aOther).get_CachePutAllResult());
            break;
        }
    case TCacheDeleteResult:
        {
            new (ptr_CacheDeleteResult()) CacheDeleteResult((aOther).get_CacheDeleteResult());
            break;
        }
    case TCacheKeysResult:
        {
            new (ptr_CacheKeysResult()) CacheKeysResult((aOther).get_CacheKeysResult());
            break;
        }
    case TStorageMatchResult:
        {
            new (ptr_StorageMatchResult()) StorageMatchResult((aOther).get_StorageMatchResult());
            break;
        }
    case TStorageHasResult:
        {
            new (ptr_StorageHasResult()) StorageHasResult((aOther).get_StorageHasResult());
            break;
        }
    case TStorageOpenResult:
        {
            new (ptr_StorageOpenResult()) StorageOpenResult((aOther).get_StorageOpenResult());
            break;
        }
    case TStorageDeleteResult:
        {
            new (ptr_StorageDeleteResult()) StorageDeleteResult((aOther).get_StorageDeleteResult());
            break;
        }
    case TStorageKeysResult:
        {
            new (ptr_StorageKeysResult()) StorageKeysResult((aOther).get_StorageKeysResult());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

CacheOpResult::~CacheOpResult()
{
    MaybeDestroy(T__None);
}

auto CacheOpResult::operator=(const void_t& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto CacheOpResult::operator=(const CacheMatchResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TCacheMatchResult)) {
        new (ptr_CacheMatchResult()) CacheMatchResult;
    }
    (*(ptr_CacheMatchResult())) = aRhs;
    mType = TCacheMatchResult;
    return (*(this));
}

auto CacheOpResult::operator=(const CacheMatchAllResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TCacheMatchAllResult)) {
        new (ptr_CacheMatchAllResult()) CacheMatchAllResult;
    }
    (*(ptr_CacheMatchAllResult())) = aRhs;
    mType = TCacheMatchAllResult;
    return (*(this));
}

auto CacheOpResult::operator=(const CachePutAllResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TCachePutAllResult)) {
        new (ptr_CachePutAllResult()) CachePutAllResult;
    }
    (*(ptr_CachePutAllResult())) = aRhs;
    mType = TCachePutAllResult;
    return (*(this));
}

auto CacheOpResult::operator=(const CacheDeleteResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TCacheDeleteResult)) {
        new (ptr_CacheDeleteResult()) CacheDeleteResult;
    }
    (*(ptr_CacheDeleteResult())) = aRhs;
    mType = TCacheDeleteResult;
    return (*(this));
}

auto CacheOpResult::operator=(const CacheKeysResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TCacheKeysResult)) {
        new (ptr_CacheKeysResult()) CacheKeysResult;
    }
    (*(ptr_CacheKeysResult())) = aRhs;
    mType = TCacheKeysResult;
    return (*(this));
}

auto CacheOpResult::operator=(const StorageMatchResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TStorageMatchResult)) {
        new (ptr_StorageMatchResult()) StorageMatchResult;
    }
    (*(ptr_StorageMatchResult())) = aRhs;
    mType = TStorageMatchResult;
    return (*(this));
}

auto CacheOpResult::operator=(const StorageHasResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TStorageHasResult)) {
        new (ptr_StorageHasResult()) StorageHasResult;
    }
    (*(ptr_StorageHasResult())) = aRhs;
    mType = TStorageHasResult;
    return (*(this));
}

auto CacheOpResult::operator=(const StorageOpenResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TStorageOpenResult)) {
        new (ptr_StorageOpenResult()) StorageOpenResult;
    }
    (*(ptr_StorageOpenResult())) = aRhs;
    mType = TStorageOpenResult;
    return (*(this));
}

auto CacheOpResult::operator=(const StorageDeleteResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TStorageDeleteResult)) {
        new (ptr_StorageDeleteResult()) StorageDeleteResult;
    }
    (*(ptr_StorageDeleteResult())) = aRhs;
    mType = TStorageDeleteResult;
    return (*(this));
}

auto CacheOpResult::operator=(const StorageKeysResult& aRhs) -> CacheOpResult&
{
    if (MaybeDestroy(TStorageKeysResult)) {
        new (ptr_StorageKeysResult()) StorageKeysResult;
    }
    (*(ptr_StorageKeysResult())) = aRhs;
    mType = TStorageKeysResult;
    return (*(this));
}

auto CacheOpResult::operator=(const CacheOpResult& aRhs) -> CacheOpResult&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case TCacheMatchResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheMatchResult()) CacheMatchResult;
            }
            (*(ptr_CacheMatchResult())) = (aRhs).get_CacheMatchResult();
            break;
        }
    case TCacheMatchAllResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheMatchAllResult()) CacheMatchAllResult;
            }
            (*(ptr_CacheMatchAllResult())) = (aRhs).get_CacheMatchAllResult();
            break;
        }
    case TCachePutAllResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CachePutAllResult()) CachePutAllResult;
            }
            (*(ptr_CachePutAllResult())) = (aRhs).get_CachePutAllResult();
            break;
        }
    case TCacheDeleteResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheDeleteResult()) CacheDeleteResult;
            }
            (*(ptr_CacheDeleteResult())) = (aRhs).get_CacheDeleteResult();
            break;
        }
    case TCacheKeysResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_CacheKeysResult()) CacheKeysResult;
            }
            (*(ptr_CacheKeysResult())) = (aRhs).get_CacheKeysResult();
            break;
        }
    case TStorageMatchResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageMatchResult()) StorageMatchResult;
            }
            (*(ptr_StorageMatchResult())) = (aRhs).get_StorageMatchResult();
            break;
        }
    case TStorageHasResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageHasResult()) StorageHasResult;
            }
            (*(ptr_StorageHasResult())) = (aRhs).get_StorageHasResult();
            break;
        }
    case TStorageOpenResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageOpenResult()) StorageOpenResult;
            }
            (*(ptr_StorageOpenResult())) = (aRhs).get_StorageOpenResult();
            break;
        }
    case TStorageDeleteResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageDeleteResult()) StorageDeleteResult;
            }
            (*(ptr_StorageDeleteResult())) = (aRhs).get_StorageDeleteResult();
            break;
        }
    case TStorageKeysResult:
        {
            if (MaybeDestroy(t)) {
                new (ptr_StorageKeysResult()) StorageKeysResult;
            }
            (*(ptr_StorageKeysResult())) = (aRhs).get_StorageKeysResult();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto CacheOpResult::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto CacheOpResult::operator==(const CacheMatchResult& aRhs) const -> bool
{
    return (get_CacheMatchResult()) == (aRhs);
}

auto CacheOpResult::operator==(const CacheMatchAllResult& aRhs) const -> bool
{
    return (get_CacheMatchAllResult()) == (aRhs);
}

auto CacheOpResult::operator==(const CachePutAllResult& aRhs) const -> bool
{
    return (get_CachePutAllResult()) == (aRhs);
}

auto CacheOpResult::operator==(const CacheDeleteResult& aRhs) const -> bool
{
    return (get_CacheDeleteResult()) == (aRhs);
}

auto CacheOpResult::operator==(const CacheKeysResult& aRhs) const -> bool
{
    return (get_CacheKeysResult()) == (aRhs);
}

auto CacheOpResult::operator==(const StorageMatchResult& aRhs) const -> bool
{
    return (get_StorageMatchResult()) == (aRhs);
}

auto CacheOpResult::operator==(const StorageHasResult& aRhs) const -> bool
{
    return (get_StorageHasResult()) == (aRhs);
}

auto CacheOpResult::operator==(const StorageOpenResult& aRhs) const -> bool
{
    return (get_StorageOpenResult()) == (aRhs);
}

auto CacheOpResult::operator==(const StorageDeleteResult& aRhs) const -> bool
{
    return (get_StorageDeleteResult()) == (aRhs);
}

auto CacheOpResult::operator==(const StorageKeysResult& aRhs) const -> bool
{
    return (get_StorageKeysResult()) == (aRhs);
}

auto CacheOpResult::operator==(const CacheOpResult& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    case TCacheMatchResult:
        {
            return (get_CacheMatchResult()) == ((aRhs).get_CacheMatchResult());
        }
    case TCacheMatchAllResult:
        {
            return (get_CacheMatchAllResult()) == ((aRhs).get_CacheMatchAllResult());
        }
    case TCachePutAllResult:
        {
            return (get_CachePutAllResult()) == ((aRhs).get_CachePutAllResult());
        }
    case TCacheDeleteResult:
        {
            return (get_CacheDeleteResult()) == ((aRhs).get_CacheDeleteResult());
        }
    case TCacheKeysResult:
        {
            return (get_CacheKeysResult()) == ((aRhs).get_CacheKeysResult());
        }
    case TStorageMatchResult:
        {
            return (get_StorageMatchResult()) == ((aRhs).get_StorageMatchResult());
        }
    case TStorageHasResult:
        {
            return (get_StorageHasResult()) == ((aRhs).get_StorageHasResult());
        }
    case TStorageOpenResult:
        {
            return (get_StorageOpenResult()) == ((aRhs).get_StorageOpenResult());
        }
    case TStorageDeleteResult:
        {
            return (get_StorageDeleteResult()) == ((aRhs).get_StorageDeleteResult());
        }
    case TStorageKeysResult:
        {
            return (get_StorageKeysResult()) == ((aRhs).get_StorageKeysResult());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace cache
} // namespace dom
} // namespace mozilla
