//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union OptionalID|
//
namespace mozilla {
namespace dom {
auto OptionalID::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TnsID:
        {
            (ptr_nsID())->~nsID__tdef();
            break;
        }
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT OptionalID::OptionalID(const nsID& aOther)
{
    new (ptr_nsID()) nsID(aOther);
    mType = TnsID;
}

MOZ_IMPLICIT OptionalID::OptionalID(const void_t& aOther)
{
    new (ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT OptionalID::OptionalID(const OptionalID& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TnsID:
        {
            new (ptr_nsID()) nsID((aOther).get_nsID());
            break;
        }
    case Tvoid_t:
        {
            new (ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

OptionalID::~OptionalID()
{
    MaybeDestroy(T__None);
}

auto OptionalID::operator=(const nsID& aRhs) -> OptionalID&
{
    if (MaybeDestroy(TnsID)) {
        new (ptr_nsID()) nsID;
    }
    (*(ptr_nsID())) = aRhs;
    mType = TnsID;
    return (*(this));
}

auto OptionalID::operator=(const void_t& aRhs) -> OptionalID&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto OptionalID::operator=(const OptionalID& aRhs) -> OptionalID&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsID:
        {
            if (MaybeDestroy(t)) {
                new (ptr_nsID()) nsID;
            }
            (*(ptr_nsID())) = (aRhs).get_nsID();
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto OptionalID::operator==(const nsID& aRhs) const -> bool
{
    return (get_nsID()) == (aRhs);
}

auto OptionalID::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto OptionalID::operator==(const OptionalID& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TnsID:
        {
            return (get_nsID()) == ((aRhs).get_nsID());
        }
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT ClonedMessageData::ClonedMessageData() :
    data_()
{
    Init();
}

ClonedMessageData::~ClonedMessageData()
{
}

auto ClonedMessageData::operator==(const ClonedMessageData& _o) const -> bool
{
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    if ((!((blobsParent()) == ((_o).blobsParent())))) {
        return false;
    }
    if ((!((blobsChild()) == ((_o).blobsChild())))) {
        return false;
    }
    return true;
}

auto ClonedMessageData::Init() -> void
{
}

auto ClonedMessageData::Assign(
        const SerializedStructuredCloneBuffer& _data,
        const nsTArray<PBlobParent*>& _blobsParent,
        const nsTArray<PBlobChild*>& _blobsChild) -> void
{
    data_ = _data;
    blobsParent_ = _blobsParent;
    blobsChild_ = _blobsChild;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union BlobData|
//
namespace mozilla {
namespace dom {
auto BlobData::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TnsID:
        {
            (ptr_nsID())->~nsID__tdef();
            break;
        }
    case TArrayOfuint8_t:
        {
            (ptr_ArrayOfuint8_t())->~ArrayOfuint8_t__tdef();
            break;
        }
    case TArrayOfBlobData:
        {
            delete ptr_ArrayOfBlobData();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT BlobData::BlobData(const nsID& aOther)
{
    new (ptr_nsID()) nsID(aOther);
    mType = TnsID;
}

MOZ_IMPLICIT BlobData::BlobData(const nsTArray<uint8_t>& aOther)
{
    new (ptr_ArrayOfuint8_t()) nsTArray<uint8_t>(aOther);
    mType = TArrayOfuint8_t;
}

MOZ_IMPLICIT BlobData::BlobData(const nsTArray<BlobData>& aOther)
{
    ptr_ArrayOfBlobData() = new nsTArray<BlobData>(aOther);
    mType = TArrayOfBlobData;
}

MOZ_IMPLICIT BlobData::BlobData(const BlobData& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TnsID:
        {
            new (ptr_nsID()) nsID((aOther).get_nsID());
            break;
        }
    case TArrayOfuint8_t:
        {
            new (ptr_ArrayOfuint8_t()) nsTArray<uint8_t>((aOther).get_ArrayOfuint8_t());
            break;
        }
    case TArrayOfBlobData:
        {
            ptr_ArrayOfBlobData() = new nsTArray<BlobData>((aOther).get_ArrayOfBlobData());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

BlobData::~BlobData()
{
    MaybeDestroy(T__None);
}

auto BlobData::operator=(const nsID& aRhs) -> BlobData&
{
    if (MaybeDestroy(TnsID)) {
        new (ptr_nsID()) nsID;
    }
    (*(ptr_nsID())) = aRhs;
    mType = TnsID;
    return (*(this));
}

auto BlobData::operator=(const nsTArray<uint8_t>& aRhs) -> BlobData&
{
    if (MaybeDestroy(TArrayOfuint8_t)) {
        new (ptr_ArrayOfuint8_t()) nsTArray<uint8_t>;
    }
    (*(ptr_ArrayOfuint8_t())) = aRhs;
    mType = TArrayOfuint8_t;
    return (*(this));
}

auto BlobData::operator=(const nsTArray<BlobData>& aRhs) -> BlobData&
{
    if (MaybeDestroy(TArrayOfBlobData)) {
        ptr_ArrayOfBlobData() = new nsTArray<BlobData>;
    }
    (*(ptr_ArrayOfBlobData())) = aRhs;
    mType = TArrayOfBlobData;
    return (*(this));
}

auto BlobData::operator=(const BlobData& aRhs) -> BlobData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsID:
        {
            if (MaybeDestroy(t)) {
                new (ptr_nsID()) nsID;
            }
            (*(ptr_nsID())) = (aRhs).get_nsID();
            break;
        }
    case TArrayOfuint8_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_ArrayOfuint8_t()) nsTArray<uint8_t>;
            }
            (*(ptr_ArrayOfuint8_t())) = (aRhs).get_ArrayOfuint8_t();
            break;
        }
    case TArrayOfBlobData:
        {
            if (MaybeDestroy(t)) {
                ptr_ArrayOfBlobData() = new nsTArray<BlobData>;
            }
            (*(ptr_ArrayOfBlobData())) = (aRhs).get_ArrayOfBlobData();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto BlobData::operator==(const nsID& aRhs) const -> bool
{
    return (get_nsID()) == (aRhs);
}

auto BlobData::operator==(const nsTArray<uint8_t>& aRhs) const -> bool
{
    return (get_ArrayOfuint8_t()) == (aRhs);
}

auto BlobData::operator==(const nsTArray<BlobData>& aRhs) const -> bool
{
    return (get_ArrayOfBlobData()) == (aRhs);
}

auto BlobData::operator==(const BlobData& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TnsID:
        {
            return (get_nsID()) == ((aRhs).get_nsID());
        }
    case TArrayOfuint8_t:
        {
            return (get_ArrayOfuint8_t()) == ((aRhs).get_ArrayOfuint8_t());
        }
    case TArrayOfBlobData:
        {
            return (get_ArrayOfBlobData()) == ((aRhs).get_ArrayOfBlobData());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union OptionalBlobData|
//
namespace mozilla {
namespace dom {
auto OptionalBlobData::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TBlobData:
        {
            (ptr_BlobData())->~BlobData__tdef();
            break;
        }
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT OptionalBlobData::OptionalBlobData(const BlobData& aOther)
{
    new (ptr_BlobData()) BlobData(aOther);
    mType = TBlobData;
}

MOZ_IMPLICIT OptionalBlobData::OptionalBlobData(const void_t& aOther)
{
    new (ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT OptionalBlobData::OptionalBlobData(const OptionalBlobData& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TBlobData:
        {
            new (ptr_BlobData()) BlobData((aOther).get_BlobData());
            break;
        }
    case Tvoid_t:
        {
            new (ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

OptionalBlobData::~OptionalBlobData()
{
    MaybeDestroy(T__None);
}

auto OptionalBlobData::operator=(const BlobData& aRhs) -> OptionalBlobData&
{
    if (MaybeDestroy(TBlobData)) {
        new (ptr_BlobData()) BlobData;
    }
    (*(ptr_BlobData())) = aRhs;
    mType = TBlobData;
    return (*(this));
}

auto OptionalBlobData::operator=(const void_t& aRhs) -> OptionalBlobData&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto OptionalBlobData::operator=(const OptionalBlobData& aRhs) -> OptionalBlobData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TBlobData:
        {
            if (MaybeDestroy(t)) {
                new (ptr_BlobData()) BlobData;
            }
            (*(ptr_BlobData())) = (aRhs).get_BlobData();
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto OptionalBlobData::operator==(const BlobData& aRhs) const -> bool
{
    return (get_BlobData()) == (aRhs);
}

auto OptionalBlobData::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto OptionalBlobData::operator==(const OptionalBlobData& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TBlobData:
        {
            return (get_BlobData()) == ((aRhs).get_BlobData());
        }
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct NormalBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT NormalBlobConstructorParams::NormalBlobConstructorParams() :
    contentType_(),
    length_()
{
    Init();
}

NormalBlobConstructorParams::~NormalBlobConstructorParams()
{
}

auto NormalBlobConstructorParams::operator==(const NormalBlobConstructorParams& _o) const -> bool
{
    if ((!((contentType()) == ((_o).contentType())))) {
        return false;
    }
    if ((!((length()) == ((_o).length())))) {
        return false;
    }
    if ((!((optionalBlobData()) == ((_o).optionalBlobData())))) {
        return false;
    }
    return true;
}

auto NormalBlobConstructorParams::Init() -> void
{
}

auto NormalBlobConstructorParams::Assign(
        const nsString& _contentType,
        const uint64_t& _length,
        const OptionalBlobData& _optionalBlobData) -> void
{
    contentType_ = _contentType;
    length_ = _length;
    optionalBlobData_ = _optionalBlobData;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct FileBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT FileBlobConstructorParams::FileBlobConstructorParams() :
    name_(),
    contentType_(),
    length_(),
    modDate_(),
    dirState_()
{
    Init();
}

FileBlobConstructorParams::~FileBlobConstructorParams()
{
}

auto FileBlobConstructorParams::operator==(const FileBlobConstructorParams& _o) const -> bool
{
    if ((!((name()) == ((_o).name())))) {
        return false;
    }
    if ((!((contentType()) == ((_o).contentType())))) {
        return false;
    }
    if ((!((length()) == ((_o).length())))) {
        return false;
    }
    if ((!((modDate()) == ((_o).modDate())))) {
        return false;
    }
    if ((!((dirState()) == ((_o).dirState())))) {
        return false;
    }
    if ((!((optionalBlobData()) == ((_o).optionalBlobData())))) {
        return false;
    }
    return true;
}

auto FileBlobConstructorParams::Init() -> void
{
}

auto FileBlobConstructorParams::Assign(
        const nsString& _name,
        const nsString& _contentType,
        const uint64_t& _length,
        const int64_t& _modDate,
        const uint32_t& _dirState,
        const OptionalBlobData& _optionalBlobData) -> void
{
    name_ = _name;
    contentType_ = _contentType;
    length_ = _length;
    modDate_ = _modDate;
    dirState_ = _dirState;
    optionalBlobData_ = _optionalBlobData;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SlicedBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT SlicedBlobConstructorParams::SlicedBlobConstructorParams() :
    id_(),
    begin_(),
    end_(),
    contentType_()
{
    Init();
}

SlicedBlobConstructorParams::~SlicedBlobConstructorParams()
{
}

auto SlicedBlobConstructorParams::operator==(const SlicedBlobConstructorParams& _o) const -> bool
{
    if ((!((sourceParent()) == ((_o).sourceParent())))) {
        return false;
    }
    if ((!((sourceChild()) == ((_o).sourceChild())))) {
        return false;
    }
    if ((!((id()) == ((_o).id())))) {
        return false;
    }
    if ((!((begin()) == ((_o).begin())))) {
        return false;
    }
    if ((!((end()) == ((_o).end())))) {
        return false;
    }
    if ((!((contentType()) == ((_o).contentType())))) {
        return false;
    }
    return true;
}

auto SlicedBlobConstructorParams::Init() -> void
{
    sourceParent_ = nullptr;
    sourceChild_ = nullptr;
}

auto SlicedBlobConstructorParams::Assign(
        PBlobParent* _sourceParent,
        PBlobChild* _sourceChild,
        const nsID& _id,
        const uint64_t& _begin,
        const uint64_t& _end,
        const nsString& _contentType) -> void
{
    sourceParent_ = _sourceParent;
    sourceChild_ = _sourceChild;
    id_ = _id;
    begin_ = _begin;
    end_ = _end;
    contentType_ = _contentType;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct MysteryBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MysteryBlobConstructorParams::~MysteryBlobConstructorParams()
{
}

auto MysteryBlobConstructorParams::operator==(const MysteryBlobConstructorParams& _o) const -> bool
{
    return true;
}

auto MysteryBlobConstructorParams::Init() -> void
{
}

auto MysteryBlobConstructorParams::Assign() -> void
{
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct KnownBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT KnownBlobConstructorParams::KnownBlobConstructorParams() :
    id_()
{
    Init();
}

KnownBlobConstructorParams::~KnownBlobConstructorParams()
{
}

auto KnownBlobConstructorParams::operator==(const KnownBlobConstructorParams& _o) const -> bool
{
    if ((!((id()) == ((_o).id())))) {
        return false;
    }
    return true;
}

auto KnownBlobConstructorParams::Init() -> void
{
}

auto KnownBlobConstructorParams::Assign(const nsID& _id) -> void
{
    id_ = _id;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SameProcessBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT SameProcessBlobConstructorParams::SameProcessBlobConstructorParams() :
    addRefedBlobImpl_()
{
    Init();
}

SameProcessBlobConstructorParams::~SameProcessBlobConstructorParams()
{
}

auto SameProcessBlobConstructorParams::operator==(const SameProcessBlobConstructorParams& _o) const -> bool
{
    if ((!((addRefedBlobImpl()) == ((_o).addRefedBlobImpl())))) {
        return false;
    }
    return true;
}

auto SameProcessBlobConstructorParams::Init() -> void
{
}

auto SameProcessBlobConstructorParams::Assign(const intptr_t& _addRefedBlobImpl) -> void
{
    addRefedBlobImpl_ = _addRefedBlobImpl;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union AnyBlobConstructorParams|
//
namespace mozilla {
namespace dom {
auto AnyBlobConstructorParams::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TNormalBlobConstructorParams:
        {
            (ptr_NormalBlobConstructorParams())->~NormalBlobConstructorParams__tdef();
            break;
        }
    case TFileBlobConstructorParams:
        {
            (ptr_FileBlobConstructorParams())->~FileBlobConstructorParams__tdef();
            break;
        }
    case TSameProcessBlobConstructorParams:
        {
            (ptr_SameProcessBlobConstructorParams())->~SameProcessBlobConstructorParams__tdef();
            break;
        }
    case TMysteryBlobConstructorParams:
        {
            (ptr_MysteryBlobConstructorParams())->~MysteryBlobConstructorParams__tdef();
            break;
        }
    case TSlicedBlobConstructorParams:
        {
            (ptr_SlicedBlobConstructorParams())->~SlicedBlobConstructorParams__tdef();
            break;
        }
    case TKnownBlobConstructorParams:
        {
            (ptr_KnownBlobConstructorParams())->~KnownBlobConstructorParams__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT AnyBlobConstructorParams::AnyBlobConstructorParams(const NormalBlobConstructorParams& aOther)
{
    new (ptr_NormalBlobConstructorParams()) NormalBlobConstructorParams(aOther);
    mType = TNormalBlobConstructorParams;
}

MOZ_IMPLICIT AnyBlobConstructorParams::AnyBlobConstructorParams(const FileBlobConstructorParams& aOther)
{
    new (ptr_FileBlobConstructorParams()) FileBlobConstructorParams(aOther);
    mType = TFileBlobConstructorParams;
}

MOZ_IMPLICIT AnyBlobConstructorParams::AnyBlobConstructorParams(const SameProcessBlobConstructorParams& aOther)
{
    new (ptr_SameProcessBlobConstructorParams()) SameProcessBlobConstructorParams(aOther);
    mType = TSameProcessBlobConstructorParams;
}

MOZ_IMPLICIT AnyBlobConstructorParams::AnyBlobConstructorParams(const MysteryBlobConstructorParams& aOther)
{
    new (ptr_MysteryBlobConstructorParams()) MysteryBlobConstructorParams(aOther);
    mType = TMysteryBlobConstructorParams;
}

MOZ_IMPLICIT AnyBlobConstructorParams::AnyBlobConstructorParams(const SlicedBlobConstructorParams& aOther)
{
    new (ptr_SlicedBlobConstructorParams()) SlicedBlobConstructorParams(aOther);
    mType = TSlicedBlobConstructorParams;
}

MOZ_IMPLICIT AnyBlobConstructorParams::AnyBlobConstructorParams(const KnownBlobConstructorParams& aOther)
{
    new (ptr_KnownBlobConstructorParams()) KnownBlobConstructorParams(aOther);
    mType = TKnownBlobConstructorParams;
}

MOZ_IMPLICIT AnyBlobConstructorParams::AnyBlobConstructorParams(const AnyBlobConstructorParams& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TNormalBlobConstructorParams:
        {
            new (ptr_NormalBlobConstructorParams()) NormalBlobConstructorParams((aOther).get_NormalBlobConstructorParams());
            break;
        }
    case TFileBlobConstructorParams:
        {
            new (ptr_FileBlobConstructorParams()) FileBlobConstructorParams((aOther).get_FileBlobConstructorParams());
            break;
        }
    case TSameProcessBlobConstructorParams:
        {
            new (ptr_SameProcessBlobConstructorParams()) SameProcessBlobConstructorParams((aOther).get_SameProcessBlobConstructorParams());
            break;
        }
    case TMysteryBlobConstructorParams:
        {
            new (ptr_MysteryBlobConstructorParams()) MysteryBlobConstructorParams((aOther).get_MysteryBlobConstructorParams());
            break;
        }
    case TSlicedBlobConstructorParams:
        {
            new (ptr_SlicedBlobConstructorParams()) SlicedBlobConstructorParams((aOther).get_SlicedBlobConstructorParams());
            break;
        }
    case TKnownBlobConstructorParams:
        {
            new (ptr_KnownBlobConstructorParams()) KnownBlobConstructorParams((aOther).get_KnownBlobConstructorParams());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

AnyBlobConstructorParams::~AnyBlobConstructorParams()
{
    MaybeDestroy(T__None);
}

auto AnyBlobConstructorParams::operator=(const NormalBlobConstructorParams& aRhs) -> AnyBlobConstructorParams&
{
    if (MaybeDestroy(TNormalBlobConstructorParams)) {
        new (ptr_NormalBlobConstructorParams()) NormalBlobConstructorParams;
    }
    (*(ptr_NormalBlobConstructorParams())) = aRhs;
    mType = TNormalBlobConstructorParams;
    return (*(this));
}

auto AnyBlobConstructorParams::operator=(const FileBlobConstructorParams& aRhs) -> AnyBlobConstructorParams&
{
    if (MaybeDestroy(TFileBlobConstructorParams)) {
        new (ptr_FileBlobConstructorParams()) FileBlobConstructorParams;
    }
    (*(ptr_FileBlobConstructorParams())) = aRhs;
    mType = TFileBlobConstructorParams;
    return (*(this));
}

auto AnyBlobConstructorParams::operator=(const SameProcessBlobConstructorParams& aRhs) -> AnyBlobConstructorParams&
{
    if (MaybeDestroy(TSameProcessBlobConstructorParams)) {
        new (ptr_SameProcessBlobConstructorParams()) SameProcessBlobConstructorParams;
    }
    (*(ptr_SameProcessBlobConstructorParams())) = aRhs;
    mType = TSameProcessBlobConstructorParams;
    return (*(this));
}

auto AnyBlobConstructorParams::operator=(const MysteryBlobConstructorParams& aRhs) -> AnyBlobConstructorParams&
{
    if (MaybeDestroy(TMysteryBlobConstructorParams)) {
        new (ptr_MysteryBlobConstructorParams()) MysteryBlobConstructorParams;
    }
    (*(ptr_MysteryBlobConstructorParams())) = aRhs;
    mType = TMysteryBlobConstructorParams;
    return (*(this));
}

auto AnyBlobConstructorParams::operator=(const SlicedBlobConstructorParams& aRhs) -> AnyBlobConstructorParams&
{
    if (MaybeDestroy(TSlicedBlobConstructorParams)) {
        new (ptr_SlicedBlobConstructorParams()) SlicedBlobConstructorParams;
    }
    (*(ptr_SlicedBlobConstructorParams())) = aRhs;
    mType = TSlicedBlobConstructorParams;
    return (*(this));
}

auto AnyBlobConstructorParams::operator=(const KnownBlobConstructorParams& aRhs) -> AnyBlobConstructorParams&
{
    if (MaybeDestroy(TKnownBlobConstructorParams)) {
        new (ptr_KnownBlobConstructorParams()) KnownBlobConstructorParams;
    }
    (*(ptr_KnownBlobConstructorParams())) = aRhs;
    mType = TKnownBlobConstructorParams;
    return (*(this));
}

auto AnyBlobConstructorParams::operator=(const AnyBlobConstructorParams& aRhs) -> AnyBlobConstructorParams&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TNormalBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_NormalBlobConstructorParams()) NormalBlobConstructorParams;
            }
            (*(ptr_NormalBlobConstructorParams())) = (aRhs).get_NormalBlobConstructorParams();
            break;
        }
    case TFileBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_FileBlobConstructorParams()) FileBlobConstructorParams;
            }
            (*(ptr_FileBlobConstructorParams())) = (aRhs).get_FileBlobConstructorParams();
            break;
        }
    case TSameProcessBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_SameProcessBlobConstructorParams()) SameProcessBlobConstructorParams;
            }
            (*(ptr_SameProcessBlobConstructorParams())) = (aRhs).get_SameProcessBlobConstructorParams();
            break;
        }
    case TMysteryBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_MysteryBlobConstructorParams()) MysteryBlobConstructorParams;
            }
            (*(ptr_MysteryBlobConstructorParams())) = (aRhs).get_MysteryBlobConstructorParams();
            break;
        }
    case TSlicedBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_SlicedBlobConstructorParams()) SlicedBlobConstructorParams;
            }
            (*(ptr_SlicedBlobConstructorParams())) = (aRhs).get_SlicedBlobConstructorParams();
            break;
        }
    case TKnownBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_KnownBlobConstructorParams()) KnownBlobConstructorParams;
            }
            (*(ptr_KnownBlobConstructorParams())) = (aRhs).get_KnownBlobConstructorParams();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto AnyBlobConstructorParams::operator==(const NormalBlobConstructorParams& aRhs) const -> bool
{
    return (get_NormalBlobConstructorParams()) == (aRhs);
}

auto AnyBlobConstructorParams::operator==(const FileBlobConstructorParams& aRhs) const -> bool
{
    return (get_FileBlobConstructorParams()) == (aRhs);
}

auto AnyBlobConstructorParams::operator==(const SameProcessBlobConstructorParams& aRhs) const -> bool
{
    return (get_SameProcessBlobConstructorParams()) == (aRhs);
}

auto AnyBlobConstructorParams::operator==(const MysteryBlobConstructorParams& aRhs) const -> bool
{
    return (get_MysteryBlobConstructorParams()) == (aRhs);
}

auto AnyBlobConstructorParams::operator==(const SlicedBlobConstructorParams& aRhs) const -> bool
{
    return (get_SlicedBlobConstructorParams()) == (aRhs);
}

auto AnyBlobConstructorParams::operator==(const KnownBlobConstructorParams& aRhs) const -> bool
{
    return (get_KnownBlobConstructorParams()) == (aRhs);
}

auto AnyBlobConstructorParams::operator==(const AnyBlobConstructorParams& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TNormalBlobConstructorParams:
        {
            return (get_NormalBlobConstructorParams()) == ((aRhs).get_NormalBlobConstructorParams());
        }
    case TFileBlobConstructorParams:
        {
            return (get_FileBlobConstructorParams()) == ((aRhs).get_FileBlobConstructorParams());
        }
    case TSameProcessBlobConstructorParams:
        {
            return (get_SameProcessBlobConstructorParams()) == ((aRhs).get_SameProcessBlobConstructorParams());
        }
    case TMysteryBlobConstructorParams:
        {
            return (get_MysteryBlobConstructorParams()) == ((aRhs).get_MysteryBlobConstructorParams());
        }
    case TSlicedBlobConstructorParams:
        {
            return (get_SlicedBlobConstructorParams()) == ((aRhs).get_SlicedBlobConstructorParams());
        }
    case TKnownBlobConstructorParams:
        {
            return (get_KnownBlobConstructorParams()) == ((aRhs).get_KnownBlobConstructorParams());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ChildBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT ChildBlobConstructorParams::ChildBlobConstructorParams() :
    id_()
{
    Init();
}

ChildBlobConstructorParams::~ChildBlobConstructorParams()
{
}

auto ChildBlobConstructorParams::operator==(const ChildBlobConstructorParams& _o) const -> bool
{
    if ((!((id()) == ((_o).id())))) {
        return false;
    }
    if ((!((blobParams()) == ((_o).blobParams())))) {
        return false;
    }
    return true;
}

auto ChildBlobConstructorParams::Init() -> void
{
}

auto ChildBlobConstructorParams::Assign(
        const nsID& _id,
        const AnyBlobConstructorParams& _blobParams) -> void
{
    id_ = _id;
    blobParams_ = _blobParams;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ParentBlobConstructorParams|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT ParentBlobConstructorParams::ParentBlobConstructorParams()
{
    Init();
}

ParentBlobConstructorParams::~ParentBlobConstructorParams()
{
}

auto ParentBlobConstructorParams::operator==(const ParentBlobConstructorParams& _o) const -> bool
{
    if ((!((blobParams()) == ((_o).blobParams())))) {
        return false;
    }
    return true;
}

auto ParentBlobConstructorParams::Init() -> void
{
}

auto ParentBlobConstructorParams::Assign(const AnyBlobConstructorParams& _blobParams) -> void
{
    blobParams_ = _blobParams;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union BlobConstructorParams|
//
namespace mozilla {
namespace dom {
auto BlobConstructorParams::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TChildBlobConstructorParams:
        {
            (ptr_ChildBlobConstructorParams())->~ChildBlobConstructorParams__tdef();
            break;
        }
    case TParentBlobConstructorParams:
        {
            (ptr_ParentBlobConstructorParams())->~ParentBlobConstructorParams__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT BlobConstructorParams::BlobConstructorParams(const ChildBlobConstructorParams& aOther)
{
    new (ptr_ChildBlobConstructorParams()) ChildBlobConstructorParams(aOther);
    mType = TChildBlobConstructorParams;
}

MOZ_IMPLICIT BlobConstructorParams::BlobConstructorParams(const ParentBlobConstructorParams& aOther)
{
    new (ptr_ParentBlobConstructorParams()) ParentBlobConstructorParams(aOther);
    mType = TParentBlobConstructorParams;
}

MOZ_IMPLICIT BlobConstructorParams::BlobConstructorParams(const BlobConstructorParams& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TChildBlobConstructorParams:
        {
            new (ptr_ChildBlobConstructorParams()) ChildBlobConstructorParams((aOther).get_ChildBlobConstructorParams());
            break;
        }
    case TParentBlobConstructorParams:
        {
            new (ptr_ParentBlobConstructorParams()) ParentBlobConstructorParams((aOther).get_ParentBlobConstructorParams());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

BlobConstructorParams::~BlobConstructorParams()
{
    MaybeDestroy(T__None);
}

auto BlobConstructorParams::operator=(const ChildBlobConstructorParams& aRhs) -> BlobConstructorParams&
{
    if (MaybeDestroy(TChildBlobConstructorParams)) {
        new (ptr_ChildBlobConstructorParams()) ChildBlobConstructorParams;
    }
    (*(ptr_ChildBlobConstructorParams())) = aRhs;
    mType = TChildBlobConstructorParams;
    return (*(this));
}

auto BlobConstructorParams::operator=(const ParentBlobConstructorParams& aRhs) -> BlobConstructorParams&
{
    if (MaybeDestroy(TParentBlobConstructorParams)) {
        new (ptr_ParentBlobConstructorParams()) ParentBlobConstructorParams;
    }
    (*(ptr_ParentBlobConstructorParams())) = aRhs;
    mType = TParentBlobConstructorParams;
    return (*(this));
}

auto BlobConstructorParams::operator=(const BlobConstructorParams& aRhs) -> BlobConstructorParams&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TChildBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_ChildBlobConstructorParams()) ChildBlobConstructorParams;
            }
            (*(ptr_ChildBlobConstructorParams())) = (aRhs).get_ChildBlobConstructorParams();
            break;
        }
    case TParentBlobConstructorParams:
        {
            if (MaybeDestroy(t)) {
                new (ptr_ParentBlobConstructorParams()) ParentBlobConstructorParams;
            }
            (*(ptr_ParentBlobConstructorParams())) = (aRhs).get_ParentBlobConstructorParams();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto BlobConstructorParams::operator==(const ChildBlobConstructorParams& aRhs) const -> bool
{
    return (get_ChildBlobConstructorParams()) == (aRhs);
}

auto BlobConstructorParams::operator==(const ParentBlobConstructorParams& aRhs) const -> bool
{
    return (get_ParentBlobConstructorParams()) == (aRhs);
}

auto BlobConstructorParams::operator==(const BlobConstructorParams& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TChildBlobConstructorParams:
        {
            return (get_ChildBlobConstructorParams()) == ((aRhs).get_ChildBlobConstructorParams());
        }
    case TParentBlobConstructorParams:
        {
            return (get_ParentBlobConstructorParams()) == ((aRhs).get_ParentBlobConstructorParams());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union IPCDataTransferData|
//
namespace mozilla {
namespace dom {
auto IPCDataTransferData::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TnsString:
        {
            (ptr_nsString())->~nsString__tdef();
            break;
        }
    case TnsCString:
        {
            (ptr_nsCString())->~nsCString__tdef();
            break;
        }
    case TPBlobParent:
        {
            (ptr_PBlobParent())->~PBlobParent__tdef();
            break;
        }
    case TPBlobChild:
        {
            (ptr_PBlobChild())->~PBlobChild__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const nsString& aOther)
{
    new (ptr_nsString()) nsString(aOther);
    mType = TnsString;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const nsCString& aOther)
{
    new (ptr_nsCString()) nsCString(aOther);
    mType = TnsCString;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(PBlobParent* aOther)
{
    new (ptr_PBlobParent()) PBlobParent*(const_cast<PBlobParent*>(aOther));
    mType = TPBlobParent;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(PBlobChild* aOther)
{
    new (ptr_PBlobChild()) PBlobChild*(const_cast<PBlobChild*>(aOther));
    mType = TPBlobChild;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const IPCDataTransferData& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TnsString:
        {
            new (ptr_nsString()) nsString((aOther).get_nsString());
            break;
        }
    case TnsCString:
        {
            new (ptr_nsCString()) nsCString((aOther).get_nsCString());
            break;
        }
    case TPBlobParent:
        {
            new (ptr_PBlobParent()) PBlobParent*(const_cast<PBlobParent*>((aOther).get_PBlobParent()));
            break;
        }
    case TPBlobChild:
        {
            new (ptr_PBlobChild()) PBlobChild*(const_cast<PBlobChild*>((aOther).get_PBlobChild()));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

IPCDataTransferData::~IPCDataTransferData()
{
    MaybeDestroy(T__None);
}

auto IPCDataTransferData::operator=(const nsString& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TnsString)) {
        new (ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = aRhs;
    mType = TnsString;
    return (*(this));
}

auto IPCDataTransferData::operator=(const nsCString& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TnsCString)) {
        new (ptr_nsCString()) nsCString;
    }
    (*(ptr_nsCString())) = aRhs;
    mType = TnsCString;
    return (*(this));
}

auto IPCDataTransferData::operator=(PBlobParent* aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TPBlobParent)) {
        new (ptr_PBlobParent()) PBlobParent*;
    }
    (*(ptr_PBlobParent())) = const_cast<PBlobParent*>(aRhs);
    mType = TPBlobParent;
    return (*(this));
}

auto IPCDataTransferData::operator=(PBlobChild* aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TPBlobChild)) {
        new (ptr_PBlobChild()) PBlobChild*;
    }
    (*(ptr_PBlobChild())) = const_cast<PBlobChild*>(aRhs);
    mType = TPBlobChild;
    return (*(this));
}

auto IPCDataTransferData::operator=(const IPCDataTransferData& aRhs) -> IPCDataTransferData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = (aRhs).get_nsString();
            break;
        }
    case TnsCString:
        {
            if (MaybeDestroy(t)) {
                new (ptr_nsCString()) nsCString;
            }
            (*(ptr_nsCString())) = (aRhs).get_nsCString();
            break;
        }
    case TPBlobParent:
        {
            if (MaybeDestroy(t)) {
                new (ptr_PBlobParent()) PBlobParent*;
            }
            (*(ptr_PBlobParent())) = const_cast<PBlobParent*>((aRhs).get_PBlobParent());
            break;
        }
    case TPBlobChild:
        {
            if (MaybeDestroy(t)) {
                new (ptr_PBlobChild()) PBlobChild*;
            }
            (*(ptr_PBlobChild())) = const_cast<PBlobChild*>((aRhs).get_PBlobChild());
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto IPCDataTransferData::operator==(const nsString& aRhs) const -> bool
{
    return (get_nsString()) == (aRhs);
}

auto IPCDataTransferData::operator==(const nsCString& aRhs) const -> bool
{
    return (get_nsCString()) == (aRhs);
}

auto IPCDataTransferData::operator==(PBlobParent* aRhs) const -> bool
{
    return (get_PBlobParent()) == (aRhs);
}

auto IPCDataTransferData::operator==(PBlobChild* aRhs) const -> bool
{
    return (get_PBlobChild()) == (aRhs);
}

auto IPCDataTransferData::operator==(const IPCDataTransferData& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TnsString:
        {
            return (get_nsString()) == ((aRhs).get_nsString());
        }
    case TnsCString:
        {
            return (get_nsCString()) == ((aRhs).get_nsCString());
        }
    case TPBlobParent:
        {
            return (get_PBlobParent()) == ((aRhs).get_PBlobParent());
        }
    case TPBlobChild:
        {
            return (get_PBlobChild()) == ((aRhs).get_PBlobChild());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransferImage|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT IPCDataTransferImage::IPCDataTransferImage() :
    width_(),
    height_(),
    stride_(),
    format_()
{
    Init();
}

IPCDataTransferImage::~IPCDataTransferImage()
{
}

auto IPCDataTransferImage::operator==(const IPCDataTransferImage& _o) const -> bool
{
    if ((!((width()) == ((_o).width())))) {
        return false;
    }
    if ((!((height()) == ((_o).height())))) {
        return false;
    }
    if ((!((stride()) == ((_o).stride())))) {
        return false;
    }
    if ((!((format()) == ((_o).format())))) {
        return false;
    }
    return true;
}

auto IPCDataTransferImage::Init() -> void
{
}

auto IPCDataTransferImage::Assign(
        const uint32_t& _width,
        const uint32_t& _height,
        const uint32_t& _stride,
        const uint8_t& _format) -> void
{
    width_ = _width;
    height_ = _height;
    stride_ = _stride;
    format_ = _format;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransferItem|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT IPCDataTransferItem::IPCDataTransferItem() :
    flavor_()
{
    Init();
}

IPCDataTransferItem::~IPCDataTransferItem()
{
}

auto IPCDataTransferItem::operator==(const IPCDataTransferItem& _o) const -> bool
{
    if ((!((flavor()) == ((_o).flavor())))) {
        return false;
    }
    if ((!((imageDetails()) == ((_o).imageDetails())))) {
        return false;
    }
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    return true;
}

auto IPCDataTransferItem::Init() -> void
{
}

auto IPCDataTransferItem::Assign(
        const nsCString& _flavor,
        const IPCDataTransferImage& _imageDetails,
        const IPCDataTransferData& _data) -> void
{
    flavor_ = _flavor;
    imageDetails_ = _imageDetails;
    data_ = _data;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransfer|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT IPCDataTransfer::IPCDataTransfer()
{
    Init();
}

IPCDataTransfer::~IPCDataTransfer()
{
}

auto IPCDataTransfer::operator==(const IPCDataTransfer& _o) const -> bool
{
    if ((!((items()) == ((_o).items())))) {
        return false;
    }
    return true;
}

auto IPCDataTransfer::Init() -> void
{
}

auto IPCDataTransfer::Assign(const nsTArray<IPCDataTransferItem>& _items) -> void
{
    items_ = _items;
}

} // namespace dom
} // namespace mozilla
