//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheStorageParent.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/PBlobParent.h"
#include "mozilla/dom/cache/PCacheParent.h"
#include "mozilla/dom/cache/PCacheOpParent.h"
#include "mozilla/dom/cache/PCachePushStreamParent.h"
#include "mozilla/dom/cache/PCacheStreamControlParent.h"
#include "mozilla/ipc/PFileDescriptorSetParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheStorageParent::RecvPCacheOpConstructor(
        PCacheOpParent* actor,
        const CacheOpArgs& aOpArgs) -> bool
{
    return true;
}


MOZ_IMPLICIT PCacheStorageParent::PCacheStorageParent() :
    mId(0),
    mState(PCacheStorage::__Dead)
{
    MOZ_COUNT_CTOR(PCacheStorageParent);
}

PCacheStorageParent::~PCacheStorageParent()
{
    MOZ_COUNT_DTOR(PCacheStorageParent);
}

auto PCacheStorageParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(mManager);
}

auto PCacheStorageParent::ManagedPCacheOpParent(nsTArray<PCacheOpParent*>& aArr) const -> void
{
    uint32_t i = 0;
    PCacheOpParent** elements = (aArr).AppendElements((mManagedPCacheOpParent).Count());
    for (auto iter = (mManagedPCacheOpParent).ConstIter(); (!((iter).Done())); (iter).Next()) {
        elements[i] = ((iter).Get())->GetKey();
        (++(i));
    }
}

auto PCacheStorageParent::ManagedPCacheOpParent() const -> const ManagedContainer<PCacheOpParent>&
{
    return mManagedPCacheOpParent;
}

auto PCacheStorageParent::state() -> PCacheStorage::State
{
    return mState;
}

auto PCacheStorageParent::Send__delete__(PCacheStorageParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PCacheStorage::Msg___delete__* msg__ = new PCacheStorage::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCacheStorageParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCacheStorage", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PCacheStorage::Transition((actor)->mState, Trigger(Trigger::Send, PCacheStorage::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PCacheStorageMsgStart, actor);
    return sendok__;
}

auto PCacheStorageParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PCacheStorageParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PCacheStorageParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PCacheStorageParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PCacheStorageParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
        {
            PCacheOpParent* actor = static_cast<PCacheOpParent*>(aListener);
            MOZ_ASSERT((mManagedPCacheOpParent).Contains(actor), "actor not managed by this!");

            (mManagedPCacheOpParent).RemoveEntry(actor);
            DeallocPCacheOpParent(actor);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
}

auto PCacheStorageParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PCacheStorageParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PCacheStorageParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PCacheStorageParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PCacheStorageParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PCacheStorageParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PCacheStorageParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PCacheStorageParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
    PCacheStorageParent* other = static_cast<PCacheStorageParent*>(aSource);
    {
        nsTArray<PCacheOpParent*> kids;
        (other)->ManagedPCacheOpParent(kids);
        PCacheOpParent* actor;
        for (uint32_t i = 0; (i) < ((kids).Length()); (++(i))) {
            actor = static_cast<PCacheOpParent*>((kids[i])->CloneProtocol(mChannel, aCtx));
            if ((actor) == (nullptr)) {
                NS_RUNTIMEABORT("can not clone an PCacheOp actor");
                return;
            }
            (actor)->mId = (kids[i])->mId;
            (actor)->mManager = this;
            (actor)->mChannel = mChannel;
            (actor)->mState = (kids[i])->mState;
            (mManagedPCacheOpParent).PutEntry(actor);
            RegisterID(actor, (actor)->mId);
            (actor)->CloneManagees(kids[i], aCtx);
        }
    }
}

auto PCacheStorageParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PCacheStorage has not yet been implemented");
    return nullptr;
}

auto PCacheStorageParent::OnMessageReceived(const Message& msg__) -> PCacheStorageParent::Result
{
    switch ((msg__).type()) {
    case PCacheStorage::Msg_PCacheOpConstructor__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCacheStorage::Msg_PCacheOpConstructor");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCacheStorage::Msg_PCacheOpConstructor*>((&(msg__))))->Log("[PCacheStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCacheStorage", "RecvPCacheOpConstructor", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            ActorHandle handle__;
            PCacheOpParent* actor;
            CacheOpArgs aOpArgs;

            if ((!(Read((&(handle__)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            if ((!(Read((&(aOpArgs)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCacheStorage::Transition(mState, Trigger(Trigger::Recv, PCacheStorage::Msg_PCacheOpConstructor__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            actor = AllocPCacheOpParent(mozilla::Move(aOpArgs));
            if ((!(actor))) {
                NS_WARNING("Error constructing actor PCacheOpParent");
                return MsgValueError;
            }
            (actor)->mId = RegisterID(actor, (handle__).mId);
            (actor)->mManager = this;
            (actor)->mChannel = mChannel;
            (mManagedPCacheOpParent).PutEntry(actor);
            (actor)->mState = mozilla::dom::cache::PCacheOp::__Start;

            if ((!(RecvPCacheOpConstructor(mozilla::Move(actor), mozilla::Move(aOpArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for PCacheOp returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Msg_Teardown__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCacheStorage::Msg_Teardown");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCacheStorage::Msg_Teardown*>((&(msg__))))->Log("[PCacheStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCacheStorage", "RecvTeardown", js::ProfileEntry::Category::OTHER);

            if ((!(PCacheStorage::Transition(mState, Trigger(Trigger::Recv, PCacheStorage::Msg_Teardown__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvTeardown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Teardown returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PCacheStorageParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageParent::Result
{
    return MsgNotKnown;
}

auto PCacheStorageParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheStorageParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PCacheStorageParent::GetProtocolTypeId() -> int32_t
{
    return PCacheStorageMsgStart;
}

auto PCacheStorageParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PCacheStorageParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PCacheStorageParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PCacheStorageParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PCacheStorageParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCacheStorageParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCacheStorageParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCacheStorageParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PCacheStorageParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PCacheStorageParent", aMsg, OtherPid(), true);
}

auto PCacheStorageParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    ActorDestroyReason subtreewhy = (((why) == (Deletion)) || ((why) == (FailedConstructor)) ? AncestorDeletion : why);

    {
        // Recursively shutting down PCacheOp kids
        nsTArray<PCacheOpParent*> kids((mManagedPCacheOpParent).Count());
        // Accumulate kids into a stable structure to iterate over
        ManagedPCacheOpParent(kids);
        for (uint32_t i = 0; (i) < ((kids).Length()); (++(i))) {
            (kids[i])->DestroySubtree(subtreewhy);
        }
    }

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PCacheStorageParent::DeallocSubtree() -> void
{
    {
        // Recursively deleting PCacheOp kids
        for (auto iter = (mManagedPCacheOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            (((iter).Get())->GetKey())->DeallocSubtree();
        }

        for (auto iter = (mManagedPCacheOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            DeallocPCacheOpParent(((iter).Get())->GetKey());
        }
        (mManagedPCacheOpParent).Clear();
    }
}

auto PCacheStorageParent::Write(
        const SystemPrincipalInfo& v__,
        Message* msg__) -> void
{
}

auto PCacheStorageParent::Read(
        SystemPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<InputStreamParams>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<InputStreamParams>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<InputStreamParams> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'InputStreamParams[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'InputStreamParams[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<CacheRequestResponse>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<CacheRequestResponse>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<CacheRequestResponse> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'CacheRequestResponse[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'CacheRequestResponse[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const StorageOpenArgs& v__,
        Message* msg__) -> void
{
    Write((v__).key(), msg__);
}

auto PCacheStorageParent::Read(
        StorageOpenArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->key())), msg__, iter__)))) {
        FatalError("Error deserializing 'key' (nsString) member of 'StorageOpenArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheRequestResponse& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    Write((v__).response(), msg__);
}

auto PCacheStorageParent::Read(
        CacheRequestResponse* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'CacheRequestResponse'");
        return false;
    }
    if ((!(Read((&((v__)->response())), msg__, iter__)))) {
        FatalError("Error deserializing 'response' (CacheResponse) member of 'CacheRequestResponse'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheRequest& v__,
        Message* msg__) -> void
{
    Write((v__).method(), msg__);
    Write((v__).urlWithoutQuery(), msg__);
    Write((v__).urlQuery(), msg__);
    Write((v__).headers(), msg__);
    Write((v__).headersGuard(), msg__);
    Write((v__).referrer(), msg__);
    Write((v__).mode(), msg__);
    Write((v__).credentials(), msg__);
    Write((v__).body(), msg__);
    Write((v__).contentPolicyType(), msg__);
    Write((v__).requestCache(), msg__);
    Write((v__).requestRedirect(), msg__);
}

auto PCacheStorageParent::Read(
        CacheRequest* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->method())), msg__, iter__)))) {
        FatalError("Error deserializing 'method' (nsCString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->urlWithoutQuery())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlWithoutQuery' (nsCString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->urlQuery())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlQuery' (nsCString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (HeadersEntry[]) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->headersGuard())), msg__, iter__)))) {
        FatalError("Error deserializing 'headersGuard' (HeadersGuardEnum) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->referrer())), msg__, iter__)))) {
        FatalError("Error deserializing 'referrer' (nsString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->mode())), msg__, iter__)))) {
        FatalError("Error deserializing 'mode' (RequestMode) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->credentials())), msg__, iter__)))) {
        FatalError("Error deserializing 'credentials' (RequestCredentials) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->body())), msg__, iter__)))) {
        FatalError("Error deserializing 'body' (CacheReadStreamOrVoid) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->contentPolicyType())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentPolicyType' (uint32_t) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->requestCache())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestCache' (RequestCache) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->requestRedirect())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestRedirect' (RequestRedirect) member of 'CacheRequest'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const OptionalInputStreamParams& v__,
        Message* msg__) -> void
{
    typedef OptionalInputStreamParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TInputStreamParams:
        {
            Write((v__).get_InputStreamParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        OptionalInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalInputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalInputStreamParams'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_InputStreamParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheMatchAllArgs& v__,
        Message* msg__) -> void
{
    Write((v__).requestOrVoid(), msg__);
    Write((v__).params(), msg__);
}

auto PCacheStorageParent::Read(
        CacheMatchAllArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->requestOrVoid())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestOrVoid' (CacheRequestOrVoid) member of 'CacheMatchAllArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheMatchAllArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheReadStreamOrVoid& v__,
        Message* msg__) -> void
{
    typedef CacheReadStreamOrVoid type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TCacheReadStream:
        {
            Write((v__).get_CacheReadStream(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        CacheReadStreamOrVoid* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef CacheReadStreamOrVoid type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'CacheReadStreamOrVoid'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TCacheReadStream:
        {
            CacheReadStream tmp = CacheReadStream();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CacheReadStream())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const FileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileDescriptorIndex(), msg__);
    Write((v__).behaviorFlags(), msg__);
    Write((v__).ioFlags(), msg__);
}

auto PCacheStorageParent::Read(
        FileInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->fileDescriptorIndex())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->behaviorFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'behaviorFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->ioFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'ioFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StorageMatchArgs& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    Write((v__).params(), msg__);
}

auto PCacheStorageParent::Read(
        StorageMatchArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'StorageMatchArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'StorageMatchArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const OptionalPrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef OptionalPrincipalInfo type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TPrincipalInfo:
        {
            Write((v__).get_PrincipalInfo(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        OptionalPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalPrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalPrincipalInfo'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TPrincipalInfo:
        {
            PrincipalInfo tmp = PrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_PrincipalInfo())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheRequestOrVoid& v__,
        Message* msg__) -> void
{
    typedef CacheRequestOrVoid type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TCacheRequest:
        {
            Write((v__).get_CacheRequest(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        CacheRequestOrVoid* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef CacheRequestOrVoid type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'CacheRequestOrVoid'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TCacheRequest:
        {
            CacheRequest tmp = CacheRequest();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CacheRequest())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheMatchArgs& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    Write((v__).params(), msg__);
}

auto PCacheStorageParent::Read(
        CacheMatchArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'CacheMatchArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheMatchArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheResponse& v__,
        Message* msg__) -> void
{
    Write((v__).type(), msg__);
    Write((v__).url(), msg__);
    Write((v__).status(), msg__);
    Write((v__).statusText(), msg__);
    Write((v__).headers(), msg__);
    Write((v__).headersGuard(), msg__);
    Write((v__).body(), msg__);
    Write((v__).channelInfo(), msg__);
    Write((v__).principalInfo(), msg__);
}

auto PCacheStorageParent::Read(
        CacheResponse* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->type())), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (ResponseType) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->url())), msg__, iter__)))) {
        FatalError("Error deserializing 'url' (nsCString) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->status())), msg__, iter__)))) {
        FatalError("Error deserializing 'status' (uint32_t) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->statusText())), msg__, iter__)))) {
        FatalError("Error deserializing 'statusText' (nsCString) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (HeadersEntry[]) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->headersGuard())), msg__, iter__)))) {
        FatalError("Error deserializing 'headersGuard' (HeadersGuardEnum) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->body())), msg__, iter__)))) {
        FatalError("Error deserializing 'body' (CacheReadStreamOrVoid) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->channelInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'channelInfo' (IPCChannelInfo) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->principalInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'principalInfo' (OptionalPrincipalInfo) member of 'CacheResponse'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const ExpandedPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).whitelist(), msg__);
}

auto PCacheStorageParent::Read(
        ExpandedPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->whitelist())), msg__, iter__)))) {
        FatalError("Error deserializing 'whitelist' (PrincipalInfo[]) member of 'ExpandedPrincipalInfo'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheQueryParams& v__,
        Message* msg__) -> void
{
    Write((v__).ignoreSearch(), msg__);
    Write((v__).ignoreMethod(), msg__);
    Write((v__).ignoreVary(), msg__);
    Write((v__).cacheNameSet(), msg__);
    Write((v__).cacheName(), msg__);
}

auto PCacheStorageParent::Read(
        CacheQueryParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->ignoreSearch())), msg__, iter__)))) {
        FatalError("Error deserializing 'ignoreSearch' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->ignoreMethod())), msg__, iter__)))) {
        FatalError("Error deserializing 'ignoreMethod' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->ignoreVary())), msg__, iter__)))) {
        FatalError("Error deserializing 'ignoreVary' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->cacheNameSet())), msg__, iter__)))) {
        FatalError("Error deserializing 'cacheNameSet' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->cacheName())), msg__, iter__)))) {
        FatalError("Error deserializing 'cacheName' (nsString) member of 'CacheQueryParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        PCacheStorageParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PCacheStorageParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PCacheStorageParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PCacheStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PCacheStorage");
        return false;
    }

    if ((PCacheStorageMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PCacheStorage has different type");
        return false;
    }

    (*(v__)) = static_cast<PCacheStorageParent*>(listener);
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<FileDescriptor>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<FileDescriptor>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<FileDescriptor> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'FileDescriptor[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'FileDescriptor[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const CacheOpArgs& v__,
        Message* msg__) -> void
{
    typedef CacheOpArgs type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TCacheMatchArgs:
        {
            Write((v__).get_CacheMatchArgs(), msg__);
            return;
        }
    case type__::TCacheMatchAllArgs:
        {
            Write((v__).get_CacheMatchAllArgs(), msg__);
            return;
        }
    case type__::TCachePutAllArgs:
        {
            Write((v__).get_CachePutAllArgs(), msg__);
            return;
        }
    case type__::TCacheDeleteArgs:
        {
            Write((v__).get_CacheDeleteArgs(), msg__);
            return;
        }
    case type__::TCacheKeysArgs:
        {
            Write((v__).get_CacheKeysArgs(), msg__);
            return;
        }
    case type__::TStorageMatchArgs:
        {
            Write((v__).get_StorageMatchArgs(), msg__);
            return;
        }
    case type__::TStorageHasArgs:
        {
            Write((v__).get_StorageHasArgs(), msg__);
            return;
        }
    case type__::TStorageOpenArgs:
        {
            Write((v__).get_StorageOpenArgs(), msg__);
            return;
        }
    case type__::TStorageDeleteArgs:
        {
            Write((v__).get_StorageDeleteArgs(), msg__);
            return;
        }
    case type__::TStorageKeysArgs:
        {
            Write((v__).get_StorageKeysArgs(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        CacheOpArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef CacheOpArgs type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'CacheOpArgs'");
        return false;
    }

    switch (type) {
    case type__::TCacheMatchArgs:
        {
            CacheMatchArgs tmp = CacheMatchArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CacheMatchArgs())), msg__, iter__);
        }
    case type__::TCacheMatchAllArgs:
        {
            CacheMatchAllArgs tmp = CacheMatchAllArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CacheMatchAllArgs())), msg__, iter__);
        }
    case type__::TCachePutAllArgs:
        {
            CachePutAllArgs tmp = CachePutAllArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CachePutAllArgs())), msg__, iter__);
        }
    case type__::TCacheDeleteArgs:
        {
            CacheDeleteArgs tmp = CacheDeleteArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CacheDeleteArgs())), msg__, iter__);
        }
    case type__::TCacheKeysArgs:
        {
            CacheKeysArgs tmp = CacheKeysArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CacheKeysArgs())), msg__, iter__);
        }
    case type__::TStorageMatchArgs:
        {
            StorageMatchArgs tmp = StorageMatchArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StorageMatchArgs())), msg__, iter__);
        }
    case type__::TStorageHasArgs:
        {
            StorageHasArgs tmp = StorageHasArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StorageHasArgs())), msg__, iter__);
        }
    case type__::TStorageOpenArgs:
        {
            StorageOpenArgs tmp = StorageOpenArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StorageOpenArgs())), msg__, iter__);
        }
    case type__::TStorageDeleteArgs:
        {
            StorageDeleteArgs tmp = StorageDeleteArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StorageDeleteArgs())), msg__, iter__);
        }
    case type__::TStorageKeysArgs:
        {
            StorageKeysArgs tmp = StorageKeysArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StorageKeysArgs())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const IPCChannelInfo& v__,
        Message* msg__) -> void
{
    Write((v__).securityInfo(), msg__);
}

auto PCacheStorageParent::Read(
        IPCChannelInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->securityInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'securityInfo' (nsCString) member of 'IPCChannelInfo'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StorageDeleteArgs& v__,
        Message* msg__) -> void
{
    Write((v__).key(), msg__);
}

auto PCacheStorageParent::Read(
        StorageDeleteArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->key())), msg__, iter__)))) {
        FatalError("Error deserializing 'key' (nsString) member of 'StorageDeleteArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const PrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef PrincipalInfo type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TContentPrincipalInfo:
        {
            Write((v__).get_ContentPrincipalInfo(), msg__);
            return;
        }
    case type__::TSystemPrincipalInfo:
        {
            Write((v__).get_SystemPrincipalInfo(), msg__);
            return;
        }
    case type__::TNullPrincipalInfo:
        {
            Write((v__).get_NullPrincipalInfo(), msg__);
            return;
        }
    case type__::TExpandedPrincipalInfo:
        {
            Write((v__).get_ExpandedPrincipalInfo(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        PrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef PrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'PrincipalInfo'");
        return false;
    }

    switch (type) {
    case type__::TContentPrincipalInfo:
        {
            ContentPrincipalInfo tmp = ContentPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_ContentPrincipalInfo())), msg__, iter__);
        }
    case type__::TSystemPrincipalInfo:
        {
            SystemPrincipalInfo tmp = SystemPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SystemPrincipalInfo())), msg__, iter__);
        }
    case type__::TNullPrincipalInfo:
        {
            NullPrincipalInfo tmp = NullPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_NullPrincipalInfo())), msg__, iter__);
        }
    case type__::TExpandedPrincipalInfo:
        {
            ExpandedPrincipalInfo tmp = ExpandedPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_ExpandedPrincipalInfo())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheKeysArgs& v__,
        Message* msg__) -> void
{
    Write((v__).requestOrVoid(), msg__);
    Write((v__).params(), msg__);
}

auto PCacheStorageParent::Read(
        CacheKeysArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->requestOrVoid())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestOrVoid' (CacheRequestOrVoid) member of 'CacheKeysArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheKeysArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const MIMEInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    Write((v__).headers(), msg__);
    Write((v__).contentLength(), msg__);
    Write((v__).startedReading(), msg__);
    Write((v__).addContentLength(), msg__);
}

auto PCacheStorageParent::Read(
        MIMEInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->contentLength())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentLength' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReading())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReading' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->addContentLength())), msg__, iter__)))) {
        FatalError("Error deserializing 'addContentLength' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        PCacheOpParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PCacheOpParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PCacheOpParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PCacheStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PCacheOp");
        return false;
    }

    if ((PCacheOpMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PCacheOp has different type");
        return false;
    }

    (*(v__)) = static_cast<PCacheOpParent*>(listener);
    return true;
}

auto PCacheStorageParent::Write(
        const InputStreamParams& v__,
        Message* msg__) -> void
{
    typedef InputStreamParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TStringInputStreamParams:
        {
            Write((v__).get_StringInputStreamParams(), msg__);
            return;
        }
    case type__::TFileInputStreamParams:
        {
            Write((v__).get_FileInputStreamParams(), msg__);
            return;
        }
    case type__::TPartialFileInputStreamParams:
        {
            Write((v__).get_PartialFileInputStreamParams(), msg__);
            return;
        }
    case type__::TBufferedInputStreamParams:
        {
            Write((v__).get_BufferedInputStreamParams(), msg__);
            return;
        }
    case type__::TMIMEInputStreamParams:
        {
            Write((v__).get_MIMEInputStreamParams(), msg__);
            return;
        }
    case type__::TMultiplexInputStreamParams:
        {
            Write((v__).get_MultiplexInputStreamParams(), msg__);
            return;
        }
    case type__::TRemoteInputStreamParams:
        {
            Write((v__).get_RemoteInputStreamParams(), msg__);
            return;
        }
    case type__::TSameProcessInputStreamParams:
        {
            Write((v__).get_SameProcessInputStreamParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        InputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef InputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'InputStreamParams'");
        return false;
    }

    switch (type) {
    case type__::TStringInputStreamParams:
        {
            StringInputStreamParams tmp = StringInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StringInputStreamParams())), msg__, iter__);
        }
    case type__::TFileInputStreamParams:
        {
            FileInputStreamParams tmp = FileInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_FileInputStreamParams())), msg__, iter__);
        }
    case type__::TPartialFileInputStreamParams:
        {
            PartialFileInputStreamParams tmp = PartialFileInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_PartialFileInputStreamParams())), msg__, iter__);
        }
    case type__::TBufferedInputStreamParams:
        {
            BufferedInputStreamParams tmp = BufferedInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_BufferedInputStreamParams())), msg__, iter__);
        }
    case type__::TMIMEInputStreamParams:
        {
            MIMEInputStreamParams tmp = MIMEInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_MIMEInputStreamParams())), msg__, iter__);
        }
    case type__::TMultiplexInputStreamParams:
        {
            MultiplexInputStreamParams tmp = MultiplexInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_MultiplexInputStreamParams())), msg__, iter__);
        }
    case type__::TRemoteInputStreamParams:
        {
            RemoteInputStreamParams tmp = RemoteInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_RemoteInputStreamParams())), msg__, iter__);
        }
    case type__::TSameProcessInputStreamParams:
        {
            SameProcessInputStreamParams tmp = SameProcessInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SameProcessInputStreamParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const SameProcessInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).addRefedInputStream(), msg__);
}

auto PCacheStorageParent::Read(
        SameProcessInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->addRefedInputStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'addRefedInputStream' (intptr_t) member of 'SameProcessInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const OptionalFileDescriptorSet& v__,
        Message* msg__) -> void
{
    typedef OptionalFileDescriptorSet type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TPFileDescriptorSetParent:
        {
            Write((v__).get_PFileDescriptorSetParent(), msg__, false);
            return;
        }
    case type__::TPFileDescriptorSetChild:
        {
            NS_RUNTIMEABORT("wrong side!");
            return;
        }
    case type__::TArrayOfFileDescriptor:
        {
            Write((v__).get_ArrayOfFileDescriptor(), msg__);
            return;
        }
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        OptionalFileDescriptorSet* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalFileDescriptorSet type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalFileDescriptorSet'");
        return false;
    }

    switch (type) {
    case type__::TPFileDescriptorSetParent:
        {
            return false;
        }
    case type__::TPFileDescriptorSetChild:
        {
            PFileDescriptorSetParent* tmp = nullptr;
            (*(v__)) = tmp;
            return Read((&((v__)->get_PFileDescriptorSetParent())), msg__, iter__, false);
        }
    case type__::TArrayOfFileDescriptor:
        {
            nsTArray<FileDescriptor> tmp;
            (*(v__)) = tmp;
            return Read((&((v__)->get_ArrayOfFileDescriptor())), msg__, iter__);
        }
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheDeleteArgs& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    Write((v__).params(), msg__);
}

auto PCacheStorageParent::Read(
        CacheDeleteArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'CacheDeleteArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheDeleteArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheReadStream& v__,
        Message* msg__) -> void
{
    Write((v__).id(), msg__);
    Write((v__).params(), msg__);
    Write((v__).fds(), msg__);
    Write((v__).controlParent(), msg__, true);
    // skipping actor field that's meaningless on this side
    Write((v__).pushStreamParent(), msg__, true);
    // skipping actor field that's meaningless on this side
}

auto PCacheStorageParent::Read(
        CacheReadStream* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->id())), msg__, iter__)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'CacheReadStream'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (OptionalInputStreamParams) member of 'CacheReadStream'");
        return false;
    }
    if ((!(Read((&((v__)->fds())), msg__, iter__)))) {
        FatalError("Error deserializing 'fds' (OptionalFileDescriptorSet) member of 'CacheReadStream'");
        return false;
    }
    if ((!(Read((&((v__)->controlParent())), msg__, iter__, true)))) {
        FatalError("Error deserializing 'controlParent' (PCacheStreamControl) member of 'CacheReadStream'");
        return false;
    }
    // skipping actor field that's meaningless on this side
    if ((!(Read((&((v__)->pushStreamParent())), msg__, iter__, true)))) {
        FatalError("Error deserializing 'pushStreamParent' (PCachePushStream) member of 'CacheReadStream'");
        return false;
    }
    // skipping actor field that's meaningless on this side
    return true;
}

auto PCacheStorageParent::Write(
        const CachePutAllArgs& v__,
        Message* msg__) -> void
{
    Write((v__).requestResponseList(), msg__);
}

auto PCacheStorageParent::Read(
        CachePutAllArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->requestResponseList())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestResponseList' (CacheRequestResponse[]) member of 'CachePutAllArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StringInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).data(), msg__);
}

auto PCacheStorageParent::Read(
        StringInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->data())), msg__, iter__)))) {
        FatalError("Error deserializing 'data' (nsCString) member of 'StringInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const HeadersEntry& v__,
        Message* msg__) -> void
{
    Write((v__).name(), msg__);
    Write((v__).value(), msg__);
}

auto PCacheStorageParent::Read(
        HeadersEntry* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->name())), msg__, iter__)))) {
        FatalError("Error deserializing 'name' (nsCString) member of 'HeadersEntry'");
        return false;
    }
    if ((!(Read((&((v__)->value())), msg__, iter__)))) {
        FatalError("Error deserializing 'value' (nsCString) member of 'HeadersEntry'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StorageHasArgs& v__,
        Message* msg__) -> void
{
    Write((v__).key(), msg__);
}

auto PCacheStorageParent::Read(
        StorageHasArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->key())), msg__, iter__)))) {
        FatalError("Error deserializing 'key' (nsString) member of 'StorageHasArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const MultiplexInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).streams(), msg__);
    Write((v__).currentStream(), msg__);
    Write((v__).status(), msg__);
    Write((v__).startedReadingCurrent(), msg__);
}

auto PCacheStorageParent::Read(
        MultiplexInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->streams())), msg__, iter__)))) {
        FatalError("Error deserializing 'streams' (InputStreamParams[]) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->currentStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'currentStream' (uint32_t) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->status())), msg__, iter__)))) {
        FatalError("Error deserializing 'status' (nsresult) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReadingCurrent())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReadingCurrent' (bool) member of 'MultiplexInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        PFileDescriptorSetParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PFileDescriptorSetParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PFileDescriptorSetParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PCacheStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PFileDescriptorSet");
        return false;
    }

    if ((PFileDescriptorSetMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PFileDescriptorSet has different type");
        return false;
    }

    (*(v__)) = static_cast<PFileDescriptorSetParent*>(listener);
    return true;
}

auto PCacheStorageParent::Write(
        const StorageKeysArgs& v__,
        Message* msg__) -> void
{
}

auto PCacheStorageParent::Read(
        StorageKeysArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<HeadersEntry>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<HeadersEntry>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<HeadersEntry> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'HeadersEntry[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'HeadersEntry[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<PrincipalInfo>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<PrincipalInfo>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<PrincipalInfo> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'PrincipalInfo[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'PrincipalInfo[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        PCachePushStreamParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PCachePushStreamParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PCachePushStreamParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PCacheStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PCachePushStream");
        return false;
    }

    if ((PCachePushStreamMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PCachePushStream has different type");
        return false;
    }

    (*(v__)) = static_cast<PCachePushStreamParent*>(listener);
    return true;
}

auto PCacheStorageParent::Write(
        const FileDescriptor& v__,
        Message* msg__) -> void
{
    FileDescriptor::PickleType pfd = (v__).ShareTo(FileDescriptor::IPDLPrivate(), OtherPid());
    IPC::WriteParam(msg__, pfd);
}

auto PCacheStorageParent::Read(
        FileDescriptor* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FileDescriptor::PickleType pfd;
    if ((!(IPC::ReadParam(msg__, iter__, (&(pfd)))))) {
        return false;
    }

    FileDescriptor fd = FileDescriptor(FileDescriptor::IPDLPrivate(), pfd);
    if ((!((fd).IsValid()))) {
        mozilla::ipc::ProtocolErrorBreakpoint("[PCacheStorageParent] Received an invalid file descriptor!");
    }

    (*(v__)) = fd;
    return true;
}

auto PCacheStorageParent::Write(
        const BufferedInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    Write((v__).bufferSize(), msg__);
}

auto PCacheStorageParent::Read(
        BufferedInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'BufferedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->bufferSize())), msg__, iter__)))) {
        FatalError("Error deserializing 'bufferSize' (uint32_t) member of 'BufferedInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const NullPrincipalInfo& v__,
        Message* msg__) -> void
{
}

auto PCacheStorageParent::Read(
        NullPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PCacheStorageParent::Write(
        const PartialFileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileStreamParams(), msg__);
    Write((v__).begin(), msg__);
    Write((v__).length(), msg__);
}

auto PCacheStorageParent::Read(
        PartialFileInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->fileStreamParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileStreamParams' (FileInputStreamParams) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->begin())), msg__, iter__)))) {
        FatalError("Error deserializing 'begin' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->length())), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const ContentPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).attrs(), msg__);
    Write((v__).spec(), msg__);
}

auto PCacheStorageParent::Read(
        ContentPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->attrs())), msg__, iter__)))) {
        FatalError("Error deserializing 'attrs' (PrincipalOriginAttributes) member of 'ContentPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->spec())), msg__, iter__)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'ContentPrincipalInfo'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const RemoteInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).id(), msg__);
}

auto PCacheStorageParent::Read(
        RemoteInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->id())), msg__, iter__)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'RemoteInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        PCacheStreamControlParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PCacheStreamControlParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PCacheStreamControlParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PCacheStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PCacheStreamControl");
        return false;
    }

    if ((PCacheStreamControlMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PCacheStreamControl has different type");
        return false;
    }

    (*(v__)) = static_cast<PCacheStreamControlParent*>(listener);
    return true;
}



} // namespace cache
} // namespace dom
} // namespace mozilla
