//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/camera/PCamerasParent.h"

#include "mozilla/dom/PContentParent.h"
#include "mozilla/ipc/PBackgroundParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace camera {



MOZ_IMPLICIT PCamerasParent::PCamerasParent() :
    mId(0),
    mState(PCameras::__Dead)
{
    MOZ_COUNT_CTOR(PCamerasParent);
}

PCamerasParent::~PCamerasParent()
{
    MOZ_COUNT_DTOR(PCamerasParent);
}

auto PCamerasParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(mManager);
}

auto PCamerasParent::state() -> PCameras::State
{
    return mState;
}

auto PCamerasParent::SendFrameSizeChange(
        const int& capEngine,
        const int& cap_id,
        const int& w,
        const int& h) -> bool
{
    PCameras::Msg_FrameSizeChange* msg__ = new PCameras::Msg_FrameSizeChange(mId);

    Write(capEngine, msg__);
    Write(cap_id, msg__);
    Write(w, msg__);
    Write(h, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendFrameSizeChange", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_FrameSizeChange__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendDeliverFrame(
        const int& capEngine,
        const int& cap_id,
        Shmem& buffer,
        const size_t& size,
        const uint32_t& time_stamp,
        const int64_t& ntp_time,
        const int64_t& render_time) -> bool
{
    PCameras::Msg_DeliverFrame* msg__ = new PCameras::Msg_DeliverFrame(mId);

    Write(capEngine, msg__);
    Write(cap_id, msg__);
    Write(buffer, msg__);
    Write(size, msg__);
    Write(time_stamp, msg__);
    Write(ntp_time, msg__);
    Write(render_time, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendDeliverFrame", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_DeliverFrame__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendReplyNumberOfCaptureDevices(const int& numdev) -> bool
{
    PCameras::Msg_ReplyNumberOfCaptureDevices* msg__ = new PCameras::Msg_ReplyNumberOfCaptureDevices(mId);

    Write(numdev, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendReplyNumberOfCaptureDevices", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_ReplyNumberOfCaptureDevices__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendReplyNumberOfCapabilities(const int& numdev) -> bool
{
    PCameras::Msg_ReplyNumberOfCapabilities* msg__ = new PCameras::Msg_ReplyNumberOfCapabilities(mId);

    Write(numdev, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendReplyNumberOfCapabilities", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_ReplyNumberOfCapabilities__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendReplyAllocateCaptureDevice(const int& numdev) -> bool
{
    PCameras::Msg_ReplyAllocateCaptureDevice* msg__ = new PCameras::Msg_ReplyAllocateCaptureDevice(mId);

    Write(numdev, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendReplyAllocateCaptureDevice", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_ReplyAllocateCaptureDevice__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendReplyGetCaptureCapability(const CaptureCapability& cap) -> bool
{
    PCameras::Msg_ReplyGetCaptureCapability* msg__ = new PCameras::Msg_ReplyGetCaptureCapability(mId);

    Write(cap, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendReplyGetCaptureCapability", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_ReplyGetCaptureCapability__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendReplyGetCaptureDevice(
        const nsCString& device_name,
        const nsCString& device_id) -> bool
{
    PCameras::Msg_ReplyGetCaptureDevice* msg__ = new PCameras::Msg_ReplyGetCaptureDevice(mId);

    Write(device_name, msg__);
    Write(device_id, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendReplyGetCaptureDevice", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_ReplyGetCaptureDevice__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendReplyFailure() -> bool
{
    PCameras::Msg_ReplyFailure* msg__ = new PCameras::Msg_ReplyFailure(mId);





    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendReplyFailure", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_ReplyFailure__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::SendReplySuccess() -> bool
{
    PCameras::Msg_ReplySuccess* msg__ = new PCameras::Msg_ReplySuccess(mId);





    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSendReplySuccess", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition(mState, Trigger(Trigger::Send, PCameras::Msg_ReplySuccess__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCamerasParent::Send__delete__(PCamerasParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PCameras::Msg___delete__* msg__ = new PCameras::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCamerasParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCameras", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PCameras::Transition((actor)->mState, Trigger(Trigger::Send, PCameras::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PCamerasMsgStart, actor);
    return sendok__;
}

auto PCamerasParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PCamerasParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PCamerasParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PCamerasParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PCamerasParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PCamerasParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PCamerasParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PCamerasParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PCamerasParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PCamerasParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PCamerasParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PCamerasParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PCamerasParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PCamerasParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PCameras has not yet been implemented");
    return nullptr;
}

auto PCamerasParent::OnMessageReceived(const Message& msg__) -> PCamerasParent::Result
{
    switch ((msg__).type()) {
    case PCameras::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PCameras::Msg_NumberOfCaptureDevices__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_NumberOfCaptureDevices");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_NumberOfCaptureDevices*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvNumberOfCaptureDevices", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_NumberOfCaptureDevices__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvNumberOfCaptureDevices(mozilla::Move(engine))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for NumberOfCaptureDevices returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_NumberOfCapabilities__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_NumberOfCapabilities");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_NumberOfCapabilities*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvNumberOfCapabilities", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;
            nsCString deviceUniqueIdUTF8;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(deviceUniqueIdUTF8)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_NumberOfCapabilities__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvNumberOfCapabilities(mozilla::Move(engine), mozilla::Move(deviceUniqueIdUTF8))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for NumberOfCapabilities returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_GetCaptureCapability__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_GetCaptureCapability");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_GetCaptureCapability*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvGetCaptureCapability", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;
            nsCString unique_idUTF8;
            int capability_number;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(unique_idUTF8)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(capability_number)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_GetCaptureCapability__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvGetCaptureCapability(mozilla::Move(engine), mozilla::Move(unique_idUTF8), mozilla::Move(capability_number))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for GetCaptureCapability returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_GetCaptureDevice__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_GetCaptureDevice");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_GetCaptureDevice*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvGetCaptureDevice", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;
            int num;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(num)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_GetCaptureDevice__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvGetCaptureDevice(mozilla::Move(engine), mozilla::Move(num))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for GetCaptureDevice returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_AllocateCaptureDevice__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_AllocateCaptureDevice");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_AllocateCaptureDevice*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvAllocateCaptureDevice", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;
            nsCString unique_idUTF8;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(unique_idUTF8)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_AllocateCaptureDevice__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvAllocateCaptureDevice(mozilla::Move(engine), mozilla::Move(unique_idUTF8))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for AllocateCaptureDevice returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_ReleaseCaptureDevice__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_ReleaseCaptureDevice");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_ReleaseCaptureDevice*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvReleaseCaptureDevice", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;
            int numdev;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(numdev)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_ReleaseCaptureDevice__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvReleaseCaptureDevice(mozilla::Move(engine), mozilla::Move(numdev))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for ReleaseCaptureDevice returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_StartCapture__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_StartCapture");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_StartCapture*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvStartCapture", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;
            int numdev;
            CaptureCapability capability;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(numdev)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(capability)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'CaptureCapability'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_StartCapture__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvStartCapture(mozilla::Move(engine), mozilla::Move(numdev), mozilla::Move(capability))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for StartCapture returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_StopCapture__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_StopCapture");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_StopCapture*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvStopCapture", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int engine;
            int numdev;

            if ((!(Read((&(engine)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            if ((!(Read((&(numdev)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_StopCapture__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvStopCapture(mozilla::Move(engine), mozilla::Move(numdev))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for StopCapture returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_ReleaseFrame__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_ReleaseFrame");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_ReleaseFrame*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvReleaseFrame", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            Shmem s;

            if ((!(Read((&(s)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'Shmem'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_ReleaseFrame__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvReleaseFrame(mozilla::Move(s))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for ReleaseFrame returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCameras::Msg_AllDone__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCameras::Msg_AllDone");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCameras::Msg_AllDone*>((&(msg__))))->Log("[PCamerasParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCameras", "RecvAllDone", js::ProfileEntry::Category::OTHER);

            if ((!(PCameras::Transition(mState, Trigger(Trigger::Recv, PCameras::Msg_AllDone__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvAllDone()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for AllDone returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PCamerasParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCamerasParent::Result
{
    return MsgNotKnown;
}

auto PCamerasParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCamerasParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCamerasParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PCamerasParent::GetProtocolTypeId() -> int32_t
{
    return PCamerasMsgStart;
}

auto PCamerasParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PCamerasParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PCamerasParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PCamerasParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PCamerasParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCamerasParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCamerasParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCamerasParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PCamerasParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PCamerasParent", aMsg, OtherPid(), true);
}

auto PCamerasParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PCamerasParent::DeallocSubtree() -> void
{
}

auto PCamerasParent::Write(
        const CaptureCapability& v__,
        Message* msg__) -> void
{
    Write((v__).width(), msg__);
    Write((v__).height(), msg__);
    Write((v__).maxFPS(), msg__);
    Write((v__).expectedCaptureDelay(), msg__);
    Write((v__).rawType(), msg__);
    Write((v__).codecType(), msg__);
    Write((v__).interlaced(), msg__);
}

auto PCamerasParent::Read(
        CaptureCapability* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->width())), msg__, iter__)))) {
        FatalError("Error deserializing 'width' (int) member of 'CaptureCapability'");
        return false;
    }
    if ((!(Read((&((v__)->height())), msg__, iter__)))) {
        FatalError("Error deserializing 'height' (int) member of 'CaptureCapability'");
        return false;
    }
    if ((!(Read((&((v__)->maxFPS())), msg__, iter__)))) {
        FatalError("Error deserializing 'maxFPS' (int) member of 'CaptureCapability'");
        return false;
    }
    if ((!(Read((&((v__)->expectedCaptureDelay())), msg__, iter__)))) {
        FatalError("Error deserializing 'expectedCaptureDelay' (int) member of 'CaptureCapability'");
        return false;
    }
    if ((!(Read((&((v__)->rawType())), msg__, iter__)))) {
        FatalError("Error deserializing 'rawType' (int) member of 'CaptureCapability'");
        return false;
    }
    if ((!(Read((&((v__)->codecType())), msg__, iter__)))) {
        FatalError("Error deserializing 'codecType' (int) member of 'CaptureCapability'");
        return false;
    }
    if ((!(Read((&((v__)->interlaced())), msg__, iter__)))) {
        FatalError("Error deserializing 'interlaced' (bool) member of 'CaptureCapability'");
        return false;
    }
    return true;
}

auto PCamerasParent::Write(
        PCamerasParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCamerasParent::Read(
        PCamerasParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PCamerasParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PCameras");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PCameras");
        return false;
    }

    if ((PCamerasMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PCameras has different type");
        return false;
    }

    (*(v__)) = static_cast<PCamerasParent*>(listener);
    return true;
}

auto PCamerasParent::Write(
        Shmem& v__,
        Message* msg__) -> void
{
    IPC::WriteParam(msg__, v__);
    (v__).RevokeRights(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    (v__).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
}

auto PCamerasParent::Read(
        Shmem* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    Shmem tmp;
    if ((!(IPC::ReadParam(msg__, iter__, (&(tmp)))))) {
        return false;
    }

    Shmem::id_t shmemid = (tmp).Id(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    Shmem::SharedMemory* rawmem = LookupSharedMemory(shmemid);
    if (rawmem) {
        (*(v__)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, shmemid);
        return true;
    }
    (*(v__)) = Shmem();
    return true;
}



} // namespace camera
} // namespace mozilla
