//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PDNSRequestChild.h"

#include "mozilla/net/PNeckoChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {


auto PDNSRequestChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PDNSRequestChild::PDNSRequestChild() :
    mId(0),
    mState(PDNSRequest::__Dead)
{
    MOZ_COUNT_CTOR(PDNSRequestChild);
}

PDNSRequestChild::~PDNSRequestChild()
{
    MOZ_COUNT_DTOR(PDNSRequestChild);
}

auto PDNSRequestChild::Manager() const -> PNeckoChild*
{
    return static_cast<PNeckoChild*>(mManager);
}

auto PDNSRequestChild::state() -> PDNSRequest::State
{
    return mState;
}

auto PDNSRequestChild::SendCancelDNSRequest(
        const nsCString& hostName,
        const uint32_t& flags,
        const nsCString& networkInterface,
        const nsresult& reason) -> bool
{
    PDNSRequest::Msg_CancelDNSRequest* msg__ = new PDNSRequest::Msg_CancelDNSRequest(mId);

    Write(hostName, msg__);
    Write(flags, msg__);
    Write(networkInterface, msg__);
    Write(reason, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PDNSRequestChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PDNSRequest", "AsyncSendCancelDNSRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PDNSRequest::Transition(mState, Trigger(Trigger::Recv, PDNSRequest::Msg_CancelDNSRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PDNSRequestChild::Send__delete__(PDNSRequestChild* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PDNSRequest::Msg___delete__* msg__ = new PDNSRequest::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PDNSRequestChild] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PDNSRequest", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PDNSRequest::Transition((actor)->mState, Trigger(Trigger::Recv, PDNSRequest::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PDNSRequestMsgStart, actor);
    return sendok__;
}

auto PDNSRequestChild::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PDNSRequestChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PDNSRequestChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PDNSRequestChild::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PDNSRequestChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PDNSRequestChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PDNSRequestChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PDNSRequestChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PDNSRequestChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PDNSRequestChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PDNSRequestChild::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PDNSRequestChild::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PDNSRequestChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PDNSRequestChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PDNSRequest has not yet been implemented");
    return nullptr;
}

auto PDNSRequestChild::OnMessageReceived(const Message& msg__) -> PDNSRequestChild::Result
{
    switch ((msg__).type()) {
    case PDNSRequest::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PDNSRequest::Msg_LookupCompleted__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PDNSRequest::Msg_LookupCompleted");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PDNSRequest::Msg_LookupCompleted*>((&(msg__))))->Log("[PDNSRequestChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PDNSRequest", "RecvLookupCompleted", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            DNSRequestResponse reply;

            if ((!(Read((&(reply)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'DNSRequestResponse'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PDNSRequest::Transition(mState, Trigger(Trigger::Send, PDNSRequest::Msg_LookupCompleted__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvLookupCompleted(mozilla::Move(reply))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for LookupCompleted returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PDNSRequestChild::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PDNSRequestChild::Result
{
    return MsgNotKnown;
}

auto PDNSRequestChild::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PDNSRequestChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PDNSRequestChild::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PDNSRequestChild::GetProtocolTypeId() -> int32_t
{
    return PDNSRequestMsgStart;
}

auto PDNSRequestChild::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PDNSRequestChild::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PDNSRequestChild::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PDNSRequestChild::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PDNSRequestChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PDNSRequestChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PDNSRequestChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PDNSRequestChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PDNSRequestChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PDNSRequestChild", aMsg, 0, false);
}

auto PDNSRequestChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PDNSRequestChild::DeallocSubtree() -> void
{
}

auto PDNSRequestChild::Write(
        const DNSRequestResponse& v__,
        Message* msg__) -> void
{
    typedef DNSRequestResponse type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TDNSRecord:
        {
            Write((v__).get_DNSRecord(), msg__);
            return;
        }
    case type__::Tnsresult:
        {
            Write((v__).get_nsresult(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PDNSRequestChild::Read(
        DNSRequestResponse* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef DNSRequestResponse type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'DNSRequestResponse'");
        return false;
    }

    switch (type) {
    case type__::TDNSRecord:
        {
            DNSRecord tmp = DNSRecord();
            (*(v__)) = tmp;
            return Read((&((v__)->get_DNSRecord())), msg__, iter__);
        }
    case type__::Tnsresult:
        {
            nsresult tmp = nsresult();
            (*(v__)) = tmp;
            return Read((&((v__)->get_nsresult())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PDNSRequestChild::Write(
        PDNSRequestChild* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PDNSRequestChild::Read(
        PDNSRequestChild** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PDNSRequestChild'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PDNSRequest");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PDNSRequest");
        return false;
    }

    if ((PDNSRequestMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PDNSRequest has different type");
        return false;
    }

    (*(v__)) = static_cast<PDNSRequestChild*>(listener);
    return true;
}

auto PDNSRequestChild::Write(
        const DNSRecord& v__,
        Message* msg__) -> void
{
    Write((v__).canonicalName(), msg__);
    Write((v__).addrs(), msg__);
}

auto PDNSRequestChild::Read(
        DNSRecord* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->canonicalName())), msg__, iter__)))) {
        FatalError("Error deserializing 'canonicalName' (nsCString) member of 'DNSRecord'");
        return false;
    }
    if ((!(Read((&((v__)->addrs())), msg__, iter__)))) {
        FatalError("Error deserializing 'addrs' (NetAddrArray) member of 'DNSRecord'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
