//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/gmp/PGMPServiceChild.h"
#ifdef MOZ_CRASHREPORTER
#  include "nsXULAppAPI.h"
#endif

#include "mozilla/gmp/PGMPChild.h"
#include "mozilla/gmp/PGMPContentParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace gmp {


auto PGMPServiceChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

auto PGMPServiceChild::ProcessingError(
        Result aCode,
        const char* aReason) -> void
{
}

auto PGMPServiceChild::ShouldContinueFromReplyTimeout() -> bool
{
    return true;
}

auto PGMPServiceChild::EnteredCxxStack() -> void
{
}

auto PGMPServiceChild::ExitedCxxStack() -> void
{
}

auto PGMPServiceChild::EnteredCall() -> void
{
}

auto PGMPServiceChild::ExitedCall() -> void
{
}

MOZ_IMPLICIT PGMPServiceChild::PGMPServiceChild() :
    mozilla::ipc::IToplevelProtocol(PGMPServiceMsgStart),
    mChannel(ALLOW_THIS_IN_INITIALIZER_LIST(this)),
    mLastRouteId(0),
    mOtherPid(mozilla::ipc::kInvalidProcessId),
    mLastShmemId(0),
    mState(PGMPService::__Start)
{
    MOZ_COUNT_CTOR(PGMPServiceChild);
}

PGMPServiceChild::~PGMPServiceChild()
{
    MOZ_COUNT_DTOR(PGMPServiceChild);
}

auto PGMPServiceChild::Open(
        Channel::Transport* aTransport,
        base::ProcessId aOtherPid,
        MessageLoop* aThread,
        mozilla::ipc::Side aSide) -> bool
{
    mOtherPid = aOtherPid;
    return (mChannel).Open(aTransport, aThread, aSide);
}

auto PGMPServiceChild::Open(
        MessageChannel* aChannel,
        MessageLoop* aMessageLoop,
        mozilla::ipc::Side aSide) -> bool
{
    mOtherPid = base::GetCurrentProcId();
    return (mChannel).Open(aChannel, aMessageLoop, aSide);
}

auto PGMPServiceChild::Close() -> void
{
    (mChannel).Close();
}

auto PGMPServiceChild::SetReplyTimeoutMs(int32_t aTimeoutMs) -> void
{
    (mChannel).SetReplyTimeoutMs(aTimeoutMs);
}

auto PGMPServiceChild::state() -> PGMPService::State
{
    return mState;
}

auto PGMPServiceChild::SendLoadGMP(
        const nsCString& nodeId,
        const nsCString& api,
        const nsTArray<nsCString>& tags,
        const nsTArray<ProcessId>& alreadyBridgedTo,
        ProcessId* id,
        nsCString* displayName,
        uint32_t* pluginId) -> bool
{
    PGMPService::Msg_LoadGMP* msg__ = new PGMPService::Msg_LoadGMP(MSG_ROUTING_CONTROL);

    Write(nodeId, msg__);
    Write(api, msg__);
    Write(tags, msg__);
    Write(alreadyBridgedTo, msg__);

    (msg__)->set_sync();


    Message reply__;

    if (mozilla::ipc::LoggingEnabledFor("PGMPService")) {
        (msg__)->Log("[PGMPServiceChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPService", "SendLoadGMP", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPService::Transition(mState, Trigger(Trigger::Recv, PGMPService::Msg_LoadGMP__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel).Send(msg__, (&(reply__)));
    if ((!(sendok__))) {
        return false;
    }

    if (mozilla::ipc::LoggingEnabledFor("PGMPService")) {
        (static_cast<const PGMPService::Reply_LoadGMP*>((&(reply__))))->Log("[PGMPServiceChild] Received reply ", OtherPid(), true);
    }

    void* iter__ = nullptr;
    if ((!(Read(id, (&(reply__)), (&(iter__)))))) {
        FatalError("Error deserializing 'ProcessId'");
        return false;
    }
    if ((!(Read(displayName, (&(reply__)), (&(iter__)))))) {
        FatalError("Error deserializing 'nsCString'");
        return false;
    }
    if ((!(Read(pluginId, (&(reply__)), (&(iter__)))))) {
        FatalError("Error deserializing 'uint32_t'");
        return false;
    }
    (reply__).EndRead(iter__);

    return true;
}

auto PGMPServiceChild::SendGetGMPNodeId(
        const nsString& origin,
        const nsString& topLevelOrigin,
        const nsString& gmpName,
        const bool& inPrivateBrowsing,
        nsCString* id) -> bool
{
    PGMPService::Msg_GetGMPNodeId* msg__ = new PGMPService::Msg_GetGMPNodeId(MSG_ROUTING_CONTROL);

    Write(origin, msg__);
    Write(topLevelOrigin, msg__);
    Write(gmpName, msg__);
    Write(inPrivateBrowsing, msg__);

    (msg__)->set_sync();


    Message reply__;

    if (mozilla::ipc::LoggingEnabledFor("PGMPService")) {
        (msg__)->Log("[PGMPServiceChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPService", "SendGetGMPNodeId", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPService::Transition(mState, Trigger(Trigger::Recv, PGMPService::Msg_GetGMPNodeId__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel).Send(msg__, (&(reply__)));
    if ((!(sendok__))) {
        return false;
    }

    if (mozilla::ipc::LoggingEnabledFor("PGMPService")) {
        (static_cast<const PGMPService::Reply_GetGMPNodeId*>((&(reply__))))->Log("[PGMPServiceChild] Received reply ", OtherPid(), true);
    }

    void* iter__ = nullptr;
    if ((!(Read(id, (&(reply__)), (&(iter__)))))) {
        FatalError("Error deserializing 'nsCString'");
        return false;
    }
    (reply__).EndRead(iter__);

    return true;
}

auto PGMPServiceChild::SendUpdateGMPTrialCreateState(
        const nsString& keySystem,
        const uint32_t& status) -> bool
{
    PGMPService::Msg_UpdateGMPTrialCreateState* msg__ = new PGMPService::Msg_UpdateGMPTrialCreateState(MSG_ROUTING_CONTROL);

    Write(keySystem, msg__);
    Write(status, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMPService")) {
        (msg__)->Log("[PGMPServiceChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPService", "AsyncSendUpdateGMPTrialCreateState", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPService::Transition(mState, Trigger(Trigger::Recv, PGMPService::Msg_UpdateGMPTrialCreateState__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel).Send(msg__);
    return sendok__;
}

auto PGMPServiceChild::Register(ProtocolBase* aRouted) -> int32_t
{
    int32_t tmp = (--(mLastRouteId));
    (mActorMap).AddWithID(aRouted, tmp);
    return tmp;
}

auto PGMPServiceChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    (mActorMap).AddWithID(aRouted, aId);
    return aId;
}

auto PGMPServiceChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mActorMap).Lookup(aId);
}

auto PGMPServiceChild::Unregister(int32_t aId) -> void
{
    return (mActorMap).Remove(aId);
}

auto PGMPServiceChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PGMPServiceChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    RefPtr<Shmem::SharedMemory> segment(Shmem::Alloc(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), aSize, aType, aUnsafe));
    if ((!(segment))) {
        return nullptr;
    }
    Shmem shmem(
            Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(),
            (segment).get(),
            (--(mLastShmemId)));
    Message* descriptor = (shmem).ShareTo(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), OtherPid(), MSG_ROUTING_CONTROL);
    if ((!(descriptor))) {
        return nullptr;
    }
    if ((!((mChannel).Send(descriptor)))) {
    }
    (*(aId)) = (shmem).Id(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    Shmem::SharedMemory* rawSegment = (segment).get();
    (mShmemMap).AddWithID(((segment).forget()).take(), (*(aId)));
    return rawSegment;
}

auto PGMPServiceChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    Shmem shmem(
            Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(),
            segment,
            (--(mLastShmemId)));
    Message* descriptor = (shmem).ShareTo(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), OtherPid(), MSG_ROUTING_CONTROL);
    if ((!(descriptor))) {
        return false;
    }
    if ((!((mChannel).Send(descriptor)))) {
    }
    (*(aId)) = (shmem).Id(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    (mShmemMap).AddWithID(segment, (*(aId)));
    (segment)->AddRef();
    return true;
}

auto PGMPServiceChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mShmemMap).Lookup(aId);
}

auto PGMPServiceChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mShmemMap).HasData(segment);
}

auto PGMPServiceChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    Shmem::id_t aId = (shmem).Id(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    Shmem::SharedMemory* segment = LookupSharedMemory(aId);
    if ((!(segment))) {
        return false;
    }

    Message* descriptor = (shmem).UnshareFrom(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), OtherPid(), MSG_ROUTING_CONTROL);

    (mShmemMap).Remove(aId);
    Shmem::Dealloc(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), segment);

    if ((!((mChannel).CanSend()))) {
        delete descriptor;
        return true;
    }

    return (descriptor) && ((mChannel).Send(descriptor));
}

auto PGMPServiceChild::OtherPid() const -> base::ProcessId
{
    return mOtherPid;
}

auto PGMPServiceChild::GetIPCChannel() -> MessageChannel*
{
    return (&(mChannel));
}

auto PGMPServiceChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PGMPServiceChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PGMPService has not yet been implemented");
    return nullptr;
}

auto PGMPServiceChild::OnMessageReceived(const Message& msg__) -> PGMPServiceChild::Result
{
    switch ((msg__).type()) {
    case CHANNEL_OPENED_MESSAGE_TYPE:
        {
            TransportDescriptor td;
            ProcessId pid;
            ProtocolId protocolid;
            if ((!(mozilla::ipc::UnpackChannelOpened(mozilla::ipc::PrivateIPDLInterface(), msg__, (&(td)), (&(pid)), (&(protocolid)))))) {
                return MsgPayloadError;
            }

            switch (protocolid) {
            case PGMPContentMsgStart:
                {
                    Transport* t;
                    PGMPContentParent* p;
                    if ((!(t = mozilla::ipc::OpenDescriptor(td, mozilla::ipc::Transport::MODE_SERVER)))) {
                        return MsgValueError;
                    }
                    if ((!(p = AllocPGMPContentParent(t, pid)))) {
                        return MsgProcessingError;
                    }
                    (p)->IToplevelProtocol::SetTransport(t);
                    IToplevelProtocol::AddOpenedActor(p);
                    break;
                }
            default:
                NS_RUNTIMEABORT("Invalid protocol");
                return MsgValueError;
            }
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    case SHMEM_CREATED_MESSAGE_TYPE:
        {
            NS_RUNTIMEABORT("this protocol tree does not use shmem");
            return MsgNotKnown;
        }
    case SHMEM_DESTROYED_MESSAGE_TYPE:
        {
            NS_RUNTIMEABORT("this protocol tree does not use shmem");
            return MsgNotKnown;
        }
    }
}

auto PGMPServiceChild::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPServiceChild::Result
{
    return MsgNotKnown;
}

auto PGMPServiceChild::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPServiceChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PGMPServiceChild::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    return ProcessingError(aCode, aReason);
}

auto PGMPServiceChild::GetProtocolTypeId() -> int32_t
{
    return PGMPServiceMsgStart;
}

auto PGMPServiceChild::OnReplyTimeout() -> bool
{
    return ShouldContinueFromReplyTimeout();
}

auto PGMPServiceChild::OnEnteredCxxStack() -> void
{
    return EnteredCxxStack();
}

auto PGMPServiceChild::OnExitedCxxStack() -> void
{
    return ExitedCxxStack();
}

auto PGMPServiceChild::OnEnteredCall() -> void
{
    return EnteredCall();
}

auto PGMPServiceChild::OnExitedCall() -> void
{
    return ExitedCall();
}

auto PGMPServiceChild::IsOnCxxStack() const -> bool
{
    return (mChannel).IsOnCxxStack();
}

auto PGMPServiceChild::FlushPendingInterruptQueue() -> void
{
    ((this)->mChannel).FlushPendingInterruptQueue();
}

auto PGMPServiceChild::OnChannelClose() -> void
{
    DestroySubtree(NormalShutdown);
    DeallocSubtree();
    DeallocShmems();
}

auto PGMPServiceChild::OnChannelError() -> void
{
    DestroySubtree(AbnormalShutdown);
    DeallocSubtree();
    DeallocShmems();
}

auto PGMPServiceChild::OnChannelConnected(int32_t aPid) -> void
{
}

auto PGMPServiceChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPServiceChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPServiceChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPServiceChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PGMPServiceChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PGMPServiceChild", aMsg, 0, false);
}

auto PGMPServiceChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PGMPServiceChild::DeallocSubtree() -> void
{
}

auto PGMPServiceChild::DeallocShmems() -> void
{
    for (IDMap<SharedMemory>::const_iterator cit = (mShmemMap).begin(); (cit) != ((mShmemMap).end()); (++(cit))) {
        Shmem::Dealloc(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), (cit)->second);
    }
    (mShmemMap).Clear();
}



} // namespace gmp
} // namespace mozilla
