//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/gmp/PGMPTimerParent.h"

#include "mozilla/gmp/PGMPParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace gmp {


auto PGMPTimerParent::Recv__delete__() -> bool
{
    return true;
}


MOZ_IMPLICIT PGMPTimerParent::PGMPTimerParent() :
    mId(0),
    mState(PGMPTimer::__Dead)
{
    MOZ_COUNT_CTOR(PGMPTimerParent);
}

PGMPTimerParent::~PGMPTimerParent()
{
    MOZ_COUNT_DTOR(PGMPTimerParent);
}

auto PGMPTimerParent::Manager() const -> PGMPParent*
{
    return static_cast<PGMPParent*>(mManager);
}

auto PGMPTimerParent::state() -> PGMPTimer::State
{
    return mState;
}

auto PGMPTimerParent::SendTimerExpired(const uint32_t& aTimerId) -> bool
{
    PGMPTimer::Msg_TimerExpired* msg__ = new PGMPTimer::Msg_TimerExpired(mId);

    Write(aTimerId, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPTimerParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPTimer", "AsyncSendTimerExpired", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPTimer::Transition(mState, Trigger(Trigger::Send, PGMPTimer::Msg_TimerExpired__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPTimerParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PGMPTimerParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PGMPTimerParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PGMPTimerParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PGMPTimerParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PGMPTimerParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PGMPTimerParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PGMPTimerParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PGMPTimerParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PGMPTimerParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PGMPTimerParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PGMPTimerParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PGMPTimerParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PGMPTimerParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PGMPTimer has not yet been implemented");
    return nullptr;
}

auto PGMPTimerParent::OnMessageReceived(const Message& msg__) -> PGMPTimerParent::Result
{
    switch ((msg__).type()) {
    case PGMPTimer::Msg_SetTimer__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPTimer::Msg_SetTimer");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPTimer::Msg_SetTimer*>((&(msg__))))->Log("[PGMPTimerParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPTimer", "RecvSetTimer", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            uint32_t aTimerId;
            uint32_t aTimeoutMs;

            if ((!(Read((&(aTimerId)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(aTimeoutMs)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPTimer::Transition(mState, Trigger(Trigger::Recv, PGMPTimer::Msg_SetTimer__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSetTimer(mozilla::Move(aTimerId), mozilla::Move(aTimeoutMs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SetTimer returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPTimer::Msg___delete____ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPTimer::Msg___delete__");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPTimer::Msg___delete__*>((&(msg__))))->Log("[PGMPTimerParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPTimer", "Recv__delete__", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            PGMPTimerParent* actor;

            if ((!(Read((&(actor)), (&(msg__)), (&(iter__)), false)))) {
                FatalError("Error deserializing 'PGMPTimerParent'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPTimer::Transition(mState, Trigger(Trigger::Recv, PGMPTimer::Msg___delete____ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for __delete__ returned error code");
                return MsgProcessingError;
            }


            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            ((actor)->mManager)->RemoveManagee(PGMPTimerMsgStart, actor);

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PGMPTimerParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPTimerParent::Result
{
    return MsgNotKnown;
}

auto PGMPTimerParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPTimerParent::Result
{
    return MsgNotKnown;
}

auto PGMPTimerParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PGMPTimerParent::GetProtocolTypeId() -> int32_t
{
    return PGMPTimerMsgStart;
}

auto PGMPTimerParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PGMPTimerParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PGMPTimerParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PGMPTimerParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PGMPTimerParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPTimerParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPTimerParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPTimerParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PGMPTimerParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PGMPTimerParent", aMsg, OtherPid(), true);
}

auto PGMPTimerParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PGMPTimerParent::DeallocSubtree() -> void
{
}

auto PGMPTimerParent::Write(
        PGMPTimerParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PGMPTimerParent::Read(
        PGMPTimerParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PGMPTimerParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PGMPTimer");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PGMPTimer");
        return false;
    }

    if ((PGMPTimerMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PGMPTimer has different type");
        return false;
    }

    (*(v__)) = static_cast<PGMPTimerParent*>(listener);
    return true;
}



} // namespace gmp
} // namespace mozilla
