//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PHttpChannelParent.h"
#include "mozilla/net/TimingStruct.h"
#include "nsHttpHeaderArray.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {


auto PHttpChannelParent::Recv__delete__() -> bool
{
    return true;
}


MOZ_IMPLICIT PHttpChannelParent::PHttpChannelParent() :
    mId(0),
    mState(PHttpChannel::__Dead)
{
    MOZ_COUNT_CTOR(PHttpChannelParent);
}

PHttpChannelParent::~PHttpChannelParent()
{
    MOZ_COUNT_DTOR(PHttpChannelParent);
}

auto PHttpChannelParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(mManager);
}

auto PHttpChannelParent::state() -> PHttpChannel::State
{
    return mState;
}

auto PHttpChannelParent::SendOnStartRequest(
        const nsresult& channelStatus,
        const nsHttpResponseHead& responseHead,
        const bool& useResponseHead,
        const nsHttpHeaderArray& requestHeaders,
        const bool& isFromCache,
        const bool& cacheEntryAvailable,
        const uint32_t& cacheExpirationTime,
        const nsCString& cachedCharset,
        const nsCString& securityInfoSerialization,
        const NetAddr& selfAddr,
        const NetAddr& peerAddr,
        const int16_t& redirectCount,
        const uint32_t& cacheKey) -> bool
{
    PHttpChannel::Msg_OnStartRequest* msg__ = new PHttpChannel::Msg_OnStartRequest(mId);

    Write(channelStatus, msg__);
    Write(responseHead, msg__);
    Write(useResponseHead, msg__);
    Write(requestHeaders, msg__);
    Write(isFromCache, msg__);
    Write(cacheEntryAvailable, msg__);
    Write(cacheExpirationTime, msg__);
    Write(cachedCharset, msg__);
    Write(securityInfoSerialization, msg__);
    Write(selfAddr, msg__);
    Write(peerAddr, msg__);
    Write(redirectCount, msg__);
    Write(cacheKey, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnStartRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStartRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendOnTransportAndData(
        const nsresult& channelStatus,
        const nsresult& transportStatus,
        const uint64_t& progress,
        const uint64_t& progressMax,
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count) -> bool
{
    PHttpChannel::Msg_OnTransportAndData* msg__ = new PHttpChannel::Msg_OnTransportAndData(mId);

    Write(channelStatus, msg__);
    Write(transportStatus, msg__);
    Write(progress, msg__);
    Write(progressMax, msg__);
    Write(data, msg__);
    Write(offset, msg__);
    Write(count, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnTransportAndData", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnTransportAndData__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendOnStopRequest(
        const nsresult& channelStatus,
        const ResourceTimingStruct& timing) -> bool
{
    PHttpChannel::Msg_OnStopRequest* msg__ = new PHttpChannel::Msg_OnStopRequest(mId);

    Write(channelStatus, msg__);
    Write(timing, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnStopRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStopRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendOnProgress(
        const int64_t& progress,
        const int64_t& progressMax) -> bool
{
    PHttpChannel::Msg_OnProgress* msg__ = new PHttpChannel::Msg_OnProgress(mId);

    Write(progress, msg__);
    Write(progressMax, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnProgress", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnProgress__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendOnStatus(const nsresult& status) -> bool
{
    PHttpChannel::Msg_OnStatus* msg__ = new PHttpChannel::Msg_OnStatus(mId);

    Write(status, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnStatus", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStatus__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendFailedAsyncOpen(const nsresult& status) -> bool
{
    PHttpChannel::Msg_FailedAsyncOpen* msg__ = new PHttpChannel::Msg_FailedAsyncOpen(mId);

    Write(status, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendFailedAsyncOpen", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_FailedAsyncOpen__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendRedirect1Begin(
        const uint32_t& newChannelId,
        const URIParams& newUri,
        const uint32_t& redirectFlags,
        const nsHttpResponseHead& responseHead,
        const nsCString& securityInfoSerialization) -> bool
{
    PHttpChannel::Msg_Redirect1Begin* msg__ = new PHttpChannel::Msg_Redirect1Begin(mId);

    Write(newChannelId, msg__);
    Write(newUri, msg__);
    Write(redirectFlags, msg__);
    Write(responseHead, msg__);
    Write(securityInfoSerialization, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendRedirect1Begin", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_Redirect1Begin__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendRedirect3Complete() -> bool
{
    PHttpChannel::Msg_Redirect3Complete* msg__ = new PHttpChannel::Msg_Redirect3Complete(mId);





    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendRedirect3Complete", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_Redirect3Complete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendAssociateApplicationCache(
        const nsCString& groupID,
        const nsCString& clientID) -> bool
{
    PHttpChannel::Msg_AssociateApplicationCache* msg__ = new PHttpChannel::Msg_AssociateApplicationCache(mId);

    Write(groupID, msg__);
    Write(clientID, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendAssociateApplicationCache", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_AssociateApplicationCache__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendNotifyTrackingProtectionDisabled() -> bool
{
    PHttpChannel::Msg_NotifyTrackingProtectionDisabled* msg__ = new PHttpChannel::Msg_NotifyTrackingProtectionDisabled(mId);





    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendNotifyTrackingProtectionDisabled", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_NotifyTrackingProtectionDisabled__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendFlushedForDiversion() -> bool
{
    PHttpChannel::Msg_FlushedForDiversion* msg__ = new PHttpChannel::Msg_FlushedForDiversion(mId);





    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendFlushedForDiversion", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_FlushedForDiversion__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendDivertMessages() -> bool
{
    PHttpChannel::Msg_DivertMessages* msg__ = new PHttpChannel::Msg_DivertMessages(mId);





    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDivertMessages", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_DivertMessages__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendReportSecurityMessage(
        const nsString& messageTag,
        const nsString& messageCategory) -> bool
{
    PHttpChannel::Msg_ReportSecurityMessage* msg__ = new PHttpChannel::Msg_ReportSecurityMessage(mId);

    Write(messageTag, msg__);
    Write(messageCategory, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendReportSecurityMessage", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_ReportSecurityMessage__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendDeleteSelf() -> bool
{
    PHttpChannel::Msg_DeleteSelf* msg__ = new PHttpChannel::Msg_DeleteSelf(mId);





    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDeleteSelf", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_DeleteSelf__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendIssueDeprecationWarning(
        const uint32_t& warning,
        const bool& asError) -> bool
{
    PHttpChannel::Msg_IssueDeprecationWarning* msg__ = new PHttpChannel::Msg_IssueDeprecationWarning(mId);

    Write(warning, msg__);
    Write(asError, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendIssueDeprecationWarning", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_IssueDeprecationWarning__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::SendReportRedirectionError() -> bool
{
    PHttpChannel::Msg_ReportRedirectionError* msg__ = new PHttpChannel::Msg_ReportRedirectionError(mId);





    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PHttpChannelParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendReportRedirectionError", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_ReportRedirectionError__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PHttpChannelParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PHttpChannelParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PHttpChannelParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PHttpChannelParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PHttpChannelParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PHttpChannelParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PHttpChannelParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PHttpChannelParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PHttpChannelParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PHttpChannelParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PHttpChannelParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PHttpChannelParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PHttpChannelParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PHttpChannelParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PHttpChannel has not yet been implemented");
    return nullptr;
}

auto PHttpChannelParent::OnMessageReceived(const Message& msg__) -> PHttpChannelParent::Result
{
    switch ((msg__).type()) {
    case PHttpChannel::Msg_SetPriority__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_SetPriority");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_SetPriority*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvSetPriority", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            uint16_t priority;

            if ((!(Read((&(priority)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint16_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_SetPriority__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSetPriority(mozilla::Move(priority))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SetPriority returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_SetClassOfService__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_SetClassOfService");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_SetClassOfService*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvSetClassOfService", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            uint32_t cos;

            if ((!(Read((&(cos)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_SetClassOfService__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSetClassOfService(mozilla::Move(cos))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SetClassOfService returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_SetCacheTokenCachedCharset__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_SetCacheTokenCachedCharset");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_SetCacheTokenCachedCharset*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvSetCacheTokenCachedCharset", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString charset;

            if ((!(Read((&(charset)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_SetCacheTokenCachedCharset__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSetCacheTokenCachedCharset(mozilla::Move(charset))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SetCacheTokenCachedCharset returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_UpdateAssociatedContentSecurity__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_UpdateAssociatedContentSecurity");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_UpdateAssociatedContentSecurity*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvUpdateAssociatedContentSecurity", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            int32_t broken;
            int32_t no;

            if ((!(Read((&(broken)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(no)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'int32_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_UpdateAssociatedContentSecurity__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvUpdateAssociatedContentSecurity(mozilla::Move(broken), mozilla::Move(no))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for UpdateAssociatedContentSecurity returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Suspend__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_Suspend");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Suspend*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvSuspend", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Suspend__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSuspend()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Suspend returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Resume__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_Resume");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Resume*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvResume", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Resume__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvResume()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Resume returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Cancel__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_Cancel");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Cancel*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvCancel", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsresult status;

            if ((!(Read((&(status)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Cancel__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvCancel(mozilla::Move(status))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Cancel returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Redirect2Verify__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_Redirect2Verify");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Redirect2Verify*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvRedirect2Verify", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsresult result;
            RequestHeaderTuples changedHeaders;
            uint32_t loadFlags;
            OptionalURIParams apiRedirectTo;
            OptionalCorsPreflightArgs corsPreflightArgs;

            if ((!(Read((&(result)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(Read((&(changedHeaders)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'RequestHeaderTuples'");
                return MsgValueError;
            }
            if ((!(Read((&(loadFlags)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(apiRedirectTo)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'OptionalURIParams'");
                return MsgValueError;
            }
            if ((!(Read((&(corsPreflightArgs)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'OptionalCorsPreflightArgs'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Redirect2Verify__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRedirect2Verify(mozilla::Move(result), mozilla::Move(changedHeaders), mozilla::Move(loadFlags), mozilla::Move(apiRedirectTo), mozilla::Move(corsPreflightArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Redirect2Verify returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DocumentChannelCleanup__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_DocumentChannelCleanup");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DocumentChannelCleanup*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDocumentChannelCleanup", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DocumentChannelCleanup__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDocumentChannelCleanup()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DocumentChannelCleanup returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvMarkOfflineCacheEntryAsForeign", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvMarkOfflineCacheEntryAsForeign()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for MarkOfflineCacheEntryAsForeign returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DivertOnDataAvailable__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_DivertOnDataAvailable");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DivertOnDataAvailable*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDivertOnDataAvailable", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString data;
            uint64_t offset;
            uint32_t count;

            if ((!(Read((&(data)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(offset)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(count)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertOnDataAvailable__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertOnDataAvailable(mozilla::Move(data), mozilla::Move(offset), mozilla::Move(count))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertOnDataAvailable returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DivertOnStopRequest__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_DivertOnStopRequest");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DivertOnStopRequest*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDivertOnStopRequest", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsresult statusCode;

            if ((!(Read((&(statusCode)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertOnStopRequest__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertOnStopRequest(mozilla::Move(statusCode))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertOnStopRequest returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DivertComplete__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_DivertComplete");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DivertComplete*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDivertComplete", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertComplete()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_RemoveCorsPreflightCacheEntry__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg_RemoveCorsPreflightCacheEntry");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_RemoveCorsPreflightCacheEntry*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvRemoveCorsPreflightCacheEntry", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            URIParams uri;
            PrincipalInfo requestingPrincipal;

            if ((!(Read((&(uri)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'URIParams'");
                return MsgValueError;
            }
            if ((!(Read((&(requestingPrincipal)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'PrincipalInfo'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_RemoveCorsPreflightCacheEntry__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRemoveCorsPreflightCacheEntry(mozilla::Move(uri), mozilla::Move(requestingPrincipal))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for RemoveCorsPreflightCacheEntry returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg___delete____ID:
        {
            (const_cast<Message&>(msg__)).set_name("PHttpChannel::Msg___delete__");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg___delete__*>((&(msg__))))->Log("[PHttpChannelParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "Recv__delete__", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            PHttpChannelParent* actor;

            if ((!(Read((&(actor)), (&(msg__)), (&(iter__)), false)))) {
                FatalError("Error deserializing 'PHttpChannelParent'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg___delete____ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for __delete__ returned error code");
                return MsgProcessingError;
            }


            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            ((actor)->mManager)->RemoveManagee(PHttpChannelMsgStart, actor);

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PHttpChannelParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PHttpChannelParent::Result
{
    return MsgNotKnown;
}

auto PHttpChannelParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PHttpChannelParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PHttpChannelParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PHttpChannelParent::GetProtocolTypeId() -> int32_t
{
    return PHttpChannelMsgStart;
}

auto PHttpChannelParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PHttpChannelParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PHttpChannelParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PHttpChannelParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PHttpChannelParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PHttpChannelParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PHttpChannelParent", aMsg, OtherPid(), true);
}

auto PHttpChannelParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PHttpChannelParent::DeallocSubtree() -> void
{
}

auto PHttpChannelParent::Write(
        const SystemPrincipalInfo& v__,
        Message* msg__) -> void
{
}

auto PHttpChannelParent::Read(
        SystemPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PHttpChannelParent::Write(
        const nsTArray<PrincipalInfo>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PHttpChannelParent::Read(
        nsTArray<PrincipalInfo>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<PrincipalInfo> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'PrincipalInfo[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'PrincipalInfo[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PHttpChannelParent::Write(
        PHttpChannelParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PHttpChannelParent::Read(
        PHttpChannelParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PHttpChannelParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PHttpChannel");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PHttpChannel");
        return false;
    }

    if ((PHttpChannelMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PHttpChannel has different type");
        return false;
    }

    (*(v__)) = static_cast<PHttpChannelParent*>(listener);
    return true;
}

auto PHttpChannelParent::Write(
        const NullPrincipalURIParams& v__,
        Message* msg__) -> void
{
}

auto PHttpChannelParent::Read(
        NullPrincipalURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PHttpChannelParent::Write(
        const IconURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).uri(), msg__);
    Write((v__).size(), msg__);
    Write((v__).contentType(), msg__);
    Write((v__).fileName(), msg__);
    Write((v__).stockIcon(), msg__);
    Write((v__).iconSize(), msg__);
    Write((v__).iconState(), msg__);
}

auto PHttpChannelParent::Read(
        IconURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->uri())), msg__, iter__)))) {
        FatalError("Error deserializing 'uri' (OptionalURIParams) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->size())), msg__, iter__)))) {
        FatalError("Error deserializing 'size' (uint32_t) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->contentType())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentType' (nsCString) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->fileName())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileName' (nsCString) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->stockIcon())), msg__, iter__)))) {
        FatalError("Error deserializing 'stockIcon' (nsCString) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->iconSize())), msg__, iter__)))) {
        FatalError("Error deserializing 'iconSize' (int32_t) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->iconState())), msg__, iter__)))) {
        FatalError("Error deserializing 'iconState' (int32_t) member of 'IconURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const ExpandedPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).whitelist(), msg__);
}

auto PHttpChannelParent::Read(
        ExpandedPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->whitelist())), msg__, iter__)))) {
        FatalError("Error deserializing 'whitelist' (PrincipalInfo[]) member of 'ExpandedPrincipalInfo'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const JARURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).jarFile(), msg__);
    Write((v__).jarEntry(), msg__);
    Write((v__).charset(), msg__);
}

auto PHttpChannelParent::Read(
        JARURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->jarFile())), msg__, iter__)))) {
        FatalError("Error deserializing 'jarFile' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->jarEntry())), msg__, iter__)))) {
        FatalError("Error deserializing 'jarEntry' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->charset())), msg__, iter__)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'JARURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const SimpleNestedURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).simpleParams(), msg__);
    Write((v__).innerURI(), msg__);
}

auto PHttpChannelParent::Read(
        SimpleNestedURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->simpleParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'simpleParams' (SimpleURIParams) member of 'SimpleNestedURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->innerURI())), msg__, iter__)))) {
        FatalError("Error deserializing 'innerURI' (URIParams) member of 'SimpleNestedURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const OptionalURIParams& v__,
        Message* msg__) -> void
{
    typedef OptionalURIParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TURIParams:
        {
            Write((v__).get_URIParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelParent::Read(
        OptionalURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalURIParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalURIParams'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TURIParams:
        {
            URIParams tmp = URIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_URIParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelParent::Write(
        const PrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef PrincipalInfo type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TContentPrincipalInfo:
        {
            Write((v__).get_ContentPrincipalInfo(), msg__);
            return;
        }
    case type__::TSystemPrincipalInfo:
        {
            Write((v__).get_SystemPrincipalInfo(), msg__);
            return;
        }
    case type__::TNullPrincipalInfo:
        {
            Write((v__).get_NullPrincipalInfo(), msg__);
            return;
        }
    case type__::TExpandedPrincipalInfo:
        {
            Write((v__).get_ExpandedPrincipalInfo(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelParent::Read(
        PrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef PrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'PrincipalInfo'");
        return false;
    }

    switch (type) {
    case type__::TContentPrincipalInfo:
        {
            ContentPrincipalInfo tmp = ContentPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_ContentPrincipalInfo())), msg__, iter__);
        }
    case type__::TSystemPrincipalInfo:
        {
            SystemPrincipalInfo tmp = SystemPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SystemPrincipalInfo())), msg__, iter__);
        }
    case type__::TNullPrincipalInfo:
        {
            NullPrincipalInfo tmp = NullPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_NullPrincipalInfo())), msg__, iter__);
        }
    case type__::TExpandedPrincipalInfo:
        {
            ExpandedPrincipalInfo tmp = ExpandedPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_ExpandedPrincipalInfo())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelParent::Write(
        const OptionalPrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef OptionalPrincipalInfo type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TPrincipalInfo:
        {
            Write((v__).get_PrincipalInfo(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelParent::Read(
        OptionalPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalPrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalPrincipalInfo'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TPrincipalInfo:
        {
            PrincipalInfo tmp = PrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_PrincipalInfo())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelParent::Write(
        const StandardURLParams& v__,
        Message* msg__) -> void
{
    Write((v__).urlType(), msg__);
    Write((v__).port(), msg__);
    Write((v__).defaultPort(), msg__);
    Write((v__).spec(), msg__);
    Write((v__).scheme(), msg__);
    Write((v__).authority(), msg__);
    Write((v__).username(), msg__);
    Write((v__).password(), msg__);
    Write((v__).host(), msg__);
    Write((v__).path(), msg__);
    Write((v__).filePath(), msg__);
    Write((v__).directory(), msg__);
    Write((v__).baseName(), msg__);
    Write((v__).extension(), msg__);
    Write((v__).query(), msg__);
    Write((v__).ref(), msg__);
    Write((v__).originCharset(), msg__);
    Write((v__).isMutable(), msg__);
    Write((v__).supportsFileURL(), msg__);
    Write((v__).hostEncoding(), msg__);
}

auto PHttpChannelParent::Read(
        StandardURLParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->urlType())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlType' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->port())), msg__, iter__)))) {
        FatalError("Error deserializing 'port' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->defaultPort())), msg__, iter__)))) {
        FatalError("Error deserializing 'defaultPort' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->spec())), msg__, iter__)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->scheme())), msg__, iter__)))) {
        FatalError("Error deserializing 'scheme' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->authority())), msg__, iter__)))) {
        FatalError("Error deserializing 'authority' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->username())), msg__, iter__)))) {
        FatalError("Error deserializing 'username' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->password())), msg__, iter__)))) {
        FatalError("Error deserializing 'password' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->host())), msg__, iter__)))) {
        FatalError("Error deserializing 'host' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->path())), msg__, iter__)))) {
        FatalError("Error deserializing 'path' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->filePath())), msg__, iter__)))) {
        FatalError("Error deserializing 'filePath' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->directory())), msg__, iter__)))) {
        FatalError("Error deserializing 'directory' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->baseName())), msg__, iter__)))) {
        FatalError("Error deserializing 'baseName' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->extension())), msg__, iter__)))) {
        FatalError("Error deserializing 'extension' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->query())), msg__, iter__)))) {
        FatalError("Error deserializing 'query' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->ref())), msg__, iter__)))) {
        FatalError("Error deserializing 'ref' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->originCharset())), msg__, iter__)))) {
        FatalError("Error deserializing 'originCharset' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->isMutable())), msg__, iter__)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->supportsFileURL())), msg__, iter__)))) {
        FatalError("Error deserializing 'supportsFileURL' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->hostEncoding())), msg__, iter__)))) {
        FatalError("Error deserializing 'hostEncoding' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const OptionalCorsPreflightArgs& v__,
        Message* msg__) -> void
{
    typedef OptionalCorsPreflightArgs type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TCorsPreflightArgs:
        {
            Write((v__).get_CorsPreflightArgs(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelParent::Read(
        OptionalCorsPreflightArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalCorsPreflightArgs type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalCorsPreflightArgs'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TCorsPreflightArgs:
        {
            CorsPreflightArgs tmp = CorsPreflightArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_CorsPreflightArgs())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelParent::Write(
        const ContentPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).attrs(), msg__);
    Write((v__).spec(), msg__);
}

auto PHttpChannelParent::Read(
        ContentPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->attrs())), msg__, iter__)))) {
        FatalError("Error deserializing 'attrs' (PrincipalOriginAttributes) member of 'ContentPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->spec())), msg__, iter__)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'ContentPrincipalInfo'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const JSURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).simpleParams(), msg__);
    Write((v__).baseURI(), msg__);
}

auto PHttpChannelParent::Read(
        JSURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->simpleParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'simpleParams' (SimpleURIParams) member of 'JSURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->baseURI())), msg__, iter__)))) {
        FatalError("Error deserializing 'baseURI' (OptionalURIParams) member of 'JSURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const NullPrincipalInfo& v__,
        Message* msg__) -> void
{
}

auto PHttpChannelParent::Read(
        NullPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PHttpChannelParent::Write(
        const StandardURLSegment& v__,
        Message* msg__) -> void
{
    Write((v__).position(), msg__);
    Write((v__).length(), msg__);
}

auto PHttpChannelParent::Read(
        StandardURLSegment* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->position())), msg__, iter__)))) {
        FatalError("Error deserializing 'position' (uint32_t) member of 'StandardURLSegment'");
        return false;
    }
    if ((!(Read((&((v__)->length())), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (int32_t) member of 'StandardURLSegment'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const URIParams& v__,
        Message* msg__) -> void
{
    typedef URIParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TSimpleURIParams:
        {
            Write((v__).get_SimpleURIParams(), msg__);
            return;
        }
    case type__::TStandardURLParams:
        {
            Write((v__).get_StandardURLParams(), msg__);
            return;
        }
    case type__::TJARURIParams:
        {
            Write((v__).get_JARURIParams(), msg__);
            return;
        }
    case type__::TIconURIParams:
        {
            Write((v__).get_IconURIParams(), msg__);
            return;
        }
    case type__::TNullPrincipalURIParams:
        {
            Write((v__).get_NullPrincipalURIParams(), msg__);
            return;
        }
    case type__::TJSURIParams:
        {
            Write((v__).get_JSURIParams(), msg__);
            return;
        }
    case type__::TSimpleNestedURIParams:
        {
            Write((v__).get_SimpleNestedURIParams(), msg__);
            return;
        }
    case type__::THostObjectURIParams:
        {
            Write((v__).get_HostObjectURIParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelParent::Read(
        URIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef URIParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'URIParams'");
        return false;
    }

    switch (type) {
    case type__::TSimpleURIParams:
        {
            SimpleURIParams tmp = SimpleURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SimpleURIParams())), msg__, iter__);
        }
    case type__::TStandardURLParams:
        {
            StandardURLParams tmp = StandardURLParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StandardURLParams())), msg__, iter__);
        }
    case type__::TJARURIParams:
        {
            JARURIParams tmp = JARURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_JARURIParams())), msg__, iter__);
        }
    case type__::TIconURIParams:
        {
            IconURIParams tmp = IconURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_IconURIParams())), msg__, iter__);
        }
    case type__::TNullPrincipalURIParams:
        {
            NullPrincipalURIParams tmp = NullPrincipalURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_NullPrincipalURIParams())), msg__, iter__);
        }
    case type__::TJSURIParams:
        {
            JSURIParams tmp = JSURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_JSURIParams())), msg__, iter__);
        }
    case type__::TSimpleNestedURIParams:
        {
            SimpleNestedURIParams tmp = SimpleNestedURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SimpleNestedURIParams())), msg__, iter__);
        }
    case type__::THostObjectURIParams:
        {
            HostObjectURIParams tmp = HostObjectURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_HostObjectURIParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelParent::Write(
        const HostObjectURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).simpleParams(), msg__);
    Write((v__).principal(), msg__);
}

auto PHttpChannelParent::Read(
        HostObjectURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->simpleParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'simpleParams' (SimpleURIParams) member of 'HostObjectURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->principal())), msg__, iter__)))) {
        FatalError("Error deserializing 'principal' (OptionalPrincipalInfo) member of 'HostObjectURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const SimpleURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).scheme(), msg__);
    Write((v__).path(), msg__);
    Write((v__).ref(), msg__);
    Write((v__).isMutable(), msg__);
}

auto PHttpChannelParent::Read(
        SimpleURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->scheme())), msg__, iter__)))) {
        FatalError("Error deserializing 'scheme' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->path())), msg__, iter__)))) {
        FatalError("Error deserializing 'path' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->ref())), msg__, iter__)))) {
        FatalError("Error deserializing 'ref' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->isMutable())), msg__, iter__)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'SimpleURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const CorsPreflightArgs& v__,
        Message* msg__) -> void
{
    Write((v__).unsafeHeaders(), msg__);
}

auto PHttpChannelParent::Read(
        CorsPreflightArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->unsafeHeaders())), msg__, iter__)))) {
        FatalError("Error deserializing 'unsafeHeaders' (nsCString[]) member of 'CorsPreflightArgs'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
