//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/media/PMediaParent.h"

#include "mozilla/dom/PContentParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace media {



MOZ_IMPLICIT PMediaParent::PMediaParent() :
    mId(0),
    mState(PMedia::__Dead)
{
    MOZ_COUNT_CTOR(PMediaParent);
}

PMediaParent::~PMediaParent()
{
    MOZ_COUNT_DTOR(PMediaParent);
}

auto PMediaParent::Manager() const -> PContentParent*
{
    return static_cast<PContentParent*>(mManager);
}

auto PMediaParent::state() -> PMedia::State
{
    return mState;
}

auto PMediaParent::SendGetOriginKeyResponse(
        const uint32_t& aRequestId,
        const nsCString& key) -> bool
{
    PMedia::Msg_GetOriginKeyResponse* msg__ = new PMedia::Msg_GetOriginKeyResponse(mId);

    Write(aRequestId, msg__);
    Write(key, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PMediaParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PMedia", "AsyncSendGetOriginKeyResponse", js::ProfileEntry::Category::OTHER);
    if ((!(PMedia::Transition(mState, Trigger(Trigger::Send, PMedia::Msg_GetOriginKeyResponse__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PMediaParent::Send__delete__(PMediaParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PMedia::Msg___delete__* msg__ = new PMedia::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PMediaParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PMedia", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PMedia::Transition((actor)->mState, Trigger(Trigger::Send, PMedia::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PMediaMsgStart, actor);
    return sendok__;
}

auto PMediaParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PMediaParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PMediaParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PMediaParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PMediaParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PMediaParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PMediaParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PMediaParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PMediaParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PMediaParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PMediaParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PMediaParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PMediaParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PMediaParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PMedia has not yet been implemented");
    return nullptr;
}

auto PMediaParent::OnMessageReceived(const Message& msg__) -> PMediaParent::Result
{
    switch ((msg__).type()) {
    case PMedia::Msg_GetOriginKey__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PMedia::Msg_GetOriginKey");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PMedia::Msg_GetOriginKey*>((&(msg__))))->Log("[PMediaParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PMedia", "RecvGetOriginKey", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            uint32_t aRequestId;
            nsCString aOrigin;
            bool aPrivateBrowsing;
            bool aPersist;

            if ((!(Read((&(aRequestId)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(aOrigin)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aPrivateBrowsing)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(aPersist)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PMedia::Transition(mState, Trigger(Trigger::Recv, PMedia::Msg_GetOriginKey__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvGetOriginKey(mozilla::Move(aRequestId), mozilla::Move(aOrigin), mozilla::Move(aPrivateBrowsing), mozilla::Move(aPersist))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for GetOriginKey returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMedia::Msg_SanitizeOriginKeys__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PMedia::Msg_SanitizeOriginKeys");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PMedia::Msg_SanitizeOriginKeys*>((&(msg__))))->Log("[PMediaParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PMedia", "RecvSanitizeOriginKeys", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            uint64_t aSinceWhen;
            bool aOnlyPrivateBrowsing;

            if ((!(Read((&(aSinceWhen)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(aOnlyPrivateBrowsing)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PMedia::Transition(mState, Trigger(Trigger::Recv, PMedia::Msg_SanitizeOriginKeys__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSanitizeOriginKeys(mozilla::Move(aSinceWhen), mozilla::Move(aOnlyPrivateBrowsing))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SanitizeOriginKeys returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMedia::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PMediaParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PMediaParent::Result
{
    return MsgNotKnown;
}

auto PMediaParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PMediaParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PMediaParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PMediaParent::GetProtocolTypeId() -> int32_t
{
    return PMediaMsgStart;
}

auto PMediaParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PMediaParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PMediaParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PMediaParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PMediaParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PMediaParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PMediaParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PMediaParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PMediaParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PMediaParent", aMsg, OtherPid(), true);
}

auto PMediaParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PMediaParent::DeallocSubtree() -> void
{
}

auto PMediaParent::Write(
        PMediaParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PMediaParent::Read(
        PMediaParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PMediaParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PMedia");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PMedia");
        return false;
    }

    if ((PMediaMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PMedia has different type");
        return false;
    }

    (*(v__)) = static_cast<PMediaParent*>(listener);
    return true;
}



} // namespace media
} // namespace mozilla
