//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PMessagePortParent.h"
#include "nsID.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {



MOZ_IMPLICIT PMessagePortParent::PMessagePortParent() :
    mId(0),
    mState(PMessagePort::__Dead)
{
    MOZ_COUNT_CTOR(PMessagePortParent);
}

PMessagePortParent::~PMessagePortParent()
{
    MOZ_COUNT_DTOR(PMessagePortParent);
}

auto PMessagePortParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(mManager);
}

auto PMessagePortParent::state() -> PMessagePort::State
{
    return mState;
}

auto PMessagePortParent::SendEntangled(const nsTArray<MessagePortMessage>& messages) -> bool
{
    PMessagePort::Msg_Entangled* msg__ = new PMessagePort::Msg_Entangled(mId);

    Write(messages, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PMessagePortParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PMessagePort", "AsyncSendEntangled", js::ProfileEntry::Category::OTHER);
    if ((!(PMessagePort::Transition(mState, Trigger(Trigger::Send, PMessagePort::Msg_Entangled__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PMessagePortParent::SendReceiveData(const nsTArray<MessagePortMessage>& messages) -> bool
{
    PMessagePort::Msg_ReceiveData* msg__ = new PMessagePort::Msg_ReceiveData(mId);

    Write(messages, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PMessagePortParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PMessagePort", "AsyncSendReceiveData", js::ProfileEntry::Category::OTHER);
    if ((!(PMessagePort::Transition(mState, Trigger(Trigger::Send, PMessagePort::Msg_ReceiveData__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PMessagePortParent::SendStopSendingDataConfirmed() -> bool
{
    PMessagePort::Msg_StopSendingDataConfirmed* msg__ = new PMessagePort::Msg_StopSendingDataConfirmed(mId);





    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PMessagePortParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PMessagePort", "AsyncSendStopSendingDataConfirmed", js::ProfileEntry::Category::OTHER);
    if ((!(PMessagePort::Transition(mState, Trigger(Trigger::Send, PMessagePort::Msg_StopSendingDataConfirmed__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PMessagePortParent::Send__delete__(PMessagePortParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PMessagePort::Msg___delete__* msg__ = new PMessagePort::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PMessagePortParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PMessagePort", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PMessagePort::Transition((actor)->mState, Trigger(Trigger::Send, PMessagePort::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PMessagePortMsgStart, actor);
    return sendok__;
}

auto PMessagePortParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PMessagePortParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PMessagePortParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PMessagePortParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PMessagePortParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PMessagePortParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PMessagePortParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PMessagePortParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PMessagePortParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PMessagePortParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PMessagePortParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PMessagePortParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PMessagePortParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PMessagePortParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PMessagePort has not yet been implemented");
    return nullptr;
}

auto PMessagePortParent::OnMessageReceived(const Message& msg__) -> PMessagePortParent::Result
{
    switch ((msg__).type()) {
    case PMessagePort::Msg_PostMessages__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PMessagePort::Msg_PostMessages");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PMessagePort::Msg_PostMessages*>((&(msg__))))->Log("[PMessagePortParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PMessagePort", "RecvPostMessages", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsTArray<MessagePortMessage> messages;

            if ((!(Read((&(messages)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsTArray'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PMessagePort::Transition(mState, Trigger(Trigger::Recv, PMessagePort::Msg_PostMessages__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvPostMessages(mozilla::Move(messages))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for PostMessages returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMessagePort::Msg_Disentangle__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PMessagePort::Msg_Disentangle");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PMessagePort::Msg_Disentangle*>((&(msg__))))->Log("[PMessagePortParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PMessagePort", "RecvDisentangle", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsTArray<MessagePortMessage> messages;

            if ((!(Read((&(messages)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsTArray'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PMessagePort::Transition(mState, Trigger(Trigger::Recv, PMessagePort::Msg_Disentangle__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDisentangle(mozilla::Move(messages))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Disentangle returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMessagePort::Msg_StopSendingData__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PMessagePort::Msg_StopSendingData");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PMessagePort::Msg_StopSendingData*>((&(msg__))))->Log("[PMessagePortParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PMessagePort", "RecvStopSendingData", js::ProfileEntry::Category::OTHER);

            if ((!(PMessagePort::Transition(mState, Trigger(Trigger::Recv, PMessagePort::Msg_StopSendingData__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvStopSendingData()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for StopSendingData returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMessagePort::Msg_Close__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PMessagePort::Msg_Close");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PMessagePort::Msg_Close*>((&(msg__))))->Log("[PMessagePortParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PMessagePort", "RecvClose", js::ProfileEntry::Category::OTHER);

            if ((!(PMessagePort::Transition(mState, Trigger(Trigger::Recv, PMessagePort::Msg_Close__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvClose()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Close returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMessagePort::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PMessagePortParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PMessagePortParent::Result
{
    return MsgNotKnown;
}

auto PMessagePortParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PMessagePortParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PMessagePortParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PMessagePortParent::GetProtocolTypeId() -> int32_t
{
    return PMessagePortMsgStart;
}

auto PMessagePortParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PMessagePortParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PMessagePortParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PMessagePortParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PMessagePortParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PMessagePortParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PMessagePortParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PMessagePortParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PMessagePortParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PMessagePortParent", aMsg, OtherPid(), true);
}

auto PMessagePortParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PMessagePortParent::DeallocSubtree() -> void
{
}

auto PMessagePortParent::Write(
        const nsTArray<MessagePortMessage>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PMessagePortParent::Read(
        nsTArray<MessagePortMessage>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<MessagePortMessage> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'MessagePortMessage[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'MessagePortMessage[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PMessagePortParent::Write(
        const MessagePortMessage& v__,
        Message* msg__) -> void
{
    Write((v__).transferredPorts(), msg__);
    Write((v__).data(), msg__);
    Write((v__).blobsParent(), msg__);
    // skipping actor field that's meaningless on this side
}

auto PMessagePortParent::Read(
        MessagePortMessage* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->transferredPorts())), msg__, iter__)))) {
        FatalError("Error deserializing 'transferredPorts' (MessagePortIdentifier[]) member of 'MessagePortMessage'");
        return false;
    }
    if ((!(Read((&((v__)->data())), msg__, iter__)))) {
        FatalError("Error deserializing 'data' (uint8_t[]) member of 'MessagePortMessage'");
        return false;
    }
    if ((!(Read((&((v__)->blobsParent())), msg__, iter__)))) {
        FatalError("Error deserializing 'blobsParent' (PBlob[]) member of 'MessagePortMessage'");
        return false;
    }
    // skipping actor field that's meaningless on this side
    return true;
}

auto PMessagePortParent::Write(
        const nsTArray<MessagePortIdentifier>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PMessagePortParent::Read(
        nsTArray<MessagePortIdentifier>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<MessagePortIdentifier> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'MessagePortIdentifier[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'MessagePortIdentifier[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PMessagePortParent::Write(
        const nsTArray<PBlobParent*>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__, false);
    }
}

auto PMessagePortParent::Read(
        nsTArray<PBlobParent*>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<PBlobParent*> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'PBlob[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__, false)))) {
            FatalError("Error deserializing 'PBlob[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PMessagePortParent::Write(
        PMessagePortParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PMessagePortParent::Read(
        PMessagePortParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PMessagePortParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PMessagePort");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PMessagePort");
        return false;
    }

    if ((PMessagePortMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PMessagePort has different type");
        return false;
    }

    (*(v__)) = static_cast<PMessagePortParent*>(listener);
    return true;
}

auto PMessagePortParent::Write(
        const MessagePortIdentifier& v__,
        Message* msg__) -> void
{
    Write((v__).uuid(), msg__);
    Write((v__).destinationUuid(), msg__);
    Write((v__).sequenceId(), msg__);
    Write((v__).neutered(), msg__);
}

auto PMessagePortParent::Read(
        MessagePortIdentifier* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->uuid())), msg__, iter__)))) {
        FatalError("Error deserializing 'uuid' (nsID) member of 'MessagePortIdentifier'");
        return false;
    }
    if ((!(Read((&((v__)->destinationUuid())), msg__, iter__)))) {
        FatalError("Error deserializing 'destinationUuid' (nsID) member of 'MessagePortIdentifier'");
        return false;
    }
    if ((!(Read((&((v__)->sequenceId())), msg__, iter__)))) {
        FatalError("Error deserializing 'sequenceId' (uint32_t) member of 'MessagePortIdentifier'");
        return false;
    }
    if ((!(Read((&((v__)->neutered())), msg__, iter__)))) {
        FatalError("Error deserializing 'neutered' (bool) member of 'MessagePortIdentifier'");
        return false;
    }
    return true;
}

auto PMessagePortParent::Write(
        PBlobParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PMessagePortParent::Read(
        PBlobParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PBlobParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PMessagePort");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PBlob");
        return false;
    }

    if ((PBlobMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PBlob has different type");
        return false;
    }

    (*(v__)) = static_cast<PBlobParent*>(listener);
    return true;
}



} // namespace dom
} // namespace mozilla
