//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PUDPSocketParent.h"
#include "ipc/IPCMessageUtils.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {



MOZ_IMPLICIT PUDPSocketParent::PUDPSocketParent() :
    mId(0),
    mState(PUDPSocket::__Dead)
{
    MOZ_COUNT_CTOR(PUDPSocketParent);
}

PUDPSocketParent::~PUDPSocketParent()
{
    MOZ_COUNT_DTOR(PUDPSocketParent);
}

auto PUDPSocketParent::state() -> PUDPSocket::State
{
    return mState;
}

auto PUDPSocketParent::SendCallbackOpened(const UDPAddressInfo& addressInfo) -> bool
{
    PUDPSocket::Msg_CallbackOpened* msg__ = new PUDPSocket::Msg_CallbackOpened(mId);

    Write(addressInfo, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PUDPSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackOpened", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackOpened__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PUDPSocketParent::SendCallbackClosed() -> bool
{
    PUDPSocket::Msg_CallbackClosed* msg__ = new PUDPSocket::Msg_CallbackClosed(mId);





    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PUDPSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackClosed", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackClosed__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PUDPSocketParent::SendCallbackReceivedData(
        const UDPAddressInfo& addressInfo,
        const nsTArray<uint8_t>& data) -> bool
{
    PUDPSocket::Msg_CallbackReceivedData* msg__ = new PUDPSocket::Msg_CallbackReceivedData(mId);

    Write(addressInfo, msg__);
    Write(data, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PUDPSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackReceivedData", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackReceivedData__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PUDPSocketParent::SendCallbackError(
        const nsCString& message,
        const nsCString& filename,
        const uint32_t& lineNumber) -> bool
{
    PUDPSocket::Msg_CallbackError* msg__ = new PUDPSocket::Msg_CallbackError(mId);

    Write(message, msg__);
    Write(filename, msg__);
    Write(lineNumber, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PUDPSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackError", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackError__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PUDPSocketParent::Send__delete__(PUDPSocketParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PUDPSocket::Msg___delete__* msg__ = new PUDPSocket::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PUDPSocketParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition((actor)->mState, Trigger(Trigger::Send, PUDPSocket::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PUDPSocketMsgStart, actor);
    return sendok__;
}

auto PUDPSocketParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PUDPSocketParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PUDPSocketParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PUDPSocketParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PUDPSocketParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PUDPSocketParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PUDPSocketParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PUDPSocketParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PUDPSocketParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PUDPSocketParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PUDPSocketParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PUDPSocketParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PUDPSocketParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PUDPSocketParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PUDPSocket has not yet been implemented");
    return nullptr;
}

auto PUDPSocketParent::OnMessageReceived(const Message& msg__) -> PUDPSocketParent::Result
{
    switch ((msg__).type()) {
    case PUDPSocket::Msg_Bind__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PUDPSocket::Msg_Bind");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_Bind*>((&(msg__))))->Log("[PUDPSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvBind", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            UDPAddressInfo addressInfo;
            bool addressReuse;
            bool loopback;

            if ((!(Read((&(addressInfo)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            if ((!(Read((&(addressReuse)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(loopback)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_Bind__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvBind(mozilla::Move(addressInfo), mozilla::Move(addressReuse), mozilla::Move(loopback))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Bind returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_OutgoingData__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PUDPSocket::Msg_OutgoingData");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_OutgoingData*>((&(msg__))))->Log("[PUDPSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvOutgoingData", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            UDPData data;
            UDPSocketAddr addr;

            if ((!(Read((&(data)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'UDPData'");
                return MsgValueError;
            }
            if ((!(Read((&(addr)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'UDPSocketAddr'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_OutgoingData__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOutgoingData(mozilla::Move(data), mozilla::Move(addr))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OutgoingData returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_JoinMulticast__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PUDPSocket::Msg_JoinMulticast");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_JoinMulticast*>((&(msg__))))->Log("[PUDPSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvJoinMulticast", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString multicastAddress;
            nsCString iface;

            if ((!(Read((&(multicastAddress)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(iface)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_JoinMulticast__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvJoinMulticast(mozilla::Move(multicastAddress), mozilla::Move(iface))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for JoinMulticast returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_LeaveMulticast__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PUDPSocket::Msg_LeaveMulticast");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_LeaveMulticast*>((&(msg__))))->Log("[PUDPSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvLeaveMulticast", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString multicastAddress;
            nsCString iface;

            if ((!(Read((&(multicastAddress)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(iface)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_LeaveMulticast__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvLeaveMulticast(mozilla::Move(multicastAddress), mozilla::Move(iface))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for LeaveMulticast returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_Close__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PUDPSocket::Msg_Close");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_Close*>((&(msg__))))->Log("[PUDPSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvClose", js::ProfileEntry::Category::OTHER);

            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_Close__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvClose()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Close returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_RequestDelete__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PUDPSocket::Msg_RequestDelete");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_RequestDelete*>((&(msg__))))->Log("[PUDPSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvRequestDelete", js::ProfileEntry::Category::OTHER);

            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_RequestDelete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRequestDelete()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for RequestDelete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PUDPSocketParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PUDPSocketParent::Result
{
    return MsgNotKnown;
}

auto PUDPSocketParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PUDPSocketParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PUDPSocketParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PUDPSocketParent::GetProtocolTypeId() -> int32_t
{
    return PUDPSocketMsgStart;
}

auto PUDPSocketParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PUDPSocketParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PUDPSocketParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PUDPSocketParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PUDPSocketParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PUDPSocketParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PUDPSocketParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PUDPSocketParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PUDPSocketParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PUDPSocketParent", aMsg, OtherPid(), true);
}

auto PUDPSocketParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PUDPSocketParent::DeallocSubtree() -> void
{
}

auto PUDPSocketParent::Write(
        const StringInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).data(), msg__);
}

auto PUDPSocketParent::Read(
        StringInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->data())), msg__, iter__)))) {
        FatalError("Error deserializing 'data' (nsCString) member of 'StringInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const FileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileDescriptorIndex(), msg__);
    Write((v__).behaviorFlags(), msg__);
    Write((v__).ioFlags(), msg__);
}

auto PUDPSocketParent::Read(
        FileInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->fileDescriptorIndex())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->behaviorFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'behaviorFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->ioFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'ioFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        PUDPSocketParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PUDPSocketParent::Read(
        PUDPSocketParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PUDPSocketParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PUDPSocket");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PUDPSocket");
        return false;
    }

    if ((PUDPSocketMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PUDPSocket has different type");
        return false;
    }

    (*(v__)) = static_cast<PUDPSocketParent*>(listener);
    return true;
}

auto PUDPSocketParent::Write(
        const MultiplexInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).streams(), msg__);
    Write((v__).currentStream(), msg__);
    Write((v__).status(), msg__);
    Write((v__).startedReadingCurrent(), msg__);
}

auto PUDPSocketParent::Read(
        MultiplexInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->streams())), msg__, iter__)))) {
        FatalError("Error deserializing 'streams' (InputStreamParams[]) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->currentStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'currentStream' (uint32_t) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->status())), msg__, iter__)))) {
        FatalError("Error deserializing 'status' (nsresult) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReadingCurrent())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReadingCurrent' (bool) member of 'MultiplexInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const nsTArray<InputStreamParams>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PUDPSocketParent::Read(
        nsTArray<InputStreamParams>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<InputStreamParams> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'InputStreamParams[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'InputStreamParams[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PUDPSocketParent::Write(
        const OptionalInputStreamParams& v__,
        Message* msg__) -> void
{
    typedef OptionalInputStreamParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TInputStreamParams:
        {
            Write((v__).get_InputStreamParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        OptionalInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalInputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalInputStreamParams'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_InputStreamParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PUDPSocketParent::Write(
        const MIMEInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    Write((v__).headers(), msg__);
    Write((v__).contentLength(), msg__);
    Write((v__).startedReading(), msg__);
    Write((v__).addContentLength(), msg__);
}

auto PUDPSocketParent::Read(
        MIMEInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->contentLength())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentLength' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReading())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReading' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->addContentLength())), msg__, iter__)))) {
        FatalError("Error deserializing 'addContentLength' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const InputStreamParams& v__,
        Message* msg__) -> void
{
    typedef InputStreamParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TStringInputStreamParams:
        {
            Write((v__).get_StringInputStreamParams(), msg__);
            return;
        }
    case type__::TFileInputStreamParams:
        {
            Write((v__).get_FileInputStreamParams(), msg__);
            return;
        }
    case type__::TPartialFileInputStreamParams:
        {
            Write((v__).get_PartialFileInputStreamParams(), msg__);
            return;
        }
    case type__::TBufferedInputStreamParams:
        {
            Write((v__).get_BufferedInputStreamParams(), msg__);
            return;
        }
    case type__::TMIMEInputStreamParams:
        {
            Write((v__).get_MIMEInputStreamParams(), msg__);
            return;
        }
    case type__::TMultiplexInputStreamParams:
        {
            Write((v__).get_MultiplexInputStreamParams(), msg__);
            return;
        }
    case type__::TRemoteInputStreamParams:
        {
            Write((v__).get_RemoteInputStreamParams(), msg__);
            return;
        }
    case type__::TSameProcessInputStreamParams:
        {
            Write((v__).get_SameProcessInputStreamParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        InputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef InputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'InputStreamParams'");
        return false;
    }

    switch (type) {
    case type__::TStringInputStreamParams:
        {
            StringInputStreamParams tmp = StringInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StringInputStreamParams())), msg__, iter__);
        }
    case type__::TFileInputStreamParams:
        {
            FileInputStreamParams tmp = FileInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_FileInputStreamParams())), msg__, iter__);
        }
    case type__::TPartialFileInputStreamParams:
        {
            PartialFileInputStreamParams tmp = PartialFileInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_PartialFileInputStreamParams())), msg__, iter__);
        }
    case type__::TBufferedInputStreamParams:
        {
            BufferedInputStreamParams tmp = BufferedInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_BufferedInputStreamParams())), msg__, iter__);
        }
    case type__::TMIMEInputStreamParams:
        {
            MIMEInputStreamParams tmp = MIMEInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_MIMEInputStreamParams())), msg__, iter__);
        }
    case type__::TMultiplexInputStreamParams:
        {
            MultiplexInputStreamParams tmp = MultiplexInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_MultiplexInputStreamParams())), msg__, iter__);
        }
    case type__::TRemoteInputStreamParams:
        {
            RemoteInputStreamParams tmp = RemoteInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_RemoteInputStreamParams())), msg__, iter__);
        }
    case type__::TSameProcessInputStreamParams:
        {
            SameProcessInputStreamParams tmp = SameProcessInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SameProcessInputStreamParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PUDPSocketParent::Write(
        const BufferedInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    Write((v__).bufferSize(), msg__);
}

auto PUDPSocketParent::Read(
        BufferedInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'BufferedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->bufferSize())), msg__, iter__)))) {
        FatalError("Error deserializing 'bufferSize' (uint32_t) member of 'BufferedInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const SameProcessInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).addRefedInputStream(), msg__);
}

auto PUDPSocketParent::Read(
        SameProcessInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->addRefedInputStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'addRefedInputStream' (intptr_t) member of 'SameProcessInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const UDPSocketAddr& v__,
        Message* msg__) -> void
{
    typedef UDPSocketAddr type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TUDPAddressInfo:
        {
            Write((v__).get_UDPAddressInfo(), msg__);
            return;
        }
    case type__::TNetAddr:
        {
            Write((v__).get_NetAddr(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        UDPSocketAddr* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef UDPSocketAddr type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'UDPSocketAddr'");
        return false;
    }

    switch (type) {
    case type__::TUDPAddressInfo:
        {
            UDPAddressInfo tmp = UDPAddressInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_UDPAddressInfo())), msg__, iter__);
        }
    case type__::TNetAddr:
        {
            NetAddr tmp = NetAddr();
            (*(v__)) = tmp;
            return Read((&((v__)->get_NetAddr())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PUDPSocketParent::Write(
        const PartialFileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileStreamParams(), msg__);
    Write((v__).begin(), msg__);
    Write((v__).length(), msg__);
}

auto PUDPSocketParent::Read(
        PartialFileInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->fileStreamParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileStreamParams' (FileInputStreamParams) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->begin())), msg__, iter__)))) {
        FatalError("Error deserializing 'begin' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->length())), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const RemoteInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).id(), msg__);
}

auto PUDPSocketParent::Read(
        RemoteInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->id())), msg__, iter__)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'RemoteInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const UDPAddressInfo& v__,
        Message* msg__) -> void
{
    Write((v__).addr(), msg__);
    Write((v__).port(), msg__);
}

auto PUDPSocketParent::Read(
        UDPAddressInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->addr())), msg__, iter__)))) {
        FatalError("Error deserializing 'addr' (nsCString) member of 'UDPAddressInfo'");
        return false;
    }
    if ((!(Read((&((v__)->port())), msg__, iter__)))) {
        FatalError("Error deserializing 'port' (uint16_t) member of 'UDPAddressInfo'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const UDPData& v__,
        Message* msg__) -> void
{
    typedef UDPData type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TArrayOfuint8_t:
        {
            Write((v__).get_ArrayOfuint8_t(), msg__);
            return;
        }
    case type__::TInputStreamParams:
        {
            Write((v__).get_InputStreamParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        UDPData* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef UDPData type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'UDPData'");
        return false;
    }

    switch (type) {
    case type__::TArrayOfuint8_t:
        {
            nsTArray<uint8_t> tmp;
            (*(v__)) = tmp;
            return Read((&((v__)->get_ArrayOfuint8_t())), msg__, iter__);
        }
    case type__::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_InputStreamParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}



} // namespace net
} // namespace mozilla
