//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCamerasChild_h
#define PCamerasChild_h

#include "mozilla/camera/PCameras.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace camera {


class PCamerasChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::ipc::PBackgroundChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::camera::CaptureCapability CaptureCapability;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;

    typedef PCameras::State State;

    virtual bool
    RecvFrameSizeChange(
            const int& capEngine,
            const int& cap_id,
            const int& w,
            const int& h) = 0;
    virtual bool
    RecvDeliverFrame(
            const int& capEngine,
            const int& cap_id,
            Shmem&& buffer,
            const size_t& size,
            const uint32_t& time_stamp,
            const int64_t& ntp_time,
            const int64_t& render_time) = 0;
    virtual bool
    RecvReplyNumberOfCaptureDevices(const int& numdev) = 0;
    virtual bool
    RecvReplyNumberOfCapabilities(const int& numdev) = 0;
    virtual bool
    RecvReplyAllocateCaptureDevice(const int& numdev) = 0;
    virtual bool
    RecvReplyGetCaptureCapability(const CaptureCapability& cap) = 0;
    virtual bool
    RecvReplyGetCaptureDevice(
            const nsCString& device_name,
            const nsCString& device_id) = 0;
    virtual bool
    RecvReplyFailure() = 0;
    virtual bool
    RecvReplySuccess() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PCamerasChild();

    virtual ~PCamerasChild();

    PBackgroundChild*
    Manager() const;

    PCameras::State
    state();

    bool
    SendNumberOfCaptureDevices(const int& engine);

    bool
    SendNumberOfCapabilities(
            const int& engine,
            const nsCString& deviceUniqueIdUTF8);

    bool
    SendGetCaptureCapability(
            const int& engine,
            const nsCString& unique_idUTF8,
            const int& capability_number);

    bool
    SendGetCaptureDevice(
            const int& engine,
            const int& num);

    bool
    SendAllocateCaptureDevice(
            const int& engine,
            const nsCString& unique_idUTF8);

    bool
    SendReleaseCaptureDevice(
            const int& engine,
            const int& numdev);

    bool
    SendStartCapture(
            const int& engine,
            const int& numdev,
            const CaptureCapability& capability);

    bool
    SendStopCapture(
            const int& engine,
            const int& numdev);

    bool
    SendReleaseFrame(Shmem& s);

    bool
    SendAllDone();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const CaptureCapability& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            CaptureCapability* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PCamerasChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PCamerasChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            Shmem* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace camera
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace camera {
class CamerasChild :
    public PCamerasChild
{
    virtual bool
    RecvFrameSizeChange(
            const int& capEngine,
            const int& cap_id,
            const int& w,
            const int& h);

    virtual bool
    RecvDeliverFrame(
            const int& capEngine,
            const int& cap_id,
            Shmem&& buffer,
            const size_t& size,
            const uint32_t& time_stamp,
            const int64_t& ntp_time,
            const int64_t& render_time);

    virtual bool
    RecvReplyNumberOfCaptureDevices(const int& numdev);

    virtual bool
    RecvReplyNumberOfCapabilities(const int& numdev);

    virtual bool
    RecvReplyAllocateCaptureDevice(const int& numdev);

    virtual bool
    RecvReplyGetCaptureCapability(const CaptureCapability& cap);

    virtual bool
    RecvReplyGetCaptureDevice(
            const nsCString& device_name,
            const nsCString& device_id);

    virtual bool
    RecvReplyFailure();

    virtual bool
    RecvReplySuccess();

    MOZ_IMPLICIT CamerasChild();
    virtual ~CamerasChild();
};
} // namespace camera
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace camera {
bool
CamerasChild::RecvFrameSizeChange(
        const int& capEngine,
        const int& cap_id,
        const int& w,
        const int& h)
{
    return false;
}

bool
CamerasChild::RecvDeliverFrame(
        const int& capEngine,
        const int& cap_id,
        Shmem&& buffer,
        const size_t& size,
        const uint32_t& time_stamp,
        const int64_t& ntp_time,
        const int64_t& render_time)
{
    return false;
}

bool
CamerasChild::RecvReplyNumberOfCaptureDevices(const int& numdev)
{
    return false;
}

bool
CamerasChild::RecvReplyNumberOfCapabilities(const int& numdev)
{
    return false;
}

bool
CamerasChild::RecvReplyAllocateCaptureDevice(const int& numdev)
{
    return false;
}

bool
CamerasChild::RecvReplyGetCaptureCapability(const CaptureCapability& cap)
{
    return false;
}

bool
CamerasChild::RecvReplyGetCaptureDevice(
        const nsCString& device_name,
        const nsCString& device_id)
{
    return false;
}

bool
CamerasChild::RecvReplyFailure()
{
    return false;
}

bool
CamerasChild::RecvReplySuccess()
{
    return false;
}

MOZ_IMPLICIT CamerasChild::CamerasChild()
{
    MOZ_COUNT_CTOR(CamerasChild);
}

MOZ_IMPLICIT CamerasChild::~CamerasChild()
{
    MOZ_COUNT_DTOR(CamerasChild);
}

} // namespace camera
} // namespace mozilla
#endif // if 0

#endif // ifndef PCamerasChild_h
