//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCamerasParent_h
#define PCamerasParent_h

#include "mozilla/camera/PCameras.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace camera {


class PCamerasParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::ipc::PBackgroundParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::camera::CaptureCapability CaptureCapability;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PCameras::State State;

    virtual bool
    RecvNumberOfCaptureDevices(const int& engine) = 0;
    virtual bool
    RecvNumberOfCapabilities(
            const int& engine,
            const nsCString& deviceUniqueIdUTF8) = 0;
    virtual bool
    RecvGetCaptureCapability(
            const int& engine,
            const nsCString& unique_idUTF8,
            const int& capability_number) = 0;
    virtual bool
    RecvGetCaptureDevice(
            const int& engine,
            const int& num) = 0;
    virtual bool
    RecvAllocateCaptureDevice(
            const int& engine,
            const nsCString& unique_idUTF8) = 0;
    virtual bool
    RecvReleaseCaptureDevice(
            const int& engine,
            const int& numdev) = 0;
    virtual bool
    RecvStartCapture(
            const int& engine,
            const int& numdev,
            const CaptureCapability& capability) = 0;
    virtual bool
    RecvStopCapture(
            const int& engine,
            const int& numdev) = 0;
    virtual bool
    RecvReleaseFrame(Shmem&& s) = 0;
    virtual bool
    RecvAllDone() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PCamerasParent();

    virtual ~PCamerasParent();

    PBackgroundParent*
    Manager() const;

    PCameras::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendFrameSizeChange(
            const int& capEngine,
            const int& cap_id,
            const int& w,
            const int& h);

    MOZ_WARN_UNUSED_RESULT bool
    SendDeliverFrame(
            const int& capEngine,
            const int& cap_id,
            Shmem& buffer,
            const size_t& size,
            const uint32_t& time_stamp,
            const int64_t& ntp_time,
            const int64_t& render_time);

    MOZ_WARN_UNUSED_RESULT bool
    SendReplyNumberOfCaptureDevices(const int& numdev);

    MOZ_WARN_UNUSED_RESULT bool
    SendReplyNumberOfCapabilities(const int& numdev);

    MOZ_WARN_UNUSED_RESULT bool
    SendReplyAllocateCaptureDevice(const int& numdev);

    MOZ_WARN_UNUSED_RESULT bool
    SendReplyGetCaptureCapability(const CaptureCapability& cap);

    MOZ_WARN_UNUSED_RESULT bool
    SendReplyGetCaptureDevice(
            const nsCString& device_name,
            const nsCString& device_id);

    MOZ_WARN_UNUSED_RESULT bool
    SendReplyFailure();

    MOZ_WARN_UNUSED_RESULT bool
    SendReplySuccess();

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(PCamerasParent* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const CaptureCapability& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            CaptureCapability* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PCamerasParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PCamerasParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            Shmem* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace camera
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace camera {
class CamerasParent :
    public PCamerasParent
{
    virtual bool
    RecvNumberOfCaptureDevices(const int& engine);

    virtual bool
    RecvNumberOfCapabilities(
            const int& engine,
            const nsCString& deviceUniqueIdUTF8);

    virtual bool
    RecvGetCaptureCapability(
            const int& engine,
            const nsCString& unique_idUTF8,
            const int& capability_number);

    virtual bool
    RecvGetCaptureDevice(
            const int& engine,
            const int& num);

    virtual bool
    RecvAllocateCaptureDevice(
            const int& engine,
            const nsCString& unique_idUTF8);

    virtual bool
    RecvReleaseCaptureDevice(
            const int& engine,
            const int& numdev);

    virtual bool
    RecvStartCapture(
            const int& engine,
            const int& numdev,
            const CaptureCapability& capability);

    virtual bool
    RecvStopCapture(
            const int& engine,
            const int& numdev);

    virtual bool
    RecvReleaseFrame(Shmem&& s);

    virtual bool
    RecvAllDone();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT CamerasParent();
    virtual ~CamerasParent();
};
} // namespace camera
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace camera {
bool
CamerasParent::RecvNumberOfCaptureDevices(const int& engine)
{
    return false;
}

bool
CamerasParent::RecvNumberOfCapabilities(
        const int& engine,
        const nsCString& deviceUniqueIdUTF8)
{
    return false;
}

bool
CamerasParent::RecvGetCaptureCapability(
        const int& engine,
        const nsCString& unique_idUTF8,
        const int& capability_number)
{
    return false;
}

bool
CamerasParent::RecvGetCaptureDevice(
        const int& engine,
        const int& num)
{
    return false;
}

bool
CamerasParent::RecvAllocateCaptureDevice(
        const int& engine,
        const nsCString& unique_idUTF8)
{
    return false;
}

bool
CamerasParent::RecvReleaseCaptureDevice(
        const int& engine,
        const int& numdev)
{
    return false;
}

bool
CamerasParent::RecvStartCapture(
        const int& engine,
        const int& numdev,
        const CaptureCapability& capability)
{
    return false;
}

bool
CamerasParent::RecvStopCapture(
        const int& engine,
        const int& numdev)
{
    return false;
}

bool
CamerasParent::RecvReleaseFrame(Shmem&& s)
{
    return false;
}

bool
CamerasParent::RecvAllDone()
{
    return false;
}

void
CamerasParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT CamerasParent::CamerasParent()
{
    MOZ_COUNT_CTOR(CamerasParent);
}

MOZ_IMPLICIT CamerasParent::~CamerasParent()
{
    MOZ_COUNT_DTOR(CamerasParent);
}

} // namespace camera
} // namespace mozilla
#endif // if 0

#endif // ifndef PCamerasParent_h
