//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHeapSnapshotTempFileHelper_h
#define PHeapSnapshotTempFileHelper_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpenedFile|
//
namespace mozilla {
namespace devtools {
class OpenedFile final
{
private:
    typedef mozilla::ipc::FileDescriptor FileDescriptor;

public:
    MOZ_IMPLICIT OpenedFile();

    MOZ_IMPLICIT OpenedFile(
            const nsString& _path,
            const FileDescriptor& _descriptor)
    {
        Init();
        Assign(_path, _descriptor);
    }

    MOZ_IMPLICIT OpenedFile(const OpenedFile& _o)
    {
        Init();
        Assign((_o).path(), (_o).descriptor());
    }

    ~OpenedFile();

    void
    operator=(const OpenedFile& _o)
    {
        Assign((_o).path(), (_o).descriptor());
    }

    bool
    operator==(const OpenedFile& _o) const;

    nsString&
    path()
    {
        return path_;
    }
    const nsString&
    path() const
    {
        return path_;
    }

    FileDescriptor&
    descriptor()
    {
        return descriptor_;
    }
    const FileDescriptor&
    descriptor() const
    {
        return const_cast<FileDescriptor&>(descriptor_);
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _path,
            const FileDescriptor& _descriptor);

    nsString path_;
    FileDescriptor descriptor_;
};
} // namespace devtools
} // namespace mozilla

namespace mozilla {
namespace devtools {
class OpenedFile;
} // namespace devtools
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OpenHeapSnapshotTempFileResponse|
//
namespace mozilla {
namespace devtools {
class OpenHeapSnapshotTempFileResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TOpenedFile,
        T__Last = TOpenedFile
    };

private:
    typedef mozilla::devtools::OpenedFile OpenedFile;
    typedef nsresult nsresult__tdef;
    typedef OpenedFile OpenedFile__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<OpenedFile> VOpenedFile;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult* const
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    OpenedFile*
    ptr_OpenedFile()
    {
        return ((mValue).VOpenedFile).addr();
    }
    const OpenedFile* const
    constptr_OpenedFile() const
    {
        return ((mValue).VOpenedFile).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OpenHeapSnapshotTempFileResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OpenHeapSnapshotTempFileResponse(const nsresult& aOther);

    MOZ_IMPLICIT OpenHeapSnapshotTempFileResponse(const OpenedFile& aOther);

    MOZ_IMPLICIT OpenHeapSnapshotTempFileResponse(const OpenHeapSnapshotTempFileResponse& aOther);

    ~OpenHeapSnapshotTempFileResponse();

    Type
    type() const
    {
        return mType;
    }

    OpenHeapSnapshotTempFileResponse&
    operator=(const nsresult& aRhs);

    OpenHeapSnapshotTempFileResponse&
    operator=(const OpenedFile& aRhs);

    OpenHeapSnapshotTempFileResponse&
    operator=(const OpenHeapSnapshotTempFileResponse& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const OpenedFile& aRhs) const;

    bool
    operator==(const OpenHeapSnapshotTempFileResponse& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    OpenedFile&
    get_OpenedFile()
    {
        AssertSanity(TOpenedFile);
        return (*(ptr_OpenedFile()));
    }
    const OpenedFile&
    get_OpenedFile() const
    {
        AssertSanity(TOpenedFile);
        return (*(constptr_OpenedFile()));
    }
    operator OpenedFile&()
    {
        return get_OpenedFile();
    }
    operator const OpenedFile&() const
    {
        return get_OpenedFile();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace devtools
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PHeapSnapshotTempFileHelperChild and PHeapSnapshotTempFileHelperParent
//
namespace mozilla {
namespace devtools {
namespace PHeapSnapshotTempFileHelper {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PHeapSnapshotTempFileHelperStart = PHeapSnapshotTempFileHelperMsgStart << 16,
    Msg_OpenHeapSnapshotTempFile__ID,
    Reply_OpenHeapSnapshotTempFile__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PHeapSnapshotTempFileHelperEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_OpenHeapSnapshotTempFile :
    public IPC::Message
{
public:
    enum {
        ID = Msg_OpenHeapSnapshotTempFile__ID
    };
    MOZ_IMPLICIT Msg_OpenHeapSnapshotTempFile(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHeapSnapshotTempFileHelper::Msg_OpenHeapSnapshotTempFile")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_OpenHeapSnapshotTempFile(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_OpenHeapSnapshotTempFile :
    public IPC::Message
{
public:
    enum {
        ID = Reply_OpenHeapSnapshotTempFile__ID
    };
    MOZ_IMPLICIT Reply_OpenHeapSnapshotTempFile(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHeapSnapshotTempFileHelper::Reply_OpenHeapSnapshotTempFile")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_OpenHeapSnapshotTempFile(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHeapSnapshotTempFileHelper::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHeapSnapshotTempFileHelper::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PHeapSnapshotTempFileHelper
} // namespace devtools
} // namespace mozilla

#endif // ifndef PHeapSnapshotTempFileHelper_h
