//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef DOMTypes_h
#define DOMTypes_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "nsID.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalID|
//
namespace mozilla {
namespace dom {
class OptionalID final
{
public:
    enum Type {
        T__None,
        TnsID = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::void_t void_t;
    typedef nsID nsID__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<nsID> VnsID;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    nsID*
    ptr_nsID()
    {
        return ((mValue).VnsID).addr();
    }
    const nsID* const
    constptr_nsID() const
    {
        return ((mValue).VnsID).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t* const
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalID() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalID(const nsID& aOther);

    MOZ_IMPLICIT OptionalID(const void_t& aOther);

    MOZ_IMPLICIT OptionalID(const OptionalID& aOther);

    ~OptionalID();

    Type
    type() const
    {
        return mType;
    }

    OptionalID&
    operator=(const nsID& aRhs);

    OptionalID&
    operator=(const void_t& aRhs);

    OptionalID&
    operator=(const OptionalID& aRhs);

    bool
    operator==(const nsID& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalID& aRhs) const;

    nsID&
    get_nsID()
    {
        AssertSanity(TnsID);
        return (*(ptr_nsID()));
    }
    const nsID&
    get_nsID() const
    {
        AssertSanity(TnsID);
        return (*(constptr_nsID()));
    }
    operator nsID&()
    {
        return get_nsID();
    }
    operator const nsID&() const
    {
        return get_nsID();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
class ClonedMessageData final
{
private:
    typedef mozilla::SerializedStructuredCloneBuffer SerializedStructuredCloneBuffer;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT ClonedMessageData();

    MOZ_IMPLICIT ClonedMessageData(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild)
    {
        Init();
        Assign(_data, _blobsParent, _blobsChild);
    }

    MOZ_IMPLICIT ClonedMessageData(const ClonedMessageData& _o)
    {
        Init();
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild());
    }

    ~ClonedMessageData();

    void
    operator=(const ClonedMessageData& _o)
    {
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild());
    }

    bool
    operator==(const ClonedMessageData& _o) const;

    SerializedStructuredCloneBuffer&
    data()
    {
        return data_;
    }
    const SerializedStructuredCloneBuffer&
    data() const
    {
        return data_;
    }

    nsTArray<PBlobParent*>&
    blobsParent()
    {
        return blobsParent_;
    }
    const nsTArray<PBlobParent*>&
    blobsParent() const
    {
        return blobsParent_;
    }

    nsTArray<PBlobChild*>&
    blobsChild()
    {
        return blobsChild_;
    }
    const nsTArray<PBlobChild*>&
    blobsChild() const
    {
        return blobsChild_;
    }

private:
    void
    Init();

    void
    Assign(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild);

    SerializedStructuredCloneBuffer data_;
    nsTArray<PBlobParent*> blobsParent_;
    nsTArray<PBlobChild*> blobsChild_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union BlobData|
//
namespace mozilla {
namespace dom {
class BlobData final
{
public:
    enum Type {
        T__None,
        TnsID = 1,
        TArrayOfuint8_t,
        TArrayOfBlobData,
        T__Last = TArrayOfBlobData
    };

private:
    typedef nsID nsID__tdef;
    typedef nsTArray<uint8_t> ArrayOfuint8_t__tdef;
    typedef nsTArray<BlobData>* ArrayOfBlobData__tdef;

    union Value {
        mozilla::AlignedStorage2<nsID> VnsID;
        mozilla::AlignedStorage2<nsTArray<uint8_t>> VArrayOfuint8_t;
        nsTArray<BlobData>* VArrayOfBlobData;
    };

    nsID*
    ptr_nsID()
    {
        return ((mValue).VnsID).addr();
    }
    const nsID* const
    constptr_nsID() const
    {
        return ((mValue).VnsID).addr();
    }
    nsTArray<uint8_t>*
    ptr_ArrayOfuint8_t()
    {
        return ((mValue).VArrayOfuint8_t).addr();
    }
    const nsTArray<uint8_t>* const
    constptr_ArrayOfuint8_t() const
    {
        return ((mValue).VArrayOfuint8_t).addr();
    }
    nsTArray<BlobData>*&
    ptr_ArrayOfBlobData()
    {
        return (mValue).VArrayOfBlobData;
    }
    const nsTArray<BlobData>* const
    constptr_ArrayOfBlobData() const
    {
        return (mValue).VArrayOfBlobData;
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT BlobData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT BlobData(const nsID& aOther);

    MOZ_IMPLICIT BlobData(const nsTArray<uint8_t>& aOther);

    MOZ_IMPLICIT BlobData(const nsTArray<BlobData>& aOther);

    MOZ_IMPLICIT BlobData(const BlobData& aOther);

    ~BlobData();

    Type
    type() const
    {
        return mType;
    }

    BlobData&
    operator=(const nsID& aRhs);

    BlobData&
    operator=(const nsTArray<uint8_t>& aRhs);

    BlobData&
    operator=(const nsTArray<BlobData>& aRhs);

    BlobData&
    operator=(const BlobData& aRhs);

    bool
    operator==(const nsID& aRhs) const;

    bool
    operator==(const nsTArray<uint8_t>& aRhs) const;

    bool
    operator==(const nsTArray<BlobData>& aRhs) const;

    bool
    operator==(const BlobData& aRhs) const;

    nsID&
    get_nsID()
    {
        AssertSanity(TnsID);
        return (*(ptr_nsID()));
    }
    const nsID&
    get_nsID() const
    {
        AssertSanity(TnsID);
        return (*(constptr_nsID()));
    }
    operator nsID&()
    {
        return get_nsID();
    }
    operator const nsID&() const
    {
        return get_nsID();
    }

    nsTArray<uint8_t>&
    get_ArrayOfuint8_t()
    {
        AssertSanity(TArrayOfuint8_t);
        return (*(ptr_ArrayOfuint8_t()));
    }
    const nsTArray<uint8_t>&
    get_ArrayOfuint8_t() const
    {
        AssertSanity(TArrayOfuint8_t);
        return (*(constptr_ArrayOfuint8_t()));
    }
    operator nsTArray<uint8_t>&()
    {
        return get_ArrayOfuint8_t();
    }
    operator const nsTArray<uint8_t>&() const
    {
        return get_ArrayOfuint8_t();
    }

    nsTArray<BlobData>&
    get_ArrayOfBlobData()
    {
        AssertSanity(TArrayOfBlobData);
        return (*(ptr_ArrayOfBlobData()));
    }
    const nsTArray<BlobData>&
    get_ArrayOfBlobData() const
    {
        AssertSanity(TArrayOfBlobData);
        return (*(constptr_ArrayOfBlobData()));
    }
    operator nsTArray<BlobData>&()
    {
        return get_ArrayOfBlobData();
    }
    operator const nsTArray<BlobData>&() const
    {
        return get_ArrayOfBlobData();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class BlobData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalBlobData|
//
namespace mozilla {
namespace dom {
class OptionalBlobData final
{
public:
    enum Type {
        T__None,
        TBlobData = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::dom::BlobData BlobData;
    typedef mozilla::void_t void_t;
    typedef BlobData BlobData__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<BlobData> VBlobData;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    BlobData*
    ptr_BlobData()
    {
        return ((mValue).VBlobData).addr();
    }
    const BlobData* const
    constptr_BlobData() const
    {
        return ((mValue).VBlobData).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t* const
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalBlobData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalBlobData(const BlobData& aOther);

    MOZ_IMPLICIT OptionalBlobData(const void_t& aOther);

    MOZ_IMPLICIT OptionalBlobData(const OptionalBlobData& aOther);

    ~OptionalBlobData();

    Type
    type() const
    {
        return mType;
    }

    OptionalBlobData&
    operator=(const BlobData& aRhs);

    OptionalBlobData&
    operator=(const void_t& aRhs);

    OptionalBlobData&
    operator=(const OptionalBlobData& aRhs);

    bool
    operator==(const BlobData& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalBlobData& aRhs) const;

    BlobData&
    get_BlobData()
    {
        AssertSanity(TBlobData);
        return (*(ptr_BlobData()));
    }
    const BlobData&
    get_BlobData() const
    {
        AssertSanity(TBlobData);
        return (*(constptr_BlobData()));
    }
    operator BlobData&()
    {
        return get_BlobData();
    }
    operator const BlobData&() const
    {
        return get_BlobData();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class OptionalBlobData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NormalBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class NormalBlobConstructorParams final
{
private:
    typedef mozilla::dom::OptionalBlobData OptionalBlobData;

public:
    MOZ_IMPLICIT NormalBlobConstructorParams();

    MOZ_IMPLICIT NormalBlobConstructorParams(
            const nsString& _contentType,
            const uint64_t& _length,
            const OptionalBlobData& _optionalBlobData)
    {
        Init();
        Assign(_contentType, _length, _optionalBlobData);
    }

    MOZ_IMPLICIT NormalBlobConstructorParams(const NormalBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).contentType(), (_o).length(), (_o).optionalBlobData());
    }

    ~NormalBlobConstructorParams();

    void
    operator=(const NormalBlobConstructorParams& _o)
    {
        Assign((_o).contentType(), (_o).length(), (_o).optionalBlobData());
    }

    bool
    operator==(const NormalBlobConstructorParams& _o) const;

    nsString&
    contentType()
    {
        return contentType_;
    }
    const nsString&
    contentType() const
    {
        return contentType_;
    }

    uint64_t&
    length()
    {
        return length_;
    }
    const uint64_t&
    length() const
    {
        return length_;
    }

    OptionalBlobData&
    optionalBlobData()
    {
        return optionalBlobData_;
    }
    const OptionalBlobData&
    optionalBlobData() const
    {
        return optionalBlobData_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _contentType,
            const uint64_t& _length,
            const OptionalBlobData& _optionalBlobData);

    nsString contentType_;
    uint64_t length_;
    OptionalBlobData optionalBlobData_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class OptionalBlobData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class FileBlobConstructorParams final
{
private:
    typedef mozilla::dom::OptionalBlobData OptionalBlobData;

public:
    MOZ_IMPLICIT FileBlobConstructorParams();

    MOZ_IMPLICIT FileBlobConstructorParams(
            const nsString& _name,
            const nsString& _contentType,
            const uint64_t& _length,
            const int64_t& _modDate,
            const uint32_t& _dirState,
            const OptionalBlobData& _optionalBlobData)
    {
        Init();
        Assign(_name, _contentType, _length, _modDate, _dirState, _optionalBlobData);
    }

    MOZ_IMPLICIT FileBlobConstructorParams(const FileBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).name(), (_o).contentType(), (_o).length(), (_o).modDate(), (_o).dirState(), (_o).optionalBlobData());
    }

    ~FileBlobConstructorParams();

    void
    operator=(const FileBlobConstructorParams& _o)
    {
        Assign((_o).name(), (_o).contentType(), (_o).length(), (_o).modDate(), (_o).dirState(), (_o).optionalBlobData());
    }

    bool
    operator==(const FileBlobConstructorParams& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    nsString&
    contentType()
    {
        return contentType_;
    }
    const nsString&
    contentType() const
    {
        return contentType_;
    }

    uint64_t&
    length()
    {
        return length_;
    }
    const uint64_t&
    length() const
    {
        return length_;
    }

    int64_t&
    modDate()
    {
        return modDate_;
    }
    const int64_t&
    modDate() const
    {
        return modDate_;
    }

    uint32_t&
    dirState()
    {
        return dirState_;
    }
    const uint32_t&
    dirState() const
    {
        return dirState_;
    }

    OptionalBlobData&
    optionalBlobData()
    {
        return optionalBlobData_;
    }
    const OptionalBlobData&
    optionalBlobData() const
    {
        return optionalBlobData_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _name,
            const nsString& _contentType,
            const uint64_t& _length,
            const int64_t& _modDate,
            const uint32_t& _dirState,
            const OptionalBlobData& _optionalBlobData);

    nsString name_;
    nsString contentType_;
    uint64_t length_;
    int64_t modDate_;
    uint32_t dirState_;
    OptionalBlobData optionalBlobData_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SlicedBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class SlicedBlobConstructorParams final
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT SlicedBlobConstructorParams();

    MOZ_IMPLICIT SlicedBlobConstructorParams(
            PBlobParent* _sourceParent,
            PBlobChild* _sourceChild,
            const nsID& _id,
            const uint64_t& _begin,
            const uint64_t& _end,
            const nsString& _contentType)
    {
        Init();
        Assign(_sourceParent, _sourceChild, _id, _begin, _end, _contentType);
    }

    MOZ_IMPLICIT SlicedBlobConstructorParams(const SlicedBlobConstructorParams& _o)
    {
        Init();
        Assign(const_cast<PBlobParent*>((_o).sourceParent()), const_cast<PBlobChild*>((_o).sourceChild()), (_o).id(), (_o).begin(), (_o).end(), (_o).contentType());
    }

    ~SlicedBlobConstructorParams();

    void
    operator=(const SlicedBlobConstructorParams& _o)
    {
        Assign(const_cast<PBlobParent*>((_o).sourceParent()), const_cast<PBlobChild*>((_o).sourceChild()), (_o).id(), (_o).begin(), (_o).end(), (_o).contentType());
    }

    bool
    operator==(const SlicedBlobConstructorParams& _o) const;

    PBlobParent*&
    sourceParent()
    {
        return sourceParent_;
    }
    PBlobParent*
    sourceParent() const
    {
        return sourceParent_;
    }

    PBlobChild*&
    sourceChild()
    {
        return sourceChild_;
    }
    PBlobChild*
    sourceChild() const
    {
        return sourceChild_;
    }

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    uint64_t&
    begin()
    {
        return begin_;
    }
    const uint64_t&
    begin() const
    {
        return begin_;
    }

    uint64_t&
    end()
    {
        return end_;
    }
    const uint64_t&
    end() const
    {
        return end_;
    }

    nsString&
    contentType()
    {
        return contentType_;
    }
    const nsString&
    contentType() const
    {
        return contentType_;
    }

private:
    void
    Init();

    void
    Assign(
            PBlobParent* _sourceParent,
            PBlobChild* _sourceChild,
            const nsID& _id,
            const uint64_t& _begin,
            const uint64_t& _end,
            const nsString& _contentType);

    PBlobParent* sourceParent_;
    PBlobChild* sourceChild_;
    nsID id_;
    uint64_t begin_;
    uint64_t end_;
    nsString contentType_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MysteryBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class MysteryBlobConstructorParams final
{
private:

public:
    MOZ_IMPLICIT MysteryBlobConstructorParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT MysteryBlobConstructorParams(const MysteryBlobConstructorParams& _o)
    {
        Init();
        Assign();
    }

    ~MysteryBlobConstructorParams();

    void
    operator=(const MysteryBlobConstructorParams& _o)
    {
        Assign();
    }

    bool
    operator==(const MysteryBlobConstructorParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct KnownBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class KnownBlobConstructorParams final
{
private:

public:
    MOZ_IMPLICIT KnownBlobConstructorParams();

    MOZ_IMPLICIT KnownBlobConstructorParams(const nsID& _id)
    {
        Init();
        Assign(_id);
    }

    MOZ_IMPLICIT KnownBlobConstructorParams(const KnownBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).id());
    }

    ~KnownBlobConstructorParams();

    void
    operator=(const KnownBlobConstructorParams& _o)
    {
        Assign((_o).id());
    }

    bool
    operator==(const KnownBlobConstructorParams& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

private:
    void
    Init();

    void
    Assign(const nsID& _id);

    nsID id_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SameProcessBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class SameProcessBlobConstructorParams final
{
private:

public:
    MOZ_IMPLICIT SameProcessBlobConstructorParams();

    MOZ_IMPLICIT SameProcessBlobConstructorParams(const intptr_t& _addRefedBlobImpl)
    {
        Init();
        Assign(_addRefedBlobImpl);
    }

    MOZ_IMPLICIT SameProcessBlobConstructorParams(const SameProcessBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).addRefedBlobImpl());
    }

    ~SameProcessBlobConstructorParams();

    void
    operator=(const SameProcessBlobConstructorParams& _o)
    {
        Assign((_o).addRefedBlobImpl());
    }

    bool
    operator==(const SameProcessBlobConstructorParams& _o) const;

    intptr_t&
    addRefedBlobImpl()
    {
        return addRefedBlobImpl_;
    }
    const intptr_t&
    addRefedBlobImpl() const
    {
        return addRefedBlobImpl_;
    }

private:
    void
    Init();

    void
    Assign(const intptr_t& _addRefedBlobImpl);

    intptr_t addRefedBlobImpl_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class NormalBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class SameProcessBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class MysteryBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class SlicedBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class KnownBlobConstructorParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AnyBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class AnyBlobConstructorParams final
{
public:
    enum Type {
        T__None,
        TNormalBlobConstructorParams = 1,
        TFileBlobConstructorParams,
        TSameProcessBlobConstructorParams,
        TMysteryBlobConstructorParams,
        TSlicedBlobConstructorParams,
        TKnownBlobConstructorParams,
        T__Last = TKnownBlobConstructorParams
    };

private:
    typedef mozilla::dom::NormalBlobConstructorParams NormalBlobConstructorParams;
    typedef mozilla::dom::FileBlobConstructorParams FileBlobConstructorParams;
    typedef mozilla::dom::SameProcessBlobConstructorParams SameProcessBlobConstructorParams;
    typedef mozilla::dom::MysteryBlobConstructorParams MysteryBlobConstructorParams;
    typedef mozilla::dom::SlicedBlobConstructorParams SlicedBlobConstructorParams;
    typedef mozilla::dom::KnownBlobConstructorParams KnownBlobConstructorParams;
    typedef NormalBlobConstructorParams NormalBlobConstructorParams__tdef;
    typedef FileBlobConstructorParams FileBlobConstructorParams__tdef;
    typedef SameProcessBlobConstructorParams SameProcessBlobConstructorParams__tdef;
    typedef MysteryBlobConstructorParams MysteryBlobConstructorParams__tdef;
    typedef SlicedBlobConstructorParams SlicedBlobConstructorParams__tdef;
    typedef KnownBlobConstructorParams KnownBlobConstructorParams__tdef;

    union Value {
        mozilla::AlignedStorage2<NormalBlobConstructorParams> VNormalBlobConstructorParams;
        mozilla::AlignedStorage2<FileBlobConstructorParams> VFileBlobConstructorParams;
        mozilla::AlignedStorage2<SameProcessBlobConstructorParams> VSameProcessBlobConstructorParams;
        mozilla::AlignedStorage2<MysteryBlobConstructorParams> VMysteryBlobConstructorParams;
        mozilla::AlignedStorage2<SlicedBlobConstructorParams> VSlicedBlobConstructorParams;
        mozilla::AlignedStorage2<KnownBlobConstructorParams> VKnownBlobConstructorParams;
    };

    NormalBlobConstructorParams*
    ptr_NormalBlobConstructorParams()
    {
        return ((mValue).VNormalBlobConstructorParams).addr();
    }
    const NormalBlobConstructorParams* const
    constptr_NormalBlobConstructorParams() const
    {
        return ((mValue).VNormalBlobConstructorParams).addr();
    }
    FileBlobConstructorParams*
    ptr_FileBlobConstructorParams()
    {
        return ((mValue).VFileBlobConstructorParams).addr();
    }
    const FileBlobConstructorParams* const
    constptr_FileBlobConstructorParams() const
    {
        return ((mValue).VFileBlobConstructorParams).addr();
    }
    SameProcessBlobConstructorParams*
    ptr_SameProcessBlobConstructorParams()
    {
        return ((mValue).VSameProcessBlobConstructorParams).addr();
    }
    const SameProcessBlobConstructorParams* const
    constptr_SameProcessBlobConstructorParams() const
    {
        return ((mValue).VSameProcessBlobConstructorParams).addr();
    }
    MysteryBlobConstructorParams*
    ptr_MysteryBlobConstructorParams()
    {
        return ((mValue).VMysteryBlobConstructorParams).addr();
    }
    const MysteryBlobConstructorParams* const
    constptr_MysteryBlobConstructorParams() const
    {
        return ((mValue).VMysteryBlobConstructorParams).addr();
    }
    SlicedBlobConstructorParams*
    ptr_SlicedBlobConstructorParams()
    {
        return ((mValue).VSlicedBlobConstructorParams).addr();
    }
    const SlicedBlobConstructorParams* const
    constptr_SlicedBlobConstructorParams() const
    {
        return ((mValue).VSlicedBlobConstructorParams).addr();
    }
    KnownBlobConstructorParams*
    ptr_KnownBlobConstructorParams()
    {
        return ((mValue).VKnownBlobConstructorParams).addr();
    }
    const KnownBlobConstructorParams* const
    constptr_KnownBlobConstructorParams() const
    {
        return ((mValue).VKnownBlobConstructorParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AnyBlobConstructorParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AnyBlobConstructorParams(const NormalBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const FileBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const SameProcessBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const MysteryBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const SlicedBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const KnownBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const AnyBlobConstructorParams& aOther);

    ~AnyBlobConstructorParams();

    Type
    type() const
    {
        return mType;
    }

    AnyBlobConstructorParams&
    operator=(const NormalBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const FileBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const SameProcessBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const MysteryBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const SlicedBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const KnownBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const AnyBlobConstructorParams& aRhs);

    bool
    operator==(const NormalBlobConstructorParams& aRhs) const;

    bool
    operator==(const FileBlobConstructorParams& aRhs) const;

    bool
    operator==(const SameProcessBlobConstructorParams& aRhs) const;

    bool
    operator==(const MysteryBlobConstructorParams& aRhs) const;

    bool
    operator==(const SlicedBlobConstructorParams& aRhs) const;

    bool
    operator==(const KnownBlobConstructorParams& aRhs) const;

    bool
    operator==(const AnyBlobConstructorParams& aRhs) const;

    NormalBlobConstructorParams&
    get_NormalBlobConstructorParams()
    {
        AssertSanity(TNormalBlobConstructorParams);
        return (*(ptr_NormalBlobConstructorParams()));
    }
    const NormalBlobConstructorParams&
    get_NormalBlobConstructorParams() const
    {
        AssertSanity(TNormalBlobConstructorParams);
        return (*(constptr_NormalBlobConstructorParams()));
    }
    operator NormalBlobConstructorParams&()
    {
        return get_NormalBlobConstructorParams();
    }
    operator const NormalBlobConstructorParams&() const
    {
        return get_NormalBlobConstructorParams();
    }

    FileBlobConstructorParams&
    get_FileBlobConstructorParams()
    {
        AssertSanity(TFileBlobConstructorParams);
        return (*(ptr_FileBlobConstructorParams()));
    }
    const FileBlobConstructorParams&
    get_FileBlobConstructorParams() const
    {
        AssertSanity(TFileBlobConstructorParams);
        return (*(constptr_FileBlobConstructorParams()));
    }
    operator FileBlobConstructorParams&()
    {
        return get_FileBlobConstructorParams();
    }
    operator const FileBlobConstructorParams&() const
    {
        return get_FileBlobConstructorParams();
    }

    SameProcessBlobConstructorParams&
    get_SameProcessBlobConstructorParams()
    {
        AssertSanity(TSameProcessBlobConstructorParams);
        return (*(ptr_SameProcessBlobConstructorParams()));
    }
    const SameProcessBlobConstructorParams&
    get_SameProcessBlobConstructorParams() const
    {
        AssertSanity(TSameProcessBlobConstructorParams);
        return (*(constptr_SameProcessBlobConstructorParams()));
    }
    operator SameProcessBlobConstructorParams&()
    {
        return get_SameProcessBlobConstructorParams();
    }
    operator const SameProcessBlobConstructorParams&() const
    {
        return get_SameProcessBlobConstructorParams();
    }

    MysteryBlobConstructorParams&
    get_MysteryBlobConstructorParams()
    {
        AssertSanity(TMysteryBlobConstructorParams);
        return (*(ptr_MysteryBlobConstructorParams()));
    }
    const MysteryBlobConstructorParams&
    get_MysteryBlobConstructorParams() const
    {
        AssertSanity(TMysteryBlobConstructorParams);
        return (*(constptr_MysteryBlobConstructorParams()));
    }
    operator MysteryBlobConstructorParams&()
    {
        return get_MysteryBlobConstructorParams();
    }
    operator const MysteryBlobConstructorParams&() const
    {
        return get_MysteryBlobConstructorParams();
    }

    SlicedBlobConstructorParams&
    get_SlicedBlobConstructorParams()
    {
        AssertSanity(TSlicedBlobConstructorParams);
        return (*(ptr_SlicedBlobConstructorParams()));
    }
    const SlicedBlobConstructorParams&
    get_SlicedBlobConstructorParams() const
    {
        AssertSanity(TSlicedBlobConstructorParams);
        return (*(constptr_SlicedBlobConstructorParams()));
    }
    operator SlicedBlobConstructorParams&()
    {
        return get_SlicedBlobConstructorParams();
    }
    operator const SlicedBlobConstructorParams&() const
    {
        return get_SlicedBlobConstructorParams();
    }

    KnownBlobConstructorParams&
    get_KnownBlobConstructorParams()
    {
        AssertSanity(TKnownBlobConstructorParams);
        return (*(ptr_KnownBlobConstructorParams()));
    }
    const KnownBlobConstructorParams&
    get_KnownBlobConstructorParams() const
    {
        AssertSanity(TKnownBlobConstructorParams);
        return (*(constptr_KnownBlobConstructorParams()));
    }
    operator KnownBlobConstructorParams&()
    {
        return get_KnownBlobConstructorParams();
    }
    operator const KnownBlobConstructorParams&() const
    {
        return get_KnownBlobConstructorParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class AnyBlobConstructorParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ChildBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class ChildBlobConstructorParams final
{
private:
    typedef mozilla::dom::AnyBlobConstructorParams AnyBlobConstructorParams;

public:
    MOZ_IMPLICIT ChildBlobConstructorParams();

    MOZ_IMPLICIT ChildBlobConstructorParams(
            const nsID& _id,
            const AnyBlobConstructorParams& _blobParams)
    {
        Init();
        Assign(_id, _blobParams);
    }

    MOZ_IMPLICIT ChildBlobConstructorParams(const ChildBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).id(), (_o).blobParams());
    }

    ~ChildBlobConstructorParams();

    void
    operator=(const ChildBlobConstructorParams& _o)
    {
        Assign((_o).id(), (_o).blobParams());
    }

    bool
    operator==(const ChildBlobConstructorParams& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    AnyBlobConstructorParams&
    blobParams()
    {
        return blobParams_;
    }
    const AnyBlobConstructorParams&
    blobParams() const
    {
        return blobParams_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _id,
            const AnyBlobConstructorParams& _blobParams);

    nsID id_;
    AnyBlobConstructorParams blobParams_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class AnyBlobConstructorParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class ParentBlobConstructorParams final
{
private:
    typedef mozilla::dom::AnyBlobConstructorParams AnyBlobConstructorParams;

public:
    MOZ_IMPLICIT ParentBlobConstructorParams();

    MOZ_IMPLICIT ParentBlobConstructorParams(const AnyBlobConstructorParams& _blobParams)
    {
        Init();
        Assign(_blobParams);
    }

    MOZ_IMPLICIT ParentBlobConstructorParams(const ParentBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).blobParams());
    }

    ~ParentBlobConstructorParams();

    void
    operator=(const ParentBlobConstructorParams& _o)
    {
        Assign((_o).blobParams());
    }

    bool
    operator==(const ParentBlobConstructorParams& _o) const;

    AnyBlobConstructorParams&
    blobParams()
    {
        return blobParams_;
    }
    const AnyBlobConstructorParams&
    blobParams() const
    {
        return blobParams_;
    }

private:
    void
    Init();

    void
    Assign(const AnyBlobConstructorParams& _blobParams);

    AnyBlobConstructorParams blobParams_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class ChildBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ParentBlobConstructorParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union BlobConstructorParams|
//
namespace mozilla {
namespace dom {
class BlobConstructorParams final
{
public:
    enum Type {
        T__None,
        TChildBlobConstructorParams = 1,
        TParentBlobConstructorParams,
        T__Last = TParentBlobConstructorParams
    };

private:
    typedef mozilla::dom::ChildBlobConstructorParams ChildBlobConstructorParams;
    typedef mozilla::dom::ParentBlobConstructorParams ParentBlobConstructorParams;
    typedef ChildBlobConstructorParams ChildBlobConstructorParams__tdef;
    typedef ParentBlobConstructorParams ParentBlobConstructorParams__tdef;

    union Value {
        mozilla::AlignedStorage2<ChildBlobConstructorParams> VChildBlobConstructorParams;
        mozilla::AlignedStorage2<ParentBlobConstructorParams> VParentBlobConstructorParams;
    };

    ChildBlobConstructorParams*
    ptr_ChildBlobConstructorParams()
    {
        return ((mValue).VChildBlobConstructorParams).addr();
    }
    const ChildBlobConstructorParams* const
    constptr_ChildBlobConstructorParams() const
    {
        return ((mValue).VChildBlobConstructorParams).addr();
    }
    ParentBlobConstructorParams*
    ptr_ParentBlobConstructorParams()
    {
        return ((mValue).VParentBlobConstructorParams).addr();
    }
    const ParentBlobConstructorParams* const
    constptr_ParentBlobConstructorParams() const
    {
        return ((mValue).VParentBlobConstructorParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT BlobConstructorParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT BlobConstructorParams(const ChildBlobConstructorParams& aOther);

    MOZ_IMPLICIT BlobConstructorParams(const ParentBlobConstructorParams& aOther);

    MOZ_IMPLICIT BlobConstructorParams(const BlobConstructorParams& aOther);

    ~BlobConstructorParams();

    Type
    type() const
    {
        return mType;
    }

    BlobConstructorParams&
    operator=(const ChildBlobConstructorParams& aRhs);

    BlobConstructorParams&
    operator=(const ParentBlobConstructorParams& aRhs);

    BlobConstructorParams&
    operator=(const BlobConstructorParams& aRhs);

    bool
    operator==(const ChildBlobConstructorParams& aRhs) const;

    bool
    operator==(const ParentBlobConstructorParams& aRhs) const;

    bool
    operator==(const BlobConstructorParams& aRhs) const;

    ChildBlobConstructorParams&
    get_ChildBlobConstructorParams()
    {
        AssertSanity(TChildBlobConstructorParams);
        return (*(ptr_ChildBlobConstructorParams()));
    }
    const ChildBlobConstructorParams&
    get_ChildBlobConstructorParams() const
    {
        AssertSanity(TChildBlobConstructorParams);
        return (*(constptr_ChildBlobConstructorParams()));
    }
    operator ChildBlobConstructorParams&()
    {
        return get_ChildBlobConstructorParams();
    }
    operator const ChildBlobConstructorParams&() const
    {
        return get_ChildBlobConstructorParams();
    }

    ParentBlobConstructorParams&
    get_ParentBlobConstructorParams()
    {
        AssertSanity(TParentBlobConstructorParams);
        return (*(ptr_ParentBlobConstructorParams()));
    }
    const ParentBlobConstructorParams&
    get_ParentBlobConstructorParams() const
    {
        AssertSanity(TParentBlobConstructorParams);
        return (*(constptr_ParentBlobConstructorParams()));
    }
    operator ParentBlobConstructorParams&()
    {
        return get_ParentBlobConstructorParams();
    }
    operator const ParentBlobConstructorParams&() const
    {
        return get_ParentBlobConstructorParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCDataTransferData|
//
namespace mozilla {
namespace dom {
class IPCDataTransferData final
{
public:
    enum Type {
        T__None,
        TnsString = 1,
        TnsCString,
        TPBlobParent,
        TPBlobChild,
        T__Last = TPBlobChild
    };

private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef nsString nsString__tdef;
    typedef nsCString nsCString__tdef;
    typedef PBlobParent* PBlobParent__tdef;
    typedef PBlobChild* PBlobChild__tdef;

    union Value {
        mozilla::AlignedStorage2<nsString> VnsString;
        mozilla::AlignedStorage2<nsCString> VnsCString;
        mozilla::AlignedStorage2<PBlobParent*> VPBlobParent;
        mozilla::AlignedStorage2<PBlobChild*> VPBlobChild;
    };

    nsString*
    ptr_nsString()
    {
        return ((mValue).VnsString).addr();
    }
    const nsString* const
    constptr_nsString() const
    {
        return ((mValue).VnsString).addr();
    }
    nsCString*
    ptr_nsCString()
    {
        return ((mValue).VnsCString).addr();
    }
    const nsCString* const
    constptr_nsCString() const
    {
        return ((mValue).VnsCString).addr();
    }
    PBlobParent**
    ptr_PBlobParent()
    {
        return ((mValue).VPBlobParent).addr();
    }
    PBlobParent* const*
    constptr_PBlobParent() const
    {
        return ((mValue).VPBlobParent).addr();
    }
    PBlobChild**
    ptr_PBlobChild()
    {
        return ((mValue).VPBlobChild).addr();
    }
    PBlobChild* const*
    constptr_PBlobChild() const
    {
        return ((mValue).VPBlobChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCDataTransferData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCDataTransferData(const nsString& aOther);

    MOZ_IMPLICIT IPCDataTransferData(const nsCString& aOther);

    MOZ_IMPLICIT IPCDataTransferData(PBlobParent* aOther);

    MOZ_IMPLICIT IPCDataTransferData(PBlobChild* aOther);

    MOZ_IMPLICIT IPCDataTransferData(const IPCDataTransferData& aOther);

    ~IPCDataTransferData();

    Type
    type() const
    {
        return mType;
    }

    IPCDataTransferData&
    operator=(const nsString& aRhs);

    IPCDataTransferData&
    operator=(const nsCString& aRhs);

    IPCDataTransferData&
    operator=(PBlobParent* aRhs);

    IPCDataTransferData&
    operator=(PBlobChild* aRhs);

    IPCDataTransferData&
    operator=(const IPCDataTransferData& aRhs);

    bool
    operator==(const nsString& aRhs) const;

    bool
    operator==(const nsCString& aRhs) const;

    bool
    operator==(PBlobParent* aRhs) const;

    bool
    operator==(PBlobChild* aRhs) const;

    bool
    operator==(const IPCDataTransferData& aRhs) const;

    nsString&
    get_nsString()
    {
        AssertSanity(TnsString);
        return (*(ptr_nsString()));
    }
    const nsString&
    get_nsString() const
    {
        AssertSanity(TnsString);
        return (*(constptr_nsString()));
    }
    operator nsString&()
    {
        return get_nsString();
    }
    operator const nsString&() const
    {
        return get_nsString();
    }

    nsCString&
    get_nsCString()
    {
        AssertSanity(TnsCString);
        return (*(ptr_nsCString()));
    }
    const nsCString&
    get_nsCString() const
    {
        AssertSanity(TnsCString);
        return (*(constptr_nsCString()));
    }
    operator nsCString&()
    {
        return get_nsCString();
    }
    operator const nsCString&() const
    {
        return get_nsCString();
    }

    PBlobParent*&
    get_PBlobParent()
    {
        AssertSanity(TPBlobParent);
        return (*(ptr_PBlobParent()));
    }
    PBlobParent*
    get_PBlobParent() const
    {
        AssertSanity(TPBlobParent);
        return (*(constptr_PBlobParent()));
    }
    operator PBlobParent*&()
    {
        return get_PBlobParent();
    }
    operator PBlobParent*() const
    {
        return get_PBlobParent();
    }

    PBlobChild*&
    get_PBlobChild()
    {
        AssertSanity(TPBlobChild);
        return (*(ptr_PBlobChild()));
    }
    PBlobChild*
    get_PBlobChild() const
    {
        AssertSanity(TPBlobChild);
        return (*(constptr_PBlobChild()));
    }
    operator PBlobChild*&()
    {
        return get_PBlobChild();
    }
    operator PBlobChild*() const
    {
        return get_PBlobChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferImage|
//
namespace mozilla {
namespace dom {
class IPCDataTransferImage final
{
private:

public:
    MOZ_IMPLICIT IPCDataTransferImage();

    MOZ_IMPLICIT IPCDataTransferImage(
            const uint32_t& _width,
            const uint32_t& _height,
            const uint32_t& _stride,
            const uint8_t& _format)
    {
        Init();
        Assign(_width, _height, _stride, _format);
    }

    MOZ_IMPLICIT IPCDataTransferImage(const IPCDataTransferImage& _o)
    {
        Init();
        Assign((_o).width(), (_o).height(), (_o).stride(), (_o).format());
    }

    ~IPCDataTransferImage();

    void
    operator=(const IPCDataTransferImage& _o)
    {
        Assign((_o).width(), (_o).height(), (_o).stride(), (_o).format());
    }

    bool
    operator==(const IPCDataTransferImage& _o) const;

    uint32_t&
    width()
    {
        return width_;
    }
    const uint32_t&
    width() const
    {
        return width_;
    }

    uint32_t&
    height()
    {
        return height_;
    }
    const uint32_t&
    height() const
    {
        return height_;
    }

    uint32_t&
    stride()
    {
        return stride_;
    }
    const uint32_t&
    stride() const
    {
        return stride_;
    }

    uint8_t&
    format()
    {
        return format_;
    }
    const uint8_t&
    format() const
    {
        return format_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _width,
            const uint32_t& _height,
            const uint32_t& _stride,
            const uint8_t& _format);

    uint32_t width_;
    uint32_t height_;
    uint32_t stride_;
    uint8_t format_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCDataTransferImage;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCDataTransferData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferItem|
//
namespace mozilla {
namespace dom {
class IPCDataTransferItem final
{
private:
    typedef mozilla::dom::IPCDataTransferImage IPCDataTransferImage;
    typedef mozilla::dom::IPCDataTransferData IPCDataTransferData;

public:
    MOZ_IMPLICIT IPCDataTransferItem();

    MOZ_IMPLICIT IPCDataTransferItem(
            const nsCString& _flavor,
            const IPCDataTransferImage& _imageDetails,
            const IPCDataTransferData& _data)
    {
        Init();
        Assign(_flavor, _imageDetails, _data);
    }

    MOZ_IMPLICIT IPCDataTransferItem(const IPCDataTransferItem& _o)
    {
        Init();
        Assign((_o).flavor(), (_o).imageDetails(), (_o).data());
    }

    ~IPCDataTransferItem();

    void
    operator=(const IPCDataTransferItem& _o)
    {
        Assign((_o).flavor(), (_o).imageDetails(), (_o).data());
    }

    bool
    operator==(const IPCDataTransferItem& _o) const;

    nsCString&
    flavor()
    {
        return flavor_;
    }
    const nsCString&
    flavor() const
    {
        return flavor_;
    }

    IPCDataTransferImage&
    imageDetails()
    {
        return imageDetails_;
    }
    const IPCDataTransferImage&
    imageDetails() const
    {
        return imageDetails_;
    }

    IPCDataTransferData&
    data()
    {
        return data_;
    }
    const IPCDataTransferData&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _flavor,
            const IPCDataTransferImage& _imageDetails,
            const IPCDataTransferData& _data);

    nsCString flavor_;
    IPCDataTransferImage imageDetails_;
    IPCDataTransferData data_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCDataTransferItem;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransfer|
//
namespace mozilla {
namespace dom {
class IPCDataTransfer final
{
private:
    typedef mozilla::dom::IPCDataTransferItem IPCDataTransferItem;

public:
    MOZ_IMPLICIT IPCDataTransfer();

    MOZ_IMPLICIT IPCDataTransfer(const nsTArray<IPCDataTransferItem>& _items)
    {
        Init();
        Assign(_items);
    }

    MOZ_IMPLICIT IPCDataTransfer(const IPCDataTransfer& _o)
    {
        Init();
        Assign((_o).items());
    }

    ~IPCDataTransfer();

    void
    operator=(const IPCDataTransfer& _o)
    {
        Assign((_o).items());
    }

    bool
    operator==(const IPCDataTransfer& _o) const;

    nsTArray<IPCDataTransferItem>&
    items()
    {
        return items_;
    }
    const nsTArray<IPCDataTransferItem>&
    items() const
    {
        return items_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<IPCDataTransferItem>& _items);

    nsTArray<IPCDataTransferItem> items_;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef DOMTypes_h
