//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundFileHandle_h
#define PBackgroundFileHandle_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestGetMetadataParams|
//
namespace mozilla {
namespace dom {
class FileRequestGetMetadataParams final
{
private:

public:
    MOZ_IMPLICIT FileRequestGetMetadataParams();

    MOZ_IMPLICIT FileRequestGetMetadataParams(
            const bool& _size,
            const bool& _lastModified)
    {
        Init();
        Assign(_size, _lastModified);
    }

    MOZ_IMPLICIT FileRequestGetMetadataParams(const FileRequestGetMetadataParams& _o)
    {
        Init();
        Assign((_o).size(), (_o).lastModified());
    }

    ~FileRequestGetMetadataParams();

    void
    operator=(const FileRequestGetMetadataParams& _o)
    {
        Assign((_o).size(), (_o).lastModified());
    }

    bool
    operator==(const FileRequestGetMetadataParams& _o) const;

    bool&
    size()
    {
        return size_;
    }
    const bool&
    size() const
    {
        return size_;
    }

    bool&
    lastModified()
    {
        return lastModified_;
    }
    const bool&
    lastModified() const
    {
        return lastModified_;
    }

private:
    void
    Init();

    void
    Assign(
            const bool& _size,
            const bool& _lastModified);

    bool size_;
    bool lastModified_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestReadParams|
//
namespace mozilla {
namespace dom {
class FileRequestReadParams final
{
private:

public:
    MOZ_IMPLICIT FileRequestReadParams();

    MOZ_IMPLICIT FileRequestReadParams(
            const uint64_t& _offset,
            const uint64_t& _size)
    {
        Init();
        Assign(_offset, _size);
    }

    MOZ_IMPLICIT FileRequestReadParams(const FileRequestReadParams& _o)
    {
        Init();
        Assign((_o).offset(), (_o).size());
    }

    ~FileRequestReadParams();

    void
    operator=(const FileRequestReadParams& _o)
    {
        Assign((_o).offset(), (_o).size());
    }

    bool
    operator==(const FileRequestReadParams& _o) const;

    uint64_t&
    offset()
    {
        return offset_;
    }
    const uint64_t&
    offset() const
    {
        return offset_;
    }

    uint64_t&
    size()
    {
        return size_;
    }
    const uint64_t&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _offset,
            const uint64_t& _size);

    uint64_t offset_;
    uint64_t size_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestStringData|
//
namespace mozilla {
namespace dom {
class FileRequestStringData final
{
private:

public:
    MOZ_IMPLICIT FileRequestStringData();

    MOZ_IMPLICIT FileRequestStringData(const nsCString& _string)
    {
        Init();
        Assign(_string);
    }

    MOZ_IMPLICIT FileRequestStringData(const FileRequestStringData& _o)
    {
        Init();
        Assign((_o).string());
    }

    ~FileRequestStringData();

    void
    operator=(const FileRequestStringData& _o)
    {
        Assign((_o).string());
    }

    bool
    operator==(const FileRequestStringData& _o) const;

    nsCString&
    string()
    {
        return string_;
    }
    const nsCString&
    string() const
    {
        return string_;
    }

private:
    void
    Init();

    void
    Assign(const nsCString& _string);

    nsCString string_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestBlobData|
//
namespace mozilla {
namespace dom {
class FileRequestBlobData final
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT FileRequestBlobData();

    MOZ_IMPLICIT FileRequestBlobData(
            PBlobParent* _blobParent,
            PBlobChild* _blobChild)
    {
        Init();
        Assign(_blobParent, _blobChild);
    }

    MOZ_IMPLICIT FileRequestBlobData(const FileRequestBlobData& _o)
    {
        Init();
        Assign(const_cast<PBlobParent*>((_o).blobParent()), const_cast<PBlobChild*>((_o).blobChild()));
    }

    ~FileRequestBlobData();

    void
    operator=(const FileRequestBlobData& _o)
    {
        Assign(const_cast<PBlobParent*>((_o).blobParent()), const_cast<PBlobChild*>((_o).blobChild()));
    }

    bool
    operator==(const FileRequestBlobData& _o) const;

    PBlobParent*&
    blobParent()
    {
        return blobParent_;
    }
    PBlobParent*
    blobParent() const
    {
        return blobParent_;
    }

    PBlobChild*&
    blobChild()
    {
        return blobChild_;
    }
    PBlobChild*
    blobChild() const
    {
        return blobChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PBlobParent* _blobParent,
            PBlobChild* _blobChild);

    PBlobParent* blobParent_;
    PBlobChild* blobChild_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileRequestStringData;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileRequestBlobData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileRequestData|
//
namespace mozilla {
namespace dom {
class FileRequestData final
{
public:
    enum Type {
        T__None,
        TFileRequestStringData = 1,
        TFileRequestBlobData,
        T__Last = TFileRequestBlobData
    };

private:
    typedef mozilla::dom::FileRequestStringData FileRequestStringData;
    typedef mozilla::dom::FileRequestBlobData FileRequestBlobData;
    typedef FileRequestStringData FileRequestStringData__tdef;
    typedef FileRequestBlobData FileRequestBlobData__tdef;

    union Value {
        mozilla::AlignedStorage2<FileRequestStringData> VFileRequestStringData;
        mozilla::AlignedStorage2<FileRequestBlobData> VFileRequestBlobData;
    };

    FileRequestStringData*
    ptr_FileRequestStringData()
    {
        return ((mValue).VFileRequestStringData).addr();
    }
    const FileRequestStringData* const
    constptr_FileRequestStringData() const
    {
        return ((mValue).VFileRequestStringData).addr();
    }
    FileRequestBlobData*
    ptr_FileRequestBlobData()
    {
        return ((mValue).VFileRequestBlobData).addr();
    }
    const FileRequestBlobData* const
    constptr_FileRequestBlobData() const
    {
        return ((mValue).VFileRequestBlobData).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileRequestData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileRequestData(const FileRequestStringData& aOther);

    MOZ_IMPLICIT FileRequestData(const FileRequestBlobData& aOther);

    MOZ_IMPLICIT FileRequestData(const FileRequestData& aOther);

    ~FileRequestData();

    Type
    type() const
    {
        return mType;
    }

    FileRequestData&
    operator=(const FileRequestStringData& aRhs);

    FileRequestData&
    operator=(const FileRequestBlobData& aRhs);

    FileRequestData&
    operator=(const FileRequestData& aRhs);

    bool
    operator==(const FileRequestStringData& aRhs) const;

    bool
    operator==(const FileRequestBlobData& aRhs) const;

    bool
    operator==(const FileRequestData& aRhs) const;

    FileRequestStringData&
    get_FileRequestStringData()
    {
        AssertSanity(TFileRequestStringData);
        return (*(ptr_FileRequestStringData()));
    }
    const FileRequestStringData&
    get_FileRequestStringData() const
    {
        AssertSanity(TFileRequestStringData);
        return (*(constptr_FileRequestStringData()));
    }
    operator FileRequestStringData&()
    {
        return get_FileRequestStringData();
    }
    operator const FileRequestStringData&() const
    {
        return get_FileRequestStringData();
    }

    FileRequestBlobData&
    get_FileRequestBlobData()
    {
        AssertSanity(TFileRequestBlobData);
        return (*(ptr_FileRequestBlobData()));
    }
    const FileRequestBlobData&
    get_FileRequestBlobData() const
    {
        AssertSanity(TFileRequestBlobData);
        return (*(constptr_FileRequestBlobData()));
    }
    operator FileRequestBlobData&()
    {
        return get_FileRequestBlobData();
    }
    operator const FileRequestBlobData&() const
    {
        return get_FileRequestBlobData();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileRequestData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestWriteParams|
//
namespace mozilla {
namespace dom {
class FileRequestWriteParams final
{
private:
    typedef mozilla::dom::FileRequestData FileRequestData;

public:
    MOZ_IMPLICIT FileRequestWriteParams();

    MOZ_IMPLICIT FileRequestWriteParams(
            const uint64_t& _offset,
            const FileRequestData& _data,
            const uint64_t& _dataLength)
    {
        Init();
        Assign(_offset, _data, _dataLength);
    }

    MOZ_IMPLICIT FileRequestWriteParams(const FileRequestWriteParams& _o)
    {
        Init();
        Assign((_o).offset(), (_o).data(), (_o).dataLength());
    }

    ~FileRequestWriteParams();

    void
    operator=(const FileRequestWriteParams& _o)
    {
        Assign((_o).offset(), (_o).data(), (_o).dataLength());
    }

    bool
    operator==(const FileRequestWriteParams& _o) const;

    uint64_t&
    offset()
    {
        return offset_;
    }
    const uint64_t&
    offset() const
    {
        return offset_;
    }

    FileRequestData&
    data()
    {
        return data_;
    }
    const FileRequestData&
    data() const
    {
        return data_;
    }

    uint64_t&
    dataLength()
    {
        return dataLength_;
    }
    const uint64_t&
    dataLength() const
    {
        return dataLength_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _offset,
            const FileRequestData& _data,
            const uint64_t& _dataLength);

    uint64_t offset_;
    FileRequestData data_;
    uint64_t dataLength_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestTruncateParams|
//
namespace mozilla {
namespace dom {
class FileRequestTruncateParams final
{
private:

public:
    MOZ_IMPLICIT FileRequestTruncateParams();

    MOZ_IMPLICIT FileRequestTruncateParams(const uint64_t& _offset)
    {
        Init();
        Assign(_offset);
    }

    MOZ_IMPLICIT FileRequestTruncateParams(const FileRequestTruncateParams& _o)
    {
        Init();
        Assign((_o).offset());
    }

    ~FileRequestTruncateParams();

    void
    operator=(const FileRequestTruncateParams& _o)
    {
        Assign((_o).offset());
    }

    bool
    operator==(const FileRequestTruncateParams& _o) const;

    uint64_t&
    offset()
    {
        return offset_;
    }
    const uint64_t&
    offset() const
    {
        return offset_;
    }

private:
    void
    Init();

    void
    Assign(const uint64_t& _offset);

    uint64_t offset_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestFlushParams|
//
namespace mozilla {
namespace dom {
class FileRequestFlushParams final
{
private:

public:
    MOZ_IMPLICIT FileRequestFlushParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT FileRequestFlushParams(const FileRequestFlushParams& _o)
    {
        Init();
        Assign();
    }

    ~FileRequestFlushParams();

    void
    operator=(const FileRequestFlushParams& _o)
    {
        Assign();
    }

    bool
    operator==(const FileRequestFlushParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileRequestGetFileParams|
//
namespace mozilla {
namespace dom {
class FileRequestGetFileParams final
{
private:

public:
    MOZ_IMPLICIT FileRequestGetFileParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT FileRequestGetFileParams(const FileRequestGetFileParams& _o)
    {
        Init();
        Assign();
    }

    ~FileRequestGetFileParams();

    void
    operator=(const FileRequestGetFileParams& _o)
    {
        Assign();
    }

    bool
    operator==(const FileRequestGetFileParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileRequestGetMetadataParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileRequestReadParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileRequestWriteParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileRequestTruncateParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileRequestFlushParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileRequestGetFileParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileRequestParams|
//
namespace mozilla {
namespace dom {
class FileRequestParams final
{
public:
    enum Type {
        T__None,
        TFileRequestGetMetadataParams = 1,
        TFileRequestReadParams,
        TFileRequestWriteParams,
        TFileRequestTruncateParams,
        TFileRequestFlushParams,
        TFileRequestGetFileParams,
        T__Last = TFileRequestGetFileParams
    };

private:
    typedef mozilla::dom::FileRequestGetMetadataParams FileRequestGetMetadataParams;
    typedef mozilla::dom::FileRequestReadParams FileRequestReadParams;
    typedef mozilla::dom::FileRequestWriteParams FileRequestWriteParams;
    typedef mozilla::dom::FileRequestTruncateParams FileRequestTruncateParams;
    typedef mozilla::dom::FileRequestFlushParams FileRequestFlushParams;
    typedef mozilla::dom::FileRequestGetFileParams FileRequestGetFileParams;
    typedef FileRequestGetMetadataParams FileRequestGetMetadataParams__tdef;
    typedef FileRequestReadParams FileRequestReadParams__tdef;
    typedef FileRequestWriteParams FileRequestWriteParams__tdef;
    typedef FileRequestTruncateParams FileRequestTruncateParams__tdef;
    typedef FileRequestFlushParams FileRequestFlushParams__tdef;
    typedef FileRequestGetFileParams FileRequestGetFileParams__tdef;

    union Value {
        mozilla::AlignedStorage2<FileRequestGetMetadataParams> VFileRequestGetMetadataParams;
        mozilla::AlignedStorage2<FileRequestReadParams> VFileRequestReadParams;
        mozilla::AlignedStorage2<FileRequestWriteParams> VFileRequestWriteParams;
        mozilla::AlignedStorage2<FileRequestTruncateParams> VFileRequestTruncateParams;
        mozilla::AlignedStorage2<FileRequestFlushParams> VFileRequestFlushParams;
        mozilla::AlignedStorage2<FileRequestGetFileParams> VFileRequestGetFileParams;
    };

    FileRequestGetMetadataParams*
    ptr_FileRequestGetMetadataParams()
    {
        return ((mValue).VFileRequestGetMetadataParams).addr();
    }
    const FileRequestGetMetadataParams* const
    constptr_FileRequestGetMetadataParams() const
    {
        return ((mValue).VFileRequestGetMetadataParams).addr();
    }
    FileRequestReadParams*
    ptr_FileRequestReadParams()
    {
        return ((mValue).VFileRequestReadParams).addr();
    }
    const FileRequestReadParams* const
    constptr_FileRequestReadParams() const
    {
        return ((mValue).VFileRequestReadParams).addr();
    }
    FileRequestWriteParams*
    ptr_FileRequestWriteParams()
    {
        return ((mValue).VFileRequestWriteParams).addr();
    }
    const FileRequestWriteParams* const
    constptr_FileRequestWriteParams() const
    {
        return ((mValue).VFileRequestWriteParams).addr();
    }
    FileRequestTruncateParams*
    ptr_FileRequestTruncateParams()
    {
        return ((mValue).VFileRequestTruncateParams).addr();
    }
    const FileRequestTruncateParams* const
    constptr_FileRequestTruncateParams() const
    {
        return ((mValue).VFileRequestTruncateParams).addr();
    }
    FileRequestFlushParams*
    ptr_FileRequestFlushParams()
    {
        return ((mValue).VFileRequestFlushParams).addr();
    }
    const FileRequestFlushParams* const
    constptr_FileRequestFlushParams() const
    {
        return ((mValue).VFileRequestFlushParams).addr();
    }
    FileRequestGetFileParams*
    ptr_FileRequestGetFileParams()
    {
        return ((mValue).VFileRequestGetFileParams).addr();
    }
    const FileRequestGetFileParams* const
    constptr_FileRequestGetFileParams() const
    {
        return ((mValue).VFileRequestGetFileParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileRequestParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileRequestParams(const FileRequestGetMetadataParams& aOther);

    MOZ_IMPLICIT FileRequestParams(const FileRequestReadParams& aOther);

    MOZ_IMPLICIT FileRequestParams(const FileRequestWriteParams& aOther);

    MOZ_IMPLICIT FileRequestParams(const FileRequestTruncateParams& aOther);

    MOZ_IMPLICIT FileRequestParams(const FileRequestFlushParams& aOther);

    MOZ_IMPLICIT FileRequestParams(const FileRequestGetFileParams& aOther);

    MOZ_IMPLICIT FileRequestParams(const FileRequestParams& aOther);

    ~FileRequestParams();

    Type
    type() const
    {
        return mType;
    }

    FileRequestParams&
    operator=(const FileRequestGetMetadataParams& aRhs);

    FileRequestParams&
    operator=(const FileRequestReadParams& aRhs);

    FileRequestParams&
    operator=(const FileRequestWriteParams& aRhs);

    FileRequestParams&
    operator=(const FileRequestTruncateParams& aRhs);

    FileRequestParams&
    operator=(const FileRequestFlushParams& aRhs);

    FileRequestParams&
    operator=(const FileRequestGetFileParams& aRhs);

    FileRequestParams&
    operator=(const FileRequestParams& aRhs);

    bool
    operator==(const FileRequestGetMetadataParams& aRhs) const;

    bool
    operator==(const FileRequestReadParams& aRhs) const;

    bool
    operator==(const FileRequestWriteParams& aRhs) const;

    bool
    operator==(const FileRequestTruncateParams& aRhs) const;

    bool
    operator==(const FileRequestFlushParams& aRhs) const;

    bool
    operator==(const FileRequestGetFileParams& aRhs) const;

    bool
    operator==(const FileRequestParams& aRhs) const;

    FileRequestGetMetadataParams&
    get_FileRequestGetMetadataParams()
    {
        AssertSanity(TFileRequestGetMetadataParams);
        return (*(ptr_FileRequestGetMetadataParams()));
    }
    const FileRequestGetMetadataParams&
    get_FileRequestGetMetadataParams() const
    {
        AssertSanity(TFileRequestGetMetadataParams);
        return (*(constptr_FileRequestGetMetadataParams()));
    }
    operator FileRequestGetMetadataParams&()
    {
        return get_FileRequestGetMetadataParams();
    }
    operator const FileRequestGetMetadataParams&() const
    {
        return get_FileRequestGetMetadataParams();
    }

    FileRequestReadParams&
    get_FileRequestReadParams()
    {
        AssertSanity(TFileRequestReadParams);
        return (*(ptr_FileRequestReadParams()));
    }
    const FileRequestReadParams&
    get_FileRequestReadParams() const
    {
        AssertSanity(TFileRequestReadParams);
        return (*(constptr_FileRequestReadParams()));
    }
    operator FileRequestReadParams&()
    {
        return get_FileRequestReadParams();
    }
    operator const FileRequestReadParams&() const
    {
        return get_FileRequestReadParams();
    }

    FileRequestWriteParams&
    get_FileRequestWriteParams()
    {
        AssertSanity(TFileRequestWriteParams);
        return (*(ptr_FileRequestWriteParams()));
    }
    const FileRequestWriteParams&
    get_FileRequestWriteParams() const
    {
        AssertSanity(TFileRequestWriteParams);
        return (*(constptr_FileRequestWriteParams()));
    }
    operator FileRequestWriteParams&()
    {
        return get_FileRequestWriteParams();
    }
    operator const FileRequestWriteParams&() const
    {
        return get_FileRequestWriteParams();
    }

    FileRequestTruncateParams&
    get_FileRequestTruncateParams()
    {
        AssertSanity(TFileRequestTruncateParams);
        return (*(ptr_FileRequestTruncateParams()));
    }
    const FileRequestTruncateParams&
    get_FileRequestTruncateParams() const
    {
        AssertSanity(TFileRequestTruncateParams);
        return (*(constptr_FileRequestTruncateParams()));
    }
    operator FileRequestTruncateParams&()
    {
        return get_FileRequestTruncateParams();
    }
    operator const FileRequestTruncateParams&() const
    {
        return get_FileRequestTruncateParams();
    }

    FileRequestFlushParams&
    get_FileRequestFlushParams()
    {
        AssertSanity(TFileRequestFlushParams);
        return (*(ptr_FileRequestFlushParams()));
    }
    const FileRequestFlushParams&
    get_FileRequestFlushParams() const
    {
        AssertSanity(TFileRequestFlushParams);
        return (*(constptr_FileRequestFlushParams()));
    }
    operator FileRequestFlushParams&()
    {
        return get_FileRequestFlushParams();
    }
    operator const FileRequestFlushParams&() const
    {
        return get_FileRequestFlushParams();
    }

    FileRequestGetFileParams&
    get_FileRequestGetFileParams()
    {
        AssertSanity(TFileRequestGetFileParams);
        return (*(ptr_FileRequestGetFileParams()));
    }
    const FileRequestGetFileParams&
    get_FileRequestGetFileParams() const
    {
        AssertSanity(TFileRequestGetFileParams);
        return (*(constptr_FileRequestGetFileParams()));
    }
    operator FileRequestGetFileParams&()
    {
        return get_FileRequestGetFileParams();
    }
    operator const FileRequestGetFileParams&() const
    {
        return get_FileRequestGetFileParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBackgroundFileHandleChild and PBackgroundFileHandleParent
//
namespace mozilla {
namespace dom {
namespace PBackgroundFileHandle {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PBackgroundFileHandleStart = PBackgroundFileHandleMsgStart << 16,
    Msg_DeleteMe__ID,
    Msg_Finish__ID,
    Msg_Abort__ID,
    Msg_PBackgroundFileRequestConstructor__ID,
    Reply_PBackgroundFileRequestConstructor__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_Complete__ID,
    PBackgroundFileHandleEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_DeleteMe :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DeleteMe__ID
    };
    MOZ_IMPLICIT Msg_DeleteMe(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Msg_DeleteMe")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DeleteMe(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Finish :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Finish__ID
    };
    MOZ_IMPLICIT Msg_Finish(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Msg_Finish")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Finish(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Abort :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Abort__ID
    };
    MOZ_IMPLICIT Msg_Abort(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Msg_Abort")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Abort(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PBackgroundFileRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PBackgroundFileRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PBackgroundFileRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Msg_PBackgroundFileRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PBackgroundFileRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PBackgroundFileRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PBackgroundFileRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PBackgroundFileRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Reply_PBackgroundFileRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PBackgroundFileRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Complete :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Complete__ID
    };
    MOZ_IMPLICIT Msg_Complete(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundFileHandle::Msg_Complete")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Complete(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PBackgroundFileHandle
} // namespace dom
} // namespace mozilla

#endif // ifndef PBackgroundFileHandle_h
