//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBrowser_h
#define PBrowser_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/EventForwards.h"
#include "mozilla/dom/DOMTypes.h"
#include "mozilla/jsipc/JavaScriptTypes.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/dom/BrowserConfiguration.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NativeKeyBinding|
//
namespace mozilla {
namespace dom {
class NativeKeyBinding final
{
private:
    typedef mozilla::CommandInt CommandInt;

public:
    MOZ_IMPLICIT NativeKeyBinding();

    MOZ_IMPLICIT NativeKeyBinding(
            const nsTArray<CommandInt>& _singleLineCommands,
            const nsTArray<CommandInt>& _multiLineCommands,
            const nsTArray<CommandInt>& _richTextCommands)
    {
        Init();
        Assign(_singleLineCommands, _multiLineCommands, _richTextCommands);
    }

    MOZ_IMPLICIT NativeKeyBinding(const NativeKeyBinding& _o)
    {
        Init();
        Assign((_o).singleLineCommands(), (_o).multiLineCommands(), (_o).richTextCommands());
    }

    ~NativeKeyBinding();

    void
    operator=(const NativeKeyBinding& _o)
    {
        Assign((_o).singleLineCommands(), (_o).multiLineCommands(), (_o).richTextCommands());
    }

    bool
    operator==(const NativeKeyBinding& _o) const;

    nsTArray<CommandInt>&
    singleLineCommands()
    {
        return singleLineCommands_;
    }
    const nsTArray<CommandInt>&
    singleLineCommands() const
    {
        return singleLineCommands_;
    }

    nsTArray<CommandInt>&
    multiLineCommands()
    {
        return multiLineCommands_;
    }
    const nsTArray<CommandInt>&
    multiLineCommands() const
    {
        return multiLineCommands_;
    }

    nsTArray<CommandInt>&
    richTextCommands()
    {
        return richTextCommands_;
    }
    const nsTArray<CommandInt>&
    richTextCommands() const
    {
        return richTextCommands_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<CommandInt>& _singleLineCommands,
            const nsTArray<CommandInt>& _multiLineCommands,
            const nsTArray<CommandInt>& _richTextCommands);

    nsTArray<CommandInt> singleLineCommands_;
    nsTArray<CommandInt> multiLineCommands_;
    nsTArray<CommandInt> richTextCommands_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class NativeKeyBinding;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeNativeKeyBinding|
//
namespace mozilla {
namespace dom {
class MaybeNativeKeyBinding final
{
public:
    enum Type {
        T__None,
        TNativeKeyBinding = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::dom::NativeKeyBinding NativeKeyBinding;
    typedef mozilla::void_t void_t;
    typedef NativeKeyBinding NativeKeyBinding__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<NativeKeyBinding> VNativeKeyBinding;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    NativeKeyBinding*
    ptr_NativeKeyBinding()
    {
        return ((mValue).VNativeKeyBinding).addr();
    }
    const NativeKeyBinding* const
    constptr_NativeKeyBinding() const
    {
        return ((mValue).VNativeKeyBinding).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t* const
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeNativeKeyBinding() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeNativeKeyBinding(const NativeKeyBinding& aOther);

    MOZ_IMPLICIT MaybeNativeKeyBinding(const void_t& aOther);

    MOZ_IMPLICIT MaybeNativeKeyBinding(const MaybeNativeKeyBinding& aOther);

    ~MaybeNativeKeyBinding();

    Type
    type() const
    {
        return mType;
    }

    MaybeNativeKeyBinding&
    operator=(const NativeKeyBinding& aRhs);

    MaybeNativeKeyBinding&
    operator=(const void_t& aRhs);

    MaybeNativeKeyBinding&
    operator=(const MaybeNativeKeyBinding& aRhs);

    bool
    operator==(const NativeKeyBinding& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const MaybeNativeKeyBinding& aRhs) const;

    NativeKeyBinding&
    get_NativeKeyBinding()
    {
        AssertSanity(TNativeKeyBinding);
        return (*(ptr_NativeKeyBinding()));
    }
    const NativeKeyBinding&
    get_NativeKeyBinding() const
    {
        AssertSanity(TNativeKeyBinding);
        return (*(constptr_NativeKeyBinding()));
    }
    operator NativeKeyBinding&()
    {
        return get_NativeKeyBinding();
    }
    operator const NativeKeyBinding&() const
    {
        return get_NativeKeyBinding();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ShowInfo|
//
namespace mozilla {
namespace dom {
class ShowInfo final
{
private:

public:
    MOZ_IMPLICIT ShowInfo();

    MOZ_IMPLICIT ShowInfo(
            const nsString& _name,
            const bool& _fullscreenAllowed,
            const bool& _isPrivate,
            const bool& _fakeShowInfo,
            const float& _dpi,
            const double& _defaultScale)
    {
        Init();
        Assign(_name, _fullscreenAllowed, _isPrivate, _fakeShowInfo, _dpi, _defaultScale);
    }

    MOZ_IMPLICIT ShowInfo(const ShowInfo& _o)
    {
        Init();
        Assign((_o).name(), (_o).fullscreenAllowed(), (_o).isPrivate(), (_o).fakeShowInfo(), (_o).dpi(), (_o).defaultScale());
    }

    ~ShowInfo();

    void
    operator=(const ShowInfo& _o)
    {
        Assign((_o).name(), (_o).fullscreenAllowed(), (_o).isPrivate(), (_o).fakeShowInfo(), (_o).dpi(), (_o).defaultScale());
    }

    bool
    operator==(const ShowInfo& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    bool&
    fullscreenAllowed()
    {
        return fullscreenAllowed_;
    }
    const bool&
    fullscreenAllowed() const
    {
        return fullscreenAllowed_;
    }

    bool&
    isPrivate()
    {
        return isPrivate_;
    }
    const bool&
    isPrivate() const
    {
        return isPrivate_;
    }

    bool&
    fakeShowInfo()
    {
        return fakeShowInfo_;
    }
    const bool&
    fakeShowInfo() const
    {
        return fakeShowInfo_;
    }

    float&
    dpi()
    {
        return dpi_;
    }
    const float&
    dpi() const
    {
        return dpi_;
    }

    double&
    defaultScale()
    {
        return defaultScale_;
    }
    const double&
    defaultScale() const
    {
        return defaultScale_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _name,
            const bool& _fullscreenAllowed,
            const bool& _isPrivate,
            const bool& _fakeShowInfo,
            const float& _dpi,
            const double& _defaultScale);

    nsString name_;
    bool fullscreenAllowed_;
    bool isPrivate_;
    bool fakeShowInfo_;
    float dpi_;
    double defaultScale_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBrowserChild and PBrowserParent
//
namespace mozilla {
namespace dom {
namespace PBrowser {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PBrowserStart = PBrowserMsgStart << 16,
    Msg_AsyncMessage__ID,
    Msg_PRenderFrameConstructor__ID,
    Reply_PRenderFrameConstructor__ID,
    Msg_PDocAccessibleConstructor__ID,
    Reply_PDocAccessibleConstructor__ID,
    Msg_PPluginWidgetConstructor__ID,
    Reply_PPluginWidgetConstructor__ID,
    Msg_GetWidgetNativeData__ID,
    Reply_GetWidgetNativeData__ID,
    Msg_SetNativeChildOfShareableWindow__ID,
    Msg_DispatchFocusToTopLevelWindow__ID,
    Reply_DispatchFocusToTopLevelWindow__ID,
    Msg_MoveFocus__ID,
    Msg_Event__ID,
    Msg_SyncMessage__ID,
    Reply_SyncMessage__ID,
    Msg_RpcMessage__ID,
    Reply_RpcMessage__ID,
    Msg_NotifyIMEFocus__ID,
    Reply_NotifyIMEFocus__ID,
    Msg_NotifyIMETextChange__ID,
    Msg_NotifyIMECompositionUpdate__ID,
    Msg_NotifyIMESelection__ID,
    Msg_UpdateContentCache__ID,
    Msg_NotifyIMEMouseButtonEvent__ID,
    Reply_NotifyIMEMouseButtonEvent__ID,
    Msg_NotifyIMEPositionChange__ID,
    Msg_RequestIMEToCommitComposition__ID,
    Reply_RequestIMEToCommitComposition__ID,
    Msg_OnEventNeedingAckHandled__ID,
    Msg_StartPluginIME__ID,
    Reply_StartPluginIME__ID,
    Msg_SetPluginFocused__ID,
    Msg_RequestFocus__ID,
    Msg_EnableDisableCommands__ID,
    Msg_GetInputContext__ID,
    Reply_GetInputContext__ID,
    Msg_SetInputContext__ID,
    Msg_IsParentWindowMainWidgetVisible__ID,
    Reply_IsParentWindowMainWidgetVisible__ID,
    Msg_GetDPI__ID,
    Reply_GetDPI__ID,
    Msg_GetDefaultScale__ID,
    Reply_GetDefaultScale__ID,
    Msg_GetMaxTouchPoints__ID,
    Reply_GetMaxTouchPoints__ID,
    Msg_SetCursor__ID,
    Msg_SetCustomCursor__ID,
    Msg_SetStatus__ID,
    Msg_ShowTooltip__ID,
    Msg_HideTooltip__ID,
    Msg_PColorPickerConstructor__ID,
    Reply_PColorPickerConstructor__ID,
    Msg_PFilePickerConstructor__ID,
    Reply_PFilePickerConstructor__ID,
    Msg_PIndexedDBPermissionRequestConstructor__ID,
    Reply_PIndexedDBPermissionRequestConstructor__ID,
    Msg_BrowserFrameOpenWindow__ID,
    Reply_BrowserFrameOpenWindow__ID,
    Msg_ZoomToRect__ID,
    Msg_ContentReceivedInputBlock__ID,
    Msg_SetTargetAPZC__ID,
    Msg_SetAllowedTouchBehavior__ID,
    Msg_UpdateZoomConstraints__ID,
    Msg_RespondStartSwipeEvent__ID,
    Msg_AsyncAuthPrompt__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_ReplyKeyEvent__ID,
    Msg_DispatchAfterKeyboardEvent__ID,
    Msg_RequestNativeKeyBindings__ID,
    Reply_RequestNativeKeyBindings__ID,
    Msg_SynthesizeNativeKeyEvent__ID,
    Msg_SynthesizeNativeMouseEvent__ID,
    Msg_SynthesizeNativeMouseMove__ID,
    Msg_SynthesizeNativeMouseScrollEvent__ID,
    Msg_SynthesizeNativeTouchPoint__ID,
    Msg_SynthesizeNativeTouchTap__ID,
    Msg_ClearNativeTouchSequence__ID,
    Msg_NativeSynthesisResponse__ID,
    Msg_RemotePaintIsReady__ID,
    Msg_GetRenderFrameInfo__ID,
    Reply_GetRenderFrameInfo__ID,
    Msg_SetDimensions__ID,
    Msg_DispatchWheelEvent__ID,
    Reply_DispatchWheelEvent__ID,
    Msg_DispatchMouseEvent__ID,
    Reply_DispatchMouseEvent__ID,
    Msg_DispatchKeyboardEvent__ID,
    Reply_DispatchKeyboardEvent__ID,
    Msg_StartScrollbarDrag__ID,
    Msg_InvokeDragSession__ID,
    Msg_AudioChannelActivityNotification__ID,
    Msg_Show__ID,
    Msg_LoadURL__ID,
    Msg_OpenURI__ID,
    Msg_CacheFileDescriptor__ID,
    Msg_UpdateDimensions__ID,
    Msg_UpdateFrame__ID,
    Msg_RequestFlingSnap__ID,
    Msg_AcknowledgeScrollUpdate__ID,
    Msg_HandleDoubleTap__ID,
    Msg_HandleSingleTap__ID,
    Msg_HandleLongTap__ID,
    Msg_NotifyAPZStateChange__ID,
    Msg_NotifyFlushComplete__ID,
    Msg_Activate__ID,
    Msg_Deactivate__ID,
    Msg_ParentActivated__ID,
    Msg_StopIMEStateManagement__ID,
    Msg_MenuKeyboardListenerInstalled__ID,
    Msg_MouseEvent__ID,
    Msg_RealMouseMoveEvent__ID,
    Msg_SynthMouseMoveEvent__ID,
    Msg_RealMouseButtonEvent__ID,
    Msg_RealKeyEvent__ID,
    Msg_MouseWheelEvent__ID,
    Msg_RealTouchEvent__ID,
    Msg_RealTouchMoveEvent__ID,
    Msg_RealDragEvent__ID,
    Msg_KeyEvent__ID,
    Msg_MouseScrollTestEvent__ID,
    Msg_CompositionEvent__ID,
    Msg_SelectionEvent__ID,
    Msg_ActivateFrameEvent__ID,
    Msg_LoadRemoteScript__ID,
    Msg_PDocumentRendererConstructor__ID,
    Reply_PDocumentRendererConstructor__ID,
    Msg_Destroy__ID,
    Msg_SetUpdateHitRegion__ID,
    Msg_SetDocShellIsActive__ID,
    Msg_SuppressDisplayport__ID,
    Msg_NavigateByKey__ID,
    Msg_RequestNotifyAfterRemotePaint__ID,
    Msg_UIResolutionChanged__ID,
    Msg_ThemeChanged__ID,
    Msg_AppOfflineStatus__ID,
    Msg_SwappedWithOtherRemoteLoader__ID,
    Msg_HandleAccessKey__ID,
    PBrowserEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_AsyncMessage :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AsyncMessage__ID
    };
    MOZ_IMPLICIT Msg_AsyncMessage(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_AsyncMessage")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AsyncMessage(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PRenderFrameConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PRenderFrameConstructor__ID
    };
    MOZ_IMPLICIT Msg_PRenderFrameConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_PRenderFrameConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PRenderFrameConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PRenderFrameConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PRenderFrameConstructor__ID
    };
    MOZ_IMPLICIT Reply_PRenderFrameConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_PRenderFrameConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PRenderFrameConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PDocAccessibleConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PDocAccessibleConstructor__ID
    };
    MOZ_IMPLICIT Msg_PDocAccessibleConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_PDocAccessibleConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PDocAccessibleConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PDocAccessibleConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PDocAccessibleConstructor__ID
    };
    MOZ_IMPLICIT Reply_PDocAccessibleConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_PDocAccessibleConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PDocAccessibleConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PPluginWidgetConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PPluginWidgetConstructor__ID
    };
    MOZ_IMPLICIT Msg_PPluginWidgetConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_PPluginWidgetConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PPluginWidgetConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PPluginWidgetConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PPluginWidgetConstructor__ID
    };
    MOZ_IMPLICIT Reply_PPluginWidgetConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_PPluginWidgetConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PPluginWidgetConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetWidgetNativeData :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetWidgetNativeData__ID
    };
    MOZ_IMPLICIT Msg_GetWidgetNativeData(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_GetWidgetNativeData")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetWidgetNativeData(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetWidgetNativeData :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetWidgetNativeData__ID
    };
    MOZ_IMPLICIT Reply_GetWidgetNativeData(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_GetWidgetNativeData")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetWidgetNativeData(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetNativeChildOfShareableWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetNativeChildOfShareableWindow__ID
    };
    MOZ_IMPLICIT Msg_SetNativeChildOfShareableWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetNativeChildOfShareableWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetNativeChildOfShareableWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DispatchFocusToTopLevelWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DispatchFocusToTopLevelWindow__ID
    };
    MOZ_IMPLICIT Msg_DispatchFocusToTopLevelWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_DispatchFocusToTopLevelWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DispatchFocusToTopLevelWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_DispatchFocusToTopLevelWindow :
    public IPC::Message
{
public:
    enum {
        ID = Reply_DispatchFocusToTopLevelWindow__ID
    };
    MOZ_IMPLICIT Reply_DispatchFocusToTopLevelWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_DispatchFocusToTopLevelWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_DispatchFocusToTopLevelWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_MoveFocus :
    public IPC::Message
{
public:
    enum {
        ID = Msg_MoveFocus__ID
    };
    MOZ_IMPLICIT Msg_MoveFocus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_MoveFocus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_MoveFocus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Event :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Event__ID
    };
    MOZ_IMPLICIT Msg_Event(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_Event")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Event(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SyncMessage :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SyncMessage__ID
    };
    MOZ_IMPLICIT Msg_SyncMessage(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SyncMessage")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SyncMessage(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_SyncMessage :
    public IPC::Message
{
public:
    enum {
        ID = Reply_SyncMessage__ID
    };
    MOZ_IMPLICIT Reply_SyncMessage(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_SyncMessage")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_SyncMessage(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RpcMessage :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RpcMessage__ID
    };
    MOZ_IMPLICIT Msg_RpcMessage(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Msg_RpcMessage")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RpcMessage(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_RpcMessage :
    public IPC::Message
{
public:
    enum {
        ID = Reply_RpcMessage__ID
    };
    MOZ_IMPLICIT Reply_RpcMessage(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Reply_RpcMessage")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_RpcMessage(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyIMEFocus :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyIMEFocus__ID
    };
    MOZ_IMPLICIT Msg_NotifyIMEFocus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_NotifyIMEFocus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyIMEFocus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NotifyIMEFocus :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NotifyIMEFocus__ID
    };
    MOZ_IMPLICIT Reply_NotifyIMEFocus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Reply_NotifyIMEFocus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NotifyIMEFocus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyIMETextChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyIMETextChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyIMETextChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_NotifyIMETextChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyIMETextChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyIMECompositionUpdate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyIMECompositionUpdate__ID
    };
    MOZ_IMPLICIT Msg_NotifyIMECompositionUpdate(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_NotifyIMECompositionUpdate")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyIMECompositionUpdate(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyIMESelection :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyIMESelection__ID
    };
    MOZ_IMPLICIT Msg_NotifyIMESelection(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_NotifyIMESelection")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyIMESelection(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UpdateContentCache :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UpdateContentCache__ID
    };
    MOZ_IMPLICIT Msg_UpdateContentCache(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_UpdateContentCache")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UpdateContentCache(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyIMEMouseButtonEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyIMEMouseButtonEvent__ID
    };
    MOZ_IMPLICIT Msg_NotifyIMEMouseButtonEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_NotifyIMEMouseButtonEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyIMEMouseButtonEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NotifyIMEMouseButtonEvent :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NotifyIMEMouseButtonEvent__ID
    };
    MOZ_IMPLICIT Reply_NotifyIMEMouseButtonEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Reply_NotifyIMEMouseButtonEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NotifyIMEMouseButtonEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyIMEPositionChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyIMEPositionChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyIMEPositionChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_NotifyIMEPositionChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyIMEPositionChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RequestIMEToCommitComposition :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RequestIMEToCommitComposition__ID
    };
    MOZ_IMPLICIT Msg_RequestIMEToCommitComposition(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_RequestIMEToCommitComposition")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RequestIMEToCommitComposition(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_RequestIMEToCommitComposition :
    public IPC::Message
{
public:
    enum {
        ID = Reply_RequestIMEToCommitComposition__ID
    };
    MOZ_IMPLICIT Reply_RequestIMEToCommitComposition(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Reply_RequestIMEToCommitComposition")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_RequestIMEToCommitComposition(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_OnEventNeedingAckHandled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_OnEventNeedingAckHandled__ID
    };
    MOZ_IMPLICIT Msg_OnEventNeedingAckHandled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_OnEventNeedingAckHandled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_OnEventNeedingAckHandled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_StartPluginIME :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StartPluginIME__ID
    };
    MOZ_IMPLICIT Msg_StartPluginIME(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_StartPluginIME")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_StartPluginIME(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_StartPluginIME :
    public IPC::Message
{
public:
    enum {
        ID = Reply_StartPluginIME__ID
    };
    MOZ_IMPLICIT Reply_StartPluginIME(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Reply_StartPluginIME")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_StartPluginIME(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetPluginFocused :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetPluginFocused__ID
    };
    MOZ_IMPLICIT Msg_SetPluginFocused(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_SetPluginFocused")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetPluginFocused(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RequestFocus :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RequestFocus__ID
    };
    MOZ_IMPLICIT Msg_RequestFocus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RequestFocus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RequestFocus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableDisableCommands :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableDisableCommands__ID
    };
    MOZ_IMPLICIT Msg_EnableDisableCommands(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_EnableDisableCommands")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableDisableCommands(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetInputContext :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetInputContext__ID
    };
    MOZ_IMPLICIT Msg_GetInputContext(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_GetInputContext")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetInputContext(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetInputContext :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetInputContext__ID
    };
    MOZ_IMPLICIT Reply_GetInputContext(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Reply_GetInputContext")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetInputContext(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetInputContext :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetInputContext__ID
    };
    MOZ_IMPLICIT Msg_SetInputContext(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PBrowser::Msg_SetInputContext")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetInputContext(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_IsParentWindowMainWidgetVisible :
    public IPC::Message
{
public:
    enum {
        ID = Msg_IsParentWindowMainWidgetVisible__ID
    };
    MOZ_IMPLICIT Msg_IsParentWindowMainWidgetVisible(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_IsParentWindowMainWidgetVisible")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_IsParentWindowMainWidgetVisible(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_IsParentWindowMainWidgetVisible :
    public IPC::Message
{
public:
    enum {
        ID = Reply_IsParentWindowMainWidgetVisible__ID
    };
    MOZ_IMPLICIT Reply_IsParentWindowMainWidgetVisible(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_IsParentWindowMainWidgetVisible")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_IsParentWindowMainWidgetVisible(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetDPI :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetDPI__ID
    };
    MOZ_IMPLICIT Msg_GetDPI(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_GetDPI")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetDPI(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetDPI :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetDPI__ID
    };
    MOZ_IMPLICIT Reply_GetDPI(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_GetDPI")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetDPI(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetDefaultScale :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetDefaultScale__ID
    };
    MOZ_IMPLICIT Msg_GetDefaultScale(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_GetDefaultScale")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetDefaultScale(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetDefaultScale :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetDefaultScale__ID
    };
    MOZ_IMPLICIT Reply_GetDefaultScale(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_GetDefaultScale")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetDefaultScale(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetMaxTouchPoints :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetMaxTouchPoints__ID
    };
    MOZ_IMPLICIT Msg_GetMaxTouchPoints(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_GetMaxTouchPoints")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetMaxTouchPoints(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetMaxTouchPoints :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetMaxTouchPoints__ID
    };
    MOZ_IMPLICIT Reply_GetMaxTouchPoints(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_GetMaxTouchPoints")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetMaxTouchPoints(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetCursor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetCursor__ID
    };
    MOZ_IMPLICIT Msg_SetCursor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetCursor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetCursor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetCustomCursor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetCustomCursor__ID
    };
    MOZ_IMPLICIT Msg_SetCustomCursor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetCustomCursor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetCustomCursor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetStatus :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetStatus__ID
    };
    MOZ_IMPLICIT Msg_SetStatus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetStatus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetStatus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ShowTooltip :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ShowTooltip__ID
    };
    MOZ_IMPLICIT Msg_ShowTooltip(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ShowTooltip")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ShowTooltip(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_HideTooltip :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HideTooltip__ID
    };
    MOZ_IMPLICIT Msg_HideTooltip(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_HideTooltip")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_HideTooltip(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PColorPickerConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PColorPickerConstructor__ID
    };
    MOZ_IMPLICIT Msg_PColorPickerConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_PColorPickerConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PColorPickerConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PColorPickerConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PColorPickerConstructor__ID
    };
    MOZ_IMPLICIT Reply_PColorPickerConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_PColorPickerConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PColorPickerConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PFilePickerConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PFilePickerConstructor__ID
    };
    MOZ_IMPLICIT Msg_PFilePickerConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_PFilePickerConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PFilePickerConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PFilePickerConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PFilePickerConstructor__ID
    };
    MOZ_IMPLICIT Reply_PFilePickerConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_PFilePickerConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PFilePickerConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PIndexedDBPermissionRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PIndexedDBPermissionRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PIndexedDBPermissionRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_PIndexedDBPermissionRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PIndexedDBPermissionRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PIndexedDBPermissionRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PIndexedDBPermissionRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PIndexedDBPermissionRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_PIndexedDBPermissionRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PIndexedDBPermissionRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_BrowserFrameOpenWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_BrowserFrameOpenWindow__ID
    };
    MOZ_IMPLICIT Msg_BrowserFrameOpenWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_BrowserFrameOpenWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_BrowserFrameOpenWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_BrowserFrameOpenWindow :
    public IPC::Message
{
public:
    enum {
        ID = Reply_BrowserFrameOpenWindow__ID
    };
    MOZ_IMPLICIT Reply_BrowserFrameOpenWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_BrowserFrameOpenWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_BrowserFrameOpenWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ZoomToRect :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ZoomToRect__ID
    };
    MOZ_IMPLICIT Msg_ZoomToRect(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ZoomToRect")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ZoomToRect(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ContentReceivedInputBlock :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ContentReceivedInputBlock__ID
    };
    MOZ_IMPLICIT Msg_ContentReceivedInputBlock(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ContentReceivedInputBlock")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ContentReceivedInputBlock(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetTargetAPZC :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetTargetAPZC__ID
    };
    MOZ_IMPLICIT Msg_SetTargetAPZC(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetTargetAPZC")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetTargetAPZC(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetAllowedTouchBehavior :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetAllowedTouchBehavior__ID
    };
    MOZ_IMPLICIT Msg_SetAllowedTouchBehavior(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetAllowedTouchBehavior")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetAllowedTouchBehavior(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UpdateZoomConstraints :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UpdateZoomConstraints__ID
    };
    MOZ_IMPLICIT Msg_UpdateZoomConstraints(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_UpdateZoomConstraints")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UpdateZoomConstraints(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RespondStartSwipeEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RespondStartSwipeEvent__ID
    };
    MOZ_IMPLICIT Msg_RespondStartSwipeEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RespondStartSwipeEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RespondStartSwipeEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AsyncAuthPrompt :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AsyncAuthPrompt__ID
    };
    MOZ_IMPLICIT Msg_AsyncAuthPrompt(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_AsyncAuthPrompt")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AsyncAuthPrompt(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ReplyKeyEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ReplyKeyEvent__ID
    };
    MOZ_IMPLICIT Msg_ReplyKeyEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ReplyKeyEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ReplyKeyEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DispatchAfterKeyboardEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DispatchAfterKeyboardEvent__ID
    };
    MOZ_IMPLICIT Msg_DispatchAfterKeyboardEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_DispatchAfterKeyboardEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DispatchAfterKeyboardEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RequestNativeKeyBindings :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RequestNativeKeyBindings__ID
    };
    MOZ_IMPLICIT Msg_RequestNativeKeyBindings(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RequestNativeKeyBindings")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RequestNativeKeyBindings(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_RequestNativeKeyBindings :
    public IPC::Message
{
public:
    enum {
        ID = Reply_RequestNativeKeyBindings__ID
    };
    MOZ_IMPLICIT Reply_RequestNativeKeyBindings(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_RequestNativeKeyBindings")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_RequestNativeKeyBindings(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SynthesizeNativeKeyEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SynthesizeNativeKeyEvent__ID
    };
    MOZ_IMPLICIT Msg_SynthesizeNativeKeyEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SynthesizeNativeKeyEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SynthesizeNativeKeyEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SynthesizeNativeMouseEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SynthesizeNativeMouseEvent__ID
    };
    MOZ_IMPLICIT Msg_SynthesizeNativeMouseEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SynthesizeNativeMouseEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SynthesizeNativeMouseEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SynthesizeNativeMouseMove :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SynthesizeNativeMouseMove__ID
    };
    MOZ_IMPLICIT Msg_SynthesizeNativeMouseMove(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SynthesizeNativeMouseMove")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SynthesizeNativeMouseMove(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SynthesizeNativeMouseScrollEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SynthesizeNativeMouseScrollEvent__ID
    };
    MOZ_IMPLICIT Msg_SynthesizeNativeMouseScrollEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SynthesizeNativeMouseScrollEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SynthesizeNativeMouseScrollEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SynthesizeNativeTouchPoint :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SynthesizeNativeTouchPoint__ID
    };
    MOZ_IMPLICIT Msg_SynthesizeNativeTouchPoint(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SynthesizeNativeTouchPoint")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SynthesizeNativeTouchPoint(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SynthesizeNativeTouchTap :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SynthesizeNativeTouchTap__ID
    };
    MOZ_IMPLICIT Msg_SynthesizeNativeTouchTap(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SynthesizeNativeTouchTap")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SynthesizeNativeTouchTap(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ClearNativeTouchSequence :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ClearNativeTouchSequence__ID
    };
    MOZ_IMPLICIT Msg_ClearNativeTouchSequence(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ClearNativeTouchSequence")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ClearNativeTouchSequence(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NativeSynthesisResponse :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NativeSynthesisResponse__ID
    };
    MOZ_IMPLICIT Msg_NativeSynthesisResponse(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_NativeSynthesisResponse")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NativeSynthesisResponse(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RemotePaintIsReady :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RemotePaintIsReady__ID
    };
    MOZ_IMPLICIT Msg_RemotePaintIsReady(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RemotePaintIsReady")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RemotePaintIsReady(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetRenderFrameInfo :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetRenderFrameInfo__ID
    };
    MOZ_IMPLICIT Msg_GetRenderFrameInfo(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_GetRenderFrameInfo")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetRenderFrameInfo(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetRenderFrameInfo :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetRenderFrameInfo__ID
    };
    MOZ_IMPLICIT Reply_GetRenderFrameInfo(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_GetRenderFrameInfo")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetRenderFrameInfo(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetDimensions :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetDimensions__ID
    };
    MOZ_IMPLICIT Msg_SetDimensions(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetDimensions")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetDimensions(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DispatchWheelEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DispatchWheelEvent__ID
    };
    MOZ_IMPLICIT Msg_DispatchWheelEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Msg_DispatchWheelEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DispatchWheelEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_DispatchWheelEvent :
    public IPC::Message
{
public:
    enum {
        ID = Reply_DispatchWheelEvent__ID
    };
    MOZ_IMPLICIT Reply_DispatchWheelEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Reply_DispatchWheelEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_DispatchWheelEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DispatchMouseEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DispatchMouseEvent__ID
    };
    MOZ_IMPLICIT Msg_DispatchMouseEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Msg_DispatchMouseEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DispatchMouseEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_DispatchMouseEvent :
    public IPC::Message
{
public:
    enum {
        ID = Reply_DispatchMouseEvent__ID
    };
    MOZ_IMPLICIT Reply_DispatchMouseEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Reply_DispatchMouseEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_DispatchMouseEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DispatchKeyboardEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DispatchKeyboardEvent__ID
    };
    MOZ_IMPLICIT Msg_DispatchKeyboardEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Msg_DispatchKeyboardEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DispatchKeyboardEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_DispatchKeyboardEvent :
    public IPC::Message
{
public:
    enum {
        ID = Reply_DispatchKeyboardEvent__ID
    };
    MOZ_IMPLICIT Reply_DispatchKeyboardEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_HIGH, COMPRESSION_NONE, "PBrowser::Reply_DispatchKeyboardEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_DispatchKeyboardEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_StartScrollbarDrag :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StartScrollbarDrag__ID
    };
    MOZ_IMPLICIT Msg_StartScrollbarDrag(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_StartScrollbarDrag")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_StartScrollbarDrag(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_InvokeDragSession :
    public IPC::Message
{
public:
    enum {
        ID = Msg_InvokeDragSession__ID
    };
    MOZ_IMPLICIT Msg_InvokeDragSession(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_InvokeDragSession")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_InvokeDragSession(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AudioChannelActivityNotification :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AudioChannelActivityNotification__ID
    };
    MOZ_IMPLICIT Msg_AudioChannelActivityNotification(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_AudioChannelActivityNotification")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AudioChannelActivityNotification(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Show :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Show__ID
    };
    MOZ_IMPLICIT Msg_Show(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_Show")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Show(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_LoadURL :
    public IPC::Message
{
public:
    enum {
        ID = Msg_LoadURL__ID
    };
    MOZ_IMPLICIT Msg_LoadURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_LoadURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_LoadURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_OpenURI :
    public IPC::Message
{
public:
    enum {
        ID = Msg_OpenURI__ID
    };
    MOZ_IMPLICIT Msg_OpenURI(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_OpenURI")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_OpenURI(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CacheFileDescriptor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CacheFileDescriptor__ID
    };
    MOZ_IMPLICIT Msg_CacheFileDescriptor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_CacheFileDescriptor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CacheFileDescriptor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UpdateDimensions :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UpdateDimensions__ID
    };
    MOZ_IMPLICIT Msg_UpdateDimensions(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_ALL, "PBrowser::Msg_UpdateDimensions")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UpdateDimensions(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UpdateFrame :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UpdateFrame__ID
    };
    MOZ_IMPLICIT Msg_UpdateFrame(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_UpdateFrame")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UpdateFrame(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RequestFlingSnap :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RequestFlingSnap__ID
    };
    MOZ_IMPLICIT Msg_RequestFlingSnap(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RequestFlingSnap")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RequestFlingSnap(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AcknowledgeScrollUpdate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AcknowledgeScrollUpdate__ID
    };
    MOZ_IMPLICIT Msg_AcknowledgeScrollUpdate(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_AcknowledgeScrollUpdate")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AcknowledgeScrollUpdate(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_HandleDoubleTap :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HandleDoubleTap__ID
    };
    MOZ_IMPLICIT Msg_HandleDoubleTap(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_HandleDoubleTap")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_HandleDoubleTap(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_HandleSingleTap :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HandleSingleTap__ID
    };
    MOZ_IMPLICIT Msg_HandleSingleTap(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_HandleSingleTap")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_HandleSingleTap(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_HandleLongTap :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HandleLongTap__ID
    };
    MOZ_IMPLICIT Msg_HandleLongTap(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_HandleLongTap")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_HandleLongTap(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyAPZStateChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyAPZStateChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyAPZStateChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_NotifyAPZStateChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyAPZStateChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyFlushComplete :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyFlushComplete__ID
    };
    MOZ_IMPLICIT Msg_NotifyFlushComplete(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_NotifyFlushComplete")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyFlushComplete(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Activate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Activate__ID
    };
    MOZ_IMPLICIT Msg_Activate(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_Activate")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Activate(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Deactivate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Deactivate__ID
    };
    MOZ_IMPLICIT Msg_Deactivate(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_Deactivate")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Deactivate(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ParentActivated :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ParentActivated__ID
    };
    MOZ_IMPLICIT Msg_ParentActivated(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ParentActivated")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ParentActivated(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_StopIMEStateManagement :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StopIMEStateManagement__ID
    };
    MOZ_IMPLICIT Msg_StopIMEStateManagement(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_StopIMEStateManagement")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_StopIMEStateManagement(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_MenuKeyboardListenerInstalled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_MenuKeyboardListenerInstalled__ID
    };
    MOZ_IMPLICIT Msg_MenuKeyboardListenerInstalled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_MenuKeyboardListenerInstalled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_MenuKeyboardListenerInstalled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_MouseEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_MouseEvent__ID
    };
    MOZ_IMPLICIT Msg_MouseEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_MouseEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_MouseEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RealMouseMoveEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RealMouseMoveEvent__ID
    };
    MOZ_IMPLICIT Msg_RealMouseMoveEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_ENABLED, "PBrowser::Msg_RealMouseMoveEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RealMouseMoveEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SynthMouseMoveEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SynthMouseMoveEvent__ID
    };
    MOZ_IMPLICIT Msg_SynthMouseMoveEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SynthMouseMoveEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SynthMouseMoveEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RealMouseButtonEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RealMouseButtonEvent__ID
    };
    MOZ_IMPLICIT Msg_RealMouseButtonEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RealMouseButtonEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RealMouseButtonEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RealKeyEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RealKeyEvent__ID
    };
    MOZ_IMPLICIT Msg_RealKeyEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RealKeyEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RealKeyEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_MouseWheelEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_MouseWheelEvent__ID
    };
    MOZ_IMPLICIT Msg_MouseWheelEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_MouseWheelEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_MouseWheelEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RealTouchEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RealTouchEvent__ID
    };
    MOZ_IMPLICIT Msg_RealTouchEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RealTouchEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RealTouchEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RealTouchMoveEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RealTouchMoveEvent__ID
    };
    MOZ_IMPLICIT Msg_RealTouchMoveEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RealTouchMoveEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RealTouchMoveEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RealDragEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RealDragEvent__ID
    };
    MOZ_IMPLICIT Msg_RealDragEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RealDragEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RealDragEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_KeyEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_KeyEvent__ID
    };
    MOZ_IMPLICIT Msg_KeyEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_KeyEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_KeyEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_MouseScrollTestEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_MouseScrollTestEvent__ID
    };
    MOZ_IMPLICIT Msg_MouseScrollTestEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_MouseScrollTestEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_MouseScrollTestEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CompositionEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CompositionEvent__ID
    };
    MOZ_IMPLICIT Msg_CompositionEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_CompositionEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CompositionEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SelectionEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SelectionEvent__ID
    };
    MOZ_IMPLICIT Msg_SelectionEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SelectionEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SelectionEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ActivateFrameEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ActivateFrameEvent__ID
    };
    MOZ_IMPLICIT Msg_ActivateFrameEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ActivateFrameEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ActivateFrameEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_LoadRemoteScript :
    public IPC::Message
{
public:
    enum {
        ID = Msg_LoadRemoteScript__ID
    };
    MOZ_IMPLICIT Msg_LoadRemoteScript(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_LoadRemoteScript")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_LoadRemoteScript(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PDocumentRendererConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PDocumentRendererConstructor__ID
    };
    MOZ_IMPLICIT Msg_PDocumentRendererConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_PDocumentRendererConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PDocumentRendererConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PDocumentRendererConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PDocumentRendererConstructor__ID
    };
    MOZ_IMPLICIT Reply_PDocumentRendererConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Reply_PDocumentRendererConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PDocumentRendererConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Destroy :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Destroy__ID
    };
    MOZ_IMPLICIT Msg_Destroy(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_Destroy")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Destroy(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetUpdateHitRegion :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetUpdateHitRegion__ID
    };
    MOZ_IMPLICIT Msg_SetUpdateHitRegion(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetUpdateHitRegion")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetUpdateHitRegion(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetDocShellIsActive :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetDocShellIsActive__ID
    };
    MOZ_IMPLICIT Msg_SetDocShellIsActive(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SetDocShellIsActive")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetDocShellIsActive(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SuppressDisplayport :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SuppressDisplayport__ID
    };
    MOZ_IMPLICIT Msg_SuppressDisplayport(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SuppressDisplayport")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SuppressDisplayport(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NavigateByKey :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NavigateByKey__ID
    };
    MOZ_IMPLICIT Msg_NavigateByKey(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_NavigateByKey")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NavigateByKey(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RequestNotifyAfterRemotePaint :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RequestNotifyAfterRemotePaint__ID
    };
    MOZ_IMPLICIT Msg_RequestNotifyAfterRemotePaint(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_RequestNotifyAfterRemotePaint")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RequestNotifyAfterRemotePaint(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UIResolutionChanged :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UIResolutionChanged__ID
    };
    MOZ_IMPLICIT Msg_UIResolutionChanged(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_UIResolutionChanged")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UIResolutionChanged(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ThemeChanged :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ThemeChanged__ID
    };
    MOZ_IMPLICIT Msg_ThemeChanged(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_ThemeChanged")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ThemeChanged(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AppOfflineStatus :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AppOfflineStatus__ID
    };
    MOZ_IMPLICIT Msg_AppOfflineStatus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_AppOfflineStatus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AppOfflineStatus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SwappedWithOtherRemoteLoader :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SwappedWithOtherRemoteLoader__ID
    };
    MOZ_IMPLICIT Msg_SwappedWithOtherRemoteLoader(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_SwappedWithOtherRemoteLoader")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SwappedWithOtherRemoteLoader(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_HandleAccessKey :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HandleAccessKey__ID
    };
    MOZ_IMPLICIT Msg_HandleAccessKey(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBrowser::Msg_HandleAccessKey")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_HandleAccessKey(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PBrowser
} // namespace dom
} // namespace mozilla

#endif // ifndef PBrowser_h
