//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCrashReporter_h
#define PCrashReporter_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Mapping|
//
namespace mozilla {
namespace dom {
class Mapping final
{
private:

public:
    MOZ_IMPLICIT Mapping();

    MOZ_IMPLICIT Mapping(
            const nsCString& _library_name,
            const nsCString& _file_id,
            const uintptr_t& _start_address,
            const size_t& _mapping_length,
            const size_t& _file_offset)
    {
        Init();
        Assign(_library_name, _file_id, _start_address, _mapping_length, _file_offset);
    }

    MOZ_IMPLICIT Mapping(const Mapping& _o)
    {
        Init();
        Assign((_o).library_name(), (_o).file_id(), (_o).start_address(), (_o).mapping_length(), (_o).file_offset());
    }

    ~Mapping();

    void
    operator=(const Mapping& _o)
    {
        Assign((_o).library_name(), (_o).file_id(), (_o).start_address(), (_o).mapping_length(), (_o).file_offset());
    }

    bool
    operator==(const Mapping& _o) const;

    nsCString&
    library_name()
    {
        return library_name_;
    }
    const nsCString&
    library_name() const
    {
        return library_name_;
    }

    nsCString&
    file_id()
    {
        return file_id_;
    }
    const nsCString&
    file_id() const
    {
        return file_id_;
    }

    uintptr_t&
    start_address()
    {
        return start_address_;
    }
    const uintptr_t&
    start_address() const
    {
        return start_address_;
    }

    size_t&
    mapping_length()
    {
        return mapping_length_;
    }
    const size_t&
    mapping_length() const
    {
        return mapping_length_;
    }

    size_t&
    file_offset()
    {
        return file_offset_;
    }
    const size_t&
    file_offset() const
    {
        return file_offset_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _library_name,
            const nsCString& _file_id,
            const uintptr_t& _start_address,
            const size_t& _mapping_length,
            const size_t& _file_offset);

    nsCString library_name_;
    nsCString file_id_;
    uintptr_t start_address_;
    size_t mapping_length_;
    size_t file_offset_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PCrashReporterChild and PCrashReporterParent
//
namespace mozilla {
namespace dom {
namespace PCrashReporter {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PCrashReporterStart = PCrashReporterMsgStart << 16,
    Msg_AnnotateCrashReport__ID,
    Msg_AppendAppNotes__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PCrashReporterEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_AnnotateCrashReport :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AnnotateCrashReport__ID
    };
    MOZ_IMPLICIT Msg_AnnotateCrashReport(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PCrashReporter::Msg_AnnotateCrashReport")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AnnotateCrashReport(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AppendAppNotes :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AppendAppNotes__ID
    };
    MOZ_IMPLICIT Msg_AppendAppNotes(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PCrashReporter::Msg_AppendAppNotes")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AppendAppNotes(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PCrashReporter::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PCrashReporter::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PCrashReporter
} // namespace dom
} // namespace mozilla

#endif // ifndef PCrashReporter_h
