//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFileSystemRequest_h
#define PFileSystemRequest_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemFileResponse|
//
namespace mozilla {
namespace dom {
class FileSystemFileResponse final
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT FileSystemFileResponse();

    MOZ_IMPLICIT FileSystemFileResponse(
            PBlobParent* _blobParent,
            PBlobChild* _blobChild)
    {
        Init();
        Assign(_blobParent, _blobChild);
    }

    MOZ_IMPLICIT FileSystemFileResponse(const FileSystemFileResponse& _o)
    {
        Init();
        Assign(const_cast<PBlobParent*>((_o).blobParent()), const_cast<PBlobChild*>((_o).blobChild()));
    }

    ~FileSystemFileResponse();

    void
    operator=(const FileSystemFileResponse& _o)
    {
        Assign(const_cast<PBlobParent*>((_o).blobParent()), const_cast<PBlobChild*>((_o).blobChild()));
    }

    bool
    operator==(const FileSystemFileResponse& _o) const;

    PBlobParent*&
    blobParent()
    {
        return blobParent_;
    }
    PBlobParent*
    blobParent() const
    {
        return blobParent_;
    }

    PBlobChild*&
    blobChild()
    {
        return blobChild_;
    }
    PBlobChild*
    blobChild() const
    {
        return blobChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PBlobParent* _blobParent,
            PBlobChild* _blobChild);

    PBlobParent* blobParent_;
    PBlobChild* blobChild_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemDirectoryResponse|
//
namespace mozilla {
namespace dom {
class FileSystemDirectoryResponse final
{
private:

public:
    MOZ_IMPLICIT FileSystemDirectoryResponse();

    MOZ_IMPLICIT FileSystemDirectoryResponse(const nsString& _realPath)
    {
        Init();
        Assign(_realPath);
    }

    MOZ_IMPLICIT FileSystemDirectoryResponse(const FileSystemDirectoryResponse& _o)
    {
        Init();
        Assign((_o).realPath());
    }

    ~FileSystemDirectoryResponse();

    void
    operator=(const FileSystemDirectoryResponse& _o)
    {
        Assign((_o).realPath());
    }

    bool
    operator==(const FileSystemDirectoryResponse& _o) const;

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _realPath);

    nsString realPath_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemDirectoryListingResponse|
//
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponse final
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT FileSystemDirectoryListingResponse();

    MOZ_IMPLICIT FileSystemDirectoryListingResponse(
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild)
    {
        Init();
        Assign(_blobsParent, _blobsChild);
    }

    MOZ_IMPLICIT FileSystemDirectoryListingResponse(const FileSystemDirectoryListingResponse& _o)
    {
        Init();
        Assign((_o).blobsParent(), (_o).blobsChild());
    }

    ~FileSystemDirectoryListingResponse();

    void
    operator=(const FileSystemDirectoryListingResponse& _o)
    {
        Assign((_o).blobsParent(), (_o).blobsChild());
    }

    bool
    operator==(const FileSystemDirectoryListingResponse& _o) const;

    nsTArray<PBlobParent*>&
    blobsParent()
    {
        return blobsParent_;
    }
    const nsTArray<PBlobParent*>&
    blobsParent() const
    {
        return blobsParent_;
    }

    nsTArray<PBlobChild*>&
    blobsChild()
    {
        return blobsChild_;
    }
    const nsTArray<PBlobChild*>&
    blobsChild() const
    {
        return blobsChild_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild);

    nsTArray<PBlobParent*> blobsParent_;
    nsTArray<PBlobChild*> blobsChild_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemErrorResponse|
//
namespace mozilla {
namespace dom {
class FileSystemErrorResponse final
{
private:

public:
    MOZ_IMPLICIT FileSystemErrorResponse();

    MOZ_IMPLICIT FileSystemErrorResponse(const nsresult& _error)
    {
        Init();
        Assign(_error);
    }

    MOZ_IMPLICIT FileSystemErrorResponse(const FileSystemErrorResponse& _o)
    {
        Init();
        Assign((_o).error());
    }

    ~FileSystemErrorResponse();

    void
    operator=(const FileSystemErrorResponse& _o)
    {
        Assign((_o).error());
    }

    bool
    operator==(const FileSystemErrorResponse& _o) const;

    nsresult&
    error()
    {
        return error_;
    }
    const nsresult&
    error() const
    {
        return error_;
    }

private:
    void
    Init();

    void
    Assign(const nsresult& _error);

    nsresult error_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemBooleanResponse|
//
namespace mozilla {
namespace dom {
class FileSystemBooleanResponse final
{
private:

public:
    MOZ_IMPLICIT FileSystemBooleanResponse();

    MOZ_IMPLICIT FileSystemBooleanResponse(const bool& _success)
    {
        Init();
        Assign(_success);
    }

    MOZ_IMPLICIT FileSystemBooleanResponse(const FileSystemBooleanResponse& _o)
    {
        Init();
        Assign((_o).success());
    }

    ~FileSystemBooleanResponse();

    void
    operator=(const FileSystemBooleanResponse& _o)
    {
        Assign((_o).success());
    }

    bool
    operator==(const FileSystemBooleanResponse& _o) const;

    bool&
    success()
    {
        return success_;
    }
    const bool&
    success() const
    {
        return success_;
    }

private:
    void
    Init();

    void
    Assign(const bool& _success);

    bool success_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemBooleanResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemDirectoryResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemFileResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemErrorResponse;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemResponseValue|
//
namespace mozilla {
namespace dom {
class FileSystemResponseValue final
{
public:
    enum Type {
        T__None,
        TFileSystemBooleanResponse = 1,
        TFileSystemDirectoryResponse,
        TFileSystemDirectoryListingResponse,
        TFileSystemFileResponse,
        TFileSystemErrorResponse,
        T__Last = TFileSystemErrorResponse
    };

private:
    typedef mozilla::dom::FileSystemBooleanResponse FileSystemBooleanResponse;
    typedef mozilla::dom::FileSystemDirectoryResponse FileSystemDirectoryResponse;
    typedef mozilla::dom::FileSystemDirectoryListingResponse FileSystemDirectoryListingResponse;
    typedef mozilla::dom::FileSystemFileResponse FileSystemFileResponse;
    typedef mozilla::dom::FileSystemErrorResponse FileSystemErrorResponse;
    typedef FileSystemBooleanResponse FileSystemBooleanResponse__tdef;
    typedef FileSystemDirectoryResponse FileSystemDirectoryResponse__tdef;
    typedef FileSystemDirectoryListingResponse FileSystemDirectoryListingResponse__tdef;
    typedef FileSystemFileResponse FileSystemFileResponse__tdef;
    typedef FileSystemErrorResponse FileSystemErrorResponse__tdef;

    union Value {
        mozilla::AlignedStorage2<FileSystemBooleanResponse> VFileSystemBooleanResponse;
        mozilla::AlignedStorage2<FileSystemDirectoryResponse> VFileSystemDirectoryResponse;
        mozilla::AlignedStorage2<FileSystemDirectoryListingResponse> VFileSystemDirectoryListingResponse;
        mozilla::AlignedStorage2<FileSystemFileResponse> VFileSystemFileResponse;
        mozilla::AlignedStorage2<FileSystemErrorResponse> VFileSystemErrorResponse;
    };

    FileSystemBooleanResponse*
    ptr_FileSystemBooleanResponse()
    {
        return ((mValue).VFileSystemBooleanResponse).addr();
    }
    const FileSystemBooleanResponse* const
    constptr_FileSystemBooleanResponse() const
    {
        return ((mValue).VFileSystemBooleanResponse).addr();
    }
    FileSystemDirectoryResponse*
    ptr_FileSystemDirectoryResponse()
    {
        return ((mValue).VFileSystemDirectoryResponse).addr();
    }
    const FileSystemDirectoryResponse* const
    constptr_FileSystemDirectoryResponse() const
    {
        return ((mValue).VFileSystemDirectoryResponse).addr();
    }
    FileSystemDirectoryListingResponse*
    ptr_FileSystemDirectoryListingResponse()
    {
        return ((mValue).VFileSystemDirectoryListingResponse).addr();
    }
    const FileSystemDirectoryListingResponse* const
    constptr_FileSystemDirectoryListingResponse() const
    {
        return ((mValue).VFileSystemDirectoryListingResponse).addr();
    }
    FileSystemFileResponse*
    ptr_FileSystemFileResponse()
    {
        return ((mValue).VFileSystemFileResponse).addr();
    }
    const FileSystemFileResponse* const
    constptr_FileSystemFileResponse() const
    {
        return ((mValue).VFileSystemFileResponse).addr();
    }
    FileSystemErrorResponse*
    ptr_FileSystemErrorResponse()
    {
        return ((mValue).VFileSystemErrorResponse).addr();
    }
    const FileSystemErrorResponse* const
    constptr_FileSystemErrorResponse() const
    {
        return ((mValue).VFileSystemErrorResponse).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemResponseValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemBooleanResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemDirectoryResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemDirectoryListingResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemFileResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemErrorResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemResponseValue& aOther);

    ~FileSystemResponseValue();

    Type
    type() const
    {
        return mType;
    }

    FileSystemResponseValue&
    operator=(const FileSystemBooleanResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemDirectoryResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemDirectoryListingResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemFileResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemErrorResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemResponseValue& aRhs);

    bool
    operator==(const FileSystemBooleanResponse& aRhs) const;

    bool
    operator==(const FileSystemDirectoryResponse& aRhs) const;

    bool
    operator==(const FileSystemDirectoryListingResponse& aRhs) const;

    bool
    operator==(const FileSystemFileResponse& aRhs) const;

    bool
    operator==(const FileSystemErrorResponse& aRhs) const;

    bool
    operator==(const FileSystemResponseValue& aRhs) const;

    FileSystemBooleanResponse&
    get_FileSystemBooleanResponse()
    {
        AssertSanity(TFileSystemBooleanResponse);
        return (*(ptr_FileSystemBooleanResponse()));
    }
    const FileSystemBooleanResponse&
    get_FileSystemBooleanResponse() const
    {
        AssertSanity(TFileSystemBooleanResponse);
        return (*(constptr_FileSystemBooleanResponse()));
    }
    operator FileSystemBooleanResponse&()
    {
        return get_FileSystemBooleanResponse();
    }
    operator const FileSystemBooleanResponse&() const
    {
        return get_FileSystemBooleanResponse();
    }

    FileSystemDirectoryResponse&
    get_FileSystemDirectoryResponse()
    {
        AssertSanity(TFileSystemDirectoryResponse);
        return (*(ptr_FileSystemDirectoryResponse()));
    }
    const FileSystemDirectoryResponse&
    get_FileSystemDirectoryResponse() const
    {
        AssertSanity(TFileSystemDirectoryResponse);
        return (*(constptr_FileSystemDirectoryResponse()));
    }
    operator FileSystemDirectoryResponse&()
    {
        return get_FileSystemDirectoryResponse();
    }
    operator const FileSystemDirectoryResponse&() const
    {
        return get_FileSystemDirectoryResponse();
    }

    FileSystemDirectoryListingResponse&
    get_FileSystemDirectoryListingResponse()
    {
        AssertSanity(TFileSystemDirectoryListingResponse);
        return (*(ptr_FileSystemDirectoryListingResponse()));
    }
    const FileSystemDirectoryListingResponse&
    get_FileSystemDirectoryListingResponse() const
    {
        AssertSanity(TFileSystemDirectoryListingResponse);
        return (*(constptr_FileSystemDirectoryListingResponse()));
    }
    operator FileSystemDirectoryListingResponse&()
    {
        return get_FileSystemDirectoryListingResponse();
    }
    operator const FileSystemDirectoryListingResponse&() const
    {
        return get_FileSystemDirectoryListingResponse();
    }

    FileSystemFileResponse&
    get_FileSystemFileResponse()
    {
        AssertSanity(TFileSystemFileResponse);
        return (*(ptr_FileSystemFileResponse()));
    }
    const FileSystemFileResponse&
    get_FileSystemFileResponse() const
    {
        AssertSanity(TFileSystemFileResponse);
        return (*(constptr_FileSystemFileResponse()));
    }
    operator FileSystemFileResponse&()
    {
        return get_FileSystemFileResponse();
    }
    operator const FileSystemFileResponse&() const
    {
        return get_FileSystemFileResponse();
    }

    FileSystemErrorResponse&
    get_FileSystemErrorResponse()
    {
        AssertSanity(TFileSystemErrorResponse);
        return (*(ptr_FileSystemErrorResponse()));
    }
    const FileSystemErrorResponse&
    get_FileSystemErrorResponse() const
    {
        AssertSanity(TFileSystemErrorResponse);
        return (*(constptr_FileSystemErrorResponse()));
    }
    operator FileSystemErrorResponse&()
    {
        return get_FileSystemErrorResponse();
    }
    operator const FileSystemErrorResponse&() const
    {
        return get_FileSystemErrorResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PFileSystemRequestChild and PFileSystemRequestParent
//
namespace mozilla {
namespace dom {
namespace PFileSystemRequest {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PFileSystemRequestStart = PFileSystemRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    PFileSystemRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PFileSystemRequest::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PFileSystemRequest::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PFileSystemRequest
} // namespace dom
} // namespace mozilla

#endif // ifndef PFileSystemRequest_h
