//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMemoryReportRequest_h
#define PMemoryReportRequest_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MemoryReport|
//
namespace mozilla {
namespace dom {
class MemoryReport final
{
private:

public:
    MOZ_IMPLICIT MemoryReport();

    MOZ_IMPLICIT MemoryReport(
            const nsCString& _process,
            const nsCString& _path,
            const int32_t& _kind,
            const int32_t& _units,
            const int64_t& _amount,
            const nsCString& _desc)
    {
        Init();
        Assign(_process, _path, _kind, _units, _amount, _desc);
    }

    MOZ_IMPLICIT MemoryReport(const MemoryReport& _o)
    {
        Init();
        Assign((_o).process(), (_o).path(), (_o).kind(), (_o).units(), (_o).amount(), (_o).desc());
    }

    ~MemoryReport();

    void
    operator=(const MemoryReport& _o)
    {
        Assign((_o).process(), (_o).path(), (_o).kind(), (_o).units(), (_o).amount(), (_o).desc());
    }

    bool
    operator==(const MemoryReport& _o) const;

    nsCString&
    process()
    {
        return process_;
    }
    const nsCString&
    process() const
    {
        return process_;
    }

    nsCString&
    path()
    {
        return path_;
    }
    const nsCString&
    path() const
    {
        return path_;
    }

    int32_t&
    kind()
    {
        return kind_;
    }
    const int32_t&
    kind() const
    {
        return kind_;
    }

    int32_t&
    units()
    {
        return units_;
    }
    const int32_t&
    units() const
    {
        return units_;
    }

    int64_t&
    amount()
    {
        return amount_;
    }
    const int64_t&
    amount() const
    {
        return amount_;
    }

    nsCString&
    desc()
    {
        return desc_;
    }
    const nsCString&
    desc() const
    {
        return desc_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _process,
            const nsCString& _path,
            const int32_t& _kind,
            const int32_t& _units,
            const int64_t& _amount,
            const nsCString& _desc);

    nsCString process_;
    nsCString path_;
    int32_t kind_;
    int32_t units_;
    int64_t amount_;
    nsCString desc_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PMemoryReportRequestChild and PMemoryReportRequestParent
//
namespace mozilla {
namespace dom {
namespace PMemoryReportRequest {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PMemoryReportRequestStart = PMemoryReportRequestMsgStart << 16,
    Msg_Report__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PMemoryReportRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_Report :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Report__ID
    };
    MOZ_IMPLICIT Msg_Report(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMemoryReportRequest::Msg_Report")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Report(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMemoryReportRequest::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMemoryReportRequest::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PMemoryReportRequest
} // namespace dom
} // namespace mozilla

#endif // ifndef PMemoryReportRequest_h
