//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSpeechSynthesis_h
#define PSpeechSynthesis_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RemoteVoice|
//
namespace mozilla {
namespace dom {
class RemoteVoice final
{
private:

public:
    MOZ_IMPLICIT RemoteVoice();

    MOZ_IMPLICIT RemoteVoice(
            const nsString& _voiceURI,
            const nsString& _name,
            const nsString& _lang,
            const bool& _localService,
            const bool& _queued)
    {
        Init();
        Assign(_voiceURI, _name, _lang, _localService, _queued);
    }

    MOZ_IMPLICIT RemoteVoice(const RemoteVoice& _o)
    {
        Init();
        Assign((_o).voiceURI(), (_o).name(), (_o).lang(), (_o).localService(), (_o).queued());
    }

    ~RemoteVoice();

    void
    operator=(const RemoteVoice& _o)
    {
        Assign((_o).voiceURI(), (_o).name(), (_o).lang(), (_o).localService(), (_o).queued());
    }

    bool
    operator==(const RemoteVoice& _o) const;

    nsString&
    voiceURI()
    {
        return voiceURI_;
    }
    const nsString&
    voiceURI() const
    {
        return voiceURI_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    nsString&
    lang()
    {
        return lang_;
    }
    const nsString&
    lang() const
    {
        return lang_;
    }

    bool&
    localService()
    {
        return localService_;
    }
    const bool&
    localService() const
    {
        return localService_;
    }

    bool&
    queued()
    {
        return queued_;
    }
    const bool&
    queued() const
    {
        return queued_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _voiceURI,
            const nsString& _name,
            const nsString& _lang,
            const bool& _localService,
            const bool& _queued);

    nsString voiceURI_;
    nsString name_;
    nsString lang_;
    bool localService_;
    bool queued_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PSpeechSynthesisChild and PSpeechSynthesisParent
//
namespace mozilla {
namespace dom {
namespace PSpeechSynthesis {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PSpeechSynthesisStart = PSpeechSynthesisMsgStart << 16,
    Msg_VoiceAdded__ID,
    Msg_VoiceRemoved__ID,
    Msg_SetDefaultVoice__ID,
    Msg_IsSpeakingChanged__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_PSpeechSynthesisRequestConstructor__ID,
    Reply_PSpeechSynthesisRequestConstructor__ID,
    Msg_ReadVoicesAndState__ID,
    Reply_ReadVoicesAndState__ID,
    PSpeechSynthesisEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_VoiceAdded :
    public IPC::Message
{
public:
    enum {
        ID = Msg_VoiceAdded__ID
    };
    MOZ_IMPLICIT Msg_VoiceAdded(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_VoiceAdded")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_VoiceAdded(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_VoiceRemoved :
    public IPC::Message
{
public:
    enum {
        ID = Msg_VoiceRemoved__ID
    };
    MOZ_IMPLICIT Msg_VoiceRemoved(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_VoiceRemoved")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_VoiceRemoved(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetDefaultVoice :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetDefaultVoice__ID
    };
    MOZ_IMPLICIT Msg_SetDefaultVoice(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_SetDefaultVoice")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetDefaultVoice(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_IsSpeakingChanged :
    public IPC::Message
{
public:
    enum {
        ID = Msg_IsSpeakingChanged__ID
    };
    MOZ_IMPLICIT Msg_IsSpeakingChanged(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_IsSpeakingChanged")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_IsSpeakingChanged(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PSpeechSynthesisRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PSpeechSynthesisRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PSpeechSynthesisRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_PSpeechSynthesisRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PSpeechSynthesisRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PSpeechSynthesisRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PSpeechSynthesisRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PSpeechSynthesisRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Reply_PSpeechSynthesisRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PSpeechSynthesisRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ReadVoicesAndState :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ReadVoicesAndState__ID
    };
    MOZ_IMPLICIT Msg_ReadVoicesAndState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_ReadVoicesAndState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ReadVoicesAndState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_ReadVoicesAndState :
    public IPC::Message
{
public:
    enum {
        ID = Reply_ReadVoicesAndState__ID
    };
    MOZ_IMPLICIT Reply_ReadVoicesAndState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Reply_ReadVoicesAndState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_ReadVoicesAndState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PSpeechSynthesis
} // namespace dom
} // namespace mozilla

#endif // ifndef PSpeechSynthesis_h
