//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PStorageChild_h
#define PStorageChild_h

#include "mozilla/dom/PStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PStorageChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;

    typedef PStorage::State State;

    virtual bool
    RecvObserve(
            const nsCString& topic,
            const nsCString& scopePrefix) = 0;
    virtual bool
    RecvScopesHavingData(nsTArray<nsCString>&& scopes) = 0;
    virtual bool
    RecvLoadItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value) = 0;
    virtual bool
    RecvLoadDone(
            const nsCString& scope,
            const nsresult& rv) = 0;
    virtual bool
    RecvLoadUsage(
            const nsCString& scope,
            const int64_t& usage) = 0;
    virtual bool
    RecvError(const nsresult& rv) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PStorageChild();

    virtual ~PStorageChild();

    PContentChild*
    Manager() const;

    PStorage::State
    state();

    static bool
    Send__delete__(PStorageChild* actor);

    bool
    SendPreload(
            const nsCString& scope,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv);

    bool
    SendAsyncPreload(
            const nsCString& scope,
            const bool& priority);

    bool
    SendAsyncGetUsage(const nsCString& scope);

    bool
    SendAsyncAddItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value);

    bool
    SendAsyncUpdateItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value);

    bool
    SendAsyncRemoveItem(
            const nsCString& scope,
            const nsString& key);

    bool
    SendAsyncClear(const nsCString& scope);

    bool
    SendAsyncFlush();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PStorageChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PStorageChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class StorageChild :
    public PStorageChild
{
    virtual bool
    RecvObserve(
            const nsCString& topic,
            const nsCString& scopePrefix);

    virtual bool
    RecvScopesHavingData(nsTArray<nsCString>&& scopes);

    virtual bool
    RecvLoadItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value);

    virtual bool
    RecvLoadDone(
            const nsCString& scope,
            const nsresult& rv);

    virtual bool
    RecvLoadUsage(
            const nsCString& scope,
            const int64_t& usage);

    virtual bool
    RecvError(const nsresult& rv);

    MOZ_IMPLICIT StorageChild();
    virtual ~StorageChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
StorageChild::RecvObserve(
        const nsCString& topic,
        const nsCString& scopePrefix)
{
    return false;
}

bool
StorageChild::RecvScopesHavingData(nsTArray<nsCString>&& scopes)
{
    return false;
}

bool
StorageChild::RecvLoadItem(
        const nsCString& scope,
        const nsString& key,
        const nsString& value)
{
    return false;
}

bool
StorageChild::RecvLoadDone(
        const nsCString& scope,
        const nsresult& rv)
{
    return false;
}

bool
StorageChild::RecvLoadUsage(
        const nsCString& scope,
        const int64_t& usage)
{
    return false;
}

bool
StorageChild::RecvError(const nsresult& rv)
{
    return false;
}

MOZ_IMPLICIT StorageChild::StorageChild()
{
    MOZ_COUNT_CTOR(StorageChild);
}

MOZ_IMPLICIT StorageChild::~StorageChild()
{
    MOZ_COUNT_DTOR(StorageChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PStorageChild_h
