//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAsmJSCacheEntryParent_h
#define PAsmJSCacheEntryParent_h

#include "mozilla/dom/asmjscache/PAsmJSCacheEntry.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/dom/asmjscache/AsmJSCache.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace asmjscache {


class PAsmJSCacheEntryParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::ipc::PBackgroundParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef JS::AsmJSCacheResult AsmJSCacheResult;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::asmjscache::Metadata Metadata;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PAsmJSCacheEntry::State State;

    virtual bool
    RecvSelectCacheFileToRead(const uint32_t& moduleIndex) = 0;
    virtual bool
    RecvCacheMiss() = 0;
    virtual bool
    Recv__delete__(const AsmJSCacheResult& result);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PAsmJSCacheEntryParent();

    virtual ~PAsmJSCacheEntryParent();

    PBackgroundParent*
    Manager() const;

    PAsmJSCacheEntry::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendOnOpenMetadataForRead(const Metadata& metadata);

    MOZ_WARN_UNUSED_RESULT bool
    SendOnOpenCacheFile(
            const int64_t& fileSize,
            const FileDescriptor& fileDesc);

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(
            PAsmJSCacheEntryParent* actor,
            const AsmJSCacheResult& result);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const FileDescriptor& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            FileDescriptor* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PAsmJSCacheEntryParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PAsmJSCacheEntryParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace asmjscache
} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
namespace asmjscache {
class AsmJSCacheEntryParent :
    public PAsmJSCacheEntryParent
{
    virtual bool
    RecvSelectCacheFileToRead(const uint32_t& moduleIndex);

    virtual bool
    RecvCacheMiss();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT AsmJSCacheEntryParent();
    virtual ~AsmJSCacheEntryParent();
};
} // namespace asmjscache
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
namespace asmjscache {
bool
AsmJSCacheEntryParent::RecvSelectCacheFileToRead(const uint32_t& moduleIndex)
{
    return false;
}

bool
AsmJSCacheEntryParent::RecvCacheMiss()
{
    return false;
}

void
AsmJSCacheEntryParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT AsmJSCacheEntryParent::AsmJSCacheEntryParent()
{
    MOZ_COUNT_CTOR(AsmJSCacheEntryParent);
}

MOZ_IMPLICIT AsmJSCacheEntryParent::~AsmJSCacheEntryParent()
{
    MOZ_COUNT_DTOR(AsmJSCacheEntryParent);
}

} // namespace asmjscache
} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PAsmJSCacheEntryParent_h
