//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundIDBFactory_h
#define PBackgroundIDBFactory_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/dom/indexedDB/PBackgroundIDBSharedTypes.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"

namespace mozilla {
namespace dom {
namespace indexedDB {
class DatabaseMetadata;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CommonFactoryRequestParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class CommonFactoryRequestParams final
{
private:
    typedef mozilla::dom::indexedDB::DatabaseMetadata DatabaseMetadata;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT CommonFactoryRequestParams();

    MOZ_IMPLICIT CommonFactoryRequestParams(
            const DatabaseMetadata& _metadata,
            const PrincipalInfo& _principalInfo,
            const bool& _privateBrowsingMode)
    {
        Init();
        Assign(_metadata, _principalInfo, _privateBrowsingMode);
    }

    MOZ_IMPLICIT CommonFactoryRequestParams(const CommonFactoryRequestParams& _o)
    {
        Init();
        Assign((_o).metadata(), (_o).principalInfo(), (_o).privateBrowsingMode());
    }

    ~CommonFactoryRequestParams();

    void
    operator=(const CommonFactoryRequestParams& _o)
    {
        Assign((_o).metadata(), (_o).principalInfo(), (_o).privateBrowsingMode());
    }

    bool
    operator==(const CommonFactoryRequestParams& _o) const;

    DatabaseMetadata&
    metadata()
    {
        return metadata_;
    }
    const DatabaseMetadata&
    metadata() const
    {
        return metadata_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    bool&
    privateBrowsingMode()
    {
        return privateBrowsingMode_;
    }
    const bool&
    privateBrowsingMode() const
    {
        return privateBrowsingMode_;
    }

private:
    void
    Init();

    void
    Assign(
            const DatabaseMetadata& _metadata,
            const PrincipalInfo& _principalInfo,
            const bool& _privateBrowsingMode);

    DatabaseMetadata metadata_;
    PrincipalInfo principalInfo_;
    bool privateBrowsingMode_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class CommonFactoryRequestParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpenDatabaseRequestParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class OpenDatabaseRequestParams final
{
private:
    typedef mozilla::dom::indexedDB::CommonFactoryRequestParams CommonFactoryRequestParams;

public:
    MOZ_IMPLICIT OpenDatabaseRequestParams();

    MOZ_IMPLICIT OpenDatabaseRequestParams(const CommonFactoryRequestParams& _commonParams)
    {
        Init();
        Assign(_commonParams);
    }

    MOZ_IMPLICIT OpenDatabaseRequestParams(const OpenDatabaseRequestParams& _o)
    {
        Init();
        Assign((_o).commonParams());
    }

    ~OpenDatabaseRequestParams();

    void
    operator=(const OpenDatabaseRequestParams& _o)
    {
        Assign((_o).commonParams());
    }

    bool
    operator==(const OpenDatabaseRequestParams& _o) const;

    CommonFactoryRequestParams&
    commonParams()
    {
        return commonParams_;
    }
    const CommonFactoryRequestParams&
    commonParams() const
    {
        return commonParams_;
    }

private:
    void
    Init();

    void
    Assign(const CommonFactoryRequestParams& _commonParams);

    CommonFactoryRequestParams commonParams_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class CommonFactoryRequestParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DeleteDatabaseRequestParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class DeleteDatabaseRequestParams final
{
private:
    typedef mozilla::dom::indexedDB::CommonFactoryRequestParams CommonFactoryRequestParams;

public:
    MOZ_IMPLICIT DeleteDatabaseRequestParams();

    MOZ_IMPLICIT DeleteDatabaseRequestParams(const CommonFactoryRequestParams& _commonParams)
    {
        Init();
        Assign(_commonParams);
    }

    MOZ_IMPLICIT DeleteDatabaseRequestParams(const DeleteDatabaseRequestParams& _o)
    {
        Init();
        Assign((_o).commonParams());
    }

    ~DeleteDatabaseRequestParams();

    void
    operator=(const DeleteDatabaseRequestParams& _o)
    {
        Assign((_o).commonParams());
    }

    bool
    operator==(const DeleteDatabaseRequestParams& _o) const;

    CommonFactoryRequestParams&
    commonParams()
    {
        return commonParams_;
    }
    const CommonFactoryRequestParams&
    commonParams() const
    {
        return commonParams_;
    }

private:
    void
    Init();

    void
    Assign(const CommonFactoryRequestParams& _commonParams);

    CommonFactoryRequestParams commonParams_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OpenDatabaseRequestParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class DeleteDatabaseRequestParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FactoryRequestParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class FactoryRequestParams final
{
public:
    enum Type {
        T__None,
        TOpenDatabaseRequestParams = 1,
        TDeleteDatabaseRequestParams,
        T__Last = TDeleteDatabaseRequestParams
    };

private:
    typedef mozilla::dom::indexedDB::OpenDatabaseRequestParams OpenDatabaseRequestParams;
    typedef mozilla::dom::indexedDB::DeleteDatabaseRequestParams DeleteDatabaseRequestParams;
    typedef OpenDatabaseRequestParams OpenDatabaseRequestParams__tdef;
    typedef DeleteDatabaseRequestParams DeleteDatabaseRequestParams__tdef;

    union Value {
        mozilla::AlignedStorage2<OpenDatabaseRequestParams> VOpenDatabaseRequestParams;
        mozilla::AlignedStorage2<DeleteDatabaseRequestParams> VDeleteDatabaseRequestParams;
    };

    OpenDatabaseRequestParams*
    ptr_OpenDatabaseRequestParams()
    {
        return ((mValue).VOpenDatabaseRequestParams).addr();
    }
    const OpenDatabaseRequestParams* const
    constptr_OpenDatabaseRequestParams() const
    {
        return ((mValue).VOpenDatabaseRequestParams).addr();
    }
    DeleteDatabaseRequestParams*
    ptr_DeleteDatabaseRequestParams()
    {
        return ((mValue).VDeleteDatabaseRequestParams).addr();
    }
    const DeleteDatabaseRequestParams* const
    constptr_DeleteDatabaseRequestParams() const
    {
        return ((mValue).VDeleteDatabaseRequestParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FactoryRequestParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FactoryRequestParams(const OpenDatabaseRequestParams& aOther);

    MOZ_IMPLICIT FactoryRequestParams(const DeleteDatabaseRequestParams& aOther);

    MOZ_IMPLICIT FactoryRequestParams(const FactoryRequestParams& aOther);

    ~FactoryRequestParams();

    Type
    type() const
    {
        return mType;
    }

    FactoryRequestParams&
    operator=(const OpenDatabaseRequestParams& aRhs);

    FactoryRequestParams&
    operator=(const DeleteDatabaseRequestParams& aRhs);

    FactoryRequestParams&
    operator=(const FactoryRequestParams& aRhs);

    bool
    operator==(const OpenDatabaseRequestParams& aRhs) const;

    bool
    operator==(const DeleteDatabaseRequestParams& aRhs) const;

    bool
    operator==(const FactoryRequestParams& aRhs) const;

    OpenDatabaseRequestParams&
    get_OpenDatabaseRequestParams()
    {
        AssertSanity(TOpenDatabaseRequestParams);
        return (*(ptr_OpenDatabaseRequestParams()));
    }
    const OpenDatabaseRequestParams&
    get_OpenDatabaseRequestParams() const
    {
        AssertSanity(TOpenDatabaseRequestParams);
        return (*(constptr_OpenDatabaseRequestParams()));
    }
    operator OpenDatabaseRequestParams&()
    {
        return get_OpenDatabaseRequestParams();
    }
    operator const OpenDatabaseRequestParams&() const
    {
        return get_OpenDatabaseRequestParams();
    }

    DeleteDatabaseRequestParams&
    get_DeleteDatabaseRequestParams()
    {
        AssertSanity(TDeleteDatabaseRequestParams);
        return (*(ptr_DeleteDatabaseRequestParams()));
    }
    const DeleteDatabaseRequestParams&
    get_DeleteDatabaseRequestParams() const
    {
        AssertSanity(TDeleteDatabaseRequestParams);
        return (*(constptr_DeleteDatabaseRequestParams()));
    }
    operator DeleteDatabaseRequestParams&()
    {
        return get_DeleteDatabaseRequestParams();
    }
    operator const DeleteDatabaseRequestParams&() const
    {
        return get_DeleteDatabaseRequestParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBackgroundIDBFactoryChild and PBackgroundIDBFactoryParent
//
namespace mozilla {
namespace dom {
namespace indexedDB {
namespace PBackgroundIDBFactory {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PBackgroundIDBFactoryStart = PBackgroundIDBFactoryMsgStart << 16,
    Msg_DeleteMe__ID,
    Msg_PBackgroundIDBFactoryRequestConstructor__ID,
    Reply_PBackgroundIDBFactoryRequestConstructor__ID,
    Msg_IncrementLoggingRequestSerialNumber__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_PBackgroundIDBDatabaseConstructor__ID,
    Reply_PBackgroundIDBDatabaseConstructor__ID,
    PBackgroundIDBFactoryEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_DeleteMe :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DeleteMe__ID
    };
    MOZ_IMPLICIT Msg_DeleteMe(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Msg_DeleteMe")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DeleteMe(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PBackgroundIDBFactoryRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PBackgroundIDBFactoryRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PBackgroundIDBFactoryRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Msg_PBackgroundIDBFactoryRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PBackgroundIDBFactoryRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PBackgroundIDBFactoryRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PBackgroundIDBFactoryRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PBackgroundIDBFactoryRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Reply_PBackgroundIDBFactoryRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PBackgroundIDBFactoryRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_IncrementLoggingRequestSerialNumber :
    public IPC::Message
{
public:
    enum {
        ID = Msg_IncrementLoggingRequestSerialNumber__ID
    };
    MOZ_IMPLICIT Msg_IncrementLoggingRequestSerialNumber(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Msg_IncrementLoggingRequestSerialNumber")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_IncrementLoggingRequestSerialNumber(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PBackgroundIDBDatabaseConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PBackgroundIDBDatabaseConstructor__ID
    };
    MOZ_IMPLICIT Msg_PBackgroundIDBDatabaseConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Msg_PBackgroundIDBDatabaseConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PBackgroundIDBDatabaseConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PBackgroundIDBDatabaseConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PBackgroundIDBDatabaseConstructor__ID
    };
    MOZ_IMPLICIT Reply_PBackgroundIDBDatabaseConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactory::Reply_PBackgroundIDBDatabaseConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PBackgroundIDBDatabaseConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PBackgroundIDBFactory
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

#endif // ifndef PBackgroundIDBFactory_h
