//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PQuota_h
#define PQuota_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"

// Headers for typedefs
#include "mozilla/dom/quota/PersistenceType.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UsageParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class UsageParams final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT UsageParams();

    MOZ_IMPLICIT UsageParams(const PrincipalInfo& _principalInfo)
    {
        Init();
        Assign(_principalInfo);
    }

    MOZ_IMPLICIT UsageParams(const UsageParams& _o)
    {
        Init();
        Assign((_o).principalInfo());
    }

    ~UsageParams();

    void
    operator=(const UsageParams& _o)
    {
        Assign((_o).principalInfo());
    }

    bool
    operator==(const UsageParams& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

private:
    void
    Init();

    void
    Assign(const PrincipalInfo& _principalInfo);

    PrincipalInfo principalInfo_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class UsageParams;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union UsageRequestParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class UsageRequestParams final
{
public:
    enum Type {
        T__None,
        TUsageParams = 1,
        T__Last = TUsageParams
    };

private:
    typedef mozilla::dom::quota::UsageParams UsageParams;
    typedef UsageParams UsageParams__tdef;

    union Value {
        mozilla::AlignedStorage2<UsageParams> VUsageParams;
    };

    UsageParams*
    ptr_UsageParams()
    {
        return ((mValue).VUsageParams).addr();
    }
    const UsageParams* const
    constptr_UsageParams() const
    {
        return ((mValue).VUsageParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT UsageRequestParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT UsageRequestParams(const UsageParams& aOther);

    MOZ_IMPLICIT UsageRequestParams(const UsageRequestParams& aOther);

    ~UsageRequestParams();

    Type
    type() const
    {
        return mType;
    }

    UsageRequestParams&
    operator=(const UsageParams& aRhs);

    UsageRequestParams&
    operator=(const UsageRequestParams& aRhs);

    bool
    operator==(const UsageParams& aRhs) const;

    bool
    operator==(const UsageRequestParams& aRhs) const;

    UsageParams&
    get_UsageParams()
    {
        AssertSanity(TUsageParams);
        return (*(ptr_UsageParams()));
    }
    const UsageParams&
    get_UsageParams() const
    {
        AssertSanity(TUsageParams);
        return (*(constptr_UsageParams()));
    }
    operator UsageParams&()
    {
        return get_UsageParams();
    }
    operator const UsageParams&() const
    {
        return get_UsageParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClearOriginParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ClearOriginParams final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::dom::quota::PersistenceType PersistenceType;

public:
    MOZ_IMPLICIT ClearOriginParams();

    MOZ_IMPLICIT ClearOriginParams(
            const PrincipalInfo& _principalInfo,
            const PersistenceType& _persistenceType,
            const bool& _persistenceTypeIsExplicit)
    {
        Init();
        Assign(_principalInfo, _persistenceType, _persistenceTypeIsExplicit);
    }

    MOZ_IMPLICIT ClearOriginParams(const ClearOriginParams& _o)
    {
        Init();
        Assign((_o).principalInfo(), (_o).persistenceType(), (_o).persistenceTypeIsExplicit());
    }

    ~ClearOriginParams();

    void
    operator=(const ClearOriginParams& _o)
    {
        Assign((_o).principalInfo(), (_o).persistenceType(), (_o).persistenceTypeIsExplicit());
    }

    bool
    operator==(const ClearOriginParams& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    PersistenceType&
    persistenceType()
    {
        return persistenceType_;
    }
    const PersistenceType&
    persistenceType() const
    {
        return persistenceType_;
    }

    bool&
    persistenceTypeIsExplicit()
    {
        return persistenceTypeIsExplicit_;
    }
    const bool&
    persistenceTypeIsExplicit() const
    {
        return persistenceTypeIsExplicit_;
    }

private:
    void
    Init();

    void
    Assign(
            const PrincipalInfo& _principalInfo,
            const PersistenceType& _persistenceType,
            const bool& _persistenceTypeIsExplicit);

    PrincipalInfo principalInfo_;
    PersistenceType persistenceType_;
    bool persistenceTypeIsExplicit_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClearAppParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ClearAppParams final
{
private:

public:
    MOZ_IMPLICIT ClearAppParams();

    MOZ_IMPLICIT ClearAppParams(
            const uint32_t& _appId,
            const bool& _browserOnly)
    {
        Init();
        Assign(_appId, _browserOnly);
    }

    MOZ_IMPLICIT ClearAppParams(const ClearAppParams& _o)
    {
        Init();
        Assign((_o).appId(), (_o).browserOnly());
    }

    ~ClearAppParams();

    void
    operator=(const ClearAppParams& _o)
    {
        Assign((_o).appId(), (_o).browserOnly());
    }

    bool
    operator==(const ClearAppParams& _o) const;

    uint32_t&
    appId()
    {
        return appId_;
    }
    const uint32_t&
    appId() const
    {
        return appId_;
    }

    bool&
    browserOnly()
    {
        return browserOnly_;
    }
    const bool&
    browserOnly() const
    {
        return browserOnly_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _appId,
            const bool& _browserOnly);

    uint32_t appId_;
    bool browserOnly_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClearAllParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ClearAllParams final
{
private:

public:
    MOZ_IMPLICIT ClearAllParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT ClearAllParams(const ClearAllParams& _o)
    {
        Init();
        Assign();
    }

    ~ClearAllParams();

    void
    operator=(const ClearAllParams& _o)
    {
        Assign();
    }

    bool
    operator==(const ClearAllParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace quota
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ResetAllParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ResetAllParams final
{
private:

public:
    MOZ_IMPLICIT ResetAllParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT ResetAllParams(const ResetAllParams& _o)
    {
        Init();
        Assign();
    }

    ~ResetAllParams();

    void
    operator=(const ResetAllParams& _o)
    {
        Assign();
    }

    bool
    operator==(const ResetAllParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class ClearOriginParams;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class ClearAppParams;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class ClearAllParams;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class ResetAllParams;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union RequestParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class RequestParams final
{
public:
    enum Type {
        T__None,
        TClearOriginParams = 1,
        TClearAppParams,
        TClearAllParams,
        TResetAllParams,
        T__Last = TResetAllParams
    };

private:
    typedef mozilla::dom::quota::ClearOriginParams ClearOriginParams;
    typedef mozilla::dom::quota::ClearAppParams ClearAppParams;
    typedef mozilla::dom::quota::ClearAllParams ClearAllParams;
    typedef mozilla::dom::quota::ResetAllParams ResetAllParams;
    typedef ClearOriginParams ClearOriginParams__tdef;
    typedef ClearAppParams ClearAppParams__tdef;
    typedef ClearAllParams ClearAllParams__tdef;
    typedef ResetAllParams ResetAllParams__tdef;

    union Value {
        mozilla::AlignedStorage2<ClearOriginParams> VClearOriginParams;
        mozilla::AlignedStorage2<ClearAppParams> VClearAppParams;
        mozilla::AlignedStorage2<ClearAllParams> VClearAllParams;
        mozilla::AlignedStorage2<ResetAllParams> VResetAllParams;
    };

    ClearOriginParams*
    ptr_ClearOriginParams()
    {
        return ((mValue).VClearOriginParams).addr();
    }
    const ClearOriginParams* const
    constptr_ClearOriginParams() const
    {
        return ((mValue).VClearOriginParams).addr();
    }
    ClearAppParams*
    ptr_ClearAppParams()
    {
        return ((mValue).VClearAppParams).addr();
    }
    const ClearAppParams* const
    constptr_ClearAppParams() const
    {
        return ((mValue).VClearAppParams).addr();
    }
    ClearAllParams*
    ptr_ClearAllParams()
    {
        return ((mValue).VClearAllParams).addr();
    }
    const ClearAllParams* const
    constptr_ClearAllParams() const
    {
        return ((mValue).VClearAllParams).addr();
    }
    ResetAllParams*
    ptr_ResetAllParams()
    {
        return ((mValue).VResetAllParams).addr();
    }
    const ResetAllParams* const
    constptr_ResetAllParams() const
    {
        return ((mValue).VResetAllParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT RequestParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT RequestParams(const ClearOriginParams& aOther);

    MOZ_IMPLICIT RequestParams(const ClearAppParams& aOther);

    MOZ_IMPLICIT RequestParams(const ClearAllParams& aOther);

    MOZ_IMPLICIT RequestParams(const ResetAllParams& aOther);

    MOZ_IMPLICIT RequestParams(const RequestParams& aOther);

    ~RequestParams();

    Type
    type() const
    {
        return mType;
    }

    RequestParams&
    operator=(const ClearOriginParams& aRhs);

    RequestParams&
    operator=(const ClearAppParams& aRhs);

    RequestParams&
    operator=(const ClearAllParams& aRhs);

    RequestParams&
    operator=(const ResetAllParams& aRhs);

    RequestParams&
    operator=(const RequestParams& aRhs);

    bool
    operator==(const ClearOriginParams& aRhs) const;

    bool
    operator==(const ClearAppParams& aRhs) const;

    bool
    operator==(const ClearAllParams& aRhs) const;

    bool
    operator==(const ResetAllParams& aRhs) const;

    bool
    operator==(const RequestParams& aRhs) const;

    ClearOriginParams&
    get_ClearOriginParams()
    {
        AssertSanity(TClearOriginParams);
        return (*(ptr_ClearOriginParams()));
    }
    const ClearOriginParams&
    get_ClearOriginParams() const
    {
        AssertSanity(TClearOriginParams);
        return (*(constptr_ClearOriginParams()));
    }
    operator ClearOriginParams&()
    {
        return get_ClearOriginParams();
    }
    operator const ClearOriginParams&() const
    {
        return get_ClearOriginParams();
    }

    ClearAppParams&
    get_ClearAppParams()
    {
        AssertSanity(TClearAppParams);
        return (*(ptr_ClearAppParams()));
    }
    const ClearAppParams&
    get_ClearAppParams() const
    {
        AssertSanity(TClearAppParams);
        return (*(constptr_ClearAppParams()));
    }
    operator ClearAppParams&()
    {
        return get_ClearAppParams();
    }
    operator const ClearAppParams&() const
    {
        return get_ClearAppParams();
    }

    ClearAllParams&
    get_ClearAllParams()
    {
        AssertSanity(TClearAllParams);
        return (*(ptr_ClearAllParams()));
    }
    const ClearAllParams&
    get_ClearAllParams() const
    {
        AssertSanity(TClearAllParams);
        return (*(constptr_ClearAllParams()));
    }
    operator ClearAllParams&()
    {
        return get_ClearAllParams();
    }
    operator const ClearAllParams&() const
    {
        return get_ClearAllParams();
    }

    ResetAllParams&
    get_ResetAllParams()
    {
        AssertSanity(TResetAllParams);
        return (*(ptr_ResetAllParams()));
    }
    const ResetAllParams&
    get_ResetAllParams() const
    {
        AssertSanity(TResetAllParams);
        return (*(constptr_ResetAllParams()));
    }
    operator ResetAllParams&()
    {
        return get_ResetAllParams();
    }
    operator const ResetAllParams&() const
    {
        return get_ResetAllParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PQuotaChild and PQuotaParent
//
namespace mozilla {
namespace dom {
namespace quota {
namespace PQuota {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PQuotaStart = PQuotaMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_PQuotaUsageRequestConstructor__ID,
    Reply_PQuotaUsageRequestConstructor__ID,
    Msg_PQuotaRequestConstructor__ID,
    Reply_PQuotaRequestConstructor__ID,
    Msg_StartIdleMaintenance__ID,
    Msg_StopIdleMaintenance__ID,
    PQuotaEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PQuotaUsageRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PQuotaUsageRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PQuotaUsageRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Msg_PQuotaUsageRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PQuotaUsageRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PQuotaUsageRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PQuotaUsageRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PQuotaUsageRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Reply_PQuotaUsageRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PQuotaUsageRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PQuotaRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PQuotaRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PQuotaRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Msg_PQuotaRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PQuotaRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PQuotaRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PQuotaRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PQuotaRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Reply_PQuotaRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PQuotaRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_StartIdleMaintenance :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StartIdleMaintenance__ID
    };
    MOZ_IMPLICIT Msg_StartIdleMaintenance(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Msg_StartIdleMaintenance")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_StartIdleMaintenance(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_StopIdleMaintenance :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StopIdleMaintenance__ID
    };
    MOZ_IMPLICIT Msg_StopIdleMaintenance(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuota::Msg_StopIdleMaintenance")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_StopIdleMaintenance(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PQuota
} // namespace quota
} // namespace dom
} // namespace mozilla

#endif // ifndef PQuota_h
