//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PQuotaUsageRequest_h
#define PQuotaUsageRequest_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UsageResponse|
//
namespace mozilla {
namespace dom {
namespace quota {
class UsageResponse final
{
private:

public:
    MOZ_IMPLICIT UsageResponse();

    MOZ_IMPLICIT UsageResponse(
            const uint64_t& _usage,
            const uint64_t& _fileUsage)
    {
        Init();
        Assign(_usage, _fileUsage);
    }

    MOZ_IMPLICIT UsageResponse(const UsageResponse& _o)
    {
        Init();
        Assign((_o).usage(), (_o).fileUsage());
    }

    ~UsageResponse();

    void
    operator=(const UsageResponse& _o)
    {
        Assign((_o).usage(), (_o).fileUsage());
    }

    bool
    operator==(const UsageResponse& _o) const;

    uint64_t&
    usage()
    {
        return usage_;
    }
    const uint64_t&
    usage() const
    {
        return usage_;
    }

    uint64_t&
    fileUsage()
    {
        return fileUsage_;
    }
    const uint64_t&
    fileUsage() const
    {
        return fileUsage_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _usage,
            const uint64_t& _fileUsage);

    uint64_t usage_;
    uint64_t fileUsage_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class UsageResponse;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union UsageRequestResponse|
//
namespace mozilla {
namespace dom {
namespace quota {
class UsageRequestResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TUsageResponse,
        T__Last = TUsageResponse
    };

private:
    typedef mozilla::dom::quota::UsageResponse UsageResponse;
    typedef nsresult nsresult__tdef;
    typedef UsageResponse UsageResponse__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<UsageResponse> VUsageResponse;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult* const
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    UsageResponse*
    ptr_UsageResponse()
    {
        return ((mValue).VUsageResponse).addr();
    }
    const UsageResponse* const
    constptr_UsageResponse() const
    {
        return ((mValue).VUsageResponse).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT UsageRequestResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT UsageRequestResponse(const nsresult& aOther);

    MOZ_IMPLICIT UsageRequestResponse(const UsageResponse& aOther);

    MOZ_IMPLICIT UsageRequestResponse(const UsageRequestResponse& aOther);

    ~UsageRequestResponse();

    Type
    type() const
    {
        return mType;
    }

    UsageRequestResponse&
    operator=(const nsresult& aRhs);

    UsageRequestResponse&
    operator=(const UsageResponse& aRhs);

    UsageRequestResponse&
    operator=(const UsageRequestResponse& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const UsageResponse& aRhs) const;

    bool
    operator==(const UsageRequestResponse& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    UsageResponse&
    get_UsageResponse()
    {
        AssertSanity(TUsageResponse);
        return (*(ptr_UsageResponse()));
    }
    const UsageResponse&
    get_UsageResponse() const
    {
        AssertSanity(TUsageResponse);
        return (*(constptr_UsageResponse()));
    }
    operator UsageResponse&()
    {
        return get_UsageResponse();
    }
    operator const UsageResponse&() const
    {
        return get_UsageResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PQuotaUsageRequestChild and PQuotaUsageRequestParent
//
namespace mozilla {
namespace dom {
namespace quota {
namespace PQuotaUsageRequest {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PQuotaUsageRequestStart = PQuotaUsageRequestMsgStart << 16,
    Msg_Cancel__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PQuotaUsageRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_Cancel :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Cancel__ID
    };
    MOZ_IMPLICIT Msg_Cancel(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuotaUsageRequest::Msg_Cancel")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Cancel(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuotaUsageRequest::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PQuotaUsageRequest::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PQuotaUsageRequest
} // namespace quota
} // namespace dom
} // namespace mozilla

#endif // ifndef PQuotaUsageRequest_h
