//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef GMPTypes_h
#define GMPTypes_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"

// Headers for typedefs
#include "gmp-audio-codec.h"
#include "gmp-video-codec.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPDecryptionData|
//
namespace mozilla {
namespace gmp {
class GMPDecryptionData final
{
private:

public:
    MOZ_IMPLICIT GMPDecryptionData();

    MOZ_IMPLICIT GMPDecryptionData(
            const nsTArray<uint8_t>& _mKeyId,
            const nsTArray<uint8_t>& _mIV,
            const nsTArray<uint16_t>& _mClearBytes,
            const nsTArray<uint32_t>& _mCipherBytes,
            const nsTArray<nsCString>& _mSessionIds)
    {
        Init();
        Assign(_mKeyId, _mIV, _mClearBytes, _mCipherBytes, _mSessionIds);
    }

    MOZ_IMPLICIT GMPDecryptionData(const GMPDecryptionData& _o)
    {
        Init();
        Assign((_o).mKeyId(), (_o).mIV(), (_o).mClearBytes(), (_o).mCipherBytes(), (_o).mSessionIds());
    }

    ~GMPDecryptionData();

    void
    operator=(const GMPDecryptionData& _o)
    {
        Assign((_o).mKeyId(), (_o).mIV(), (_o).mClearBytes(), (_o).mCipherBytes(), (_o).mSessionIds());
    }

    bool
    operator==(const GMPDecryptionData& _o) const;

    nsTArray<uint8_t>&
    mKeyId()
    {
        return mKeyId_;
    }
    const nsTArray<uint8_t>&
    mKeyId() const
    {
        return mKeyId_;
    }

    nsTArray<uint8_t>&
    mIV()
    {
        return mIV_;
    }
    const nsTArray<uint8_t>&
    mIV() const
    {
        return mIV_;
    }

    nsTArray<uint16_t>&
    mClearBytes()
    {
        return mClearBytes_;
    }
    const nsTArray<uint16_t>&
    mClearBytes() const
    {
        return mClearBytes_;
    }

    nsTArray<uint32_t>&
    mCipherBytes()
    {
        return mCipherBytes_;
    }
    const nsTArray<uint32_t>&
    mCipherBytes() const
    {
        return mCipherBytes_;
    }

    nsTArray<nsCString>&
    mSessionIds()
    {
        return mSessionIds_;
    }
    const nsTArray<nsCString>&
    mSessionIds() const
    {
        return mSessionIds_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _mKeyId,
            const nsTArray<uint8_t>& _mIV,
            const nsTArray<uint16_t>& _mClearBytes,
            const nsTArray<uint32_t>& _mCipherBytes,
            const nsTArray<nsCString>& _mSessionIds);

    nsTArray<uint8_t> mKeyId_;
    nsTArray<uint8_t> mIV_;
    nsTArray<uint16_t> mClearBytes_;
    nsTArray<uint32_t> mCipherBytes_;
    nsTArray<nsCString> mSessionIds_;
};
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class GMPDecryptionData;
} // namespace gmp
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPVideoEncodedFrameData|
//
namespace mozilla {
namespace gmp {
class GMPVideoEncodedFrameData final
{
private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;

public:
    MOZ_IMPLICIT GMPVideoEncodedFrameData();

    MOZ_IMPLICIT GMPVideoEncodedFrameData(
            const uint32_t& _mEncodedWidth,
            const uint32_t& _mEncodedHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration,
            const uint32_t& _mFrameType,
            const uint32_t& _mSize,
            const GMPBufferType& _mBufferType,
            Shmem& _mBuffer,
            const bool& _mCompleteFrame,
            const GMPDecryptionData& _mDecryptionData)
    {
        Init();
        Assign(_mEncodedWidth, _mEncodedHeight, _mTimestamp, _mDuration, _mFrameType, _mSize, _mBufferType, _mBuffer, _mCompleteFrame, _mDecryptionData);
    }

    MOZ_IMPLICIT GMPVideoEncodedFrameData(const GMPVideoEncodedFrameData& _o)
    {
        Init();
        Assign((_o).mEncodedWidth(), (_o).mEncodedHeight(), (_o).mTimestamp(), (_o).mDuration(), (_o).mFrameType(), (_o).mSize(), (_o).mBufferType(), (_o).mBuffer(), (_o).mCompleteFrame(), (_o).mDecryptionData());
    }

    ~GMPVideoEncodedFrameData();

    void
    operator=(const GMPVideoEncodedFrameData& _o)
    {
        Assign((_o).mEncodedWidth(), (_o).mEncodedHeight(), (_o).mTimestamp(), (_o).mDuration(), (_o).mFrameType(), (_o).mSize(), (_o).mBufferType(), (_o).mBuffer(), (_o).mCompleteFrame(), (_o).mDecryptionData());
    }

    bool
    operator==(const GMPVideoEncodedFrameData& _o) const;

    uint32_t&
    mEncodedWidth()
    {
        return mEncodedWidth_;
    }
    const uint32_t&
    mEncodedWidth() const
    {
        return mEncodedWidth_;
    }

    uint32_t&
    mEncodedHeight()
    {
        return mEncodedHeight_;
    }
    const uint32_t&
    mEncodedHeight() const
    {
        return mEncodedHeight_;
    }

    uint64_t&
    mTimestamp()
    {
        return mTimestamp_;
    }
    const uint64_t&
    mTimestamp() const
    {
        return mTimestamp_;
    }

    uint64_t&
    mDuration()
    {
        return mDuration_;
    }
    const uint64_t&
    mDuration() const
    {
        return mDuration_;
    }

    uint32_t&
    mFrameType()
    {
        return mFrameType_;
    }
    const uint32_t&
    mFrameType() const
    {
        return mFrameType_;
    }

    uint32_t&
    mSize()
    {
        return mSize_;
    }
    const uint32_t&
    mSize() const
    {
        return mSize_;
    }

    GMPBufferType&
    mBufferType()
    {
        return mBufferType_;
    }
    const GMPBufferType&
    mBufferType() const
    {
        return mBufferType_;
    }

    Shmem&
    mBuffer()
    {
        return mBuffer_;
    }
    Shmem&
    mBuffer() const
    {
        return const_cast<Shmem&>(mBuffer_);
    }

    bool&
    mCompleteFrame()
    {
        return mCompleteFrame_;
    }
    const bool&
    mCompleteFrame() const
    {
        return mCompleteFrame_;
    }

    GMPDecryptionData&
    mDecryptionData()
    {
        return mDecryptionData_;
    }
    const GMPDecryptionData&
    mDecryptionData() const
    {
        return mDecryptionData_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _mEncodedWidth,
            const uint32_t& _mEncodedHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration,
            const uint32_t& _mFrameType,
            const uint32_t& _mSize,
            const GMPBufferType& _mBufferType,
            Shmem& _mBuffer,
            const bool& _mCompleteFrame,
            const GMPDecryptionData& _mDecryptionData);

    uint32_t mEncodedWidth_;
    uint32_t mEncodedHeight_;
    uint64_t mTimestamp_;
    uint64_t mDuration_;
    uint32_t mFrameType_;
    uint32_t mSize_;
    GMPBufferType mBufferType_;
    Shmem mBuffer_;
    bool mCompleteFrame_;
    GMPDecryptionData mDecryptionData_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPPlaneData|
//
namespace mozilla {
namespace gmp {
class GMPPlaneData final
{
private:
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT GMPPlaneData();

    MOZ_IMPLICIT GMPPlaneData(
            const int32_t& _mSize,
            const int32_t& _mStride,
            Shmem& _mBuffer)
    {
        Init();
        Assign(_mSize, _mStride, _mBuffer);
    }

    MOZ_IMPLICIT GMPPlaneData(const GMPPlaneData& _o)
    {
        Init();
        Assign((_o).mSize(), (_o).mStride(), (_o).mBuffer());
    }

    ~GMPPlaneData();

    void
    operator=(const GMPPlaneData& _o)
    {
        Assign((_o).mSize(), (_o).mStride(), (_o).mBuffer());
    }

    bool
    operator==(const GMPPlaneData& _o) const;

    int32_t&
    mSize()
    {
        return mSize_;
    }
    const int32_t&
    mSize() const
    {
        return mSize_;
    }

    int32_t&
    mStride()
    {
        return mStride_;
    }
    const int32_t&
    mStride() const
    {
        return mStride_;
    }

    Shmem&
    mBuffer()
    {
        return mBuffer_;
    }
    Shmem&
    mBuffer() const
    {
        return const_cast<Shmem&>(mBuffer_);
    }

private:
    void
    Init();

    void
    Assign(
            const int32_t& _mSize,
            const int32_t& _mStride,
            Shmem& _mBuffer);

    int32_t mSize_;
    int32_t mStride_;
    Shmem mBuffer_;
};
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class GMPPlaneData;
} // namespace gmp
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPVideoi420FrameData|
//
namespace mozilla {
namespace gmp {
class GMPVideoi420FrameData final
{
private:
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;

public:
    MOZ_IMPLICIT GMPVideoi420FrameData();

    MOZ_IMPLICIT GMPVideoi420FrameData(
            const GMPPlaneData& _mYPlane,
            const GMPPlaneData& _mUPlane,
            const GMPPlaneData& _mVPlane,
            const int32_t& _mWidth,
            const int32_t& _mHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration)
    {
        Init();
        Assign(_mYPlane, _mUPlane, _mVPlane, _mWidth, _mHeight, _mTimestamp, _mDuration);
    }

    MOZ_IMPLICIT GMPVideoi420FrameData(const GMPVideoi420FrameData& _o)
    {
        Init();
        Assign((_o).mYPlane(), (_o).mUPlane(), (_o).mVPlane(), (_o).mWidth(), (_o).mHeight(), (_o).mTimestamp(), (_o).mDuration());
    }

    ~GMPVideoi420FrameData();

    void
    operator=(const GMPVideoi420FrameData& _o)
    {
        Assign((_o).mYPlane(), (_o).mUPlane(), (_o).mVPlane(), (_o).mWidth(), (_o).mHeight(), (_o).mTimestamp(), (_o).mDuration());
    }

    bool
    operator==(const GMPVideoi420FrameData& _o) const;

    GMPPlaneData&
    mYPlane()
    {
        return mYPlane_;
    }
    const GMPPlaneData&
    mYPlane() const
    {
        return mYPlane_;
    }

    GMPPlaneData&
    mUPlane()
    {
        return mUPlane_;
    }
    const GMPPlaneData&
    mUPlane() const
    {
        return mUPlane_;
    }

    GMPPlaneData&
    mVPlane()
    {
        return mVPlane_;
    }
    const GMPPlaneData&
    mVPlane() const
    {
        return mVPlane_;
    }

    int32_t&
    mWidth()
    {
        return mWidth_;
    }
    const int32_t&
    mWidth() const
    {
        return mWidth_;
    }

    int32_t&
    mHeight()
    {
        return mHeight_;
    }
    const int32_t&
    mHeight() const
    {
        return mHeight_;
    }

    uint64_t&
    mTimestamp()
    {
        return mTimestamp_;
    }
    const uint64_t&
    mTimestamp() const
    {
        return mTimestamp_;
    }

    uint64_t&
    mDuration()
    {
        return mDuration_;
    }
    const uint64_t&
    mDuration() const
    {
        return mDuration_;
    }

private:
    void
    Init();

    void
    Assign(
            const GMPPlaneData& _mYPlane,
            const GMPPlaneData& _mUPlane,
            const GMPPlaneData& _mVPlane,
            const int32_t& _mWidth,
            const int32_t& _mHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration);

    GMPPlaneData mYPlane_;
    GMPPlaneData mUPlane_;
    GMPPlaneData mVPlane_;
    int32_t mWidth_;
    int32_t mHeight_;
    uint64_t mTimestamp_;
    uint64_t mDuration_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPAudioCodecData|
//
namespace mozilla {
namespace gmp {
class GMPAudioCodecData final
{
private:

public:
    MOZ_IMPLICIT GMPAudioCodecData();

    MOZ_IMPLICIT GMPAudioCodecData(
            const GMPAudioCodecType& _mCodecType,
            const uint32_t& _mChannelCount,
            const uint32_t& _mBitsPerChannel,
            const uint32_t& _mSamplesPerSecond,
            const nsTArray<uint8_t>& _mExtraData)
    {
        Init();
        Assign(_mCodecType, _mChannelCount, _mBitsPerChannel, _mSamplesPerSecond, _mExtraData);
    }

    MOZ_IMPLICIT GMPAudioCodecData(const GMPAudioCodecData& _o)
    {
        Init();
        Assign((_o).mCodecType(), (_o).mChannelCount(), (_o).mBitsPerChannel(), (_o).mSamplesPerSecond(), (_o).mExtraData());
    }

    ~GMPAudioCodecData();

    void
    operator=(const GMPAudioCodecData& _o)
    {
        Assign((_o).mCodecType(), (_o).mChannelCount(), (_o).mBitsPerChannel(), (_o).mSamplesPerSecond(), (_o).mExtraData());
    }

    bool
    operator==(const GMPAudioCodecData& _o) const;

    GMPAudioCodecType&
    mCodecType()
    {
        return mCodecType_;
    }
    const GMPAudioCodecType&
    mCodecType() const
    {
        return mCodecType_;
    }

    uint32_t&
    mChannelCount()
    {
        return mChannelCount_;
    }
    const uint32_t&
    mChannelCount() const
    {
        return mChannelCount_;
    }

    uint32_t&
    mBitsPerChannel()
    {
        return mBitsPerChannel_;
    }
    const uint32_t&
    mBitsPerChannel() const
    {
        return mBitsPerChannel_;
    }

    uint32_t&
    mSamplesPerSecond()
    {
        return mSamplesPerSecond_;
    }
    const uint32_t&
    mSamplesPerSecond() const
    {
        return mSamplesPerSecond_;
    }

    nsTArray<uint8_t>&
    mExtraData()
    {
        return mExtraData_;
    }
    const nsTArray<uint8_t>&
    mExtraData() const
    {
        return mExtraData_;
    }

private:
    void
    Init();

    void
    Assign(
            const GMPAudioCodecType& _mCodecType,
            const uint32_t& _mChannelCount,
            const uint32_t& _mBitsPerChannel,
            const uint32_t& _mSamplesPerSecond,
            const nsTArray<uint8_t>& _mExtraData);

    GMPAudioCodecType mCodecType_;
    uint32_t mChannelCount_;
    uint32_t mBitsPerChannel_;
    uint32_t mSamplesPerSecond_;
    nsTArray<uint8_t> mExtraData_;
};
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class GMPDecryptionData;
} // namespace gmp
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPAudioEncodedSampleData|
//
namespace mozilla {
namespace gmp {
class GMPAudioEncodedSampleData final
{
private:
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;

public:
    MOZ_IMPLICIT GMPAudioEncodedSampleData();

    MOZ_IMPLICIT GMPAudioEncodedSampleData(
            const nsTArray<uint8_t>& _mData,
            const uint64_t& _mTimeStamp,
            const GMPDecryptionData& _mDecryptionData,
            const uint32_t& _mChannelCount,
            const uint32_t& _mSamplesPerSecond)
    {
        Init();
        Assign(_mData, _mTimeStamp, _mDecryptionData, _mChannelCount, _mSamplesPerSecond);
    }

    MOZ_IMPLICIT GMPAudioEncodedSampleData(const GMPAudioEncodedSampleData& _o)
    {
        Init();
        Assign((_o).mData(), (_o).mTimeStamp(), (_o).mDecryptionData(), (_o).mChannelCount(), (_o).mSamplesPerSecond());
    }

    ~GMPAudioEncodedSampleData();

    void
    operator=(const GMPAudioEncodedSampleData& _o)
    {
        Assign((_o).mData(), (_o).mTimeStamp(), (_o).mDecryptionData(), (_o).mChannelCount(), (_o).mSamplesPerSecond());
    }

    bool
    operator==(const GMPAudioEncodedSampleData& _o) const;

    nsTArray<uint8_t>&
    mData()
    {
        return mData_;
    }
    const nsTArray<uint8_t>&
    mData() const
    {
        return mData_;
    }

    uint64_t&
    mTimeStamp()
    {
        return mTimeStamp_;
    }
    const uint64_t&
    mTimeStamp() const
    {
        return mTimeStamp_;
    }

    GMPDecryptionData&
    mDecryptionData()
    {
        return mDecryptionData_;
    }
    const GMPDecryptionData&
    mDecryptionData() const
    {
        return mDecryptionData_;
    }

    uint32_t&
    mChannelCount()
    {
        return mChannelCount_;
    }
    const uint32_t&
    mChannelCount() const
    {
        return mChannelCount_;
    }

    uint32_t&
    mSamplesPerSecond()
    {
        return mSamplesPerSecond_;
    }
    const uint32_t&
    mSamplesPerSecond() const
    {
        return mSamplesPerSecond_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _mData,
            const uint64_t& _mTimeStamp,
            const GMPDecryptionData& _mDecryptionData,
            const uint32_t& _mChannelCount,
            const uint32_t& _mSamplesPerSecond);

    nsTArray<uint8_t> mData_;
    uint64_t mTimeStamp_;
    GMPDecryptionData mDecryptionData_;
    uint32_t mChannelCount_;
    uint32_t mSamplesPerSecond_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPAudioDecodedSampleData|
//
namespace mozilla {
namespace gmp {
class GMPAudioDecodedSampleData final
{
private:

public:
    MOZ_IMPLICIT GMPAudioDecodedSampleData();

    MOZ_IMPLICIT GMPAudioDecodedSampleData(
            const nsTArray<int16_t>& _mData,
            const uint64_t& _mTimeStamp,
            const uint32_t& _mChannelCount,
            const uint32_t& _mSamplesPerSecond)
    {
        Init();
        Assign(_mData, _mTimeStamp, _mChannelCount, _mSamplesPerSecond);
    }

    MOZ_IMPLICIT GMPAudioDecodedSampleData(const GMPAudioDecodedSampleData& _o)
    {
        Init();
        Assign((_o).mData(), (_o).mTimeStamp(), (_o).mChannelCount(), (_o).mSamplesPerSecond());
    }

    ~GMPAudioDecodedSampleData();

    void
    operator=(const GMPAudioDecodedSampleData& _o)
    {
        Assign((_o).mData(), (_o).mTimeStamp(), (_o).mChannelCount(), (_o).mSamplesPerSecond());
    }

    bool
    operator==(const GMPAudioDecodedSampleData& _o) const;

    nsTArray<int16_t>&
    mData()
    {
        return mData_;
    }
    const nsTArray<int16_t>&
    mData() const
    {
        return mData_;
    }

    uint64_t&
    mTimeStamp()
    {
        return mTimeStamp_;
    }
    const uint64_t&
    mTimeStamp() const
    {
        return mTimeStamp_;
    }

    uint32_t&
    mChannelCount()
    {
        return mChannelCount_;
    }
    const uint32_t&
    mChannelCount() const
    {
        return mChannelCount_;
    }

    uint32_t&
    mSamplesPerSecond()
    {
        return mSamplesPerSecond_;
    }
    const uint32_t&
    mSamplesPerSecond() const
    {
        return mSamplesPerSecond_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<int16_t>& _mData,
            const uint64_t& _mTimeStamp,
            const uint32_t& _mChannelCount,
            const uint32_t& _mSamplesPerSecond);

    nsTArray<int16_t> mData_;
    uint64_t mTimeStamp_;
    uint32_t mChannelCount_;
    uint32_t mSamplesPerSecond_;
};
} // namespace gmp
} // namespace mozilla

#endif // ifndef GMPTypes_h
