//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPStorageParent_h
#define PGMPStorageParent_h

#include "mozilla/gmp/PGMPStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPStorageParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::gmp::PGMPParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPParent PGMPParent;
    typedef mozilla::gmp::PGMPChild PGMPChild;

    typedef PGMPStorage::State State;

    virtual bool
    RecvOpen(const nsCString& aRecordName) = 0;
    virtual bool
    RecvRead(const nsCString& aRecordName) = 0;
    virtual bool
    RecvWrite(
            const nsCString& aRecordName,
            nsTArray<uint8_t>&& aBytes) = 0;
    virtual bool
    RecvClose(const nsCString& aRecordName) = 0;
    virtual bool
    RecvGetRecordNames() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PGMPStorageParent();

    virtual ~PGMPStorageParent();

    PGMPParent*
    Manager() const;

    PGMPStorage::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendOpenComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    MOZ_WARN_UNUSED_RESULT bool
    SendReadComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus,
            const nsTArray<uint8_t>& aBytes);

    MOZ_WARN_UNUSED_RESULT bool
    SendWriteComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    MOZ_WARN_UNUSED_RESULT bool
    SendRecordNames(
            const nsTArray<nsCString>& aRecordNames,
            const GMPErr& aStatus);

    MOZ_WARN_UNUSED_RESULT bool
    SendShutdown();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PGMPStorageParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PGMPStorageParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPStorageParent :
    public PGMPStorageParent
{
    virtual bool
    RecvOpen(const nsCString& aRecordName);

    virtual bool
    RecvRead(const nsCString& aRecordName);

    virtual bool
    RecvWrite(
            const nsCString& aRecordName,
            nsTArray<uint8_t>&& aBytes);

    virtual bool
    RecvClose(const nsCString& aRecordName);

    virtual bool
    RecvGetRecordNames();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPStorageParent();
    virtual ~GMPStorageParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPStorageParent::RecvOpen(const nsCString& aRecordName)
{
    return false;
}

bool
GMPStorageParent::RecvRead(const nsCString& aRecordName)
{
    return false;
}

bool
GMPStorageParent::RecvWrite(
        const nsCString& aRecordName,
        nsTArray<uint8_t>&& aBytes)
{
    return false;
}

bool
GMPStorageParent::RecvClose(const nsCString& aRecordName)
{
    return false;
}

bool
GMPStorageParent::RecvGetRecordNames()
{
    return false;
}

void
GMPStorageParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPStorageParent::GMPStorageParent()
{
    MOZ_COUNT_CTOR(GMPStorageParent);
}

MOZ_IMPLICIT GMPStorageParent::~GMPStorageParent()
{
    MOZ_COUNT_DTOR(GMPStorageParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPStorageParent_h
