//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalParent_h
#define PHalParent_h

#include "mozilla/hal_sandbox/PHal.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "nsRect.h"
#include "prtime.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class PHalParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    typedef mozilla::hal::FMRadioCountry FMRadioCountry;
    typedef mozilla::hal::FMRadioOperation FMRadioOperation;
    typedef mozilla::hal::FMRadioOperationInformation FMRadioOperationInformation;
    typedef mozilla::hal::FMRadioOperationStatus FMRadioOperationStatus;
    typedef mozilla::hal::FMRadioRDSGroup FMRadioRDSGroup;
    typedef mozilla::hal::FMRadioSettings FMRadioSettings;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef base::ProcessId ProcessId;
    typedef mozilla::hal::ProcessPriority ProcessPriority;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::hal::ScreenConfiguration ScreenConfiguration;
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;
    typedef mozilla::hal::SensorAccuracyType SensorAccuracyType;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::SwitchDevice SwitchDevice;
    typedef mozilla::hal::SwitchEvent SwitchEvent;
    typedef mozilla::hal::SwitchState SwitchState;
    typedef mozilla::hal::SystemTimezoneChangeInformation SystemTimezoneChangeInformation;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::hal::WakeLockControl WakeLockControl;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;

    typedef PHal::State State;

    virtual bool
    RecvVibrate(
            nsTArray<uint32_t>&& pattern,
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) = 0;
    virtual bool
    RecvCancelVibrate(
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) = 0;
    virtual bool
    RecvEnableBatteryNotifications() = 0;
    virtual bool
    RecvDisableBatteryNotifications() = 0;
    virtual bool
    RecvGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo) = 0;
    virtual bool
    RecvEnableNetworkNotifications() = 0;
    virtual bool
    RecvDisableNetworkNotifications() = 0;
    virtual bool
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo) = 0;
    virtual bool
    RecvGetScreenEnabled(bool* enabled) = 0;
    virtual bool
    RecvSetScreenEnabled(const bool& aEnabled) = 0;
    virtual bool
    RecvGetKeyLightEnabled(bool* enabled) = 0;
    virtual bool
    RecvSetKeyLightEnabled(const bool& aEnabled) = 0;
    virtual bool
    RecvGetCpuSleepAllowed(bool* allowed) = 0;
    virtual bool
    RecvSetCpuSleepAllowed(const bool& aAllowed) = 0;
    virtual bool
    RecvGetScreenBrightness(double* brightness) = 0;
    virtual bool
    RecvSetScreenBrightness(const double& aBrightness) = 0;
    virtual bool
    RecvAdjustSystemClock(const int64_t& aDeltaMilliseconds) = 0;
    virtual bool
    RecvSetTimezone(const nsCString& aTimezoneSpec) = 0;
    virtual bool
    RecvGetTimezone(nsCString* aTimezoneSpec) = 0;
    virtual bool
    RecvGetTimezoneOffset(int32_t* aTimezoneOffset) = 0;
    virtual bool
    RecvEnableSystemClockChangeNotifications() = 0;
    virtual bool
    RecvDisableSystemClockChangeNotifications() = 0;
    virtual bool
    RecvEnableSystemTimezoneChangeNotifications() = 0;
    virtual bool
    RecvDisableSystemTimezoneChangeNotifications() = 0;
    virtual bool
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID) = 0;
    virtual bool
    RecvEnableWakeLockNotifications() = 0;
    virtual bool
    RecvDisableWakeLockNotifications() = 0;
    virtual bool
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo) = 0;
    virtual bool
    RecvEnableScreenConfigurationNotifications() = 0;
    virtual bool
    RecvDisableScreenConfigurationNotifications() = 0;
    virtual bool
    RecvGetCurrentScreenConfiguration(ScreenConfiguration* aScreenConfiguration) = 0;
    virtual bool
    RecvLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed) = 0;
    virtual bool
    RecvUnlockScreenOrientation() = 0;
    virtual bool
    RecvEnableSwitchNotifications(const SwitchDevice& aDevice) = 0;
    virtual bool
    RecvDisableSwitchNotifications(const SwitchDevice& aDevice) = 0;
    virtual bool
    RecvGetCurrentSwitchState(
            const SwitchDevice& aDevice,
            SwitchState* aState) = 0;
    virtual bool
    RecvFactoryReset(const nsString& aReason) = 0;
    virtual bool
    RecvEnableSensorNotifications(const SensorType& aSensor) = 0;
    virtual bool
    RecvDisableSensorNotifications(const SensorType& aSensor) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PHalParent();

    virtual ~PHalParent();

    PContentParent*
    Manager() const;

    PHal::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyBatteryChange(const BatteryInformation& aBatteryInfo);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyNetworkChange(const NetworkInformation& aNetworkInfo);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifySwitchChange(const SwitchEvent& aEvent);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifySystemClockChange(const int64_t& aClockDeltaMS);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifySystemTimezoneChange(const SystemTimezoneChangeInformation& aSystemTimezoneChangeInfo);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifySensorChange(const SensorData& aSensorData);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SwitchEvent& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SwitchEvent* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PBrowserParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PBrowserParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const ScreenConfiguration& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            ScreenConfiguration* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const BatteryInformation& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            BatteryInformation* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const WakeLockInformation& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            WakeLockInformation* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const NetworkInformation& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            NetworkInformation* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SystemTimezoneChangeInformation& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SystemTimezoneChangeInformation* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SensorData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SensorData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PHalParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PHalParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace hal_sandbox
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace hal_sandbox {
class HalParent :
    public PHalParent
{
    virtual bool
    RecvVibrate(
            nsTArray<uint32_t>&& pattern,
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser);

    virtual bool
    RecvCancelVibrate(
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser);

    virtual bool
    RecvEnableBatteryNotifications();

    virtual bool
    RecvDisableBatteryNotifications();

    virtual bool
    RecvGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo);

    virtual bool
    RecvEnableNetworkNotifications();

    virtual bool
    RecvDisableNetworkNotifications();

    virtual bool
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo);

    virtual bool
    RecvGetScreenEnabled(bool* enabled);

    virtual bool
    RecvSetScreenEnabled(const bool& aEnabled);

    virtual bool
    RecvGetKeyLightEnabled(bool* enabled);

    virtual bool
    RecvSetKeyLightEnabled(const bool& aEnabled);

    virtual bool
    RecvGetCpuSleepAllowed(bool* allowed);

    virtual bool
    RecvSetCpuSleepAllowed(const bool& aAllowed);

    virtual bool
    RecvGetScreenBrightness(double* brightness);

    virtual bool
    RecvSetScreenBrightness(const double& aBrightness);

    virtual bool
    RecvAdjustSystemClock(const int64_t& aDeltaMilliseconds);

    virtual bool
    RecvSetTimezone(const nsCString& aTimezoneSpec);

    virtual bool
    RecvGetTimezone(nsCString* aTimezoneSpec);

    virtual bool
    RecvGetTimezoneOffset(int32_t* aTimezoneOffset);

    virtual bool
    RecvEnableSystemClockChangeNotifications();

    virtual bool
    RecvDisableSystemClockChangeNotifications();

    virtual bool
    RecvEnableSystemTimezoneChangeNotifications();

    virtual bool
    RecvDisableSystemTimezoneChangeNotifications();

    virtual bool
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID);

    virtual bool
    RecvEnableWakeLockNotifications();

    virtual bool
    RecvDisableWakeLockNotifications();

    virtual bool
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo);

    virtual bool
    RecvEnableScreenConfigurationNotifications();

    virtual bool
    RecvDisableScreenConfigurationNotifications();

    virtual bool
    RecvGetCurrentScreenConfiguration(ScreenConfiguration* aScreenConfiguration);

    virtual bool
    RecvLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed);

    virtual bool
    RecvUnlockScreenOrientation();

    virtual bool
    RecvEnableSwitchNotifications(const SwitchDevice& aDevice);

    virtual bool
    RecvDisableSwitchNotifications(const SwitchDevice& aDevice);

    virtual bool
    RecvGetCurrentSwitchState(
            const SwitchDevice& aDevice,
            SwitchState* aState);

    virtual bool
    RecvFactoryReset(const nsString& aReason);

    virtual bool
    RecvEnableSensorNotifications(const SensorType& aSensor);

    virtual bool
    RecvDisableSensorNotifications(const SensorType& aSensor);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT HalParent();
    virtual ~HalParent();
};
} // namespace hal_sandbox
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace hal_sandbox {
bool
HalParent::RecvVibrate(
        nsTArray<uint32_t>&& pattern,
        nsTArray<uint64_t>&& id,
        PBrowserParent* browser)
{
    return false;
}

bool
HalParent::RecvCancelVibrate(
        nsTArray<uint64_t>&& id,
        PBrowserParent* browser)
{
    return false;
}

bool
HalParent::RecvEnableBatteryNotifications()
{
    return false;
}

bool
HalParent::RecvDisableBatteryNotifications()
{
    return false;
}

bool
HalParent::RecvGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo)
{
    return false;
}

bool
HalParent::RecvEnableNetworkNotifications()
{
    return false;
}

bool
HalParent::RecvDisableNetworkNotifications()
{
    return false;
}

bool
HalParent::RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo)
{
    return false;
}

bool
HalParent::RecvGetScreenEnabled(bool* enabled)
{
    return false;
}

bool
HalParent::RecvSetScreenEnabled(const bool& aEnabled)
{
    return false;
}

bool
HalParent::RecvGetKeyLightEnabled(bool* enabled)
{
    return false;
}

bool
HalParent::RecvSetKeyLightEnabled(const bool& aEnabled)
{
    return false;
}

bool
HalParent::RecvGetCpuSleepAllowed(bool* allowed)
{
    return false;
}

bool
HalParent::RecvSetCpuSleepAllowed(const bool& aAllowed)
{
    return false;
}

bool
HalParent::RecvGetScreenBrightness(double* brightness)
{
    return false;
}

bool
HalParent::RecvSetScreenBrightness(const double& aBrightness)
{
    return false;
}

bool
HalParent::RecvAdjustSystemClock(const int64_t& aDeltaMilliseconds)
{
    return false;
}

bool
HalParent::RecvSetTimezone(const nsCString& aTimezoneSpec)
{
    return false;
}

bool
HalParent::RecvGetTimezone(nsCString* aTimezoneSpec)
{
    return false;
}

bool
HalParent::RecvGetTimezoneOffset(int32_t* aTimezoneOffset)
{
    return false;
}

bool
HalParent::RecvEnableSystemClockChangeNotifications()
{
    return false;
}

bool
HalParent::RecvDisableSystemClockChangeNotifications()
{
    return false;
}

bool
HalParent::RecvEnableSystemTimezoneChangeNotifications()
{
    return false;
}

bool
HalParent::RecvDisableSystemTimezoneChangeNotifications()
{
    return false;
}

bool
HalParent::RecvModifyWakeLock(
        const nsString& aTopic,
        const WakeLockControl& aLockAdjust,
        const WakeLockControl& aHiddenAdjust,
        const uint64_t& aProcessID)
{
    return false;
}

bool
HalParent::RecvEnableWakeLockNotifications()
{
    return false;
}

bool
HalParent::RecvDisableWakeLockNotifications()
{
    return false;
}

bool
HalParent::RecvGetWakeLockInfo(
        const nsString& aTopic,
        WakeLockInformation* aWakeLockInfo)
{
    return false;
}

bool
HalParent::RecvEnableScreenConfigurationNotifications()
{
    return false;
}

bool
HalParent::RecvDisableScreenConfigurationNotifications()
{
    return false;
}

bool
HalParent::RecvGetCurrentScreenConfiguration(ScreenConfiguration* aScreenConfiguration)
{
    return false;
}

bool
HalParent::RecvLockScreenOrientation(
        const ScreenOrientationInternal& aOrientation,
        bool* allowed)
{
    return false;
}

bool
HalParent::RecvUnlockScreenOrientation()
{
    return false;
}

bool
HalParent::RecvEnableSwitchNotifications(const SwitchDevice& aDevice)
{
    return false;
}

bool
HalParent::RecvDisableSwitchNotifications(const SwitchDevice& aDevice)
{
    return false;
}

bool
HalParent::RecvGetCurrentSwitchState(
        const SwitchDevice& aDevice,
        SwitchState* aState)
{
    return false;
}

bool
HalParent::RecvFactoryReset(const nsString& aReason)
{
    return false;
}

bool
HalParent::RecvEnableSensorNotifications(const SensorType& aSensor)
{
    return false;
}

bool
HalParent::RecvDisableSensorNotifications(const SensorType& aSensor)
{
    return false;
}

void
HalParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT HalParent::HalParent()
{
    MOZ_COUNT_CTOR(HalParent);
}

MOZ_IMPLICIT HalParent::~HalParent()
{
    MOZ_COUNT_DTOR(HalParent);
}

} // namespace hal_sandbox
} // namespace mozilla
#endif // if 0

#endif // ifndef PHalParent_h
