//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSharedBufferManagerParent_h
#define PSharedBufferManagerParent_h

#include "mozilla/layers/PSharedBufferManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

class nsIFile;

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"

namespace mozilla {
namespace layers {


class PSharedBufferManagerParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>,
    public mozilla::ipc::IToplevelProtocol
{
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::EGLImageDescriptor EGLImageDescriptor;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::layers::GrallocBufferRef GrallocBufferRef;
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::layers::MagicGrallocBufferHandle MagicGrallocBufferHandle;
    typedef mozilla::layers::MaybeMagicGrallocBufferHandle MaybeMagicGrallocBufferHandle;
    typedef mozilla::layers::OverlayHandle OverlayHandle;
    typedef mozilla::layers::OverlaySource OverlaySource;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolFdMapping ProtocolFdMapping;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::layers::SurfaceDescriptor SurfaceDescriptor;
    typedef mozilla::layers::SurfaceDescriptorD3D10 SurfaceDescriptorD3D10;
    typedef mozilla::layers::SurfaceDescriptorD3D9 SurfaceDescriptorD3D9;
    typedef mozilla::layers::SurfaceDescriptorDIB SurfaceDescriptorDIB;
    typedef mozilla::layers::SurfaceDescriptorDXGIYCbCr SurfaceDescriptorDXGIYCbCr;
    typedef mozilla::layers::SurfaceDescriptorFileMapping SurfaceDescriptorFileMapping;
    typedef mozilla::layers::SurfaceDescriptorGralloc SurfaceDescriptorGralloc;
    typedef mozilla::layers::SurfaceDescriptorMacIOSurface SurfaceDescriptorMacIOSurface;
    typedef mozilla::layers::SurfaceDescriptorMemory SurfaceDescriptorMemory;
    typedef mozilla::layers::SurfaceDescriptorSharedGLTexture SurfaceDescriptorSharedGLTexture;
    typedef mozilla::layers::SurfaceDescriptorShmem SurfaceDescriptorShmem;
    typedef mozilla::layers::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;
    typedef mozilla::layers::SurfaceTextureDescriptor SurfaceTextureDescriptor;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::WindowsHandle WindowsHandle;
    typedef mozilla::null_t null_t;

    typedef PSharedBufferManager::State State;

    virtual bool
    RecvAllocateGrallocBuffer(
            const IntSize& size,
            const uint32_t& format,
            const uint32_t& usage,
            MaybeMagicGrallocBufferHandle* handle) = 0;
    virtual bool
    RecvDropGrallocBuffer(const MaybeMagicGrallocBufferHandle& handle) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PSharedBufferManagerParent();

    virtual ~PSharedBufferManagerParent();

    bool
    Open(
            Channel::Transport* aTransport,
            base::ProcessId aOtherPid,
            MessageLoop* aThread = nullptr,
            mozilla::ipc::Side aSide = mozilla::ipc::UnknownSide);

    bool
    Open(
            MessageChannel* aChannel,
            MessageLoop* aMessageLoop,
            mozilla::ipc::Side aSide = mozilla::ipc::UnknownSide);

    void
    Close();

    void
    SetReplyTimeoutMs(int32_t aTimeoutMs);

    PSharedBufferManager::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendDropGrallocBuffer(const MaybeMagicGrallocBufferHandle& handle);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnEnteredCxxStack();
    void
    OnExitedCxxStack();
    void
    OnEnteredCall();
    void
    OnExitedCall();
    bool
    IsOnCxxStack() const;
    void
    FlushPendingInterruptQueue();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

    void
    SetOtherProcessId(base::ProcessId aOtherPid);

protected:
    bool
    TakeMinidump(
            nsIFile** aDump,
            uint32_t* aSequence) const;

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    void
    DeallocShmems();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const MaybeMagicGrallocBufferHandle& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            MaybeMagicGrallocBufferHandle* v__,
            const Message* msg__,
            void** iter__);

    Channel mChannel;
    IDMap<ProtocolBase> mActorMap;
    int32_t mLastRouteId;
    base::ProcessId mOtherPid;
    IDMap<Shmem::SharedMemory> mShmemMap;
    Shmem::id_t mLastShmemId;
    State mState;
};


} // namespace layers
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class SharedBufferManagerParent :
    public PSharedBufferManagerParent
{
    virtual bool
    RecvAllocateGrallocBuffer(
            const IntSize& size,
            const uint32_t& format,
            const uint32_t& usage,
            MaybeMagicGrallocBufferHandle* handle);

    virtual bool
    RecvDropGrallocBuffer(const MaybeMagicGrallocBufferHandle& handle);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT SharedBufferManagerParent();
    virtual ~SharedBufferManagerParent();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
bool
SharedBufferManagerParent::RecvAllocateGrallocBuffer(
        const IntSize& size,
        const uint32_t& format,
        const uint32_t& usage,
        MaybeMagicGrallocBufferHandle* handle)
{
    return false;
}

bool
SharedBufferManagerParent::RecvDropGrallocBuffer(const MaybeMagicGrallocBufferHandle& handle)
{
    return false;
}

void
SharedBufferManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT SharedBufferManagerParent::SharedBufferManagerParent()
{
    MOZ_COUNT_CTOR(SharedBufferManagerParent);
}

MOZ_IMPLICIT SharedBufferManagerParent::~SharedBufferManagerParent()
{
    MOZ_COUNT_DTOR(SharedBufferManagerParent);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PSharedBufferManagerParent_h
