//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMediaSystemResourceManagerParent_h
#define PMediaSystemResourceManagerParent_h

#include "mozilla/media/PMediaSystemResourceManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/media/MediaSystemResourceMessageUtils.h"
#include "mozilla/media/MediaSystemResourceTypes.h"

namespace mozilla {
namespace layers {
class PImageBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PImageBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PImageBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace media {


class PMediaSystemResourceManagerParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::layers::PImageBridgeParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::MediaSystemResourceType MediaSystemResourceType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::PImageBridgeParent PImageBridgeParent;
    typedef mozilla::layers::PImageBridgeChild PImageBridgeChild;

    typedef PMediaSystemResourceManager::State State;

    virtual bool
    RecvAcquire(
            const uint32_t& aId,
            const MediaSystemResourceType& aResourceType,
            const bool& aWillWait) = 0;
    virtual bool
    RecvRelease(const uint32_t& aId) = 0;
    virtual bool
    RecvRemoveResourceManager() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PMediaSystemResourceManagerParent();

    virtual ~PMediaSystemResourceManagerParent();

    PImageBridgeParent*
    Manager() const;

    PMediaSystemResourceManager::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendResponse(
            const uint32_t& aId,
            const bool& aSuccess);

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(PMediaSystemResourceManagerParent* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PMediaSystemResourceManagerParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PMediaSystemResourceManagerParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace media
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace media {
class MediaSystemResourceManagerParent :
    public PMediaSystemResourceManagerParent
{
    virtual bool
    RecvAcquire(
            const uint32_t& aId,
            const MediaSystemResourceType& aResourceType,
            const bool& aWillWait);

    virtual bool
    RecvRelease(const uint32_t& aId);

    virtual bool
    RecvRemoveResourceManager();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT MediaSystemResourceManagerParent();
    virtual ~MediaSystemResourceManagerParent();
};
} // namespace media
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace media {
bool
MediaSystemResourceManagerParent::RecvAcquire(
        const uint32_t& aId,
        const MediaSystemResourceType& aResourceType,
        const bool& aWillWait)
{
    return false;
}

bool
MediaSystemResourceManagerParent::RecvRelease(const uint32_t& aId)
{
    return false;
}

bool
MediaSystemResourceManagerParent::RecvRemoveResourceManager()
{
    return false;
}

void
MediaSystemResourceManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT MediaSystemResourceManagerParent::MediaSystemResourceManagerParent()
{
    MOZ_COUNT_CTOR(MediaSystemResourceManagerParent);
}

MOZ_IMPLICIT MediaSystemResourceManagerParent::~MediaSystemResourceManagerParent()
{
    MOZ_COUNT_DTOR(MediaSystemResourceManagerParent);
}

} // namespace media
} // namespace mozilla
#endif // if 0

#endif // ifndef PMediaSystemResourceManagerParent_h
