//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDNSRequestParent_h
#define PDNSRequestParent_h

#include "mozilla/net/PDNSRequest.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class PDNSRequestParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::net::DNSRecord DNSRecord;
    typedef mozilla::net::DNSRequestResponse DNSRequestResponse;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;

    typedef PDNSRequest::State State;

    virtual bool
    RecvCancelDNSRequest(
            const nsCString& hostName,
            const uint32_t& flags,
            const nsCString& networkInterface,
            const nsresult& reason) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PDNSRequestParent();

    virtual ~PDNSRequestParent();

    PNeckoParent*
    Manager() const;

    PDNSRequest::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendLookupCompleted(const DNSRequestResponse& reply);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const DNSRequestResponse& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            DNSRequestResponse* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PDNSRequestParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PDNSRequestParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const DNSRecord& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            DNSRecord* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class DNSRequestParent :
    public PDNSRequestParent
{
    virtual bool
    RecvCancelDNSRequest(
            const nsCString& hostName,
            const uint32_t& flags,
            const nsCString& networkInterface,
            const nsresult& reason);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT DNSRequestParent();
    virtual ~DNSRequestParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
DNSRequestParent::RecvCancelDNSRequest(
        const nsCString& hostName,
        const uint32_t& flags,
        const nsCString& networkInterface,
        const nsresult& reason)
{
    return false;
}

void
DNSRequestParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT DNSRequestParent::DNSRequestParent()
{
    MOZ_COUNT_CTOR(DNSRequestParent);
}

MOZ_IMPLICIT DNSRequestParent::~DNSRequestParent()
{
    MOZ_COUNT_DTOR(DNSRequestParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PDNSRequestParent_h
