//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTCPSocketChild_h
#define PTCPSocketChild_h

#include "mozilla/net/PTCPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PTCPServerSocketChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class PTCPSocketChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PTCPServerSocketChild;

    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::net::PNeckoParent PNeckoParent;

    typedef PTCPSocket::State State;

    virtual bool
    RecvCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState) = 0;
    virtual bool
    RecvUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber) = 0;
    virtual bool
    RecvRequestDelete() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PTCPSocketChild();

    virtual ~PTCPSocketChild();

    PNeckoChild*
    Manager() const;

    PTCPSocket::State
    state();

    bool
    SendOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const bool& useArrayBuffers);

    bool
    SendOpenBind(
            const nsCString& host,
            const uint16_t& port,
            const nsCString& localAddr,
            const uint16_t& localPort,
            const bool& useSSL,
            const bool& aUseArrayBuffers);

    bool
    SendData(
            const SendableData& data,
            const uint32_t& trackingNumber);

    bool
    SendStartTLS();

    bool
    SendSuspend();

    bool
    SendResume();

    bool
    SendClose();

    bool
    SendRequestDelete();

    static bool
    Send__delete__(PTCPSocketChild* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SendableData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SendableData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PTCPSocketChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PTCPSocketChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const CallbackData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            CallbackData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const TCPError& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            TCPError* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class TCPSocketChild :
    public PTCPSocketChild
{
    virtual bool
    RecvCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState);

    virtual bool
    RecvUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber);

    virtual bool
    RecvRequestDelete();

    MOZ_IMPLICIT TCPSocketChild();
    virtual ~TCPSocketChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
TCPSocketChild::RecvCallback(
        const nsString& type,
        const CallbackData& data,
        const uint32_t& readyState)
{
    return false;
}

bool
TCPSocketChild::RecvUpdateBufferedAmount(
        const uint32_t& bufferedAmount,
        const uint32_t& trackingNumber)
{
    return false;
}

bool
TCPSocketChild::RecvRequestDelete()
{
    return false;
}

MOZ_IMPLICIT TCPSocketChild::TCPSocketChild()
{
    MOZ_COUNT_CTOR(TCPSocketChild);
}

MOZ_IMPLICIT TCPSocketChild::~TCPSocketChild()
{
    MOZ_COUNT_DTOR(TCPSocketChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PTCPSocketChild_h
