//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PUDPSocket_h
#define PUDPSocket_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"

// Headers for typedefs
#include "mozilla/net/DNS.h"
#include "mozilla/ipc/InputStreamParams.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UDPAddressInfo|
//
class UDPAddressInfo final
{
private:

public:
    MOZ_IMPLICIT UDPAddressInfo();

    MOZ_IMPLICIT UDPAddressInfo(
            const nsCString& _addr,
            const uint16_t& _port)
    {
        Init();
        Assign(_addr, _port);
    }

    MOZ_IMPLICIT UDPAddressInfo(const UDPAddressInfo& _o)
    {
        Init();
        Assign((_o).addr(), (_o).port());
    }

    ~UDPAddressInfo();

    void
    operator=(const UDPAddressInfo& _o)
    {
        Assign((_o).addr(), (_o).port());
    }

    bool
    operator==(const UDPAddressInfo& _o) const;

    nsCString&
    addr()
    {
        return addr_;
    }
    const nsCString&
    addr() const
    {
        return addr_;
    }

    uint16_t&
    port()
    {
        return port_;
    }
    const uint16_t&
    port() const
    {
        return port_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _addr,
            const uint16_t& _port);

    nsCString addr_;
    uint16_t port_;
};

class UDPAddressInfo;

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union UDPSocketAddr|
//
class UDPSocketAddr final
{
public:
    enum Type {
        T__None,
        TUDPAddressInfo = 1,
        TNetAddr,
        T__Last = TNetAddr
    };

private:
    typedef mozilla::net::NetAddr NetAddr;
    typedef UDPAddressInfo UDPAddressInfo__tdef;
    typedef NetAddr NetAddr__tdef;

    union Value {
        mozilla::AlignedStorage2<UDPAddressInfo> VUDPAddressInfo;
        mozilla::AlignedStorage2<NetAddr> VNetAddr;
    };

    UDPAddressInfo*
    ptr_UDPAddressInfo()
    {
        return ((mValue).VUDPAddressInfo).addr();
    }
    const UDPAddressInfo* const
    constptr_UDPAddressInfo() const
    {
        return ((mValue).VUDPAddressInfo).addr();
    }
    NetAddr*
    ptr_NetAddr()
    {
        return ((mValue).VNetAddr).addr();
    }
    const NetAddr* const
    constptr_NetAddr() const
    {
        return ((mValue).VNetAddr).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT UDPSocketAddr() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT UDPSocketAddr(const UDPAddressInfo& aOther);

    MOZ_IMPLICIT UDPSocketAddr(const NetAddr& aOther);

    MOZ_IMPLICIT UDPSocketAddr(const UDPSocketAddr& aOther);

    ~UDPSocketAddr();

    Type
    type() const
    {
        return mType;
    }

    UDPSocketAddr&
    operator=(const UDPAddressInfo& aRhs);

    UDPSocketAddr&
    operator=(const NetAddr& aRhs);

    UDPSocketAddr&
    operator=(const UDPSocketAddr& aRhs);

    bool
    operator==(const UDPAddressInfo& aRhs) const;

    bool
    operator==(const NetAddr& aRhs) const;

    bool
    operator==(const UDPSocketAddr& aRhs) const;

    UDPAddressInfo&
    get_UDPAddressInfo()
    {
        AssertSanity(TUDPAddressInfo);
        return (*(ptr_UDPAddressInfo()));
    }
    const UDPAddressInfo&
    get_UDPAddressInfo() const
    {
        AssertSanity(TUDPAddressInfo);
        return (*(constptr_UDPAddressInfo()));
    }
    operator UDPAddressInfo&()
    {
        return get_UDPAddressInfo();
    }
    operator const UDPAddressInfo&() const
    {
        return get_UDPAddressInfo();
    }

    NetAddr&
    get_NetAddr()
    {
        AssertSanity(TNetAddr);
        return (*(ptr_NetAddr()));
    }
    const NetAddr&
    get_NetAddr() const
    {
        AssertSanity(TNetAddr);
        return (*(constptr_NetAddr()));
    }
    operator NetAddr&()
    {
        return get_NetAddr();
    }
    operator const NetAddr&() const
    {
        return get_NetAddr();
    }

private:
    Value mValue;
    Type mType;
};

namespace mozilla {
namespace ipc {
class InputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union UDPData|
//
class UDPData final
{
public:
    enum Type {
        T__None,
        TArrayOfuint8_t = 1,
        TInputStreamParams,
        T__Last = TInputStreamParams
    };

private:
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef nsTArray<uint8_t> ArrayOfuint8_t__tdef;
    typedef InputStreamParams InputStreamParams__tdef;

    union Value {
        mozilla::AlignedStorage2<nsTArray<uint8_t>> VArrayOfuint8_t;
        mozilla::AlignedStorage2<InputStreamParams> VInputStreamParams;
    };

    nsTArray<uint8_t>*
    ptr_ArrayOfuint8_t()
    {
        return ((mValue).VArrayOfuint8_t).addr();
    }
    const nsTArray<uint8_t>* const
    constptr_ArrayOfuint8_t() const
    {
        return ((mValue).VArrayOfuint8_t).addr();
    }
    InputStreamParams*
    ptr_InputStreamParams()
    {
        return ((mValue).VInputStreamParams).addr();
    }
    const InputStreamParams* const
    constptr_InputStreamParams() const
    {
        return ((mValue).VInputStreamParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT UDPData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT UDPData(const nsTArray<uint8_t>& aOther);

    MOZ_IMPLICIT UDPData(const InputStreamParams& aOther);

    MOZ_IMPLICIT UDPData(const UDPData& aOther);

    ~UDPData();

    Type
    type() const
    {
        return mType;
    }

    UDPData&
    operator=(const nsTArray<uint8_t>& aRhs);

    UDPData&
    operator=(const InputStreamParams& aRhs);

    UDPData&
    operator=(const UDPData& aRhs);

    bool
    operator==(const nsTArray<uint8_t>& aRhs) const;

    bool
    operator==(const InputStreamParams& aRhs) const;

    bool
    operator==(const UDPData& aRhs) const;

    nsTArray<uint8_t>&
    get_ArrayOfuint8_t()
    {
        AssertSanity(TArrayOfuint8_t);
        return (*(ptr_ArrayOfuint8_t()));
    }
    const nsTArray<uint8_t>&
    get_ArrayOfuint8_t() const
    {
        AssertSanity(TArrayOfuint8_t);
        return (*(constptr_ArrayOfuint8_t()));
    }
    operator nsTArray<uint8_t>&()
    {
        return get_ArrayOfuint8_t();
    }
    operator const nsTArray<uint8_t>&() const
    {
        return get_ArrayOfuint8_t();
    }

    InputStreamParams&
    get_InputStreamParams()
    {
        AssertSanity(TInputStreamParams);
        return (*(ptr_InputStreamParams()));
    }
    const InputStreamParams&
    get_InputStreamParams() const
    {
        AssertSanity(TInputStreamParams);
        return (*(constptr_InputStreamParams()));
    }
    operator InputStreamParams&()
    {
        return get_InputStreamParams();
    }
    operator const InputStreamParams&() const
    {
        return get_InputStreamParams();
    }

private:
    Value mValue;
    Type mType;
};

//-----------------------------------------------------------------------------
// Code common to PUDPSocketChild and PUDPSocketParent
//
namespace mozilla {
namespace net {
namespace PUDPSocket {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PUDPSocketStart = PUDPSocketMsgStart << 16,
    Msg_Bind__ID,
    Msg_OutgoingData__ID,
    Msg_JoinMulticast__ID,
    Msg_LeaveMulticast__ID,
    Msg_Close__ID,
    Msg_RequestDelete__ID,
    Msg_CallbackOpened__ID,
    Msg_CallbackClosed__ID,
    Msg_CallbackReceivedData__ID,
    Msg_CallbackError__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PUDPSocketEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_Bind :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Bind__ID
    };
    MOZ_IMPLICIT Msg_Bind(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_Bind")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Bind(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_OutgoingData :
    public IPC::Message
{
public:
    enum {
        ID = Msg_OutgoingData__ID
    };
    MOZ_IMPLICIT Msg_OutgoingData(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_OutgoingData")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_OutgoingData(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_JoinMulticast :
    public IPC::Message
{
public:
    enum {
        ID = Msg_JoinMulticast__ID
    };
    MOZ_IMPLICIT Msg_JoinMulticast(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_JoinMulticast")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_JoinMulticast(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_LeaveMulticast :
    public IPC::Message
{
public:
    enum {
        ID = Msg_LeaveMulticast__ID
    };
    MOZ_IMPLICIT Msg_LeaveMulticast(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_LeaveMulticast")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_LeaveMulticast(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Close :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Close__ID
    };
    MOZ_IMPLICIT Msg_Close(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_Close")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Close(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RequestDelete :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RequestDelete__ID
    };
    MOZ_IMPLICIT Msg_RequestDelete(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_RequestDelete")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RequestDelete(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CallbackOpened :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CallbackOpened__ID
    };
    MOZ_IMPLICIT Msg_CallbackOpened(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_CallbackOpened")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CallbackOpened(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CallbackClosed :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CallbackClosed__ID
    };
    MOZ_IMPLICIT Msg_CallbackClosed(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_CallbackClosed")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CallbackClosed(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CallbackReceivedData :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CallbackReceivedData__ID
    };
    MOZ_IMPLICIT Msg_CallbackReceivedData(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_CallbackReceivedData")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CallbackReceivedData(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CallbackError :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CallbackError__ID
    };
    MOZ_IMPLICIT Msg_CallbackError(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg_CallbackError")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CallbackError(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PUDPSocket::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PUDPSocket
} // namespace net
} // namespace mozilla

#endif // ifndef PUDPSocket_h
