//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPluginInstance_h
#define PPluginInstance_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"

// Headers for typedefs
#include "gfxipc/ShadowLayerUtils.h"
#include "ipc/IPCMessageUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IOSurfaceDescriptor|
//
namespace mozilla {
namespace plugins {
class IOSurfaceDescriptor final
{
private:

public:
    MOZ_IMPLICIT IOSurfaceDescriptor();

    MOZ_IMPLICIT IOSurfaceDescriptor(
            const uint32_t& _surfaceId,
            const double& _contentsScaleFactor)
    {
        Init();
        Assign(_surfaceId, _contentsScaleFactor);
    }

    MOZ_IMPLICIT IOSurfaceDescriptor(const IOSurfaceDescriptor& _o)
    {
        Init();
        Assign((_o).surfaceId(), (_o).contentsScaleFactor());
    }

    ~IOSurfaceDescriptor();

    void
    operator=(const IOSurfaceDescriptor& _o)
    {
        Assign((_o).surfaceId(), (_o).contentsScaleFactor());
    }

    bool
    operator==(const IOSurfaceDescriptor& _o) const;

    uint32_t&
    surfaceId()
    {
        return surfaceId_;
    }
    const uint32_t&
    surfaceId() const
    {
        return surfaceId_;
    }

    double&
    contentsScaleFactor()
    {
        return contentsScaleFactor_;
    }
    const double&
    contentsScaleFactor() const
    {
        return contentsScaleFactor_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _surfaceId,
            const double& _contentsScaleFactor);

    uint32_t surfaceId_;
    double contentsScaleFactor_;
};
} // namespace plugins
} // namespace mozilla

namespace mozilla {
namespace plugins {
class PPluginSurfaceParent;
} // namespace plugins
} // namespace mozilla

namespace mozilla {
namespace plugins {
class PPluginSurfaceChild;
} // namespace plugins
} // namespace mozilla

namespace mozilla {
namespace plugins {
class IOSurfaceDescriptor;
} // namespace plugins
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union SurfaceDescriptor|
//
namespace mozilla {
namespace plugins {
class SurfaceDescriptor final
{
public:
    enum Type {
        T__None,
        TShmem = 1,
        TSurfaceDescriptorX11,
        TPPluginSurfaceParent,
        TPPluginSurfaceChild,
        TIOSurfaceDescriptor,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::layers::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::plugins::PPluginSurfaceParent PPluginSurfaceParent;
    typedef mozilla::plugins::PPluginSurfaceChild PPluginSurfaceChild;
    typedef mozilla::plugins::IOSurfaceDescriptor IOSurfaceDescriptor;
    typedef mozilla::null_t null_t;
    typedef Shmem Shmem__tdef;
    typedef SurfaceDescriptorX11 SurfaceDescriptorX11__tdef;
    typedef PPluginSurfaceParent* PPluginSurfaceParent__tdef;
    typedef PPluginSurfaceChild* PPluginSurfaceChild__tdef;
    typedef IOSurfaceDescriptor IOSurfaceDescriptor__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<Shmem> VShmem;
        mozilla::AlignedStorage2<SurfaceDescriptorX11> VSurfaceDescriptorX11;
        mozilla::AlignedStorage2<PPluginSurfaceParent*> VPPluginSurfaceParent;
        mozilla::AlignedStorage2<PPluginSurfaceChild*> VPPluginSurfaceChild;
        mozilla::AlignedStorage2<IOSurfaceDescriptor> VIOSurfaceDescriptor;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem* const
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }
    SurfaceDescriptorX11*
    ptr_SurfaceDescriptorX11()
    {
        return ((mValue).VSurfaceDescriptorX11).addr();
    }
    const SurfaceDescriptorX11* const
    constptr_SurfaceDescriptorX11() const
    {
        return ((mValue).VSurfaceDescriptorX11).addr();
    }
    PPluginSurfaceParent**
    ptr_PPluginSurfaceParent()
    {
        return ((mValue).VPPluginSurfaceParent).addr();
    }
    PPluginSurfaceParent* const*
    constptr_PPluginSurfaceParent() const
    {
        return ((mValue).VPPluginSurfaceParent).addr();
    }
    PPluginSurfaceChild**
    ptr_PPluginSurfaceChild()
    {
        return ((mValue).VPPluginSurfaceChild).addr();
    }
    PPluginSurfaceChild* const*
    constptr_PPluginSurfaceChild() const
    {
        return ((mValue).VPPluginSurfaceChild).addr();
    }
    IOSurfaceDescriptor*
    ptr_IOSurfaceDescriptor()
    {
        return ((mValue).VIOSurfaceDescriptor).addr();
    }
    const IOSurfaceDescriptor* const
    constptr_IOSurfaceDescriptor() const
    {
        return ((mValue).VIOSurfaceDescriptor).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t* const
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT SurfaceDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT SurfaceDescriptor(Shmem& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorX11& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(PPluginSurfaceParent* aOther);

    MOZ_IMPLICIT SurfaceDescriptor(PPluginSurfaceChild* aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const IOSurfaceDescriptor& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const null_t& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptor& aOther);

    ~SurfaceDescriptor();

    Type
    type() const
    {
        return mType;
    }

    SurfaceDescriptor&
    operator=(Shmem& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorX11& aRhs);

    SurfaceDescriptor&
    operator=(PPluginSurfaceParent* aRhs);

    SurfaceDescriptor&
    operator=(PPluginSurfaceChild* aRhs);

    SurfaceDescriptor&
    operator=(const IOSurfaceDescriptor& aRhs);

    SurfaceDescriptor&
    operator=(const null_t& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptor& aRhs);

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const SurfaceDescriptorX11& aRhs) const;

    bool
    operator==(PPluginSurfaceParent* aRhs) const;

    bool
    operator==(PPluginSurfaceChild* aRhs) const;

    bool
    operator==(const IOSurfaceDescriptor& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const SurfaceDescriptor& aRhs) const;

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

    SurfaceDescriptorX11&
    get_SurfaceDescriptorX11()
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(ptr_SurfaceDescriptorX11()));
    }
    const SurfaceDescriptorX11&
    get_SurfaceDescriptorX11() const
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(constptr_SurfaceDescriptorX11()));
    }
    operator SurfaceDescriptorX11&()
    {
        return get_SurfaceDescriptorX11();
    }
    operator const SurfaceDescriptorX11&() const
    {
        return get_SurfaceDescriptorX11();
    }

    PPluginSurfaceParent*&
    get_PPluginSurfaceParent()
    {
        AssertSanity(TPPluginSurfaceParent);
        return (*(ptr_PPluginSurfaceParent()));
    }
    PPluginSurfaceParent*
    get_PPluginSurfaceParent() const
    {
        AssertSanity(TPPluginSurfaceParent);
        return (*(constptr_PPluginSurfaceParent()));
    }
    operator PPluginSurfaceParent*&()
    {
        return get_PPluginSurfaceParent();
    }
    operator PPluginSurfaceParent*() const
    {
        return get_PPluginSurfaceParent();
    }

    PPluginSurfaceChild*&
    get_PPluginSurfaceChild()
    {
        AssertSanity(TPPluginSurfaceChild);
        return (*(ptr_PPluginSurfaceChild()));
    }
    PPluginSurfaceChild*
    get_PPluginSurfaceChild() const
    {
        AssertSanity(TPPluginSurfaceChild);
        return (*(constptr_PPluginSurfaceChild()));
    }
    operator PPluginSurfaceChild*&()
    {
        return get_PPluginSurfaceChild();
    }
    operator PPluginSurfaceChild*() const
    {
        return get_PPluginSurfaceChild();
    }

    IOSurfaceDescriptor&
    get_IOSurfaceDescriptor()
    {
        AssertSanity(TIOSurfaceDescriptor);
        return (*(ptr_IOSurfaceDescriptor()));
    }
    const IOSurfaceDescriptor&
    get_IOSurfaceDescriptor() const
    {
        AssertSanity(TIOSurfaceDescriptor);
        return (*(constptr_IOSurfaceDescriptor()));
    }
    operator IOSurfaceDescriptor&()
    {
        return get_IOSurfaceDescriptor();
    }
    operator const IOSurfaceDescriptor&() const
    {
        return get_IOSurfaceDescriptor();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace plugins
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalShmem|
//
namespace mozilla {
namespace plugins {
class OptionalShmem final
{
public:
    enum Type {
        T__None,
        TShmem = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::null_t null_t;
    typedef Shmem Shmem__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<Shmem> VShmem;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem* const
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t* const
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalShmem() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalShmem(Shmem& aOther);

    MOZ_IMPLICIT OptionalShmem(const null_t& aOther);

    MOZ_IMPLICIT OptionalShmem(const OptionalShmem& aOther);

    ~OptionalShmem();

    Type
    type() const
    {
        return mType;
    }

    OptionalShmem&
    operator=(Shmem& aRhs);

    OptionalShmem&
    operator=(const null_t& aRhs);

    OptionalShmem&
    operator=(const OptionalShmem& aRhs);

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const OptionalShmem& aRhs) const;

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace plugins
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PPluginInstanceChild and PPluginInstanceParent
//
namespace mozilla {
namespace plugins {
namespace PPluginInstance {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PPluginInstanceStart = PPluginInstanceMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_CreateChildPluginWindow__ID,
    Reply_CreateChildPluginWindow__ID,
    Msg_CreateChildPopupSurrogate__ID,
    Msg_NPP_SetWindow__ID,
    Reply_NPP_SetWindow__ID,
    Msg_NPP_GetValue_NPPVpluginWantsAllNetworkStreams__ID,
    Reply_NPP_GetValue_NPPVpluginWantsAllNetworkStreams__ID,
    Msg_NPP_GetValue_NPPVpluginNeedsXEmbed__ID,
    Reply_NPP_GetValue_NPPVpluginNeedsXEmbed__ID,
    Msg_NPP_GetValue_NPPVpluginScriptableNPObject__ID,
    Reply_NPP_GetValue_NPPVpluginScriptableNPObject__ID,
    Msg_NPP_SetValue_NPNVprivateModeBool__ID,
    Reply_NPP_SetValue_NPNVprivateModeBool__ID,
    Msg_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId__ID,
    Reply_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId__ID,
    Msg_NPP_SetValue_NPNVmuteAudioBool__ID,
    Reply_NPP_SetValue_NPNVmuteAudioBool__ID,
    Msg_NPP_HandleEvent__ID,
    Reply_NPP_HandleEvent__ID,
    Msg_NPP_HandleEvent_Shmem__ID,
    Reply_NPP_HandleEvent_Shmem__ID,
    Msg_NPP_HandleEvent_IOSurface__ID,
    Reply_NPP_HandleEvent_IOSurface__ID,
    Msg_Paint__ID,
    Reply_Paint__ID,
    Msg_WindowPosChanged__ID,
    Msg_ContentsScaleFactorChanged__ID,
    Msg_AsyncSetWindow__ID,
    Msg_UpdateBackground__ID,
    Msg_NPP_DidComposite__ID,
    Msg_NPP_Destroy__ID,
    Reply_NPP_Destroy__ID,
    Msg_NPN_GetValue_NPNVWindowNPObject__ID,
    Reply_NPN_GetValue_NPNVWindowNPObject__ID,
    Msg_NPN_GetValue_NPNVPluginElementNPObject__ID,
    Reply_NPN_GetValue_NPNVPluginElementNPObject__ID,
    Msg_NPN_GetValue_NPNVprivateModeBool__ID,
    Reply_NPN_GetValue_NPNVprivateModeBool__ID,
    Msg_NPN_GetValue_NPNVnetscapeWindow__ID,
    Reply_NPN_GetValue_NPNVnetscapeWindow__ID,
    Msg_NPN_GetValue_NPNVdocumentOrigin__ID,
    Reply_NPN_GetValue_NPNVdocumentOrigin__ID,
    Msg_NPN_GetValue_DrawingModelSupport__ID,
    Reply_NPN_GetValue_DrawingModelSupport__ID,
    Msg_NPN_GetValue_SupportsAsyncBitmapSurface__ID,
    Reply_NPN_GetValue_SupportsAsyncBitmapSurface__ID,
    Msg_NPN_GetValue_SupportsAsyncDXGISurface__ID,
    Reply_NPN_GetValue_SupportsAsyncDXGISurface__ID,
    Msg_NPN_GetValue_PreferredDXGIAdapter__ID,
    Reply_NPN_GetValue_PreferredDXGIAdapter__ID,
    Msg_NPN_SetValue_NPPVpluginWindow__ID,
    Reply_NPN_SetValue_NPPVpluginWindow__ID,
    Msg_NPN_SetValue_NPPVpluginTransparent__ID,
    Reply_NPN_SetValue_NPPVpluginTransparent__ID,
    Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID,
    Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID,
    Msg_NPN_SetValue_NPPVpluginDrawingModel__ID,
    Reply_NPN_SetValue_NPPVpluginDrawingModel__ID,
    Msg_NPN_SetValue_NPPVpluginEventModel__ID,
    Reply_NPN_SetValue_NPPVpluginEventModel__ID,
    Msg_NPN_SetValue_NPPVpluginIsPlayingAudio__ID,
    Reply_NPN_SetValue_NPPVpluginIsPlayingAudio__ID,
    Msg_NPN_GetURL__ID,
    Reply_NPN_GetURL__ID,
    Msg_NPN_PostURL__ID,
    Reply_NPN_PostURL__ID,
    Msg_PStreamNotifyConstructor__ID,
    Reply_PStreamNotifyConstructor__ID,
    Msg_NPN_InvalidateRect__ID,
    Msg_RevokeCurrentDirectSurface__ID,
    Reply_RevokeCurrentDirectSurface__ID,
    Msg_InitDXGISurface__ID,
    Reply_InitDXGISurface__ID,
    Msg_FinalizeDXGISurface__ID,
    Reply_FinalizeDXGISurface__ID,
    Msg_ShowDirectBitmap__ID,
    Reply_ShowDirectBitmap__ID,
    Msg_ShowDirectDXGISurface__ID,
    Reply_ShowDirectDXGISurface__ID,
    Msg_Show__ID,
    Reply_Show__ID,
    Msg_PPluginSurfaceConstructor__ID,
    Reply_PPluginSurfaceConstructor__ID,
    Msg_NPN_PushPopupsEnabledState__ID,
    Reply_NPN_PushPopupsEnabledState__ID,
    Msg_NPN_PopPopupsEnabledState__ID,
    Reply_NPN_PopPopupsEnabledState__ID,
    Msg_NPN_GetValueForURL__ID,
    Reply_NPN_GetValueForURL__ID,
    Msg_NPN_SetValueForURL__ID,
    Reply_NPN_SetValueForURL__ID,
    Msg_NPN_GetAuthenticationInfo__ID,
    Reply_NPN_GetAuthenticationInfo__ID,
    Msg_NPN_ConvertPoint__ID,
    Reply_NPN_ConvertPoint__ID,
    Msg_RedrawPlugin__ID,
    Msg_NegotiatedCarbon__ID,
    Reply_NegotiatedCarbon__ID,
    Msg_AsyncNPP_NewResult__ID,
    Msg_SetNetscapeWindowAsParent__ID,
    Msg_PPluginScriptableObjectConstructor__ID,
    Reply_PPluginScriptableObjectConstructor__ID,
    Msg_PBrowserStreamConstructor__ID,
    Reply_PBrowserStreamConstructor__ID,
    Msg_NPP_NewStream__ID,
    Reply_NPP_NewStream__ID,
    Msg_AsyncNPP_NewStream__ID,
    Msg_PPluginStreamConstructor__ID,
    Reply_PPluginStreamConstructor__ID,
    Msg_PluginFocusChange__ID,
    Reply_PluginFocusChange__ID,
    Msg_PluginDidSetCursor__ID,
    Msg_SetPluginFocus__ID,
    Reply_SetPluginFocus__ID,
    Msg_UpdateWindow__ID,
    Reply_UpdateWindow__ID,
    Msg_PPluginBackgroundDestroyerConstructor__ID,
    Reply_PPluginBackgroundDestroyerConstructor__ID,
    PPluginInstanceEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CreateChildPluginWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CreateChildPluginWindow__ID
    };
    MOZ_IMPLICIT Msg_CreateChildPluginWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_CreateChildPluginWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CreateChildPluginWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_CreateChildPluginWindow :
    public IPC::Message
{
public:
    enum {
        ID = Reply_CreateChildPluginWindow__ID
    };
    MOZ_IMPLICIT Reply_CreateChildPluginWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_CreateChildPluginWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_CreateChildPluginWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CreateChildPopupSurrogate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CreateChildPopupSurrogate__ID
    };
    MOZ_IMPLICIT Msg_CreateChildPopupSurrogate(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_CreateChildPopupSurrogate")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CreateChildPopupSurrogate(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_SetWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_SetWindow__ID
    };
    MOZ_IMPLICIT Msg_NPP_SetWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_SetWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_SetWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_SetWindow :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_SetWindow__ID
    };
    MOZ_IMPLICIT Reply_NPP_SetWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_SetWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_SetWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_GetValue_NPPVpluginWantsAllNetworkStreams :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_GetValue_NPPVpluginWantsAllNetworkStreams__ID
    };
    MOZ_IMPLICIT Msg_NPP_GetValue_NPPVpluginWantsAllNetworkStreams(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_GetValue_NPPVpluginWantsAllNetworkStreams")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_GetValue_NPPVpluginWantsAllNetworkStreams(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_GetValue_NPPVpluginWantsAllNetworkStreams :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_GetValue_NPPVpluginWantsAllNetworkStreams__ID
    };
    MOZ_IMPLICIT Reply_NPP_GetValue_NPPVpluginWantsAllNetworkStreams(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_GetValue_NPPVpluginWantsAllNetworkStreams")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_GetValue_NPPVpluginWantsAllNetworkStreams(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_GetValue_NPPVpluginNeedsXEmbed :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_GetValue_NPPVpluginNeedsXEmbed__ID
    };
    MOZ_IMPLICIT Msg_NPP_GetValue_NPPVpluginNeedsXEmbed(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_GetValue_NPPVpluginNeedsXEmbed")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_GetValue_NPPVpluginNeedsXEmbed(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_GetValue_NPPVpluginNeedsXEmbed :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_GetValue_NPPVpluginNeedsXEmbed__ID
    };
    MOZ_IMPLICIT Reply_NPP_GetValue_NPPVpluginNeedsXEmbed(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_GetValue_NPPVpluginNeedsXEmbed")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_GetValue_NPPVpluginNeedsXEmbed(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_GetValue_NPPVpluginScriptableNPObject :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_GetValue_NPPVpluginScriptableNPObject__ID
    };
    MOZ_IMPLICIT Msg_NPP_GetValue_NPPVpluginScriptableNPObject(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_GetValue_NPPVpluginScriptableNPObject")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_GetValue_NPPVpluginScriptableNPObject(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_GetValue_NPPVpluginScriptableNPObject :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_GetValue_NPPVpluginScriptableNPObject__ID
    };
    MOZ_IMPLICIT Reply_NPP_GetValue_NPPVpluginScriptableNPObject(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_GetValue_NPPVpluginScriptableNPObject")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_GetValue_NPPVpluginScriptableNPObject(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_SetValue_NPNVprivateModeBool :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_SetValue_NPNVprivateModeBool__ID
    };
    MOZ_IMPLICIT Msg_NPP_SetValue_NPNVprivateModeBool(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_SetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_SetValue_NPNVprivateModeBool(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_SetValue_NPNVprivateModeBool :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_SetValue_NPNVprivateModeBool__ID
    };
    MOZ_IMPLICIT Reply_NPP_SetValue_NPNVprivateModeBool(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_SetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_SetValue_NPNVprivateModeBool(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId__ID
    };
    MOZ_IMPLICIT Msg_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId__ID
    };
    MOZ_IMPLICIT Reply_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_GetValue_NPPVpluginNativeAccessibleAtkPlugId(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_SetValue_NPNVmuteAudioBool :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_SetValue_NPNVmuteAudioBool__ID
    };
    MOZ_IMPLICIT Msg_NPP_SetValue_NPNVmuteAudioBool(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_SetValue_NPNVmuteAudioBool")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_SetValue_NPNVmuteAudioBool(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_SetValue_NPNVmuteAudioBool :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_SetValue_NPNVmuteAudioBool__ID
    };
    MOZ_IMPLICIT Reply_NPP_SetValue_NPNVmuteAudioBool(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_SetValue_NPNVmuteAudioBool")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_SetValue_NPNVmuteAudioBool(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_HandleEvent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_HandleEvent__ID
    };
    MOZ_IMPLICIT Msg_NPP_HandleEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_HandleEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_HandleEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_HandleEvent :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_HandleEvent__ID
    };
    MOZ_IMPLICIT Reply_NPP_HandleEvent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_HandleEvent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_HandleEvent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_HandleEvent_Shmem :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_HandleEvent_Shmem__ID
    };
    MOZ_IMPLICIT Msg_NPP_HandleEvent_Shmem(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_HandleEvent_Shmem")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_HandleEvent_Shmem(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_HandleEvent_Shmem :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_HandleEvent_Shmem__ID
    };
    MOZ_IMPLICIT Reply_NPP_HandleEvent_Shmem(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_HandleEvent_Shmem")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_HandleEvent_Shmem(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_HandleEvent_IOSurface :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_HandleEvent_IOSurface__ID
    };
    MOZ_IMPLICIT Msg_NPP_HandleEvent_IOSurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_HandleEvent_IOSurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_HandleEvent_IOSurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_HandleEvent_IOSurface :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_HandleEvent_IOSurface__ID
    };
    MOZ_IMPLICIT Reply_NPP_HandleEvent_IOSurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_HandleEvent_IOSurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_HandleEvent_IOSurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Paint :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Paint__ID
    };
    MOZ_IMPLICIT Msg_Paint(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_Paint")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Paint(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_Paint :
    public IPC::Message
{
public:
    enum {
        ID = Reply_Paint__ID
    };
    MOZ_IMPLICIT Reply_Paint(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_Paint")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_Paint(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_WindowPosChanged :
    public IPC::Message
{
public:
    enum {
        ID = Msg_WindowPosChanged__ID
    };
    MOZ_IMPLICIT Msg_WindowPosChanged(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_WindowPosChanged")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_WindowPosChanged(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ContentsScaleFactorChanged :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ContentsScaleFactorChanged__ID
    };
    MOZ_IMPLICIT Msg_ContentsScaleFactorChanged(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_ContentsScaleFactorChanged")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ContentsScaleFactorChanged(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AsyncSetWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AsyncSetWindow__ID
    };
    MOZ_IMPLICIT Msg_AsyncSetWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_AsyncSetWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AsyncSetWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UpdateBackground :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UpdateBackground__ID
    };
    MOZ_IMPLICIT Msg_UpdateBackground(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_UpdateBackground")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UpdateBackground(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_DidComposite :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_DidComposite__ID
    };
    MOZ_IMPLICIT Msg_NPP_DidComposite(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_DidComposite")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_DidComposite(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_Destroy :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_Destroy__ID
    };
    MOZ_IMPLICIT Msg_NPP_Destroy(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_Destroy")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_Destroy(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_Destroy :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_Destroy__ID
    };
    MOZ_IMPLICIT Reply_NPP_Destroy(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_Destroy")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_Destroy(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_NPNVWindowNPObject :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_NPNVWindowNPObject__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_NPNVWindowNPObject(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_NPNVWindowNPObject")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_NPNVWindowNPObject(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_NPNVWindowNPObject :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_NPNVWindowNPObject__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_NPNVWindowNPObject(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_NPNVWindowNPObject")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_NPNVWindowNPObject(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_NPNVPluginElementNPObject :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_NPNVPluginElementNPObject__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_NPNVPluginElementNPObject(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_NPNVPluginElementNPObject")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_NPNVPluginElementNPObject(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_NPNVPluginElementNPObject :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_NPNVPluginElementNPObject__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_NPNVPluginElementNPObject(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_NPNVPluginElementNPObject")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_NPNVPluginElementNPObject(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_NPNVprivateModeBool :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_NPNVprivateModeBool__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_NPNVprivateModeBool(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_NPNVprivateModeBool(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_NPNVprivateModeBool :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_NPNVprivateModeBool__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_NPNVprivateModeBool(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_NPNVprivateModeBool")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_NPNVprivateModeBool(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_NPNVnetscapeWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_NPNVnetscapeWindow__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_NPNVnetscapeWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_NPNVnetscapeWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_NPNVnetscapeWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_NPNVnetscapeWindow :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_NPNVnetscapeWindow__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_NPNVnetscapeWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_NPNVnetscapeWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_NPNVnetscapeWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_NPNVdocumentOrigin :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_NPNVdocumentOrigin__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_NPNVdocumentOrigin(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_NPNVdocumentOrigin")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_NPNVdocumentOrigin(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_NPNVdocumentOrigin :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_NPNVdocumentOrigin__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_NPNVdocumentOrigin(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_NPNVdocumentOrigin")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_NPNVdocumentOrigin(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_DrawingModelSupport :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_DrawingModelSupport__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_DrawingModelSupport(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_DrawingModelSupport")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_DrawingModelSupport(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_DrawingModelSupport :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_DrawingModelSupport__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_DrawingModelSupport(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_DrawingModelSupport")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_DrawingModelSupport(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_SupportsAsyncBitmapSurface :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_SupportsAsyncBitmapSurface__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_SupportsAsyncBitmapSurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_SupportsAsyncBitmapSurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_SupportsAsyncBitmapSurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_SupportsAsyncBitmapSurface :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_SupportsAsyncBitmapSurface__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_SupportsAsyncBitmapSurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_SupportsAsyncBitmapSurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_SupportsAsyncBitmapSurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_SupportsAsyncDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_SupportsAsyncDXGISurface__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_SupportsAsyncDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_SupportsAsyncDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_SupportsAsyncDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_SupportsAsyncDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_SupportsAsyncDXGISurface__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_SupportsAsyncDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_SupportsAsyncDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_SupportsAsyncDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValue_PreferredDXGIAdapter :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValue_PreferredDXGIAdapter__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValue_PreferredDXGIAdapter(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValue_PreferredDXGIAdapter")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValue_PreferredDXGIAdapter(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValue_PreferredDXGIAdapter :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValue_PreferredDXGIAdapter__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValue_PreferredDXGIAdapter(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValue_PreferredDXGIAdapter")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValue_PreferredDXGIAdapter(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_SetValue_NPPVpluginWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginWindow__ID
    };
    MOZ_IMPLICIT Msg_NPN_SetValue_NPPVpluginWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_SetValue_NPPVpluginWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_SetValue_NPPVpluginWindow :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginWindow__ID
    };
    MOZ_IMPLICIT Reply_NPN_SetValue_NPPVpluginWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_SetValue_NPPVpluginWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_SetValue_NPPVpluginTransparent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginTransparent__ID
    };
    MOZ_IMPLICIT Msg_NPN_SetValue_NPPVpluginTransparent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginTransparent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_SetValue_NPPVpluginTransparent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_SetValue_NPPVpluginTransparent :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginTransparent__ID
    };
    MOZ_IMPLICIT Reply_NPN_SetValue_NPPVpluginTransparent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginTransparent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_SetValue_NPPVpluginTransparent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID
    };
    MOZ_IMPLICIT Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_SetValue_NPPVpluginUsesDOMForCursor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor__ID
    };
    MOZ_IMPLICIT Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_SetValue_NPPVpluginUsesDOMForCursor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_SetValue_NPPVpluginDrawingModel :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginDrawingModel__ID
    };
    MOZ_IMPLICIT Msg_NPN_SetValue_NPPVpluginDrawingModel(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginDrawingModel")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_SetValue_NPPVpluginDrawingModel(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_SetValue_NPPVpluginDrawingModel :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginDrawingModel__ID
    };
    MOZ_IMPLICIT Reply_NPN_SetValue_NPPVpluginDrawingModel(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginDrawingModel")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_SetValue_NPPVpluginDrawingModel(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_SetValue_NPPVpluginEventModel :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginEventModel__ID
    };
    MOZ_IMPLICIT Msg_NPN_SetValue_NPPVpluginEventModel(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginEventModel")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_SetValue_NPPVpluginEventModel(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_SetValue_NPPVpluginEventModel :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginEventModel__ID
    };
    MOZ_IMPLICIT Reply_NPN_SetValue_NPPVpluginEventModel(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginEventModel")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_SetValue_NPPVpluginEventModel(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_SetValue_NPPVpluginIsPlayingAudio :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_SetValue_NPPVpluginIsPlayingAudio__ID
    };
    MOZ_IMPLICIT Msg_NPN_SetValue_NPPVpluginIsPlayingAudio(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_SetValue_NPPVpluginIsPlayingAudio")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_SetValue_NPPVpluginIsPlayingAudio(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_SetValue_NPPVpluginIsPlayingAudio :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_SetValue_NPPVpluginIsPlayingAudio__ID
    };
    MOZ_IMPLICIT Reply_NPN_SetValue_NPPVpluginIsPlayingAudio(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_SetValue_NPPVpluginIsPlayingAudio")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_SetValue_NPPVpluginIsPlayingAudio(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetURL :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetURL__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetURL :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetURL__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_PostURL :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_PostURL__ID
    };
    MOZ_IMPLICIT Msg_NPN_PostURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_PostURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_PostURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_PostURL :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_PostURL__ID
    };
    MOZ_IMPLICIT Reply_NPN_PostURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_PostURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_PostURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PStreamNotifyConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PStreamNotifyConstructor__ID
    };
    MOZ_IMPLICIT Msg_PStreamNotifyConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PStreamNotifyConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PStreamNotifyConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PStreamNotifyConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PStreamNotifyConstructor__ID
    };
    MOZ_IMPLICIT Reply_PStreamNotifyConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_PStreamNotifyConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PStreamNotifyConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_InvalidateRect :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_InvalidateRect__ID
    };
    MOZ_IMPLICIT Msg_NPN_InvalidateRect(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_InvalidateRect")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_InvalidateRect(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RevokeCurrentDirectSurface :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RevokeCurrentDirectSurface__ID
    };
    MOZ_IMPLICIT Msg_RevokeCurrentDirectSurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_RevokeCurrentDirectSurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RevokeCurrentDirectSurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_RevokeCurrentDirectSurface :
    public IPC::Message
{
public:
    enum {
        ID = Reply_RevokeCurrentDirectSurface__ID
    };
    MOZ_IMPLICIT Reply_RevokeCurrentDirectSurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_RevokeCurrentDirectSurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_RevokeCurrentDirectSurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_InitDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Msg_InitDXGISurface__ID
    };
    MOZ_IMPLICIT Msg_InitDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_InitDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_InitDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_InitDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Reply_InitDXGISurface__ID
    };
    MOZ_IMPLICIT Reply_InitDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_InitDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_InitDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_FinalizeDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Msg_FinalizeDXGISurface__ID
    };
    MOZ_IMPLICIT Msg_FinalizeDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_FinalizeDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_FinalizeDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_FinalizeDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Reply_FinalizeDXGISurface__ID
    };
    MOZ_IMPLICIT Reply_FinalizeDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_FinalizeDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_FinalizeDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ShowDirectBitmap :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ShowDirectBitmap__ID
    };
    MOZ_IMPLICIT Msg_ShowDirectBitmap(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_ShowDirectBitmap")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ShowDirectBitmap(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_ShowDirectBitmap :
    public IPC::Message
{
public:
    enum {
        ID = Reply_ShowDirectBitmap__ID
    };
    MOZ_IMPLICIT Reply_ShowDirectBitmap(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_ShowDirectBitmap")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_ShowDirectBitmap(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ShowDirectDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ShowDirectDXGISurface__ID
    };
    MOZ_IMPLICIT Msg_ShowDirectDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_ShowDirectDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ShowDirectDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_ShowDirectDXGISurface :
    public IPC::Message
{
public:
    enum {
        ID = Reply_ShowDirectDXGISurface__ID
    };
    MOZ_IMPLICIT Reply_ShowDirectDXGISurface(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_ShowDirectDXGISurface")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_ShowDirectDXGISurface(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Show :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Show__ID
    };
    MOZ_IMPLICIT Msg_Show(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_Show")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Show(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_Show :
    public IPC::Message
{
public:
    enum {
        ID = Reply_Show__ID
    };
    MOZ_IMPLICIT Reply_Show(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_Show")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_Show(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PPluginSurfaceConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PPluginSurfaceConstructor__ID
    };
    MOZ_IMPLICIT Msg_PPluginSurfaceConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PPluginSurfaceConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PPluginSurfaceConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PPluginSurfaceConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PPluginSurfaceConstructor__ID
    };
    MOZ_IMPLICIT Reply_PPluginSurfaceConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_PPluginSurfaceConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PPluginSurfaceConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_PushPopupsEnabledState :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_PushPopupsEnabledState__ID
    };
    MOZ_IMPLICIT Msg_NPN_PushPopupsEnabledState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_PushPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_PushPopupsEnabledState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_PushPopupsEnabledState :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_PushPopupsEnabledState__ID
    };
    MOZ_IMPLICIT Reply_NPN_PushPopupsEnabledState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_PushPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_PushPopupsEnabledState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_PopPopupsEnabledState :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_PopPopupsEnabledState__ID
    };
    MOZ_IMPLICIT Msg_NPN_PopPopupsEnabledState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_PopPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_PopPopupsEnabledState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_PopPopupsEnabledState :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_PopPopupsEnabledState__ID
    };
    MOZ_IMPLICIT Reply_NPN_PopPopupsEnabledState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_PopPopupsEnabledState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_PopPopupsEnabledState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetValueForURL :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetValueForURL__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetValueForURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetValueForURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetValueForURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetValueForURL :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetValueForURL__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetValueForURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetValueForURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetValueForURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_SetValueForURL :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_SetValueForURL__ID
    };
    MOZ_IMPLICIT Msg_NPN_SetValueForURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_SetValueForURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_SetValueForURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_SetValueForURL :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_SetValueForURL__ID
    };
    MOZ_IMPLICIT Reply_NPN_SetValueForURL(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_SetValueForURL")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_SetValueForURL(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_GetAuthenticationInfo :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_GetAuthenticationInfo__ID
    };
    MOZ_IMPLICIT Msg_NPN_GetAuthenticationInfo(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_GetAuthenticationInfo")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_GetAuthenticationInfo(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_GetAuthenticationInfo :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_GetAuthenticationInfo__ID
    };
    MOZ_IMPLICIT Reply_NPN_GetAuthenticationInfo(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_GetAuthenticationInfo")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_GetAuthenticationInfo(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPN_ConvertPoint :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPN_ConvertPoint__ID
    };
    MOZ_IMPLICIT Msg_NPN_ConvertPoint(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPN_ConvertPoint")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPN_ConvertPoint(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPN_ConvertPoint :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPN_ConvertPoint__ID
    };
    MOZ_IMPLICIT Reply_NPN_ConvertPoint(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPN_ConvertPoint")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPN_ConvertPoint(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RedrawPlugin :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RedrawPlugin__ID
    };
    MOZ_IMPLICIT Msg_RedrawPlugin(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_RedrawPlugin")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RedrawPlugin(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NegotiatedCarbon :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NegotiatedCarbon__ID
    };
    MOZ_IMPLICIT Msg_NegotiatedCarbon(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NegotiatedCarbon")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NegotiatedCarbon(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NegotiatedCarbon :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NegotiatedCarbon__ID
    };
    MOZ_IMPLICIT Reply_NegotiatedCarbon(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NegotiatedCarbon")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NegotiatedCarbon(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AsyncNPP_NewResult :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AsyncNPP_NewResult__ID
    };
    MOZ_IMPLICIT Msg_AsyncNPP_NewResult(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_AsyncNPP_NewResult")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AsyncNPP_NewResult(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetNetscapeWindowAsParent :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetNetscapeWindowAsParent__ID
    };
    MOZ_IMPLICIT Msg_SetNetscapeWindowAsParent(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_SetNetscapeWindowAsParent")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetNetscapeWindowAsParent(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PPluginScriptableObjectConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PPluginScriptableObjectConstructor__ID
    };
    MOZ_IMPLICIT Msg_PPluginScriptableObjectConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PPluginScriptableObjectConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PPluginScriptableObjectConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PPluginScriptableObjectConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PPluginScriptableObjectConstructor__ID
    };
    MOZ_IMPLICIT Reply_PPluginScriptableObjectConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_PPluginScriptableObjectConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PPluginScriptableObjectConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PBrowserStreamConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PBrowserStreamConstructor__ID
    };
    MOZ_IMPLICIT Msg_PBrowserStreamConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PBrowserStreamConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PBrowserStreamConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PBrowserStreamConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PBrowserStreamConstructor__ID
    };
    MOZ_IMPLICIT Reply_PBrowserStreamConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_PBrowserStreamConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PBrowserStreamConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NPP_NewStream :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NPP_NewStream__ID
    };
    MOZ_IMPLICIT Msg_NPP_NewStream(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_NPP_NewStream")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NPP_NewStream(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_NPP_NewStream :
    public IPC::Message
{
public:
    enum {
        ID = Reply_NPP_NewStream__ID
    };
    MOZ_IMPLICIT Reply_NPP_NewStream(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_NPP_NewStream")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_NPP_NewStream(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AsyncNPP_NewStream :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AsyncNPP_NewStream__ID
    };
    MOZ_IMPLICIT Msg_AsyncNPP_NewStream(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_AsyncNPP_NewStream")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AsyncNPP_NewStream(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PPluginStreamConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PPluginStreamConstructor__ID
    };
    MOZ_IMPLICIT Msg_PPluginStreamConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PPluginStreamConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PPluginStreamConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PPluginStreamConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PPluginStreamConstructor__ID
    };
    MOZ_IMPLICIT Reply_PPluginStreamConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_PPluginStreamConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PPluginStreamConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PluginFocusChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PluginFocusChange__ID
    };
    MOZ_IMPLICIT Msg_PluginFocusChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PluginFocusChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PluginFocusChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PluginFocusChange :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PluginFocusChange__ID
    };
    MOZ_IMPLICIT Reply_PluginFocusChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_PluginFocusChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PluginFocusChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PluginDidSetCursor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PluginDidSetCursor__ID
    };
    MOZ_IMPLICIT Msg_PluginDidSetCursor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PluginDidSetCursor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PluginDidSetCursor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetPluginFocus :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetPluginFocus__ID
    };
    MOZ_IMPLICIT Msg_SetPluginFocus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_SetPluginFocus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetPluginFocus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_SetPluginFocus :
    public IPC::Message
{
public:
    enum {
        ID = Reply_SetPluginFocus__ID
    };
    MOZ_IMPLICIT Reply_SetPluginFocus(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_SetPluginFocus")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_SetPluginFocus(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UpdateWindow :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UpdateWindow__ID
    };
    MOZ_IMPLICIT Msg_UpdateWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_UpdateWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UpdateWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_UpdateWindow :
    public IPC::Message
{
public:
    enum {
        ID = Reply_UpdateWindow__ID
    };
    MOZ_IMPLICIT Reply_UpdateWindow(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_UpdateWindow")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_UpdateWindow(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PPluginBackgroundDestroyerConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PPluginBackgroundDestroyerConstructor__ID
    };
    MOZ_IMPLICIT Msg_PPluginBackgroundDestroyerConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Msg_PPluginBackgroundDestroyerConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PPluginBackgroundDestroyerConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PPluginBackgroundDestroyerConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PPluginBackgroundDestroyerConstructor__ID
    };
    MOZ_IMPLICIT Reply_PPluginBackgroundDestroyerConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPluginInstance::Reply_PPluginBackgroundDestroyerConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PPluginBackgroundDestroyerConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PPluginInstance
} // namespace plugins
} // namespace mozilla

#endif // ifndef PPluginInstance_h
